***
      REAL*8 FUNCTION CORERD(KW,MC,M0,MFLASH)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
* A function to determine the radius of the core of a giant-like star.
* NOTE: this is out of date so rc should be obtained using HRDIAG!
* It is still OK to use but bear in mind that the core radius calculated
* for non-degenerate giant cores is only a rough estimate.
*
*     Author : C. A. Tout
*     Date :   26th February 1997
*     Updated 6/1/98 by J. Hurley
*
      INTEGER KW
      REAL*8 MC,MCH,M0,MFLASH
      PARAMETER (MCH = 1.44d0)
*
* First do the black holes and neutron stars.
*
      IF(KW.EQ.14)THEN
         CORERD = 4.24d-06*MC
      ELSEIF(KW.EQ.13)THEN
         CORERD = 1.4d-05
*
* Main sequence stars.
*
      ELSEIF(KW.LE.1.OR.KW.EQ.7)THEN
         CORERD = 0.d0
*
* Core-helium-burning stars, FAGB stars and non-degenerate giant cores.
*
      ELSEIF(KW.EQ.4.OR.KW.EQ.5.OR.(KW.LE.3.AND.M0.GT.MFLASH))THEN
         CORERD = 0.2239d0*MC**0.62d0
*
* The degenerate giants and white dwarfs.
*
      ELSE
         CORERD = 0.0115d0*SQRT(MAX(1.48204d-06,(MCH/MC)**(2.d0/3.d0)
     &                                        - (MC/MCH)**(2.d0/3.d0)))
*
* Degenerate giants have hot subdwarf cores.
*
         IF(KW.LE.9) CORERD = 5.d0*CORERD
      ENDIF
*
      RETURN
      END
***

***
      REAL*8 FUNCTION RL(Q)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
      REAL*8 Q,P
*
* A function to evaluate R_L/a(q), Eggleton 1983.
*
      P = Q**(1.d0/3.d0)
      RL = 0.49d0*P*P/(0.6d0*P*P + LOG(1.d0+P))
*
      RETURN
      END
***

***
      SUBROUTINE star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
*
*       Stellar luminosity & evolution time.
*       ------------------------------------
*
*
      integer kw
*
      real*8 mass,mt,tm,tn,tscls(20),lums(10),GB(10),zpars(20)
      real*8 tgb,tbagb,mch,mcmax,mc1,mc2,mcbagb,dx,am
      real*8 lambdastar,tau,mtc,mass0
      parameter(mch=1.44d0)
*
      real*8 lzamsf,lzahbf,lzhef
      real*8 tbgbf,thookf,tHef,themsf,mcgbf,mcagbf,mcheif,mcgbtf
      real*8 ltmsf,lbgbf,lHeIf,lHef,lbagbf,lmcgbf
      external lzamsf,lzahbf,lzhef
      external tbgbf,thookf,tHef,themsf,mcgbf,mcagbf,mcheif,mcgbtf
      external ltmsf,lbgbf,lHeIf,lHef,lbagbf,lmcgbf
*
*       Computes the characteristic luminosities at different stages (LUMS),
*       and various timescales (TSCLS).
*       Ref: P.P. Eggleton, M.J. Fitchett & C.A. Tout (1989) Ap.J. 347, 998.
*
*       Revised 27th March 1995 by C. A. Tout
*       and 24th October 1995 to include metallicity
*       and 13th December 1996 to include naked helium stars
*
*       Revised 5th April 1997 by J. R. Hurley
*       to include Z=0.001 as well as Z=0.02, convective overshooting,
*       MS hook and more elaborate CHeB. It now also sets the Giant
*       Branch parameters relevant to the mass of the star.
*
*       ------------------------------------------------------------
*       Times: 1; BGB              2; He ignition   3; He burning
*              4; Giant t(inf1)    5; Giant t(inf2) 6; Giant t(Mx)
*              7; FAGB t(inf1)     8; FAGB t(inf2)  9; FAGB  t(Mx)
*             10; SAGB t(inf1)    11; SAGB t(inf2) 12; SAGB  t(Mx)
*             13; TP              14; t(Mcmax)
*
*       LUMS:  1; ZAMS             2; End MS        3; BGB
*              4; He ignition      5; He burning    6; L(Mx)
*              7; BAGB             8; TP
*
*       GB:    1; effective A(H)   2; A(H,He)       3; B
*              4; D                5; p             6; q
*              7; Mx               8; A(He)         9; Mc,BGB
*
*       ------------------------------------------------------------
*
*
      mass0 = mass
C      if(mass0.gt.100.d0) mass = 100.d0
*
      if(kw.ge.7.and.kw.le.9) goto 90
      if(kw.ge.10) goto 95
*
* MS and BGB times
*
      tscls(1) = tbgbf(mass)
      tm = MAX(zpars(8),thookf(mass))*tscls(1)
*
* Zero- and terminal age main sequence luminosity
*
      lums(1) = lzamsf(mass)
      lums(2) = ltmsf(mass)
*
* Set the GB parameters
*
      GB(1) = MAX(-4.8d0,MIN(-5.7d0+0.8d0*mass,-4.1d0+0.14d0*mass))
      GB(1) = 10.d0**GB(1)
      GB(2) = 1.27d-05
      GB(8) = 8.0d-05
      GB(3) = MAX(3.0d+04,500.d0 + 1.75d+04*mass**0.6d0)
      if(mass.le.2.0)then
         GB(4) = zpars(6)
         GB(5) = 6.d0
         GB(6) = 3.d0
      elseif(mass.lt.2.5)then
         dx = zpars(6) - (0.975d0*zpars(6) - 0.18d0*2.5d0)
         GB(4) = zpars(6) - dx*(mass - 2.d0)/(0.5d0)
         GB(5) = 6.d0 - (mass - 2.d0)/(0.5d0)
         GB(6) = 3.d0 - (mass - 2.d0)/(0.5d0)
      else
         GB(4) = MAX(-1.d0,0.5d0*zpars(6) - 0.06d0*mass)
         GB(4) = MAX(GB(4),0.975d0*zpars(6) - 0.18d0*mass)
         GB(5) = 5.d0
         GB(6) = 2.d0
      endif
      GB(4) = 10.d0**GB(4)
      GB(7) = (GB(3)/GB(4))**(1.d0/(GB(5)-GB(6)))
*
* Change in slope of giant L-Mc relation.
      lums(6) = GB(4)*GB(7)**GB(5)
*
* HeI ignition luminosity
      lums(4) = lHeIf(mass,zpars(2))
      lums(7) = lbagbf(mass,zpars(2))
*
      if(mass.lt.0.1d0.and.kw.le.1)then
         tscls(2) = 1.1d0*tscls(1)
         tscls(3) = 0.1d0*tscls(1)
         lums(3) = lbgbf(mass)
         goto 96
      endif
*
      if(mass.le.zpars(3))then
* Base of the giant branch luminosity
         lums(3) = lbgbf(mass)
* Set GB timescales
         tscls(4) = tscls(1) + (1.d0/((GB(5)-1.d0)*GB(1)*GB(4)))*
     &              ((GB(4)/lums(3))**((GB(5)-1.d0)/GB(5)))
         tscls(6) = tscls(4) - (tscls(4) - tscls(1))*((lums(3)/lums(6))
     &              **((GB(5)-1.d0)/GB(5)))
         tscls(5) = tscls(6) + (1.d0/((GB(6)-1.d0)*GB(1)*GB(3)))*
     &              ((GB(3)/lums(6))**((GB(6)-1.d0)/GB(6)))
* Set Helium ignition time
         if(lums(4).le.lums(6))then
            tscls(2) = tscls(4) - (1.d0/((GB(5)-1.d0)*GB(1)*GB(4)))*
     &                      ((GB(4)/lums(4))**((GB(5)-1.d0)/GB(5)))
         else
            tscls(2) = tscls(5) - (1.d0/((GB(6)-1.d0)*GB(1)*GB(3)))*
     &                      ((GB(3)/lums(4))**((GB(6)-1.d0)/GB(6)))
         endif
         tgb = tscls(2) - tscls(1)
         if(mass.le.zpars(2))then
            mc1 = mcgbf(lums(4),GB,lums(6))
            mc2 = mcagbf(mass)
            lums(5) = lzahbf(mass,mc1,zpars(2))
            tscls(3) = tHef(mass,mc1,zpars(2))
         else
            lums(5) = lHef(mass)*lums(4)
            tscls(3) = tHef(mass,1.d0,zpars(2))*tscls(1)
         endif
      else
* Note that for M>zpars(3) there is no GB as the star goes from
* HG -> CHeB -> AGB. So in effect tscls(1) refers to the time of
* Helium ignition and not the BGB.
         tscls(2) = tscls(1)
         tscls(3) = tHef(mass,1.d0,zpars(2))*tscls(1)
* This now represents the luminosity at the end of CHeB, ie. BAGB
         lums(5) = lums(7)
* We set lums(3) to be the luminosity at the end of the HG
         lums(3) = lums(4)
      endif
*
* Set the core mass at the BGB.
*
      if(mass.le.zpars(2))then
         GB(9) = mcgbf(lums(3),GB,lums(6))
      elseif(mass.le.zpars(3))then
         GB(9) = mcheif(mass,zpars(2),zpars(9))
      else
         GB(9) = mcheif(mass,zpars(2),zpars(10))
      endif
*
* FAGB time parameters
*
      tbagb = tscls(2) + tscls(3)
      tscls(7) = tbagb + (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &               ((GB(4)/lums(7))**((GB(5)-1.d0)/GB(5)))
      tscls(9) = tscls(7) - (tscls(7) - tbagb)*((lums(7)/lums(6))
     &                                    **((GB(5)-1.d0)/GB(5)))
      tscls(8) = tscls(9) + (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &               ((GB(3)/lums(6))**((GB(6)-1.d0)/GB(6)))
*
* Now to find Ltp and ttp using Mc,He,tp
*
      mcbagb = mcagbf(mass)
      mc1 = mcbagb
      if(mc1.ge.0.8d0.and.mc1.lt.2.25d0)then
* The star undergoes dredge-up at Ltp causing a decrease in Mc,He
         mc1 = 0.44d0*mc1 + 0.448d0
      endif
      lums(8) = lmcgbf(mc1,GB)
      if(mc1.le.GB(7))then
         tscls(13) = tscls(7) - (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &                   (mc1**(1.d0-GB(5)))
      else
         tscls(13) = tscls(8) - (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &                   (mc1**(1.d0-GB(6)))
      endif
*
* SAGB time parameters
*
      if(mc1.le.GB(7))then
         tscls(10) = tscls(13) + (1.d0/((GB(5)-1.d0)*GB(2)*GB(4)))*
     &               ((GB(4)/lums(8))**((GB(5)-1.d0)/GB(5)))
         tscls(12) = tscls(10) - (tscls(10) - tscls(13))*
     &               ((lums(8)/lums(6))**((GB(5)-1.d0)/GB(5)))
         tscls(11) = tscls(12) + (1.d0/((GB(6)-1.d0)*GB(2)*GB(3)))*
     &               ((GB(3)/lums(6))**((GB(6)-1.d0)/GB(6)))
      else
         tscls(10) = tscls(7)
         tscls(12) = tscls(9)
         tscls(11) = tscls(13) + (1.d0/((GB(6)-1.d0)*GB(2)*GB(3)))*
     &               ((GB(3)/lums(8))**((GB(6)-1.d0)/GB(6)))
      endif
*
* Get an idea of when Mc,C = Mc,C,max on the AGB
      tau = tscls(2) + tscls(3)
      mc2 = mcgbtf(tau,GB(8),GB,tscls(7),tscls(8),tscls(9))
      mcmax = MAX(MAX(mch,0.773d0*mcbagb - 0.35d0),1.05d0*mc2)
*
      if(mcmax.le.mc1)then
         if(mcmax.le.GB(7))then
            tscls(14) = tscls(7) - (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &                      (mcmax**(1.d0-GB(5)))
         else
            tscls(14) = tscls(8) - (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &                      (mcmax**(1.d0-GB(6)))
         endif
      else
* Star is on SAGB and we need to increase mcmax if any 3rd
* dredge-up has occurred.
         lambdastar = MIN(0.9d0,0.3d0+0.001d0*mass**5)
         mcmax = (mcmax - lambdastar*mc1)/(1.d0 - lambdastar)
         if(mcmax.le.GB(7))then
            tscls(14) = tscls(10) - (1.d0/((GB(5)-1.d0)*GB(2)*GB(4)))*
     &                      (mcmax**(1.d0-GB(5)))
         else
            tscls(14) = tscls(11) - (1.d0/((GB(6)-1.d0)*GB(2)*GB(3)))*
     &                      (mcmax**(1.d0-GB(6)))
         endif
      endif
      tscls(14) = MAX(tbagb,tscls(14))
C      if(mass.ge.100.d0)then
C         tn = tscls(2)
C         goto 100
C      endif
*
* Calculate the nuclear timescale - the time of exhausting
* nuclear fuel without further mass loss.
* This means we want to find when Mc = Mt which defines Tn and will
* be used in determining the timestep required. Note that after some
* stars reach Mc = Mt there will be a Naked Helium Star lifetime
* which is also a nuclear burning period but is not included in Tn.
*
      if(ABS(mt-mcbagb).lt.1.0d-14.and.kw.lt.5)then
         tn = tbagb
      else
* Note that the only occurence of Mc being double-valued is for stars
* that have a dredge-up. If Mt = Mc where Mc could be the value taken
* from CHeB or from the AGB we need to check the current stellar type.
         if(mt.gt.mcbagb.or.(mt.ge.mc1.and.kw.gt.4))then
            if(kw.eq.6)then
               lambdastar = MIN(0.9d0,0.3d0+0.001d0*mass**5)
               mc1 = (mt - lambdastar*mc1)/(1.d0 - lambdastar)
            else
               mc1 = mt
            endif
            if(mc1.le.GB(7))then
               tn = tscls(10) - (1.d0/((GB(5)-1.d0)*GB(2)*GB(4)))*
     &                         (mc1**(1.d0-GB(5)))
            else
               tn = tscls(11) - (1.d0/((GB(6)-1.d0)*GB(2)*GB(3)))*
     &                         (mc1**(1.d0-GB(6)))
            endif
         else
            if(mass.gt.zpars(3))then
               mc1 = mcheif(mass,zpars(2),zpars(10))
               if(mt.le.mc1)then
                  tn = tscls(2)
               else
                  tn = tscls(2) + tscls(3)*((mt - mc1)/(mcbagb - mc1))
               endif
            elseif(mass.le.zpars(2))then
               mc1 = mcgbf(lums(3),GB,lums(6))
               mc2 = mcgbf(lums(4),GB,lums(6))
               if(mt.le.mc1)then
                  tn = tscls(1)
               elseif(mt.le.mc2)then
                  if(mt.le.GB(7))then
                     tn = tscls(4) - (1.d0/((GB(5)-1.d0)*GB(1)*GB(4)))*
     &                               (mt**(1.d0-GB(5)))
                  else
                     tn = tscls(5) - (1.d0/((GB(6)-1.d0)*GB(1)*GB(3)))*
     &                               (mt**(1.d0-GB(6)))
                  endif
               else
                  tn = tscls(2) + tscls(3)*((mt - mc2)/(mcbagb - mc2))
               endif
            else
               mc1 = mcheif(mass,zpars(2),zpars(9))
               mc2 = mcheif(mass,zpars(2),zpars(10))
               if(mt.le.mc1)then
                  tn = tscls(1)
               elseif(mt.le.mc2)then
                  tn = tscls(1) + tgb*((mt - mc1)/(mc2 - mc1))
               else
                  tn = tscls(2) + tscls(3)*((mt - mc2)/(mcbagb - mc2))
               endif
            endif
         endif
      endif
      tn = MIN(tn,tscls(14))
*
      goto 100
*
 90   continue
*
* Calculate Helium star Main Sequence lifetime.
*
      tm = themsf(mass)
      tscls(1) = tm
*
* Zero- and terminal age Helium star main sequence luminosity
*
      lums(1) = lzhef(mass)
      am = MAX(0.d0,0.85d0-0.08d0*mass)
      lums(2) = lums(1)*(1.d0+0.45d0+am)
*
* Set the Helium star GB parameters
*
      GB(8) = 8.0d-05
      GB(3) = 4.1d+04
      GB(4) = 5.5d+04/(1.d0+0.4d0*mass**4)
      GB(5) = 5.d0
      GB(6) = 3.d0
      GB(7) = (GB(3)/GB(4))**(1.d0/(GB(5)-GB(6)))
* Change in slope of giant L-Mc relation.
      lums(6) = GB(4)*GB(7)**GB(5)
*
*** Set Helium star GB timescales
*
      mc1 = mcgbf(lums(2),GB,lums(6))
      tscls(4) = tm + (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &                                          mc1**(1.d0-GB(5))
      tscls(6) = tscls(4) - (tscls(4) - tm)*((GB(7)/mc1)
     &                                     **(1.d0-GB(5)))
      tscls(5) = tscls(6) + (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &                                       GB(7)**(1.d0-GB(6))
*
* Get an idea of when Mc = MIN(Mt,Mc,C,max) on the GB
      mtc = MIN(mt,1.45d0*mt-0.31d0)
      if(mtc.le.0.d0) mtc = mt
      mcmax = MIN(mtc,MAX(mch,0.773d0*mass-0.35d0))
      if(mcmax.le.GB(7))then
         tscls(14) = tscls(4) - (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &                   (mcmax**(1.d0-GB(5)))
      else
         tscls(14) = tscls(5) - (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &                   (mcmax**(1.d0-GB(6)))
      endif
      tscls(14) = MAX(tscls(14),tm)
      tn = tscls(14)
*
      goto 100
*
 95   continue
      tm = 1.0d+10
      tscls(1) = tm
 96   continue
      tn = 1.0d+10
*
 100  continue
      mass = mass0
*
      return
      end
***

***
      real*8 FUNCTION mlwind(kw,lum,r,mt,mc,rl,z)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
      integer kw,testflag
      real*8 lum,r,mt,mc,rl,z,teff,alpha
      real*8 dml,dms,dmt,p0,x,mew,lum0,kap
      real*8 MLalpha
      external MLalpha
      parameter(lum0=7.0d+04,kap=-0.5d0)
*
*      windflag = 0 !BSE=0, startrack08=1, vink=2, vink+LBV for all
*      stars=3.
* Must be one of these values or mlwind will cause problem with code,
* i.e. mlwind not set (see last line of main if statement...).
    
      if(windflag.eq.0)then
* BSE
*
* Calculate stellar wind mass loss.
*
* Apply mass loss of Nieuwenhuijzen & de Jager, A&A, 1990, 231, 134,
* for massive stars over the entire HRD.
         dms = 0.d0
         if(lum.gt.4000.d0)then
            x = MIN(1.d0,(lum-4000.d0)/500.d0)
            dms = 9.6d-15*x*(r**0.81d0)*(lum**1.24d0)*(mt**0.16d0)
            alpha = 0.5d0
            dms = dms*(z/zsun)**(alpha)
         endif
         if(kw.ge.2.and.kw.le.9)then
* 'Reimers' mass loss
            dml = neta*4.0d-13*r*lum/mt
            if(rl.gt.0.d0) dml =
     &         dml*(1.d0 + bwind*(MIN(0.5d0,(r/rl)))**6)
* Apply mass loss of Vassiliadis & Wood, ApJ, 1993, 413, 641,
* for high pulsation periods on AGB.
            if(kw.eq.5.or.kw.eq.6)then
               p0 = -2.07d0 - 0.9d0*log10(mt) + 1.94d0*log10(r)
               p0 = 10.d0**p0
               p0 = MIN(p0,2000.d0)
               dmt = -11.4d0+0.0125d0*(p0-100.d0*MAX(mt-2.5d0,0.d0))
               dmt = 10.d0**dmt
               dmt = 1.d0*MIN(dmt,1.36d-09*lum)
               dml = MAX(dml,dmt)
            endif
            if(kw.gt.6)then
               dms = MAX(dml,1.0d-13*hewind*lum**(3.d0/2.d0))
            else
               dms = MAX(dml,dms)
               mew = ((mt-mc)/mt)*MIN(5.d0,MAX(1.2d0,(lum/lum0)**kap))
* reduced WR-like mass loss for small H-envelope mass
               if(mew.lt.1.d0)then
                  dml = 1.0d-13*lum**(3.d0/2.d0)*(1.d0 - mew)
                  dms = MAX(dml,dms)
               endif
* LBV-like mass loss beyond the Humphreys-Davidson limit.
               x = 1.0d-5*r*sqrt(lum)
               if(lum.gt.6.0d+05.and.x.gt.1.d0)then
                  dml = 0.1d0*(x-1.d0)**3*(lum/6.0d+05-1.d0)
                  dms = dms + dml
               endif
            endif
         endif
*
         mlwind = dms
      elseif(windflag.eq.1)then
* StarTrack (Beclzynski+08)
*
* Calculate stellar wind mass loss.
*
* Apply mass loss of Nieuwenhuijzen & de Jager, A&A, 1990, 231, 134,
* for massive stars over the entire HRD, with no luminosity limit
* according to Belczynsk+08 pp. 174.
*
* This may not be what is actually assumed in StarTrack (see the windf1 function).
*
*
         dms = 0.d0
         if(lum.gt.4000.d0.or.(kw.ge.0.and.kw.le.1))then
            if(lum.gt.4000.d0)then
               x = MIN(1.d0,(lum-4000.d0)/500.d0)
            else
               x = 0.1d0/500.d0
            endif !or is it simply x = Min(1, lum/500)?
            dms = 9.6d-15*x*(r**0.81d0)*(lum**1.24d0)*(mt**0.16d0)
            alpha = 0.5d0
            dms = dms*(z/zsun)**(alpha)
         endif
         if(kw.ge.2.and.kw.le.9)then
* 'Reimers' mass loss
            dml = neta*4.0d-13*r*lum/mt
            if(rl.gt.0.d0) dml =
     &         dml*(1.d0 + bwind*(MIN(0.5d0,(r/rl)))**6)
* Apply mass loss of Vassiliadis & Wood, ApJ, 1993, 413, 641,
* for high pulsation periods on AGB.
            if(kw.eq.5.or.kw.eq.6)then
               p0 = -2.07d0 - 0.9d0*log10(mt) + 1.94d0*log10(r)
               p0 = 10.d0**p0
               p0 = MIN(p0,2000.d0)
               dmt = -11.4d0+0.0125d0*(p0-100.d0*MAX(mt-2.5d0,0.d0))
               dmt = 10.d0**dmt
               dmt = 1.d0*MIN(dmt,1.36d-09*lum)
               dml = MAX(dml,dmt)
            endif
            if(kw.gt.6)then
               dms = MAX(dml,1.0d-13*lum**(3.d0/2.d0)) !hewind here for KH06, not included for StarTrack...
            else
               dms = MAX(dml,dms)
               mew = ((mt-mc)/mt)*MIN(5.d0,MAX(1.2d0,(lum/lum0)**kap))
* reduced WR-like mass loss for small H-envelope mass
               if(mew.lt.1.d0)then
                  dml = 1.0d-13*lum**(3.d0/2.d0)*(1.d0 - mew)
                  dms = MAX(dml,dms)
               endif
* LBV-like mass loss beyond the Humphreys-Davidson limit.
               x = 1.0d-5*r*sqrt(lum)
               if(lum.gt.6.0d+05.and.x.gt.1.d0)then
                  dml = 0.1d0*(x-1.d0)**3*(lum/6.0d+05-1.d0)
                  dms = dms + dml
               endif
            endif
         endif
*
         mlwind = dms
      elseif(windflag.eq.2.or.windflag.eq.3)then
* Vink winds etc according to as implemented following
* Belczynski, Bulik, Fryer, Ruiter, Valsecchi, Vink & Hurley 2010.
*
* Firstly implement BSE 'old' winds that cover all other stars not
* accounted for by Vink winds (see Belczynski+09). Then implement
* Vink et al. winds.
*
* We also include the option for a variable metallicity-dependent mass
* loss parameter which eddlimflag is set, which makes the metallicity
* dependence become weaker as the star approaches the electron-scattering
* Eddington limit (Grafener & Hamann 2008, Giacobbo et al. 2018)
*
         teff = 1000.d0*((1130.d0*lum/(r**2.d0))**(1.d0/4.d0))
         dms = 0.d0
         if(lum.gt.4000.d0)then
* Apply mass loss of Nieuwenhuijzen & de Jager, A&A, 1990, 231, 134,
* for massive stars over the entire HRD after OB stars accounted for.
            x = MIN(1.d0,(lum-4000.d0)/500.d0)
            dms = 9.6d-15*x*(r**0.81d0)*(lum**1.24d0)*(mt**0.16d0)
            alpha = 0.5d0
            dms = dms*(z/zsun)**(alpha)
            testflag = 1
         endif
         if(kw.ge.2.and.kw.le.6)then
* 'Reimers' mass loss
            dml = neta*4.0d-13*r*lum/mt
            if(rl.gt.0.d0) dml =
     &         dml*(1.d0 + bwind*(MIN(0.5d0,(r/rl)))**6)
* Apply mass loss of Vassiliadis & Wood, ApJ, 1993, 413, 641,
* for high pulsation periods on AGB.
            if(kw.eq.5.or.kw.eq.6)then
               p0 = -2.07d0 - 0.9d0*log10(mt) + 1.94d0*log10(r)
               p0 = 10.d0**p0
               p0 = MIN(p0,2000.d0)
               dmt = -11.4d0+0.0125d0*(p0-100.d0*MAX(mt-2.5d0,0.d0))
               dmt = 10.d0**dmt
               dmt = 1.d0*MIN(dmt,1.36d-09*lum)
               dml = MAX(dml,dmt)
            endif
            dms = MAX(dms,dml)
         endif
* Apply Vink, de Koter & Lamers (2001) OB star winds.
* Next check if hot massive H-rich O/B star in appropriate temperature ranges.
         if(teff.ge.12500.and.teff.le.25000)then
            if(eddlimflag.eq.0) alpha = 0.85d0
            if(eddlimflag.eq.1) alpha = MLalpha(mt,lum,kw)
            dms = -6.688d0 + 2.210d0*LOG10(lum/1.0d+05) -
     &            1.339d0*LOG10(mt/30.d0) - 1.601d0*LOG10(1.3d0/2.d0) +
     &            alpha*LOG10(z/zsun) + 1.07d0*LOG10(teff/2.0d+04)
            dms = 10.d0**dms
            testflag = 2
         elseif(teff.gt.25000.)then
*        Although Vink et al. formulae  are only defined until Teff=50000K,
*        we follow the Dutch prescription of MESA, and extend to higher Teff
             dms = -6.697d0 + 2.194d0*LOG10(lum/1.0d+05) -
     &            1.313d0*LOG10(mt/30.d0) - 1.226d0*LOG10(2.6d0/2.d0) +
     &            alpha*LOG10(z/zsun) +0.933d0*LOG10(teff/4.0d+04) -
     &            10.92d0*(LOG10(teff/4.0d+04)**2)
       dms = 10.d0**dms
       testflag = 2
         endif

         if((windflag.eq.3.or.kw.ge.2).and.kw.le.6)then
* LBV-like mass loss beyond the Humphreys-Davidson limit.
* Optional flag (windflag=3) to use for every non-degenerate star
* past the limit, rather than just for giant, evolved stars
            x = 1.0d-5*r*sqrt(lum)
            if(lum.gt.6.0d+05.and.x.gt.1.d0)then
               if(eddlimflag.eq.0) alpha = 0.d0
               if(eddlimflag.eq.1) alpha = MLalpha(mt,lum,kw)
               dms = 1.5d0*1.0d-04*((z/zsun)**alpha)
               testflag = 3
            endif
         elseif(kw.ge.7.and.kw.le.9)then !WR (naked helium stars)
* If naked helium use Hamann & Koesterke (1998) WR winds reduced by factor of
* 10 (Yoon & Langer 2005), with Vink & de Koter (2005) metallicity dependence
            if(eddlimflag.eq.0) alpha = 0.86d0
            if(eddlimflag.eq.1) alpha = MLalpha(mt,lum,kw)
            dms = 1.0d-13*(lum**1.5d0)*((z/zsun)**alpha)
            testflag = 4
         endif
*
         mlwind = dms
      elseif(windflag.eq.4)then
*
* Calculate stellar wind mass loss following MIST as closely as possible
*
         dms = 0.d0
         if(kw.ge.0.and.kw.le.9)then
* 'Reimers' mass loss over the whole HRD
            dml = 0.1*4.0d-13*r*lum/mt
            if(rl.gt.0.d0) dml =
     &         dml*(1.d0 + bwind*(MIN(0.5d0,(r/rl)))**6)
* Apply mass loss of Blocker 1995 for AGB.
            if(kw.eq.5.or.kw.eq.6)then
               dml = 4.83d-9*0.2*dml/0.1*((lum)**2.7)/((mt)**2.1)
            endif
            if(kw.gt.6)then
               dms = MAX(dml,1.0d-13*hewind*lum**(3.d0/2.d0))
            else
               dms = MAX(dml,dms)
               mew = ((mt-mc)/mt)*MIN(5.d0,MAX(1.2d0,(lum/lum0)**kap))
* reduced WR-like mass loss for small H-envelope mass
               if(mew.lt.1.d0)then
                  dml = 1.0d-13*lum**(3.d0/2.d0)*(1.d0 - mew)
                  dms = MAX(dml,dms)
               endif
* LBV-like mass loss beyond the Humphreys-Davidson limit.
               x = 1.0d-5*r*sqrt(lum)
               if(lum.gt.6.0d+05.and.x.gt.1.d0)then
                  dml = 0.1d0*(x-1.d0)**3*(lum/6.0d+05-1.d0)
                  dms = dms + dml
               endif
            endif
         endif
*
         mlwind = dms
      
      endif

      return
      end
***

***
* New flag introduced (August 2023)
* rtmsflag = 0 uses the SSE rtms for stars EXCEPT if M>200Msun 
* and Z<0.0008(~0.04Zsun). For the exception, an extrapolation
* is used (check the code in function rtmsf for details). This 
* ad hoc extrapolation works well for stars with M < 4000Msun 
* for Z >= 0.01Zsun. For lower metallicities, you may still run
* into issues of rtms<0 for very massive stars (i.e. for Z<0.01Zsun
* use at your own risk)
*
* rtmsflag > 0 uses rtms from simulation data (1=[BoOST], 2=[BPASS])
* Only common metallicity cases between BoOST & BPASS are coded.
*
* BoOST metallicities = [1.1e-4, 2.1e-4, 1e-3, 2e-3] corresponding
* to [dwarfD, IZw18, dwarfA, SMC] models (Szecsi et al. (2022))
*
* BPASS metallicities = [1e-4, *2e-4*, 1e-3, 2e-3]. 
* NOTE : For BPASS, we used a power law to fit the rtms v/s mzams 
* values for each metallicity. We have coded the best fit power-laws
* for the above BPASS metallicities here.Since, Z = 2e-4 model is 
* not available in the BPASS tracks, we assume the same rtms v/s 
* mzams power law as Z=1e-4 for Z=2e-4.
*
***
      real*8 FUNCTION lzamsf(m)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
      real*8 m,mx,a(200)
      common /MSCFF/ a
*
* A function to evaluate Lzams
* ( from Tout et al., 1996, MNRAS, 281, 257 ).
*
      mx = SQRT(m)
      lzamsf = (a(1)*m**5*mx + a(2)*m**11)/
     &         (a(3) + m**3 + a(4)*m**5 + a(5)*m**7 +
     &          a(6)*m**8 + a(7)*m**9*mx)
*
      return
      end
***
      real*8 FUNCTION rzamsf(m)
      implicit none
      real*8 m,mx,a(200)
      common /MSCFF/ a
*
* A function to evaluate Rzams
* ( from Tout et al., 1996, MNRAS, 281, 257 ).
*
      mx = SQRT(m)
      rzamsf = ((a(8)*m**2 + a(9)*m**6)*mx + a(10)*m**11 +
     &          (a(11) + a(12)*mx)*m**19)/
     &         (a(13) + a(14)*m**2 +
     &          (a(15)*m**8 + m**18 + a(16)*m**19)*mx)
*
      return
      end
***
      real*8 FUNCTION tbgbf(m)
      implicit none
      real*8 m,a(200)
      common /MSCFF/ a
*
* A function to evaluate the lifetime to the BGB or to
* Helium ignition if no FGB exists.
* (JH 24/11/97)
*
      tbgbf = (a(17) + a(18)*m**4 + a(19)*m**(11.d0/2.d0) + m**7)/
     &        (a(20)*m**2 + a(21)*m**7)
*
      return
      end
***
      real*8 FUNCTION tbgbdf(m)
      implicit none
      real*8 m,mx,f,df,g,dg,a(200)
      common /MSCFF/ a
*
* A function to evaluate the derivitive of the lifetime to the BGB
* (or to Helium ignition if no FGB exists) wrt mass.
* (JH 24/11/97)
*
      mx = SQRT(m)
      f = a(17) + a(18)*m**4 + a(19)*m**5*mx + m**7
      df = 4.d0*a(18)*m**3 + 5.5d0*a(19)*m**4*mx + 7.d0*m**6
      g = a(20)*m**2 + a(21)*m**7
      dg = 2.d0*a(20)*m + 7.d0*a(21)*m**6
      tbgbdf = (df*g - f*dg)/(g*g)
*
      return
      end
***
      real*8 FUNCTION tbgdzf(m)
      implicit none
      real*8 m,mx,f,df,g,dg,a(200)
      common /MSCFF/ a
*
* A function to evaluate the derivitive of the lifetime to the BGB
* (or to Helium ignition if no FGB exists) wrt Z.
* (JH 14/12/98)
*
      mx = m**5*SQRT(m)
      f = a(17) + a(18)*m**4 + a(19)*mx + m**7
      df = a(117) + a(118)*m**4 + a(119)*mx
      g = a(20)*m**2 + a(21)*m**7
      dg = a(120)*m**2
      tbgdzf = (df*g - f*dg)/(g*g)
*
      return
      end
***
      real*8 FUNCTION thookf(m)
      implicit none
      real*8 m,a(200)
      common /MSCFF/ a
*
* A function to evaluate the lifetime to the end of the MS
* hook ( for those models that have one ) as a fraction of
* the lifetime to the BGB
* Note that this function is only valid for M > Mhook.
* (JH 24/11/97)
*
      thookf = 1.d0 - 0.01d0*MAX(a(22)/m**a(23),a(24)+a(25)/m**a(26))
      thookf = MAX(thookf,0.5d0)
*
      return
      end
***
      real*8 FUNCTION ltmsf(m)
      implicit none
      real*8 m,a(200)
      common /MSCFF/ a
*
* A function to evaluate the luminosity at the end of the MS
* (JH 24/11/97)
*
      ltmsf = (a(27)*m**3 + a(28)*m**4 + a(29)*m**(a(32)+1.8d0))/
     &        (a(30) + a(31)*m**5 + m**a(32))
*
      return
      end
***
      real*8 FUNCTION lalphf(m)
      implicit none
      real*8 m,mcut,a(200)
      common /MSCFF/ a
*
* A function to evaluate the Luminosity alpha coefficent.
* (JH 24/11/97)
*
      mcut = 2.d0
      if(m.ge.mcut)then
         lalphf = (a(33) + a(34)*m**a(36))/(m**0.4d0 + a(35)*m**1.9d0)
      else
         if(m.le.0.5d0)then
            lalphf = a(39)
         elseif(m.le.0.7d0)then
            lalphf = a(39) + ((0.3d0 - a(39))/0.2d0)*(m - 0.5d0)
         elseif(m.le.a(37))then
            lalphf = 0.3d0 + ((a(40)-0.3d0)/(a(37)-0.7d0))*(m - 0.7d0)
         elseif(m.le.a(38))then
            lalphf = a(40) + ((a(41)-a(40))/(a(38)-a(37)))*(m - a(37))
         else
            lalphf = a(41) + ((a(42)-a(41))/(mcut-a(38)))*(m - a(38))
         endif
      endif
*
      return
      end
***
      real*8 FUNCTION lbetaf(m)
      implicit none
      real*8 m,a1,a(200)
      common /MSCFF/ a
*
* A function to evaluate the Luminosity beta coefficent.
* (JH 24/11/97)
*
      lbetaf = a(43) - a(44)*m**a(45)
      lbetaf = MAX(lbetaf,0.d0)
      if(m.gt.a(46).and.lbetaf.gt.0.d0)then
         a1 = a(43) - a(44)*a(46)**a(45)
         lbetaf = a1 - 10.d0*a1*(m - a(46))
         lbetaf = MAX(lbetaf,0.d0)
      endif
*
      return
      end
***
      real*8 FUNCTION lnetaf(m)
      implicit none
      real*8 m,a(200)
      common /MSCFF/ a
*
* A function to evaluate the Luminosity neta exponent.
* (JH 24/11/97)
*
      if(m.le.1.d0)then
         lnetaf = 10.d0
      elseif(m.ge.1.1d0)then
         lnetaf = 20.d0
      else
         lnetaf = 10.d0 + 100.d0*(m - 1.d0)
      endif
      lnetaf = MIN(lnetaf,a(97))
*
      return
      end
***
      real*8 FUNCTION lhookf(m,mhook)
      implicit none
      real*8 m,mhook,a2,a(200)
      common /MSCFF/ a
*
* A function to evalute the luminosity at the start of
* the MS hook ( for those stars that have one ).
* Note that this function is only valid for M > Mhook.
* (JH 24/11/97)
*
      if(m.le.mhook)then
         lhookf = 0.d0
      elseif(m.ge.a(51))then
         lhookf = MIN(a(47)/m**a(48),a(49)/m**a(50))
      else
         a2 = MIN(a(47)/a(51)**a(48),a(49)/a(51)**a(50))
         lhookf = a2*((m-mhook)/(a(51)-mhook))**0.4d0
      endif
*
      return
      end
***
      real*8 FUNCTION rtmssse(m)
      implicit none
      real*8 m,m2,rchk,a(200)
      common /MSCFF/ a
      real*8 rzamsf
      external rzamsf
*
* A function to evaluate the radius at the end of the MS
* Note that a safety check is added to ensure Rtms > Rzams
* when extrapolating the function to low masses.
* (JH 24/11/97)
*
      m2 = a(62) + 0.1d0
      if(m.le.a(62))then
         rchk = 1.5d0*rzamsf(m)
         rtmssse = MAX(rchk,(a(52) + a(53)*m**a(55))/(a(54) + m**a(56)))
      elseif(m.ge.m2)then
         rtmssse = (a(57)*m**3+a(58)*m**a(61)+a(59)*m**(a(61)+1.5d0))/
     &           (a(60) + m**5)
      else
         rtmssse = a(63) + ((a(64) - a(63))/0.1d0)*(m - a(62))
      endif
*
      return
      end

***
*** NEW CODE BETWEEN THESE LINES (BEGIN)

      real*8 FUNCTION rtmsf(m, met)
      implicit none
      INCLUDE 'const_bse.h'
      real*8 m,met,Rtms200,Rtms199,slope
      real*8 rtmssse, rtmsBoost, rtmsBpass
      external rtmssse
*
* For Z < 0.04 Z_sun (i.e. Z < 0.0008) the polynomial fitting extrapolation of
* Hurley et al. leads to negative stellar radii at the end of the main sequence.
* This fix calculates the slope of the Rtms-M curve for a given Z at M=200 and
* extrapolates the Rtms linearly for M>200Msun assuming the same slope. The fix
* is only applied to stars with Z < 0.0008 and M > 200Msun
*
      if (rtmsflag .eq. 0) then
*         print*,'inside cosmic conditional'
         if( (m .le. 200.0) .OR. (met .ge. 0.0008) )then
            rtmsf = rtmssse(m)
         else
            Rtms200 = rtmssse(DFLOAT(200))
            Rtms199 =  rtmssse(DFLOAT(199))
            slope = Rtms200 - Rtms199;
            rtmsf = Rtms200 + slope*(m-200.0)
*            print*,'RTMSF inside the else', met,m,Rtms200, Rtms199,
*     &               slope,rtmsf
         endif

      elseif (rtmsflag .eq. 1) then
*         print*,'inside Boost conditional'
         rtmsf = rtmsBoost(m, met)

      elseif (rtmsflag .eq. 2) then
*         print*,'inside BPASS conditional'
         rtmsf = rtmsBpass(m, met)

      else
         print*,'Specify a valid value of rtmsflag'

      endif
*      print*,'met, m, rtmsf, rtmsflag', met, m, rtmsf, rtmsflag
      return
      end
*
      real*8 FUNCTION interp(val, arrsize, arr1, arr2, extrapolate)
          implicit none
          character(*) extrapolate
          integer j, idx_u, idx_l, arrsize
          real*8 val, arr1(arrsize), arr2(arrsize), num, den, slp

          if (arr1(1) .gt. val) then
              idx_u = 2
              idx_l = 1
              num = (arr2(idx_u) - arr2(idx_l))
              den = arr1(idx_u) - arr1(idx_l)
              slp = num/den
              interp = arr2(idx_l) - slp * (arr1(idx_l) - val)
*              print*,'inside 1st if', interp, arr1(1), val
          else
              if (arr1(arrsize) .ge. val) then
                  do j = 1, arrsize
                      if (arr1(j) .ge. val) then
*                      print*, 'arr1[j]', arr1(j)
                      idx_u = j
                      exit
                      end if
                  end do
                  idx_l = idx_u - 1
                  num = (arr2(idx_u) - arr2(idx_l))
                  den = arr1(idx_u) - arr1(idx_l)
                  slp = num/den
                  interp = slp * (val - arr1(idx_l)) + arr2(idx_l)
*                  print*,'inside else - if', num, den
              else
                  if (extrapolate == 'const') then
                      interp = arr2(arrsize)
*                      print*,'inside else - else - if'
                  else
                      idx_u = arrsize
                      idx_l = idx_u - 1
                      num = (arr2(idx_u) - arr2(idx_l))
                      den = arr1(idx_u) - arr1(idx_l)
                      slp = num/den
                      interp = slp*(val - arr1(idx_u)) + arr2(idx_u)
*                      print*,'inside else - else - else'
                  endif
              endif
          endif
      return
      end FUNCTION interp
****
      real*8 FUNCTION rtmsBoost(m, met)
      implicit none
      external interp
      real*8 m,met,met_cut1,met_cut2
      real*8 interp, rzams, rtms
      real*8 mBoost(10), RZBoost(10), RTBoost(10)
      integer j, idx_l, idx_u
      met_cut1 = 0.9*met
      met_cut2 = 1.1*met
*      print*, 'mass is ', m, LOG10(m)
*      print*,'met_cut1, met_cut2 :', met_cut1, met_cut2
*
      if ( (1.1d-4 .ge. met_cut1) .and. (1.1d-4 .le. met_cut2) ) then
         mBoost = (/9., 12., 19., 30., 40., 55., 80., 100.,250.,560./)
         RZBoost = (/2.43392, 2.92073, 3.86161, 4.99635, 5.86427,
     &      6.98092, 8.5704 , 9.68978, 16.1026 , 24.6849/)
         RTBoost = (/6.68652, 8.35836, 12.2768, 19.1216, 26.1014,
     &      34.7308, 50.2973, 63.3516, 696.887, 477.342/)
*         print*,'inside if'
*
      elseif ((2.1d-4 .ge. met_cut1) .and. (2.1d-4 .le. met_cut2)) then
         mBoost = (/9.0d0, 1.7d1, 2.0d1, 2.6d1, 4.5d1,
     &     7.7d1, 1.0d2, 1.5d2, 2.57d2, 5.75d2/)
         RZBoost = (/2.55385, 3.78012, 4.16676, 4.84233, 6.56514,
     &      8.81132, 10.1899, 12.7489, 17.242, 26.9047/)
         RTBoost = (/7.10581, 10.5842, 12.005, 17.6989, 31.5715,
     &      57.746, 85.7318, 265.117, 381.817, 64.2087/)
*         print*,'inside else if 1'
*
      elseif((1.05d-3 .ge. met_cut1) .and. (1.05d-3 .le. met_cut2))then
         mBoost = (/9., 12., 19., 30., 40., 55., 100., 150.,250.,560./)
         RZBoost = (/2.90528, 3.4664, 4.54792, 5.89715, 6.90964,
     &     8.23824, 11.4877, 14.4754, 19.4907, 30.4307/)
         RTBoost = (/8.34864, 10.3943, 13.3912, 22.0983, 33.0246,
     &     67.575, 144.839, 152.163, 337.615, 226.371/)
*         print*,'inside else if 2'
*
      elseif( (2.1d-3 .ge. met_cut1) .and. (2.1d-3 .le. met_cut2) )then
         mBoost = (/9., 12., 15., 30., 40., 55., 100., 150.,250.,575./)
         RZBoost = (/3.07199, 3.65601, 4.17698, 6.19243, 7.26206,
     &      8.68025, 12.1746, 15.4243, 21.3749, 37.7439/)
         RTBoost = (/9.12709, 11.3397, 11.9156, 25.9153, 42.9715,
     &      153.085, 109.867, 241.077, 147.582, 195.808/)
*         print*,'inside else if 3'
      else
         print*,'mass and Rtms data for the given metallicity is not
     &      coded for the Boost models.'
      endif
*      print*,'mBoost is ', mBoost
*      print*,'RZBoost is ', RZBoost
*      print*,'RTBoost is ', RTBoost

*
*     We will interpolate in the log-log space.
      rtms = 10**interp(LOG10(m), size(mBoost), LOG10(mBoost),
     &                       LOG10(RTBoost), 'const')
      rzams = 10**interp(LOG10(m), size(mBoost), LOG10(mBoost),
     &                       LOG10(RZBoost), 'const')
      if (rzams .gt. rtms) then
          rtmsBoost = rzams
      else
          rtmsBoost = rtms
      endif
*      print*,'rtmsBoost, rzams, rtms are ', rtmsBoost, rzams, rtms, met
      return
      end
      real*8 function rtmsBpass(m, met)
      implicit none
      real*8 m, met, r0, alpha, met_cut1, met_cut2

      met_cut1 = 0.9*met
      met_cut2 = 1.1*met

      if ( (1.0d-4 .ge. met_cut1) .and. (1.0d-4 .le. met_cut2) ) then
          r0 = 1.43077288d0
          alpha = 6.2151019d-1

      elseif ((2.0d-4 .ge. met_cut1) .and. (2.0d-4 .le. met_cut2)) then
          r0 = 1.43077288d0
          alpha = 6.2151019d-1

      elseif ((1.0d-3 .ge. met_cut1) .and. (1.0d-3 .le. met_cut2)) then
          r0 = 8.1088547d-1
          alpha = 8.2732973d-1

      elseif ((2.0d-3 .ge. met_cut1) .and. (2.0d-3 .le. met_cut2)) then
          r0 = 4.8850513d-1
          alpha = 9.7369477d-1

      else
         print*,'mass and Rtms data for the given metallicity is not
     &      coded for the BPASS models.'
         r0 = 0.0
         alpha = 0.0

      endif

      rtmsBpass = r0*m**alpha

      return
      end function rtmsBpass

*** NEW CODE BETWEEN THESE LINES (END)
***
      real*8 FUNCTION ralphf(m)
      implicit none
      real*8 m,a5,a(200)
      common /MSCFF/ a
*
* A function to evaluate the radius alpha coefficent.
* (JH 24/11/97)
*
      if(m.le.0.5d0)then
         ralphf = a(73)
      elseif(m.le.0.65d0)then
         ralphf = a(73) + ((a(74) - a(73))/0.15d0)*(m - 0.5d0)
      elseif(m.le.a(70))then
         ralphf = a(74) + ((a(75)-a(74))/(a(70)-0.65d0))*(m - 0.65d0)
      elseif(m.le.a(71))then
         ralphf = a(75) + ((a(76) - a(75))/(a(71) - a(70)))*(m - a(70))
      elseif(m.le.a(72))then
         ralphf = (a(65)*m**a(67))/(a(66) + m**a(68))
      else
         a5 = (a(65)*a(72)**a(67))/(a(66) + a(72)**a(68))
         ralphf = a5 + a(69)*(m - a(72))
      endif
*
      return
      end
***
      real*8 FUNCTION rbetaf(m)
      implicit none
      real*8 m,m2,m3,b2,b3,a(200)
      common /MSCFF/ a
*
* A function to evaluate the radius beta coefficent.
* (JH 24/11/97)
*
      m2 = 2.d0
      m3 = 16.d0
      if(m.le.1.d0)then
         rbetaf = 1.06d0
      elseif(m.le.a(82))then
         rbetaf = 1.06d0 + ((a(81)-1.06d0)/(a(82)-1.d0))*(m-1.d0)
      elseif(m.le.m2)then
         b2 = (a(77)*m2**(7.d0/2.d0))/(a(78) + m2**a(79))
         rbetaf = a(81) + ((b2-a(81))/(m2-a(82)))*(m-a(82))
      elseif(m.le.m3)then
         rbetaf = (a(77)*m**(7.d0/2.d0))/(a(78) + m**a(79))
      else
         b3 = (a(77)*m3**(7.d0/2.d0))/(a(78) + m3**a(79))
         rbetaf = b3 + a(80)*(m - m3)
      endif
      rbetaf = rbetaf - 1.d0
*
      return
      end
***
      real*8 FUNCTION rgammf(m)
      implicit none
      real*8 m,m1,b1,a(200)
      common /MSCFF/ a
*
* A function to evaluate the radius gamma coefficent.
* (JH 24/11/97)
*
      m1 = 1.d0
      if(m.gt.(a(88)+0.1d0))then
         rgammf = 0.d0
      else
         b1 = MAX(0.d0,a(83) + a(84)*(m1-a(85))**a(86))
         if(m.le.m1)then
            rgammf = a(83) + a(84)*ABS(m-a(85))**a(86)
         elseif(m.le.a(88))then
            rgammf = b1 + (a(89) - b1)*((m - m1)/(a(88) - m1))**a(87)
         else
            if(a(88).gt.m1) b1 = a(89)
            rgammf = b1 - 10.d0*b1*(m - a(88))
         endif
         rgammf = MAX(rgammf,0.d0)
      endif
*
      return
      end
***
      real*8 FUNCTION rhookf(m,mhook)
      implicit none
      real*8 m,mhook,m2,b2,a(200)
      common /MSCFF/ a
*
* A function to evalute the radius at the start of
* the MS hook ( for those stars that have one ).
* Note that this function is only valid for M > Mhook.
* (JH 24/11/97)
*
      if(m.le.mhook)then
         rhookf = 0.d0
      elseif(m.le.a(94))then
         rhookf = a(95)*SQRT((m-mhook)/(a(94)-mhook))
      elseif(m.le.2.d0)then
         m2 = 2.d0
         b2 = (a(90) + a(91)*m2**(7.d0/2.d0))/
     &        (a(92)*m2**3 + m2**a(93)) - 1.d0
         rhookf = a(95) + (b2-a(95))*((m-a(94))/(m2-a(94)))**a(96)
      else
         rhookf = (a(90) + a(91)*m**(7.d0/2.d0))/
     &            (a(92)*m**3 + m**a(93)) - 1.d0
      endif
*
      return
      end
***
      real*8 FUNCTION lbgbf(m)
      real*8 m,a(200)
      common /GBCFF/ a
*
* A function to evaluate the luminosity at the end of the
* FGB ( for those models that have one )
* Note that this function is only valid for LM & IM stars
* (JH 24/11/97)
*
      lbgbf = (a(1)*m**a(5) + a(2)*m**a(8))/
     &        (a(3) + a(4)*m**a(7) + m**a(6))
*
      return
      end
***
      real*8 FUNCTION lbgbdf(m)
      real*8 m,a(200)
      real*8 f,df,g,dg
      common /GBCFF/ a
*
* A function to evaluate the derivitive of the Lbgb function.
* Note that this function is only valid for LM & IM stars
* (JH 24/11/97)
*
      f = a(1)*m**a(5) + a(2)*m**a(8)
      df = a(5)*a(1)*m**(a(5)-1.d0) + a(8)*a(2)*m**(a(8)-1.d0)
      g = a(3) + a(4)*m**a(7) + m**a(6)
      dg = a(7)*a(4)*m**(a(7)-1.d0) + a(6)*m**(a(6)-1.d0)
*
      lbgbdf = (df*g - f*dg)/(g*g)
*
      return
      end
***
      real*8 FUNCTION lbagbf(m,mhefl)
      implicit none
      real*8 m,mhefl,a4,a(200)
      common /GBCFF/ a
*
* A function to evaluate the BAGB luminosity. (OP 21/04/98)
* Continuity between LM and IM functions is ensured by setting
* gbp(16) = lbagbf(mhefl,0.0) with gbp(16) = 1.0.
*
      a4 = (a(9)*mhefl**a(10) - a(16))/(exp(mhefl*a(11))*a(16))
*
      if(m.lt.mhefl)then
         lbagbf = a(9)*m**a(10)/(1.d0 + a4*exp(m*a(11)))
      else
         lbagbf = (a(12) + a(13)*m**(a(15)+1.8d0))/(a(14) + m**a(15))
      endif
*
      return
      end
***
      real*8 FUNCTION rgbf(m,lum)
      implicit none
      real*8 m,lum,a1,a(200)
      common /GBCFF/ a
*
* A function to evaluate radius on the GB.
* (JH 24/11/97)
*
      a1 = MIN(a(20)/m**a(21),a(22)/m**a(23))
      rgbf = a1*(lum**a(18) + a(17)*lum**a(19))
*
      return
      end
***
      real*8 FUNCTION rgbdf(m,lum)
      implicit none
      real*8 m,lum,a1,a(200)
      common /GBCFF/ a
*
* A function to evaluate radius derivitive on the GB (as f(L)).
* (JH 24/11/97)
*
      a1 = MIN(a(20)/m**a(21),a(22)/m**a(23))
      rgbdf = a1*(a(18)*lum**(a(18)-1.d0) +
     &            a(17)*a(19)*lum**(a(19)-1.d0))
*
      return
      end
***
      real*8 FUNCTION ragbf(m,lum,mhelf)
      implicit none
      real*8 m,lum,mhelf,m1,a1,a4,xx,a(200)
      common /GBCFF/ a
*
* A function to evaluate radius on the AGB.
* (JH 24/11/97)
*
      m1 = mhelf - 0.2d0
      if(m.ge.mhelf)then
         xx = a(24)
      elseif(m.ge.m1)then
         xx = 1.d0 + 5.d0*(a(24)-1.d0)*(m-m1)
      else
         xx = 1.d0
      endif
      a4 = xx*a(19)
      if(m.le.m1)then
         a1 = a(29) + a(30)*m
      elseif(m.ge.mhelf)then
         a1 = MIN(a(25)/m**a(26),a(27)/m**a(28))
      else
         a1 = a(31) + 5.d0*(a(32)-a(31))*(m-m1)
      endif
*
      ragbf = a1*(lum**a(18) + a(17)*lum**a4)
*
      return
      end
***
      real*8 FUNCTION ragbdf(m,lum,mhelf)
      implicit none
      real*8 m,lum,mhelf,m1,a1,a4,xx,a(200)
      common /GBCFF/ a
*
* A function to evaluate radius derivitive on the AGB (as f(L)).
* (JH 24/11/97)
*
      m1 = mhelf - 0.2d0
      if(m.ge.mhelf)then
         xx = a(24)
      elseif(m.ge.m1)then
         xx = 1.d0 + 5.d0*(a(24)-1.d0)*(m-m1)
      else
         xx = 1.d0
      endif
      a4 = xx*a(19)
      if(m.le.m1)then
         a1 = a(29) + a(30)*m
      elseif(m.ge.mhelf)then
         a1 = MIN(a(25)/m**a(26),a(27)/m**a(28))
      else
         a1 = a(31) + 5.d0*(a(32)-a(31))*(m-m1)
      endif
*
      ragbdf = a1*(a(18)*lum**(a(18)-1.d0) +
     &             a(17)*a4*lum**(a4-1.d0))
*
      return
      end
***
      real*8 FUNCTION mctmsf(m)
      implicit none
      real*8 m,m525
*
* A function to evaluate core mass at the end of the MS as a
* fraction of the BGB value, i.e. this must be multiplied by
* the BGB value (see below) to give the actual core mass (JH 5/9/99)
*
      m525 = m**(21.d0/4.d0)
      mctmsf = (1.586d0 + m525)/(2.434d0 + 1.02d0*m525)
*
      return
      end
***
      real*8 FUNCTION mcheif(m,mhefl,mchefl)
      implicit none
      real*8 m,mhefl,mchefl,mcbagb,a3,a(200)
      common /GBCFF/ a
      real*8 mcagbf
      external mcagbf
*
* A function to evaluate core mass at BGB or He ignition
* (depending on mchefl) for IM & HM stars  (OP 25/11/97)
*
      mcbagb = mcagbf(m)
      a3 = mchefl**4 - a(33)*mhefl**a(34)
      mcheif = MIN(0.95d0*mcbagb,(a3 + a(33)*m**a(34))**(1.d0/4.d0))
*
      return
      end
***
      real*8 FUNCTION mheif(mc,mhefl,mchefl)
      implicit none
      real*8 mc,mhefl,mchefl,m1,m2,a3,a(200)
      common /GBCFF/ a
      real*8 mbagbf
      external mbagbf
*
* A function to evaluate mass at BGB or He ignition
* (depending on mchefl) for IM & HM stars by inverting
* mcheif
*
      m1 = mbagbf(mc/0.95d0)
      a3 = mchefl**4 - a(33)*mhefl**a(34)
      m2 = ((mc**4 - a3)/a(33))**(1.d0/a(34))
      mheif = MAX(m1,m2)
*
      return
      end
***
      real*8 FUNCTION mcagbf(m)
      implicit none
      real*8 m,a(200)
      common /GBCFF/ a
*
* A function to evaluate core mass at the BAGB  (OP 25/11/97)
*
      mcagbf = (a(37) + a(35)*m**a(36))**(1.d0/4.d0)
*
      return
      end
***
      real*8 FUNCTION mbagbf(mc)
      implicit none
      real*8 mc,mc4,a(200)
      common /GBCFF/ a
*
* A function to evaluate mass at the BAGB by inverting mcagbf.
*
      mc4 = mc**4
      if(mc4.gt.a(37))then
         mbagbf = ((mc4 - a(37))/a(35))**(1.d0/a(36))
      else
         mbagbf = 0.d0
      endif
*
      return
      end
***
      real*8 FUNCTION mcgbtf(t,A,GB,tinf1,tinf2,tx)
      implicit none
      real*8 t,A,GB(10),tinf1,tinf2,tx
*
* A function to evaluate Mc given t for GB, AGB and NHe stars
*
      if(t.le.tx)then
         mcgbtf = ((GB(5)-1.d0)*A*GB(4)*(tinf1 - t))**
     &                              (1.d0/(1.d0-GB(5)))
      else
         mcgbtf = ((GB(6)-1.d0)*A*GB(3)*(tinf2 - t))**
     &                              (1.d0/(1.d0-GB(6)))
      endif
*
      return
      end
***
      real*8 FUNCTION lgbtf(t,A,GB,tinf1,tinf2,tx)
      implicit none
      real*8 t,A,GB(10),tinf1,tinf2,tx
*
* A function to evaluate L given t for GB, AGB and NHe stars
*
      if(t.le.tx)then
         lgbtf = GB(4)*(((GB(5)-1.d0)*A*GB(4)*(tinf1 - t))**
     &                              (GB(5)/(1.d0-GB(5))))
      else
         lgbtf = GB(3)*(((GB(6)-1.d0)*A*GB(3)*(tinf2 - t))**
     &                              (GB(6)/(1.d0-GB(6))))
      endif
*
      return
      end
***
      real*8 FUNCTION mcgbf(lum,GB,lx)
      implicit none
      real*8 lum,GB(10),lx
*
* A function to evaluate Mc given L for GB, AGB and NHe stars
*
      if(lum.le.lx)then
         mcgbf = (lum/GB(4))**(1.d0/GB(5))
      else
         mcgbf = (lum/GB(3))**(1.d0/GB(6))
      endif
*
      return
      end
***
      real*8 FUNCTION lmcgbf(mc,GB)
      implicit none
      real*8 mc,GB(10)
*
* A function to evaluate L given Mc for GB, AGB and NHe stars
*
      if(mc.le.GB(7))then
         lmcgbf = GB(4)*(mc**GB(5))
      else
         lmcgbf = GB(3)*(mc**GB(6))
      endif
*
      return
      end
***
      real*8 FUNCTION lHeIf(m,mhefl)
      implicit none
      real*8 m,mhefl,a(200)
      common /GBCFF/ a
*
* A function to evaluate He-ignition luminosity  (OP 24/11/97)
* Continuity between the LM and IM functions is ensured with a first
* call setting lhefl = lHeIf(mhefl,0.0)
*
      if(m.lt.mhefl)then
         lHeIf = a(38)*m**a(39)/(1.d0 + a(41)*EXP(m*a(40)))
      else
         lHeIf = (a(42) + a(43)*m**3.8d0)/(a(44) + m**2)
      endif
*
      return
      end
***
      real*8 FUNCTION lHef(m)
      implicit none
      real*8 m,a(200)
      common /GBCFF/ a
*
* A function to evaluate the ratio LHe,min/LHeI  (OP 20/11/97)
* Note that this function is everywhere <= 1, and is only valid
* for IM stars
*
      lHef = (a(45) + a(46)*m**(a(48)+0.1d0))/(a(47) + m**a(48))
*
      return
      end
***
      real*8 FUNCTION rminf(m)
      implicit none
      real*8 m,mx,a(200)
      common /GBCFF/ a
*
* A function to evaluate the minimum radius during He-burning
* for IM & HM stars  (OP 20/11/97)
*
      mx = m**a(53)
      rminf = (a(49)*m + (a(50)*m)**a(52)*mx)/(a(51) + mx)
*
      return
      end
***
      real*8 FUNCTION tHef(m,mc,mhefl)
      implicit none
      real*8 m,mc,mhefl,mm,a(200)
      common /GBCFF/ a
      real*8 themsf
      external themsf
*
* A function to evaluate the He-burning lifetime.  (OP 26/11/97)
* For IM & HM stars, tHef is relative to tBGB.
* Continuity between LM and IM stars is ensured by setting
* thefl = tHef(mhefl,0.0,,0.0), and the call to themsf ensures
* continuity between HB and NHe stars as Menv -> 0.
*
      if(m.le.mhefl)then
         mm = MAX((mhefl - m)/(mhefl - mc),1.0d-12)
         tHef = (a(54) + (themsf(mc) - a(54))*mm**a(55))*
     &          (1.d0 + a(57)*EXP(m*a(56)))
      else
         mm = m**5
         tHef = (a(58)*m**a(61) + a(59)*mm)/(a(60) + mm)
      endif
*
      return
      end
***
      real*8 FUNCTION tblf(m,mhefl,mfgb)
      implicit none
      real*8 m,mhefl,mfgb,mr,m1,m2,r1,a(200)
      common /GBCFF/ a
      real*8 lheif,rminf,ragbf
      external lheif,rminf,ragbf
*
* A function to evaluate the blue-loop fraction of the He-burning
* lifetime for IM & HM stars  (OP 28/01/98)
*
      mr = mhefl/mfgb
      if(m.le.mfgb) then
         m1 = m/mfgb
         m2 = log10(m1)/log10(mr)
         m2 = max(m2,1.0d-12)
         tblf = a(64)*m1**a(63) + a(65)*m2**a(62)
      else
         r1 = 1.d0 - rminf(m)/ragbf(m,lheif(m,mhefl),mhefl)
         r1 = max(r1,1.0d-12)
         tblf = a(66)*m**a(67)*r1**a(68)
      end if
      tblf = MIN(1.d0,MAX(0.d0,tblf))
      if(tblf.lt.1.0d-10) tblf = 0.d0
*
      return
      end
***
      real*8 FUNCTION lzahbf(m,mc,mhefl)
      implicit none
      real*8 m,mc,mhefl,mm,a4,a5,a(200)
      common /GBCFF/ a
      real*8 lzhef
      external lzhef
*
* A function to evaluate the ZAHB luminosity for LM stars. (OP 28/01/98)
* Continuity with LHe,min for IM stars is ensured by setting
* lx = lHeif(mhefl,z,0.0,1.0)*lHef(mhefl,z,mfgb), and the call to lzhef
* ensures continuity between the ZAHB and the NHe-ZAMS as Menv -> 0.
*
      a5 = lzhef(mc)
      a4 = (a(69) + a5 - a(74))/((a(74) - a5)*exp(a(71)*mhefl))
      mm = MAX((m-mc)/(mhefl - mc),1.0d-12)
      lzahbf = a5 + (1.d0 + a(72))*a(69)*mm**a(70)/
     &         ((1.d0 + a(72)*mm**a(73))*(1.d0 + a4*EXP(m*a(71))))
*
      return
      end
***
      real*8 FUNCTION rzahbf(m,mc,mhefl)
      implicit none
      real*8 m,mc,mhefl,rx,ry,mm,f,a(200)
      common /GBCFF/ a
      real*8 rzhef,rgbf,lzahbf
*
* A function to evaluate the ZAHB radius for LM stars. (OP 28/01/98)
* Continuity with R(LHe,min) for IM stars is ensured by setting
* lx = lHeif(mhefl,z,0.0,1.0)*lHef(mhefl,z,mfgb), and the call to rzhef
* ensures continuity between the ZAHB and the NHe-ZAMS as Menv -> 0.
*
      rx = rzhef(mc)
      ry = rgbf(m,lzahbf(m,mc,mhefl))
      mm = MAX((m-mc)/(mhefl - mc),1.0d-12)
      f = (1.d0 + a(76))*mm**a(75)/(1.d0 + a(76)*mm**a(77))
      rzahbf = (1.d0 - f)*rx + f*ry
*
      return
      end
***
      real*8 FUNCTION lzhef(m)
      implicit none
      real*8 m,m15
*
* A function to evaluate Naked Helium star 'ZAMS' luminosity
*
      m15 = m*SQRT(m)
      lzhef = 1.5262d+04*m**(41.d0/4.d0)/
     &        (0.0469d0 + m**6*(31.18d0 + m15*(29.54d0 + m15)))
*
      return
      end
***
      real*8 FUNCTION rzhef(m)
      implicit none
      real*8 m
*
* A function to evaluate Helium star 'ZAMS' radius
*
      rzhef = 0.2391d0*m**4.6d0/(0.0065d0 + (0.162d0 + m)*m**3)
*
      return
      end
***
      real*8 FUNCTION themsf(m)
      implicit none
      real*8 m
*
* A function to evaluate Helium star main sequence lifetime
*
      themsf = (0.4129d0 + 18.81d0*m**4 + 1.853d0*m**6)/m**(13.d0/2.d0)
*
      return
      end
***
      real*8 FUNCTION rhehgf(m,lum,rx,lx)
      implicit none
      real*8 m,lum,rx,lx,cm
*
* A function to evaluate Helium star radius on the Hertzsprung gap
* from its mass and luminosity.
*
      cm = 2.0d-03*m**(5.d0/2.d0)/(2.d0 + m**5)
      rhehgf = rx*(lum/lx)**0.2d0 + 0.02d0*(EXP(cm*lum) - EXP(cm*lx))
*
      return
      end
***
      real*8 FUNCTION rhegbf(lum)
      implicit none
      real*8 lum
*
* A function to evaluate Helium star radius on the giant branch.
*
      rhegbf = 0.08d0*lum**(3.d0/4.d0)
*
      return
      end
***
      real*8 FUNCTION lpertf(m,mew)
      implicit none
      real*8 m,mew
      real*8 b,c
*
* A function to obtain the exponent that perturbs luminosity.
*
      b = 0.002d0*MAX(1.d0,2.5d0/m)
      c = 3.d0
      lpertf = ((1.d0 + b**c)*((mew/b)**c))/(1.d0+(mew/b)**c)
*
      return
      end
***
      real*8 FUNCTION rpertf(m,mew,r,rc)
      implicit none
      real*8 m,mew,r,rc
      real*8 a,b,c,q,fac,facmax
*
* A function to obtain the exponent that perturbs radius.
*
      if(mew.le.0.d0)then
         rpertf = 0.d0
      else
         a = 0.1d0
         b = 0.006d0*MAX(1.d0,2.5d0/m)
         c = 3.d0
         q = log(r/rc)
         fac = a/q
         facmax = -14.d0/log10(mew)
         fac = MIN(fac,facmax)
         rpertf = ((1.d0 + b**c)*((mew/b)**c)*(mew**fac))/
     &            (1.d0+(mew/b)**c)
      endif
*
      return
      end
***
      real*8 FUNCTION vrotf(m,ST)
      implicit none
      integer ST
      real*8 m
*
      if(ST.gt.0)then
         if(m.gt.6.35d0)then
            vrotf = (10.d0*m**(-0.0354d0))/(0.0389d0+m**(-7.95d0))
         else
            vrotf = (13.4d0*m**(-0.12d0))/(0.0389d0+m**(-7.95d0))
         endif
      else
         vrotf = 330.d0*m**3.3d0/(15.d0 + m**3.45d0)
      endif
*
      return
      end
***
      real*8 FUNCTION celamf(kw,m,lum,rad,rzams,menv,fac)
      implicit none
      integer kw
      real*8 m,lum,rad,rzams,menv,fac
      real*8 lam1,lam2,m1,logm,logl
      real*8 aa,bb,cc,dd
*
* A function to estimate lambda for common-envelope.
*
      if(fac.ge.0.d0)then
*
* No fits yet for naked He stars...
*
         if(kw.gt.6)then
            celamf = 0.5d0
            goto 90
         endif
*
         if(menv.gt.0.d0)then
* Formulae for giant-like stars; also used for HG and CHeB stars close
* to the Hayashi track.
            logl = log10(lum)
            logm = log10(m)
            if(kw.le.5)then
               m1 = m
               if(kw.gt.3) m1 = 100.d0
               lam1 = 3.d0/(2.4d0 + 1.d0/m1**(3.d0/2.d0)) - 0.15d0*logl
               lam1 = MIN(lam1,0.8d0)
            else
               lam1 = -3.5d0 - 0.75d0*logm + logl
            endif
            if(kw.gt.3)then
               lam2 = MIN(0.9d0,0.58d0 + 0.75d0*logm) - 0.08d0*logl
               if(kw.lt.6)then
                  lam1 = MIN(lam2,lam1)
               else
                  lam1 = MAX(lam2,lam1)
                  lam1 = MIN(lam1,1.d0)
               endif
            endif
            lam1 = 2.d0*lam1
            if(fac.gt.0.d0)then
* Use a fraction FAC of the ionization energy in the energy balance.
               if(kw.le.3)then
                  aa = MIN(1.2d0*(logm - 0.25d0)**2 - 0.7d0,-0.5d0)
               else
                  aa = MAX(-0.2d0 - logm,-0.5d0)
               endif
               bb = MAX(3.d0 - 5.d0*logm,1.5d0)
               cc = MAX(3.7d0 + 1.6d0*logm,3.3d0 + 2.1d0*logm)
               lam2 = aa + ATAN(bb*(cc - logl))
               if(kw.le.3)then
                  dd = MAX(0.d0,MIN(0.15d0,0.15d0 - 0.25d0*logm))
                  lam2 = lam2 + dd*(logl - 2.d0)
               endif
               lam2 = MAX(lam2,1.d-2)
               lam2 = MAX(1.d0/lam2,lam1)
               if(fac.ge.1.d0)then
                  lam1 = lam2
               else
                  lam1 = lam1 + fac*(lam2 - lam1)
               endif
            endif
         endif
*
         if(menv.lt.1.d0)then
* Formula for HG stars; also reasonable for CHeB stars in blue loop.
            lam2 = 0.42d0*(rzams/rad)**0.4d0
* Alternatively:
*           lam2 = 0.3d0*(rtms/rad)**0.4d0
            lam2 = 2.d0*lam2
         endif
*
         if(menv.le.0.d0)then
            celamf = lam2
         elseif(menv.ge.1.d0)then
            celamf = lam1
         else
* Interpolate between HG and GB values depending on conv. envelope mass.
            celamf = lam2 + sqrt(menv)*(lam1 - lam2)
         endif
*
 90      continue
*
      else
         celamf = -1.d0*fac
      endif
*
      return
      end
***
      real*8 FUNCTION MLalpha(m,lum,kw)
      implicit none
      integer kw
      real*8 m,lum,loggammae,gammae,Xh
*
* A function for calculating the alpha factor for metallicity-dependent
* winds from Grafener et al. 2011
* (MZ 04/08/19)
*

* First, determine the hydrogen fraction as in Graefener et al. 2011
      if(kw.ge.7 .and. kw.lt.10)then
*        WR stars
         Xh = 0.d0
      else
*        Assume metallicities for different kstars
         if(kw.eq.0 .or. kw.eq.1)then
            Xh = 0.7d0
         elseif(kw.eq.2)then
            Xh = 0.6d0
         elseif(kw.eq.3)then
            Xh = 0.5d0
         elseif(kw.eq.4)then
            Xh = 0.4d0
         elseif(kw.eq.5 .or. kw.eq.6)then
            Xh = 0.2d0
        endif
      endif

      loggammae = -4.813d0 + LOG10(1.d0+xh) + LOG10(lum) - LOG10(m)
      gammae = 10.0d0**(loggammae)
      if(gammae.gt.1d0)then
         gammae = 1.d0
      endif

* calculate metallicity scaling parameter alpha
      if(gammae.lt.(2.d0/3.d0))then
         MLalpha = 0.85d0
      elseif(gammae.ge.(2.d0/3.d0))then
         MLalpha = 2.45d0 - (2.4d0 * gammae)
      endif
*
      return
      end

***
      SUBROUTINE evolv2(kstar,mass,tb,ecc,z,tphysf,
     \ dtp,mass0,rad,lumin,massc,radc,
     \ menv,renv,ospin,B_0,bacc,tacc,epoch,tms,
     \ bhspin,tphys,zpars,bkick,kick_info,
     \ bpp_index_out,bcm_index_out,kick_info_out)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
      INCLUDE 'checkstate.h'
***
*
*           B I N A R Y
*           ***********
*
*       Roche lobe overflow.
*       --------------------
*
*       Developed by Jarrod Hurley, IOA, Cambridge.
*       .........................................................
*
*       Advice by Christopher Tout, Onno Pols & Sverre Aarseth.
*       ++++++++++++++++++++++++++++++++++++++++++++++++++
*
* Adapted from Aarseth's code 21st September 1996.
* Fully revised on 27th November 1996 to remove vestiges of N-body code and
* incorporate corrections.
* Fully revised on 1st April 1998 to include new stellar evolution formulae
* and associated binary evolution changes.
* Fully revised on 4th July 1998 to include eccentricity, tidal
* circularization, wind accretion, velocity kicks for supernovae and all
* associated orbital momentum changes.
*
***
*
* See Tout et al., 1997, MNRAS, 291, 732 for a description of many of the
* processes in this code as well as the relevant references mentioned
* within the code.
*
* Reference for the stellar evolution formulae is Hurley, Pols & Tout,
* 2000, MNRAS, 315, 543 (SSE paper).
* Reference for the binary evolution algorithm is Hurley, Tout & Pols,
* 2002, MNRAS, 329, 897 (BSE paper).
*
***
*
* March 2001 *
* Changes since version 3, i.e. since production of Paper3:
*
* 1) The Eddington limit flag (on/off) has been replaced by an
*    Eddington limit multiplicative factor (eddfac). So if you
*    want to neglect the Eddington limit you would set eddfac
*    to a large value.
*
* 2) To determine whether material transferred during RLOF forms
*    an accretion disk around the secondary or hits the secondary
*    in a direct stream we calculate a minimum radial distance, rmin,
*    of the mass stream from the secondary. This is taken from eq.(1)
*    of Ulrich & Burger (1976, ApJ, 206, 509) which they fitted to
*    the calculations of Lubow & Shu (1974, ApJ, 198, 383).
*    If rmin is less than the radius of the secondary then an
*    accretion disk is not formed.
*    Note that the formula for rmin given by Ulrich & Burger is valid
*    for all q whereas that given by Nelemans et al. (2001, A&A,
*    submitted) in their eq.(6) is only valid for q < 1 where
*    they define q = Mdonor/Maccretor, i.e. DD systems.
*
* 3) The changes to orbital and spin angular momentum owing to
*    RLOF mass transfer have been improved, and an new input option
*    now exists.
*    When mass is lost from the system during RLOF there are now
*    three choices as to how the orbital angular momentum is
*    affected: a) the lost material carries with it a fraction
*    gamma of the orbital angular momentum, i.e.
*    dJorb = gamma*dm*a^2*omega_orb; b) the material carries with it
*    the specific angular momentum of the primary, i.e.
*    dJorb = dm*a_1^2*omega_orb; or c) assume the material is lost
*    from the system as if a wind from the secondary, i.e.
*    dJorb = dm*a_2^2*omega_orb.
*    The parameter gamma is an input option.
*    Choice c) is used if the mass transfer is super-Eddington
*    or the system is experiencing novae eruptions.
*    In all other cases choice a) is used if gamma > 0.0, b) if
*    gamma = -1.0 and c) is used if gamma = -2.0.
*    The primary spin angular momentum is reduced by an amount
*    dm1*r_1^2*omega_1 when an amount of mass dm1 is transferred
*    from the primary.
*    If the secondary accretes through a disk then its spin
*    angular momentum is altered by assuming that the material
*    falls onto the star from the inner edge of a Keplerian
*    disk and that the system is in a steady state, i.e.
*    an amount dm2*SQRT(G*m_2*r_2).
*    If there is no accretion disk then we calculate the angular
*    momentum of the transferred material by using the radius at
*    at which the disk would have formed (rdisk = 1.7*rmin, see
*    Ulrich & Burger 1976) if allowed, i.e. the angular momentum
*    of the inner Lagrangian point, and add this directly to
*    the secondary, i.e. an amount dm2*SQRT(G*m_2*rdisk).
*    Total angular momentum is conserved in this model.
*
* 4) Now using q_crit = 3.0 for MS-MS Roche systems (previously we
*    had nothing). This corresponds roughly to R proportional to M^5
*    which should be true for the majority of the MS (varies from
*    (M^17 -> M^2). If q > q_crit then contact occurs.
*    For CHeB primaries we also take q_crit = 3.0 and allow
*    common-envelope to occur if this is exceeded.
*
* 5) The value of lambda used in calculations of the envelope binding
*    energy for giants in common-envelope is now variable (see function
*    in zfuncs). The lambda function has been fitted by Onno to detailed
*    models ... he will write about this soon!
*
* 6) Note that eq.42 in the paper is missing a SQRT around the
*    MR^2/a^5 part. This needs to be corrected in any code update
*    paper with a thanks to Jeremy Sepinsky (student at NorthWestern).
*    It is ok in the code.
*
* March 2003 *
* New input options added:
*
*    ifflag - for the mass of a WD you can choose to use the mass that
*             results from the evolution algorithm (basically a competition
*             between core-mass growth and envelope mass-loss) or use the IFMR
*             proposed by Han, Podsiadlowski & Eggleton, 1995, MNRAS, 272, 800
*             [>0 activates HPE IFMR].
*
*    wdflag - for the cooling of WDs you can choose to use either the standard
*             Mestel cooling law (see SSE paper) or a modified-Mestel law that
*             is better matched to detailed models (provided by Brad Hansen
*             ... see Hurley & Shara, 2003, ApJ, May 20, in press)
*             [>0 activates modified-Mestel].
*
*    bhflag - choose whether or not black holes should get velocity kicks
*             at formation
*             [0= no kick; >0 kick].
*
*    remnantflag - for the mass of neutron stars and black holes you can use either
*             the SSE prescription or the prescription presented by
*             Belczynski et al. 2002, ApJ, 572, 407 who found that SSE was
*             underestimating the masses of these stars. In either case you also
*             need to set the maximum NS mass (mxns) for the prescription
*             [0= SSE, mxns=1.8; >0 Belczynski, mxns=3.0].
*
* Sept 2004 *
* Input options added/changed:
*
*    ceflag - set to 1 this uses de Kool (or Podsiadlowski) CE prescription,
*             other options, such as Yungelson, could be added as well.
*
*    hewind - factor to control the amount of He star mass-loss, i.e.
*             1.0e-13*hewind*L^(2/3) gives He star mass-loss.
*
*
*       ++++++++++++++++++++++++++++++++++++++++++++++++++
***
*
      INTEGER loop,iter,intpol,k,ip,jp,j1,j2
      INTEGER bcm_index_out, bpp_index_out
      INTEGER kcomp1,kcomp2,formation(2)
      PARAMETER(loop=20000)
      INTEGER kstar(2),kw,kst,kw1,kw2,kmin,kmax
      INTEGER kstar1_bpp,kstar2_bpp
*
      REAL*8 km,km0,tphys,tphys0,dtm0,tphys00,tphysfhold
      REAL*8 tphysf,dtp,tsave,dtp_original
      REAL*8 aj(2),aj0(2),epoch(2),tms(2),tbgb(2),tkh(2),dtmi(2)
      REAL*8 mass0(2),mass(2),massc(2),menv(2),mass00(2),mcxx(2)
      REAL*8 mass1_bpp,mass2_bpp
      REAL*8 rad(2),rol(2),rol0(2),rdot(2),radc(2),renv(2),radx(2)
      REAL*8 lumin(2),k2str(2),q(2),dms(2),dmr(2),dmt(2)
      REAL*8 dml,vorb2,vwind2,omv2,ivsqm,lacc,kick_info(2,18)
      REAL*8 bkick(20)
      REAL*8 kick_info_out(2,18)
      REAL*8 sep,dr,tb,dme,tdyn,taum,dm1,dm2,dmchk,qc,dt,pd,rlperi
      REAL*8 m1ce,m2ce,mch,tmsnew,dm22,mew
      PARAMETER(mch=1.44d0)
      REAL*8 yeardy,yearsc,aursun
      PARAMETER(yeardy=365.24d0,aursun=214.95d0,yearsc=3.1557d+07)
      REAL*8 acc1,tiny
      PARAMETER(acc1=3.920659d+08,tiny=1.0d-14)
      REAL*8 ecc,ecc1,tc,tcirc,ttid,ecc2,omecc2,sqome2,sqome3,sqome5
      REAL*8 f1,f2,f3,f4,f5,f,raa2,raa6,eqspin,rg2,tcqr,gammadisc
      REAL*8 k3,mr23yr,twopi
      PARAMETER(k3=0.21d0,mr23yr=0.4311d0)
      REAL*8 jspin(2),ospin(2),jorb,oorb,jspbru,ospbru
      REAL*8 bhspin(2)
      REAL*8 delet,delet1,dspint(2),djspint(2),djtx(2)
      REAL*8 dtj,djorb,djgr,djmb,djt,djtt,rmin,rdisk
      REAL*8 etaBH,maxspinBH
*
      INTEGER pulsar
      INTEGER mergemsp,merge_mem,notamerger,binstate,mergertype
      REAL*8 fallback,sigmahold
      REAL*8 vk,u1,u2,s,Kconst,betahold,convradcomp(2),teff(2)
      REAL*8 B_0(2),bacc(2),tacc(2),xip,xihold
      REAL*8 deltam1_bcm,deltam2_bcm,b01_bcm,b02_bcm
      REAL*8 B(2),Bbot,omdot,b_mdot,b_mdot_lim,evolve_type
      COMMON /fall/fallback
      REAL ran3
      EXTERNAL ran3
*

*
      REAL*8 z,tm,tn,m0,mt,rm,lum,mc,rc,me,re,k2,age,dtm,dtr
      REAL*8 tscls(20),lums(10),GB(10),zpars(20)
      REAL*8 zero,ngtv,ngtv2,mt2,rrl1,rrl2,mcx,teff1,teff2
      REAL*8 mass1i,mass2i,tbi,ecci
      LOGICAL coel,com,prec,inttry,change,snova,sgl
      LOGICAL supedd,novae,disk,inspiral
      LOGICAL iplot,isave
      REAL*8 rl,mlwind,vrotf,corerd,f_fac
      EXTERNAL rl,mlwind,vrotf,corerd
*
      REAL*8 kw3,wsun,wx
      PARAMETER(kw3=619.2d0,wsun=9.46d+07,wx=9.46d+08)
      LOGICAL output
*
      REAL*8 qc_fixed
      LOGICAL switchedCE,disrupt

Cf2py intent(in) kstar
Cf2py intent(in) mass
Cf2py intent(in) tb
Cf2py intent(in) ecc
Cf2py intent(in) z
Cf2py intent(in) tphysf
Cf2py intent(in) dtp
Cf2py intent(in) mass0
Cf2py intent(in) rad
Cf2py intent(in) lumin
Cf2py intent(in) massc
Cf2py intent(in) radc
Cf2py intent(in) menv
Cf2py intent(in) renv
Cf2py intent(in) ospin
Cf2py intent(in) B_0
Cf2py intent(in) bacc
Cf2py intent(in) tacc
Cf2py intent(in) epoch
Cf2py intent(in) tms
Cf2py intent(in) bhspin
Cf2py intent(in) tphys
Cf2py intent(in) zpars
Cf2py intent(in) bkick
Cf2py intent(in) kick_info
Cf2py intent(out) bpp_index_out
Cf2py intent(out) bcm_index_out
Cf2py intent(out) kick_info_out

      if(using_cmc.eq.0)then
              CALL instar
      endif

*
* Save the initial state.
*

*      CE2flag = 0
      kstar1_bpp = 0
      kstar2_bpp = 0

      mass1_bpp = 0.d0
      mass2_bpp = 0.d0

      mass1i = mass(1)
      mass2i = mass(2)
      tbi = tb
      ecci = ecc
*
      zero = 0.d0
      ngtv = -1.d0
      ngtv2 = -2.d0
      twopi = 2.d0*ACOS(-1.d0)

      Mbh_initial = 0.d0


* disrupt tracks if system get disrupted by a SN during the common
* envelope
      disrupt = .false.
* value for bcm[ii,37] which tracks binary state; 0 for binary, 1 for merger, 2 for disrupted
      binstate = 0
* value for bcm[ii,38] which tracks merger types; only set when binstate is 1
* the logic is to combine kstar values of merged objects. so 1313 or 0809.
      mergertype = -1
*Captures original sigma so after ECSN we can reset it.
      sigmahold = sigma
*memory for wind mass loss factor
      betahold = beta

** SET PULSAR VALUES HERE**
* PDK
      pulsar = 1 ! allows for pulsar physics; not a flag since we heart pulsars
      Kconst = 2.5d-49
      Bbot = 5e+7 !100.d0 or ~d+07.
      b_mdot_lim = -1.0e-11 !limiting accretion induced field decay with mdot as a proxy for
*                           accretion temperature and number of impurities.
      xihold = xi
      xip = 1 !Modifies NS wind ang. mom. accretion.
      formation(1) = 0 !helps determine formation channel of interesting systems.
      formation(2) = 0
      pisn_track(1) = 0 !tracks whether a PISN occurred for each
component.
      pisn_track(2) = 0
      merger = -1 !used in CMC to track systems that dynamically merge
      notamerger = 0 !if 0 you reset the merger NS product to new factory settings else you don't.
      mergemsp = 1 !if set to 1 any NS that merges with another star where the NS is an MSP stays an MSP...
      merge_mem = 0
      output = .false.  ! .true. turns on, .false. turns off.
*                       WARNING: can fill up the output file very quickly.
*                       With N=2e6 .stdout was 3.2 GB in 6 mins. If needed you can
*                       be more selective with outputting, but must add this yourself!
*      if(id1_pass.eq.1)then!.and.tphysf.gt.17.50d0.and.
**     &   tphysf.lt.17.6d0)then
*         output = .true.
*      endif
*
* Initialize the parameters.
*

      if(using_cmc.eq.0)then
          bcm_index_out = 0
          bpp_index_out = 0
          kick_info_out = 0.d0
      endif


*
* Set the seed for the random number generator.
*
*      idum1 = INT(sep*100)
      if(idum1.gt.0.and.using_cmc.eq.0) idum1 = -idum1

*
* Set the collision matrix.
*
      if(using_cmc.eq.0)then
          CALL zcnsts(z,zpars)
      endif

      kmin = 1
      kmax = 2
      sgl = .false.
      mt2 = MIN(mass(1),mass(2))
      kst = 0
      iter = 0 ! PDK addition, just incase you bail out before 4 loop (usually from multiple calls for one evolve)
*
      if(mt2.lt.tiny.or.tb.le.0.d0)then
         sgl = .true.
         if(mt2.lt.tiny)then
            mt2 = 0.d0
            if(mass(1).lt.tiny)then
               if(tphys.lt.tiny)then
                  mass0(1) = 0.01d0
                  mass(1) = mass0(1)
                  kst = 1
               else
                  kmin = 2
                  lumin(1) = 1.0d-10
                  rad(1) = 1.0d-10
                  massc(1) = 0.d0
                  dmt(1) = 0.d0
                  dmr(1) = 0.d0
               endif
               ospin(1) = 1.0d-10
               jspin(1) = 1.0d-10
               dtmi(1) = 5.0d+04 !5Gyr, added for use of single stars in evolv2.f
            else
               if(tphys.lt.tiny)then
                  mass0(2) = 0.01d0
                  mass(2) = mass0(2)
                  kst = 2
               else
                  kmax = 1
                  lumin(2) = 1.0d-10
                  rad(2) = 1.0d-10
                  massc(2) = 0.d0
                  dmt(2) = 0.d0
                  dmr(2) = 0.d0
               endif
               ospin(2) = 1.0d-10
               jspin(2) = 1.0d-10
               dtmi(2) = 5.0d+04 !5Gyr, added for use of single stars in evolv2.f
            endif
         endif
         ecc = -1.d0
         tb = 0.d0
         sep = 1.0d+10
         oorb = 0.d0
         jorb = 0.d0
         if(kstar(1).ne.14.d0.or.using_cmc.eq.0) bhspin(1) = 0.d0
         if(kstar(2).ne.14.d0.or.using_cmc.eq.0) bhspin(2) = 0.d0
         if(ospin(1).lt.0.0) ospin(1) = 1.0d-10
         if(ospin(2).lt.0.0) ospin(2) = 1.0d-10
         q(1) = 1.0d+10
         q(2) = 1.0d+10
         rol(1) = 1.0d+10
         rol(2) = 1.0d+10
      else
         tb = tb/yeardy
         sep = aursun*(tb*tb*(mass(1) + mass(2)))**(1.d0/3.d0)
         oorb = twopi/tb
         jorb = mass(1)*mass(2)/(mass(1)+mass(2))
     &          *SQRT(1.d0-ecc*ecc)*sep*sep*oorb
         if(ospin(1).lt.0.d0) ospin(1) = oorb
         if(ospin(2).lt.0.d0) ospin(2) = oorb
      endif
*
      do 500 , k = kmin,kmax
         age = tphys - epoch(k)
         mc = massc(k)
         rc = radc(k)
         CALL star(kstar(k),mass0(k),mass(k),tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(mass0(k),age,mass(k),tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kstar(k),mc,rc,me,re,k2,bhspin(k),k)
         aj(k) = age
         epoch(k) = tphys - age
         rad(k) = rm
         lumin(k) = lum
         teff(k) = 1000.d0*((1130.d0*lumin(k)/
     &                    (rad(k)**2.d0))**(1.d0/4.d0))
         massc(k) = mc
         radc(k) = rc
         menv(k) = me
         renv(k) = re
         k2str(k) = k2
         tms(k) = tm
         tbgb(k) = tscls(1)
*
         if(tphys.lt.tiny.and.ospin(k).le.0.001d0)then
            ospin(k) = 45.35d0*vrotf(mass(k),ST_tide)/rm
         endif
         jspin(k) = ospin(k)*(k2*rm*rm*(mass(k)-mc)+k3*rc*rc*mc)
         if(.not.sgl)then
            q(k) = mass(k)/mass(3-k)
            rol(k) = rl(q(k))*sep*(1.d0-ecc)
         endif
         rol0(k) = rol(k)
         dmr(k) = 0.d0
         dmt(k) = 0.d0
         djspint(k) = 0.d0
         dtmi(k) = 1.0d+06
         B(k) = 0.d0 !PK
         if(kstar(k).ne.13)then
            bacc(k) = 0.d0
            tacc(k) = 0.d0
         endif
*
 500  continue
*
      if(output) write(*,*)'Init:',mass(1),mass(2),massc(1),massc(2),
     & rad(1),rad(2),kstar(1),kstar(2),sep,ospin(1),ospin(2),jspin(1),
     & jspin(2),sigma,eddfac,z,id1_pass,id2_pass,tphysf,tphys,iter,tsave
*
      if(mt2.lt.tiny)then
         sep = 0.d0
         if(kst.gt.0)then
            mass0(kst) = 0.d0
            mass(kst) = 0.d0
            kmin = 3 - kst
            kmax = kmin
         endif
      endif
*
* On the first entry the previous timestep is zero to prevent mass loss.
*
      dtm = 0.d0
      delet = 0.d0
      djorb = 0.d0
*
* Setup variables which control the output (if it is required).
*
      ip = 0
      jp = 0

      dtp_original = dtp

      tsave = tphys
      isave = .true.
      iplot = .false.
      if(dtp.le.0.d0)then
         iplot = .true.
         isave = .false.
         tsave = tphysf
      elseif(dtp.gt.tphysf)then
         isave = .false.
         tsave = tphysf
      endif
      if(tphys.ge.tphysf) goto 140

 4    iter = 0
      intpol = 0
      inttry = .false.
      change = .false.
      prec = .false.
      snova = .false.
      coel = .false.
      com = .false.
      inspiral = .false.
      tphys0 = tphys
      ecc1 = ecc
      j1 = 1
      j2 = 2
      if(kstar(1).ge.10.and.kstar(1).le.14) dtmi(1) = 0.01d0
      if(kstar(2).ge.10.and.kstar(2).le.14) dtmi(2) = 0.01d0
      dm1 = 0.d0
      dm2 = 0.d0
*
 5    kw1 = kstar(1)
      kw2 = kstar(2)

      if(xi.eq.0)then
         ospin(1) = 1.0d-10
         ospin(2) = 1.0d-10
      endif

*
      dt = 1.0d+06*dtm
      eqspin = 0.d0
      djtt = 0.d0
*
      if(output) write(*,*)'1st in 5: ',tphys,dt,kw1,kw2,
     & mass(1),mass(2),intpol,iter
*
      if(intpol.eq.0.and.ABS(dtm).gt.tiny.and..not.sgl)then
         vorb2 = acc1*(mass(1)+mass(2))/sep
         ivsqm = 1.d0/SQRT(1.d0-ecc*ecc)
         do 501 , k = 1,2
*
* Determine the eddington limit for the accretor (3-k)
* Just in case the wind mass loss rates are *very* high
*
            dme = 2.08d-03*eddfac*(1.d0/(1.d0 + zpars(11)))*rad(3-k)
* For BHs, follow Marchant et al. 2017
            if(kstar(3-k).eq.14)then
               maxspinBH = 6.d0**(1.d0/2.d0) * Mbh_initial
               if(mass(3-k).lt.maxspinBH)then
                  etaBH = 1.d0 -
     &    (1.d0 - (mass(3-k)/(3.d0*Mbh_initial))**(2.d0))**(1.d0/2.d0)
               else
                  etaBH = 0.42
               endif
               dme = 1.04e-3*eddfac*(1.d0/(1.d0 + zpars(11)))
     &    *(1.d0/etaBH)*rad(3-k)
            endif

*
* Calculate wind mass loss from the previous timestep.
*
            !check for kstar added by PA
            if(neta.gt.tiny .and. kstar(k)<15)then
               rlperi = rol(k)*(1.d0-ecc)
               dmr(k) = mlwind(kstar(k),lumin(k),rad(k),mass(k),
     &                         massc(k),rlperi,z)
*
* Calculate how much of wind mass loss from companion will be
* accreted (Boffin & Jorissen, A&A 1988, 205, 155).
*
               if(beta.lt.0.d0)then !PK. following startrack
                  beta = 0.125
                  if(kstar(k).le.1)then
                     if(mass(k).gt.120.d0)then
                        beta = 7.d0
                     elseif(mass(k).le.1.4d0)then
                        beta = 0.5
                     else
                        beta = 7.d0*((mass(k)-1.4d0)/(120.d0-1.4d0))
     &                         + 0.5d0
                     endif
                  elseif(kstar(k).ge.7.and.kstar(k).le.9)then
                     if(mass(k).gt.120.d0)then
                        beta = 7.d0
                     elseif(mass(k).le.10.d0)then
                        beta = 0.125
                     else
                        beta = 7.d0*((mass(k)-10.d0)/(120.d0-10.d0))
     &                               + 0.125d0
                     endif
                  endif
               endif
               vwind2 = 2.d0*beta*acc1*mass(k)/rad(k)
               omv2 = (1.d0 + vorb2/vwind2)**(3.d0/2.d0)
               dmt(3-k) = ivsqm*acc2*dmr(k)*((acc1*mass(3-k)/vwind2)**2)
     &                    /(2.d0*sep*sep*omv2)
               dmt(3-k) = MIN(dmt(3-k),0.8d0*dmr(k))
*
* Apply Eddington limit just in case
*
               if(dt.gt.0)then
                  dmt(3-k) = MIN(dmt(3-k),dme)
               endif
               beta = betahold
            else
               dmr(k) = 0.d0
               dmt(3-k) = 0.d0
            endif
 501     continue

*
* Diagnostic for Symbiotic-type stars.
*
         !check for kstar added by PA
         if(neta.gt.tiny .and. kstar(j2)<15)then
            lacc = 3.14d+07*mass(j2)*dmt(j2)/rad(j2)
            lacc = lacc/lumin(j1)
         endif
*
* Calculate orbital angular momentum change due to wind mass loss.
*
         ecc2 = ecc*ecc
         omecc2 = 1.d0 - ecc2
         sqome2 = SQRT(omecc2)
*
         djorb = ((dmr(1)+q(1)*dmt(1))*mass(2)*mass(2) +
     &            (dmr(2)+q(2)*dmt(2))*mass(1)*mass(1))*
     &           sep*sep*sqome2*oorb/(mass(1)+mass(2))**2
         delet = ecc*(dmt(1)*(0.5d0/mass(1) + 1.d0/(mass(1)+mass(2))) +
     &                dmt(2)*(0.5d0/mass(2) + 1.d0/(mass(1)+mass(2))))
*
* For very close systems include angular momentum loss owing to
* gravitational radiation.
*
         if(sep.le.100000.d0.and.grflag.eq.1)then
            djgr = 8.315d-10*mass(1)*mass(2)*(mass(1)+mass(2))/
     &             (sep*sep*sep*sep)
            f1 = (19.d0/6.d0) + (121.d0/96.d0)*ecc2
            sqome5 = sqome2**5
            delet1 = djgr*ecc*f1/sqome5
            djgr = djgr*jorb*(1.d0+0.875d0*ecc2)/sqome5
            djorb = djorb + djgr
            delet = delet + delet1
         endif
*
         do 502 , k = 1,2

* Evaluate convective/radiative limits for a variety of stars as based
* on the work of Belczynski et al. (2008). As option.
* Note only certain stars of type k = 0, 1, 2, 4, 5, 6, 9 **double check
* 0, 1 have range of 0.35-Mms,conv. Mms,conv is function of metalicity.
* 2 & 4 have a temperature dependence. Convective if Teff < 10**3.73
* 3, 5 & 6 are giants and have no radiative envelopes.
* 9's envelope is convective when M < Mhe,conv, Mhe,conv = 3.0Msun.
*
            if(ST_cr.le.0)then
               if(kstar(k).le.1)then
                  convradcomp(k) = 1.25d0
               else
                  convradcomp(k) = 99999999.d0
               endif
            else
               if(kstar(k).le.1)then
*                 Main sequence mass limit varying with metallicity
                  convradcomp(k) = 1.25d0
                  if(z.gt.0.001d0.and.z.lt.zsun)then
                     convradcomp(k) = 0.747d0 + 55.73d0*z - 1532*z*z
                  elseif(z.le.0.001d0)then
                     convradcomp(k) = 0.8d0
                  endif
               elseif(kstar(k).eq.2.or.kstar(k).eq.4)then
*                 H-rich HG and CHeB temperature limit
                  convradcomp(k) = 10.d0**3.73d0
               elseif(kstar(k).le.6)then
*                 No limit or all other giant stars
*                 (compare this large value to mass).
                  convradcomp(k) = 99999999.d0
               elseif(kstar(k).eq.9)then
*                 Mass limit for evolved He star
                  convradcomp(k) = 3.d0
               endif
            endif
*
* Calculate change in the intrinsic spin of the star.
*
*
* Pulsar wind spinup. PK.
*
            if(kstar(k).eq.13.and.pulsar.gt.0)then
* Place propeller stuff here eventually.
               if(xip.eq.1)then
* Modify spin angular momentum accretion according to Ruffert (1999)
* or magnetic field strength limit tested (but by no means established - in fact it
* is likely to change, especially when propeller and ablation are implemented)
* in Kiel et al. (2008).
                  if(B(k).gt.0.d0)then
                     xi = MIN(1.d0,(0.01d0*(2.0d+11/B(k)))+0.01d0)
                     xi = 0.01
                  else
                     xi = 0.01
                  endif
               endif
               djtx(k) = (2.d0/3.d0)*xi*dmt(k)*rad(3-k)*rad(3-k)*
     &                   ospin(3-k)
               djspint(k) = (2.d0/3.d0)*(dmr(k)*rad(k)*rad(k)*ospin(k))-
     &                      djtx(k)
               xi = xihold
               if(output) write(*,*)'502 1:',k,djspint(k),djtx(k),
     & dmt(k),rad(3-k),ospin(3-k),xi,xihold
            else
               djtx(k) = (2.d0/3.d0)*xi*dmt(k)*
     &                     rad(3-k)*rad(3-k)*ospin(3-k)
               djspint(k) = (2.d0/3.d0)*
     &                       (dmr(k)*rad(k)*rad(k)*ospin(k)) - djtx(k)
            endif
*
* Include magnetic braking for stars that have appreciable convective
* envelopes. This includes MS stars with M < 1.25, HG stars near the GB
* and giants. MB is not allowed for fully convective MS stars.
*
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
*               djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
*               djspint(k) = djspint(k) + djmb
*
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
*     &              menv(k).gt.0.0d0)then
*              if (ospin(k) .le. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &              (ospin(k)/wsun)**3.0d0
*              if (ospin(k) .gt. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &             (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
*              djspint(k) = djspint(k) + djmb
            djmb = 0.d0
            if(htpmb.eq.0)then
* HTP02 method
               if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
                  djmb = 5.83d-16*menv(k)*
     &                   (rad(k)*ospin(k))**3/mass(k)
                  djspint(k) = djspint(k) + djmb
               endif
            else
               if(ST_cr.le.0.and.mass(k).gt.0.35d0.and.
     &            kstar(k).lt.10.and.menv(k).gt.0.0d0)then
* Ivanova & Taam (2002) method
                  if(ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                (ospin(k)/wsun)**3.0d0
                  if(ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                  djspint(k) = djspint(k) + djmb
               elseif(ST_cr.gt.0.and.menv(k).gt.0.d0.and.
     &            ((kstar(k).le.1.and.mass(k).gt.0.35d0.and.
     &              mass(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.2.and.teff(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.4.and.teff(k).le.convradcomp(k)).or.
     &              ((kstar(k).eq.3).or.(kstar(k).eq.5).or.
     &              (kstar(k).eq.6))))then
* Ivanova & Taam (2002) method
                  if(ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &               (ospin(k)/wsun)**3.0d0
                  if(ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &               (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                  djspint(k) = djspint(k) + djmb
               endif
            endif
* Limit to a 3% angular momentum change for the star owing to MB.
* This is found to work best with the maximum iteration of 20000,
* i.e. does not create an excessive number of iterations, while not
* affecting the evolution outcome when compared with a 2% restriction.
*
            if(djmb.gt.tiny)then
               dtj = 0.03d0*jspin(k)/ABS(djmb)
               dt = MIN(dt,dtj)
               if(output) write(*,*)'mb1:',tphys,dt,djmb,djt
            endif
*
            if(kstar(k).eq.13.and.pulsar.gt.0)then
*
* NS(pulsar) magnetic braking. PK.
* No contact binary NS system.
*
               if(bdecayfac.eq.0)then
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny)then
                     B(k) = B_0(k)*exp(-CK*bacc(k)) + Bbot
                  else
                     B(k) = B_0(k)*
     &                       EXP(-(tphys-epoch(k)-tacc(k))/bconst)*
     &                       exp(-CK*bacc(k)) + Bbot
                  endif
               else
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny.and.
     &                bacc(k).eq.0.d0)then
                     B(k) = B_0(k) + Bbot
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny)then
                     B(k) = B_0(k)/(1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  elseif(bacc(k).eq.0.d0)then
                     B(k) = B_0(k)*EXP(-(tphys-epoch(k)-tacc(k))/bconst)
     &                       + Bbot
                  else
                     B(k) = B_0(k)*
     &                       EXP(-(tphys-epoch(k)-tacc(k))/bconst)/
     &                       (1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  endif
               endif
               omdot = Kconst*B(k)*B(k)*ospin(k)**3
               djmb = 0.4d0*mass(k)*rad(k)*rad(k)*omdot
               djspint(k) = djspint(k) + djmb
               if(output) write(*,*)'502 2:',k,djspint(k),djmb
               if(djmb.gt.tiny)then
                  dtj = 0.1d0*(jspin(k)/ABS(djmb))
                  dt = MIN(dt,dtj)
               endif
            endif
*
* Calculate circularization, orbital shrinkage and spin up.
*
            dspint(k) = 0.d0
            if(((kstar(k).le.9.and.rad(k).ge.0.01d0*rol(k)).or.
     &         (kstar(k).ge.10.and.k.eq.j1)).and.tflag.gt.0)then
*
               raa2 = (rad(k)/sep)**2
               raa6 = raa2**3
*
* Hut's polynomials.
*
               f5 = 1.d0+ecc2*(3.d0+ecc2*0.375d0)
               f4 = 1.d0+ecc2*(1.5d0+ecc2*0.125d0)
               f3 = 1.d0+ecc2*(3.75d0+ecc2*(1.875d0+ecc2*7.8125d-02))
               f2 = 1.d0+ecc2*(7.5d0+ecc2*(5.625d0+ecc2*0.3125d0))
               f1 = 1.d0+ecc2*(15.5d0+ecc2*(31.875d0+ecc2*(11.5625d0
     &                  +ecc2*0.390625d0)))
*
               if(ST_cr.le.0.and.
     &            ((kstar(k).eq.1.and.mass(k).ge.1.25d0).or.
     &            kstar(k).eq.4.or.kstar(k).eq.7))then
*
* Radiative damping (Zahn, 1977, A&A, 57, 383 and 1975, A&A, 41, 329).
*
                  tc = 1.592d-09*(mass(k)**2.84d0)
                  f = 1.9782d+04*SQRT((mass(k)*rad(k)*rad(k))/sep**5)*
     &                tc*(1.d0+q(3-k))**(5.d0/6.d0)
                  tcqr = f*q(3-k)*raa6
                  rg2 = k2str(k)
               elseif(ST_cr.gt.0.and.
     &                ((kstar(k).le.1.and.mass(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.2.and.teff(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.4.and.teff(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.9.and.mass(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.7).or.(kstar(k).eq.8)))then
*
* Radiative damping (Zahn, 1977, A&A, 57, 383 and 1975, A&A, 41, 329).
*
                  tc = 1.592d-09*(mass(k)**2.84d0)
                  f = 1.9782d+04*SQRT((mass(k)*rad(k)*rad(k))/sep**5)*
     &                tc*(1.d0+q(3-k))**(5.d0/6.d0)
                  tcqr = f*q(3-k)*raa6
                  rg2 = k2str(k) !for startrack comparison this should be =0.31622777d0 (sqrt(0.1)).
               elseif(kstar(k).le.9)then
*
* Convective damping (Hut, 1981, A&A, 99, 126).
*
* In BSE paper Equation 30, the default scaling coefficient is 2./21
* the fprimc_array kstar dependent array that is fed in
* keeps this same coefficient by default but allows user to
* specify their own
*
                  tc = mr23yr*(menv(k)*renv(k)*(rad(k)-0.5d0*renv(k))/
     &                 (3.d0*lumin(k)))**(1.d0/3.d0)
                  ttid = twopi/(1.0d-10 + ABS(oorb - ospin(k)))
                  f = MIN(1.d0,(ttid/(2.d0*tc))**2)
                  !kstar(k) to kstar(k)+1 by PA for kstar(k)=0
                  tcqr = fprimc_array(kstar(k)+1)*
     &                 f*q(3-k)*raa6*menv(k)/
     &                 (tc*mass(k))
                  rg2 = (k2str(k)*(mass(k)-massc(k)))/mass(k)
               elseif(ST_tide.le.0)then
*
* Degenerate damping (Campbell, 1984, MNRAS, 207, 433)
*
                  f = 7.33d-09*(lumin(k)/mass(k))**(5.d0/7.d0)
                  tcqr = f*q(3-k)*q(3-k)*raa2*raa2/(1.d0+q(3-k))
                  rg2 = k3
               endif
*
* Circularization.
*
               sqome3 = sqome2**3
               delet1 = 27.d0*tcqr*(1.d0+q(3-k))*raa2*(ecc/sqome2**13)*
     &                  (f3 - (11.d0/18.d0)*sqome3*f4*ospin(k)/oorb)
               tcirc = ecc/(ABS(delet1) + 1.0d-20)
               delet = delet + delet1
*
* Spin up of star.
*
               dspint(k) = (3.d0*q(3-k)*tcqr/(rg2*omecc2**6))*
     &                     (f2*oorb - sqome3*f5*ospin(k))
               if(output) write(*,*)'502 3:',k,dspint(k),tcqr
*
* Calculate the equilibrium spin at which no angular momentum
* can be transferred.
*
               eqspin = oorb*f2/(sqome3*f5)
*
* Calculate angular momentum change for the star owing to tides.
*
               djt = (k2str(k)*(mass(k)-massc(k))*rad(k)*rad(k) +
     &                k3*massc(k)*radc(k)*radc(k))*dspint(k)
               if(kstar(k).le.6.or.ABS(djt)/jspin(k).gt.0.1d0)then
                  djtt = djtt + djt
               endif
            endif
 502     continue
*
* Limit to 2% orbital angular momentum change.
*
         djtt = djtt + djorb
         if(ABS(djtt).gt.tiny)then
            dtj = 0.02d0*jorb/ABS(djtt)
            dt = MIN(dt,dtj)
         endif
         dtm = dt/1.0d+06
         if(output) write(*,*)'bin lim orb ang mom:',tphys,dt,kstar(1)
*
      elseif(ABS(dtm).gt.tiny.and.sgl)then
         do 503 , k = kmin,kmax
            !check for kstar added by PA
            if(neta.gt.tiny .and. kstar(k)<15)then
               rlperi = 0.d0
               dmr(k) = mlwind(kstar(k),lumin(k),rad(k),mass(k),
     &                         massc(k),rlperi,z)
            else
               dmr(k) = 0.d0
            endif
            dmt(k) = 0.d0
            djspint(k) = (2.d0/3.d0)*dmr(k)*rad(k)*rad(k)*ospin(k)
            if(output) write(*,*)'503 1:',k,djspint(k)
*
* Evaluate convective/radiative limits for a variety of stars as based
* on the work of Belczynski et al. (2008). As option.
* Note only certain stars of type k = 0, 1, 2, 4, 5, 6, 9 **double check
* 0, 1 have range of 0.35-Mms,conv. Mms,conv is function of metalicity.
* 2 & 4 have a temperature dependence. Convective if Teff < 10**3.73
* 3, 5 & 6 are giants and have no radiative envelopes.
* 9's envelope is convective when M < Mhe,conv, Mhe,conv = 3.0Msun.
*
            if(ST_cr.le.0)then
               if(kstar(k).le.1)then
                  convradcomp(k) = 1.25d0
               else
                  convradcomp(k) = 99999999.d0
               endif
            else
               if(kstar(k).le.1)then
*                 Main sequence mass limit varying with metallicity
                  convradcomp(k) = 1.25d0
                  if(z.gt.0.001d0.and.z.lt.zsun)then
                     convradcomp(k) = 0.747d0 + 55.73d0*z - 1532*z*z
                  elseif(z.le.0.001d0)then
                     convradcomp(k) = 0.8d0
                  endif
               elseif(kstar(k).eq.2.or.kstar(k).eq.4)then
*                 H-rich HG and CHeB temperature limit
                  convradcomp(k) = 10.d0**3.73d0
               elseif(kstar(k).le.6)then
*                 No limit or all other giant stars
*                 (compare this large value to mass).
                  convradcomp(k) = 99999999.d0
               elseif(kstar(k).eq.9)then
*                 Mass limit for evolved He star
                  convradcomp(k) = 3.d0
               endif
            endif
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
*               djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
*               djspint(k) = djspint(k) + djmb
*             if(mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
*     &              menv(k).gt.0.0d0)then
*                if (ospin(k) .le. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &              (ospin(k)/wsun)**3.0d0
*                if (ospin(k) .gt. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &             (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
*                djspint(k) = djspint(k) + djmb
*
*MB
            djmb = 0.d0
            if(htpmb.eq.0)then
               if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
                  djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
                  djspint(k) = djspint(k) + djmb
               endif
            elseif(htpmb.eq.1)then
               if(ST_cr.le.0.and.
     &            mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
     &            menv(k).gt.0.0d0)then
* Old BSE convective/radiative divide...
                   if(ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                 (ospin(k)/wsun)**3.0d0
                   if(ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &             (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                   djspint(k) = djspint(k) + djmb
               elseif(ST_cr.gt.0.and.(menv(k).gt.0.d0.and.
     &            ((kstar(k).le.1.and.mass(k).gt.0.35d0.and.
     &              mass(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.2.and.teff(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.4.and.teff(k).le.convradcomp(k)).or.
     &              ((kstar(k).eq.3).or.(kstar(k).eq.5).or.
     &              (kstar(k).eq.6)))))then
* MB given in Ivanova & Taam (2002)
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
*     &              menv(k).gt.0.0d0)then
                  if(ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                (ospin(k)/wsun)**3.0d0
                  if(ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &               (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                  djspint(k) = djspint(k) + djmb
               endif
            endif
*                if(output) write(*,*)'503 2:',k,djspint(k),djmb
            if(djmb.gt.tiny)then
               dtj = 0.03d0*jspin(k)/ABS(djmb)
               dt = MIN(dt,dtj)
            endif
            if(kstar(k).eq.13.and.pulsar.gt.0)then
*
* NS magnetic braking. PK.
* Single NS evolution.
*
               if(bdecayfac.eq.0)then
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny)then
                     B(k) = B_0(k)*exp(-CK*bacc(k)) + Bbot
                  else
                     B(k) = B_0(k)*
     &                       EXP(-(tphys-epoch(k)-tacc(k))/bconst)*
     &                       exp(-CK*bacc(k)) + Bbot
                  endif
               else
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny.and.
     &                bacc(k).eq.0.d0)then
                     B(k) = B_0(k) + Bbot
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny)then
                     B(k) = B_0(k)/(1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  elseif(bacc(k).eq.0.d0)then
                     B(k) = B_0(k)*EXP(-(tphys-epoch(k)-tacc(k))/bconst)
     &                       + Bbot
                  else
                     B(k) = B_0(k)*
     &                       EXP(-(tphys-epoch(k)-tacc(k))/bconst)/
     &                       (1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  endif
               endif
               omdot = Kconst*B(k)*B(k)*ospin(k)**3
               djmb = 0.4d0*mass(k)*rad(k)*rad(k)*omdot
               djspint(k) = djspint(k) + djmb
               if(output) write(*,*)'503 2:',k,djmb,djspint(k)
* Consider update of time-stepping due to dj, i.e. dt = dj/(dj/dt).
               if(djmb.gt.tiny)then
                  dtj = 0.1d0*(jspin(k)/ABS(djmb))
                  dt = MIN(dt,dtj)
               endif
            endif
 503     continue
         dtm = dt/1.0d+06
      endif
*
      do 504 , k = kmin,kmax
*
         dms(k) = (dmr(k) - dmt(k))*dt
         if(kstar(k).lt.10)then
            dml = mass(k) - massc(k)
            if(dml.lt.dms(k))then
               dml = MAX(dml,2.d0*tiny)
               dtm = (dml/dms(k))*dtm
               if(k.eq.2) dms(1) = dms(1)*dml/dms(2)
               dms(k) = dml
               dt = 1.0d+06*dtm
            endif
*
* Limit to 1% mass loss.
*
            if(dms(k).gt.0.01d0*mass(k))then
               dtm = 0.01d0*mass(k)*dtm/dms(k)
               if(k.eq.2) dms(1) = dms(1)*0.01d0*mass(2)/dms(2)
               dms(k) = 0.01d0*mass(k)
               dt = 1.0d+06*dtm
            endif
         endif
         if(output) write(*,*)'after 1p ml: ',tphys,k,dt,dtm
*
 504  continue
*
* Update mass and intrinsic spin (checking that the star is not spun
* past the equilibrium) and reset epoch for a MS (and possibly a HG) star.
*
      do 505 , k = kmin,kmax
*
         if(eqspin.gt.0.d0.and.ABS(dspint(k)).gt.tiny)then
            if(intpol.eq.0)then
               if(dspint(k).ge.0.d0)then
                  dspint(k) = MIN(dspint(k),(eqspin-ospin(k))/dt)
               else
                  dspint(k) = MAX(dspint(k),(eqspin-ospin(k))/dt)
               endif
               djt = (k2str(k)*(mass(k)-massc(k))*rad(k)*rad(k) +
     &                k3*massc(k)*radc(k)*radc(k))*dspint(k)
               djorb = djorb + djt
               djspint(k) = djspint(k) - djt
               if(output) write(*,*)'505: ',k,djt,djspint(k),jspin(k),dt
            endif
         endif
*
         if(output) write(*,*)'505 1:',tphys,k,kstar(k),djspint(k),
     & djspint(k)*dt,jspin(k),intpol
         jspin(k) = MAX(1.0d-10,jspin(k) - djspint(k)*dt)
         if(output) write(*,*)'505 2:',tphys,k,kstar(k),djspint(k),
     & djspint(k)*dt,jspin(k)
*
* Ensure that the star does not spin up beyond break-up.
*
         ospbru = twopi*SQRT(mass(k)*aursun**3/rad(k)**3)
         jspbru = (k2str(k)*(mass(k)-massc(k))*rad(k)*rad(k) +
     &             k3*massc(k)*radc(k)*radc(k))*ospbru
         if((jspin(k).gt.jspbru.or.
     &      (jspin(k).eq.1.0d-10.and.intpol.gt.0)).and.
     &      ABS(dtm).gt.tiny)then !PDK add check for jspin intpol issues here.
* If rapidly spinning star (generally NS) pushed over the edge (spins up so
* much so that jspin would have become negative according to bse, so it sets
* it to 1.d0-10) in intpol then give it the stars maximum spin.
            mew = 1.d0
            if(djtx(k).gt.0.d0.and.jspin(k).gt.1.d0-10)then !dont go in here if jspin hit wall.
               mew = MIN(mew,(jspin(k) - jspbru)/djtx(k))
            endif
            jspin(k) = jspbru
* If excess material should not be accreted, activate next line.
*           dms(k) = dms(k) + (1.d0 - mew)*dmt(k)*dt
         endif
* Update mass
         if(ABS(dms(k)).gt.tiny)then
            mass(k) = mass(k) - dms(k)
            if(kstar(k).le.2.or.kstar(k).eq.7)then
               m0 = mass0(k)
               mass0(k) = mass(k)
               CALL star(kstar(k),mass0(k),mass(k),tm,tn,tscls,
     &                   lums,GB,zpars)
               if(kstar(k).eq.2)then
                  if(GB(9).lt.massc(k).or.m0.gt.zpars(3))then
                     mass0(k) = m0
                  else
                     epoch(k) = tm + (tscls(1) - tm)*(aj(k)-tms(k))/
     &                               (tbgb(k) - tms(k))
                     epoch(k) = tphys - epoch(k)
                  endif
               else
                  epoch(k) = tphys - aj(k)*tm/tms(k)
               endif
            endif
* Update NS magnetic field owing to accretion, as a function of mass accreted. PK.
            if(kstar(k).eq.13.and.pulsar.gt.0)then
               if(dms(k).lt.0.d0)then !negative dms is mass gained.
* When propeller ev. include .not.prop here...
                  b_mdot = dms(k)/dt
                  if(b_mdot_lim.gt.0.d0.and.b_mdot.gt.b_mdot_lim)then
                     bacc(k) = bacc(k) - dms(k)
                     tacc(k) = tacc(k) + dtm
                  elseif(b_mdot_lim.le.0.d0)then
                     bacc(k) = bacc(k) - dms(k)
                     tacc(k) = tacc(k) + dtm
                  endif
               endif
            endif
         endif
*
 505  continue
*
      if(.not.sgl)then
*
         ecc1 = ecc1 - delet*dt
         ecc = MAX(ecc1,0.d0)
         if(ecc.lt.1.0d-10) ecc = 0.d0
*
         if(ecc.ge.1.d0) goto 135
*
         jorb = jorb - djorb*dt
         sep = (mass(1) + mass(2))*jorb*jorb/
     &         ((mass(1)*mass(2)*twopi)**2*aursun**3*(1.d0-ecc*ecc))
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
      endif
*
* Advance the time.
*
      if(intpol.eq.0)then
         tphys0 = tphys
         dtm0 = dtm
      endif
      tphys = tphys + dtm

      if(output) write(*,*)'time upd:',tsave, tphys,dtm,
     &                      kstar(1),kstar(2),ecc
*
      do 6 , k = kmin,kmax
*
* Acquire stellar parameters (M, R, L, Mc & K*) at apparent evolution age.
*
         age = tphys - epoch(k)
         aj0(k) = age
         kw = kstar(k)
         m0 = mass0(k)
         mt = mass(k)
         mc = massc(k)
         if(intpol.eq.0) mcxx(k) = mc
         if(intpol.gt.0) mc = mcxx(k)
         mass00(k) = m0
*
* Masses over 100Msun should probably not be trusted in the
* evolution formulae.
*
         if(mt.gt.100.d0)then
*            WRITE(99,*)' MASS EXCEEDED ',mass1i,mass2i,tbi,ecci,mt,
*     & tphysf,id1_pass,id2_pass
*            goto 140
         endif
*
         CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(m0,age,mt,tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kw,mc,rc,me,re,k2,bhspin(k),k)
*
         if(kw.ne.15)then
            ospin(k) = jspin(k)/(k2*(mt-mc)*rm*rm+k3*mc*rc*rc)
         endif
*
* At this point there may have been a supernova.
*
         if((kw.ne.kstar(k).and.kstar(k).le.12.and.
     &      (kw.eq.13.or.kw.eq.14)).or.(ABS(merger).ge.20.d0))then
            if(formation(k).ne.11) formation(k) = 1
            if(kw.eq.13.and.ecsn.gt.0.d0)then
               if(kstar(k).le.6)then
                  if(mass0(k).le.zpars(5))then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation(k) = 2
                  endif
               elseif(kstar(k).ge.7.and.kstar(k).le.9)then
                  if(mass(k).gt.ecsn_mlow.and.mass(k).le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation(k) = 2
                  endif
               elseif(formation(k).eq.11)then
* MIC
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = -sigmahold/sigmadiv
                  elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                     sigma = sigmadiv
                  endif
                  formation(k) = 5
               elseif(kstar(k).ge.10.or.kstar(k).eq.12)then
* AIC formation, will never happen here but...
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = -sigmahold/sigmadiv
                  elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                     sigma = sigmadiv
                  endif
                  formation(k) = 4
               elseif(merger.ge.20.d0)then
                  sigma = merger
                  fallback = 0.d0
                  if(merger.ge.200.d0)then!estimate CC SN
                     formation(k) = 1
                  else
                     formation(k) = 5
                  endif
               elseif(merger.le.-20.d0)then
                  sigma = ABS(merger)
                  fallback = 0.d0
                  if(merger.ge.200.d0)then!estimate CC SN
*Sourav:Possible bug in the line above. merger should really be sigms!!
*                  if(sigma.ge.200.d0)then!estimate CC SN
                     formation(k) = 1
                  else
                     formation(k) = 5
                  endif
               endif
            elseif(kw.eq.13.and.aic.gt.0)then
               if(formation(k).eq.11)then
* MIC
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = -sigmahold/sigmadiv
                  elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                     sigma = sigmadiv
                  endif
                  formation(k) = 5
               elseif(kstar(k).ge.10.or.kstar(k).eq.12)then
* AIC formation, will never happen here but...
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = -sigmahold/sigmadiv
                  elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                     sigma = sigmadiv
                  endif
                  formation(k) = 4
               endif
            elseif(ABS(merger).ge.20.d0)then
               sigma = ABS(merger)
               fallback = 0.d0
               if(merger.ge.200.d0)then!estimate CC SN
                  formation(k) = 1
               else
                  formation(k) = 5
               endif
            endif
            if(sgl)then
               evolve_type = 14.d0 + FLOAT(k)
               teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
               teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
               if(B_0(1).eq.0.d0)then !PK.
                  b01_bcm = 0.d0
               elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
                  b01_bcm = B_0(1)
               else
                  b01_bcm = B(1)
               endif
               if(B_0(2).eq.0.d0)then
                  b02_bcm = 0.d0
               elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
                  b02_bcm = B_0(2)
               else
                  b02_bcm = B(2)
               endif
               CALL writetab(jp,tphys,evolve_type,
     &                      mass(1),mass(2),kstar(1),kstar(2),
     &                      sep,tb,ecc,rrl1,rrl2,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2),
     &                      mass0(1),mass0(2),lumin(1),lumin(2),
     &                      teff1,teff2,radc(1),radc(2),
     &                      menv(1),menv(2),renv(1),renv(2),
     &                      ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin(1),bhspin(2),
     &                      deltam1_bcm,deltam2_bcm,formation(1),
     &                      formation(2),binstate,mergertype,'bpp')
               CALL kick(kw,mass(k),mt,0.d0,0.d0,-1.d0,0.d0,vk,k,
     &                  0.d0,fallback,sigmahold,kick_info,disrupt,bkick)

               sigma = sigmahold !reset sigma after possible ECSN kick dist. Remove this if u want some kick link to the intial pulsar values...
* set kick values for the bcm array

            else
               evolve_type = 14.d0 + FLOAT(k)
               teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
               teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
               if(B_0(1).eq.0.d0)then !PK.
                  b01_bcm = 0.d0
               elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
                  b01_bcm = B_0(1)
               else
                  b01_bcm = B(1)
               endif
               if(B_0(2).eq.0.d0)then
                  b02_bcm = 0.d0
               elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
                  b02_bcm = B_0(2)
               else
                  b02_bcm = B(2)
               endif

               CALL writetab(jp,tphys,evolve_type,
     &                       mass(1),mass(2),kstar(1),kstar(2),
     &                       sep,tb,ecc,rrl1,rrl2,
     &                       aj(1),aj(2),tms(1),tms(2),
     &                       massc(1),massc(2),rad(1),rad(2),
     &                       mass0(1),mass0(2),lumin(1),lumin(2),
     &                       teff1,teff2,radc(1),radc(2),
     &                       menv(1),menv(2),renv(1),renv(2),
     &                       ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                       bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                       epoch(2),bhspin(1),bhspin(2),
     &                       deltam1_bcm,deltam2_bcm,formation(1),
     &                       formation(2),binstate,mergertype,'bpp')

               CALL kick(kw,mass(k),mt,mass(3-k),ecc,sep,jorb,vk,k,
     &              rad(3-k),fallback,sigmahold,kick_info,disrupt,bkick)
               sigma = sigmahold !reset sigma after possible ECSN kick dist. Remove this if u want some kick link to the intial pulsar values...
* set kick values for the bcm array
               if(mass(3-k).lt.0.d0)then
                  if(kstar(3-k).lt.0.d0) mt = mt-mass(3-k) !ignore TZ object
                  if(kw.eq.13.and.mt.gt.mxns) kw = 14
                  CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
                  kstar(k) = kw
                  mass(k) = mt
                  epoch(k) = tphys - age
                  kstar(3-k) = 15
                  mass(3-k) = 0.d0
                  coel = .true.
                  binstate = 1
                  goto 135
               endif
               if(ecc.gt.1.d0)then
                  kstar(k) = kw
                  mass(k) = mt
                  epoch(k) = tphys - age
                  goto 135
               endif
               tb = (sep/aursun)*SQRT(sep/(aursun*(mt+mass(3-k))))
               oorb = twopi/tb
            endif

            merger = -1.d0
            snova = .true.
         endif
*
         if(kw.ne.kstar(k))then
            change = .true.
            mass(k) = mt
            dtmi(k) = 0.01d0
            if(kw.eq.15)then
               kstar(k) = kw
               goto 135
            endif
            mass0(k) = m0
            epoch(k) = tphys - age
         endif

*
*
* Force new NS or BH to have a birth spin peirod and magnetic field.
*
         if(kstar(k).eq.13.or.kstar(k).eq.14)then
* re-calculate the Eddington limit of the newly formed CO
            dme = 2.08d-03*eddfac*(1.d0/(1.d0 + zpars(11)))*rad(k)
* For BHs, follow Marchant et al. 2017
            if(kstar(k).eq.14)then
               maxspinBH = 6.d0**(1.d0/2.d0) * Mbh_initial
               if(mass(k).lt.maxspinBH)then
                  etaBH = 1.d0 -
     &    (1.d0 - (mass(k)/(3.d0*Mbh_initial))**(2.d0))**(1.d0/2.d0)
               else
                  etaBH = 0.42
               endif
               dme = 1.04e-3*eddfac*(1.d0/(1.d0 + zpars(11)))
     &    *(1.d0/etaBH)*rad(k)
            endif
            if(tphys-epoch(k).lt.tiny)then
               if(kstar(k).eq.13.and.pulsar.gt.0)then
*                  write(93,*)'birth start: ',tphys,k,B_0(k),ospin(k)
*                  CALL FLUSH(93)
 170              u1 = ran3(idum1)
                  if(u1.ge.1.d0) goto 170
                  u2 = ran3(idum1)
                  s = sqrt(-2.d0*LOG(1.d0-u1))*COS(twopi*u2)
                  s = 0.7d0*s - 0.6d0
                  if(s.ge.0.013d0.or.s.le.-1.5d0) goto 170
                  ospin(k) = (twopi*yearsc)/(10.d0**s)
 174              u1 = ran3(idum1)
                  if(u1.ge.1.d0) goto 174
                  u2 = ran3(idum1)
                  s = sqrt(-2.d0*LOG(1.d0-u1))*COS(twopi*u2)
                  s = 0.68d0*s + 12.6d0
                  if(s.lt.11.5d0.or.s.gt.13.8d0) goto 174
                  B_0(k) = 10.d0**s
                  bacc(k) = 0.d0 ! If it has been a NS before reset
                  tacc(k) = 0.d0
                  if((merger.le.-2.d0.and.merger.gt.-20.d0).or.
     &                merge_mem.eq.1)then
* Reset as MSP.
 175                 u1 = ran3(idum1)
                     u2 = ran3(idum1)
                     if(u1.gt.0.9999d0) u1 = 0.9999d0
                     if(u2.gt.1.d0) u2 = 1.d0
                     s = SQRT(-2.d0*LOG(1.d0-u1))*COS(twopi*u2)
*                  s = 0.7d0*s - 0.6d0
                     s = 0.5d0*s - 2.25d0
*                  if(s.ge.0.013.or.s.le.-1.5) goto 173
*                  if(s.ge.-2.0457d0.or.s.le.-2.53d0) goto 175
                     if(s.ge.-1.6457d0.or.s.le.-2.53d0) goto 175
                     ospin(k) = (twopi*yearsc)/(10.d0**s)!have commented this out to keeps same spin
*                  write(*,*)'P=',s
 176                 u1 = ran3(idum1)
                     u2 = ran3(idum1)
                     if(u1.gt.0.9999d0) u1 = 0.9999d0
                     if(u2.gt.1.d0) u2 = 1.d0
                     s = SQRT(-2.d0*LOG(1.d0-u1))*COS(twopi*u2)
                     s = 0.3d0*s + 8.38d0
                     if(s.lt.8.d0.or.s.gt.8.778d0) goto 176
                     B_0(k) = 10.d0**s
                  endif
               else
                  ospin(k) = 2.0d+08
               endif
               bacc(k) = 0.d0 !make sure if its been a NS before its now a new one...
               tacc(k) = 0.d0
               jspin(k) = k3*rc*rc*mc*ospin(k)
               if(output) write(*,*)'SN: ',k,kstar(k),ospin(k),sigma
               sigma = sigmahold !reset sigma after possible ECSN kick dist.
            endif
         endif
         merge_mem = 0
*
* Set radius derivative for later interpolation.
*
         if(ABS(dtm).gt.tiny)then
            rdot(k) = ABS(rm - rad(k))/dtm
         else
            rdot(k) = 0.d0
         endif
*
*     Base new time scale for changes in radius & mass on stellar type.
*
         dt = dtmi(k)
         CALL deltat(kw,age,tm,tn,tscls,dt,dtr)
         if(output) write(*,*)'post deltat:',tphys,dt,dtr,kw,
     & age,intpol,iter,k,kmin,kmax
*
* Choose minimum of time-scale and remaining interval.
*
         dtmi(k) = MIN(dt,dtr)
*
* Save relevent solar quantities.
*
         aj(k) = age
         kstar(k) = kw
         rad(k) = rm
         lumin(k) = lum
         teff(k) = 1000.d0*((1130.d0*lumin(k)/
     &                    (rad(k)**2.d0))**(1.d0/4.d0))
         massc(k) = mc
         radc(k) = rc
         menv(k) = me
         renv(k) = re
         k2str(k) = k2
         tms(k) = tm
         tbgb(k) = tscls(1)
*
 6    continue
*
      if(.not.sgl)then
*
* Determine the mass ratios.
*
         do 506 , k = 1,2
            q(k) = mass(k)/mass(3-k)
 506     continue
*
* Determine the Roche lobe radii and adjust the radius derivative.
*
         do 507 , k = 1,2
            rol(k) = rl(q(k))*sep*(1.d0-ecc)
            if(ABS(dtm).gt.tiny)then
               rdot(k) = rdot(k) + (rol(k) - rol0(k))/dtm
               rol0(k) = rol(k)
            endif
 507     continue
      else
         do 508 , k = kmin,kmax
            rol(k) = 10000.d0*rad(k)
 508     continue
      endif
*
      if((tphys.lt.tiny.and.ABS(dtm).lt.tiny.and.
     &    (mass2i.lt.0.1d0.or..not.sgl)).or.snova)then
          evolve_type = 1.d0
          rrl1 = rad(1)/rol(1)
          rrl2 = rad(2)/rol(2)
          teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
          teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
          if(B_0(1).eq.0.d0)then !PK.
             b01_bcm = 0.d0
          elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
             b01_bcm = B_0(1)
          else
             b01_bcm = B(1)
          endif
          if(B_0(2).eq.0.d0)then
             b02_bcm = 0.d0
          elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
             b02_bcm = B_0(2)
          else
             b02_bcm = B(2)
          endif

          CALL writetab(jp,tphys,evolve_type,
     &                  mass(1),mass(2),kstar(1),kstar(2),sep,
     &                  tb,ecc,rrl1,rrl2,
     &                  aj(1),aj(2),tms(1),tms(2),
     &                  massc(1),massc(2),rad(1),rad(2),
     &                  mass0(1),mass0(2),lumin(1),lumin(2),
     &                  teff1,teff2,radc(1),radc(2),
     &                  menv(1),menv(2),renv(1),renv(2),
     &                  ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                  bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                  epoch(2),bhspin(1),bhspin(2),
     &                  deltam1_bcm,deltam2_bcm,formation(1),
     &                  formation(2),binstate,mergertype,'bpp')
         if(snova)then
            bpp(jp,11) = 2.0
            dtm = 0.d0
            goto 4
         endif
      endif
      if(check_dtp.eq.1)then
          CALL checkstate(dtp,dtp_original,tsave,tphys,tphysf,
     &                      iplot,isave,binstate,evolve_type,
     &                      mass(1),mass(2),kstar(1),kstar(2),sep,
     &                      tb,ecc,rrl1,rrl2,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2),
     &                      mass0(1),mass0(2),lumin(1),lumin(2),
     &                      radc(1),radc(2),menv(1),menv(2),
     &                      renv(1),renv(2),
     &                      ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                      bacc(1),bacc(2),
     &                      tacc(1),tacc(2),epoch(1),epoch(2),
     &                      bhspin(1),bhspin(2),teff1,teff2)
      endif
*
      if((isave.and.tphys.ge.tsave).or.iplot)then
         if(sgl.or.(rad(1).lt.rol(1).and.rad(2).lt.rol(2)).
     &      or.tphys.lt.tiny)then
            if(B_0(1).eq.0.d0)then !PK.
               b01_bcm = 0.d0
            elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
               b01_bcm = B_0(1)
            else
               b01_bcm = B(1)
            endif
            if(B_0(2).eq.0.d0)then
               b02_bcm = 0.d0
            elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
               b02_bcm = B_0(2)
            else
               b02_bcm = B(2)
            endif
            teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
            teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
            rrl1 = rad(1)/rol(1)
            rrl2 = rad(2)/rol(2)
            deltam1_bcm = dmt(1) - dmr(1)
            deltam2_bcm = dmt(2) - dmr(2)
* Check if PISN occurred, and if so overwrite formation
            if(pisn_track(1).ne.0) formation(1) = pisn_track(1)
            if(pisn_track(2).ne.0) formation(2) = pisn_track(2)

            CALL writetab(ip,tphys,evolve_type,
     &                    mass(1),mass(2),kstar(1),kstar(2),
     &                    sep,tb,ecc,rrl1,rrl2,
     &                    aj(1),aj(2),tms(1),tms(2),
     &                    massc(1),massc(2),rad(1),rad(2),
     &                    mass0(1),mass0(2),lumin(1),lumin(2),
     &                    teff1,teff2,radc(1),radc(2),
     &                    menv(1),menv(2),renv(1),renv(2),
     &                    ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                    bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                    epoch(2),bhspin(1),bhspin(2),
     &                    deltam1_bcm,deltam2_bcm,formation(1),
     &                    formation(2),binstate,mergertype,'bcm')
            if(isave) tsave = tsave + dtp
            if(output) write(*,*)'bcm1',kstar(1),kstar(2),mass(1),
     & mass(2),rad(1),rad(2),ospin(1),ospin(2),jspin(1)
*     & mass(2),rad(1),rad(2),ospin(1),ospin(2),b01_bcm,b02_bcm,jspin(1)
         endif
      endif
*
* If not interpolating set the next timestep.
*
      if(intpol.eq.0)then
*         WRITE(*,*)'you should see this to advance the time'
         if(output) write(*,*)'nxt t, prior:',tphys,dtm,dtmi(1),dtmi(2)
         dtm = MAX(1.0d-07*tphys,MIN(dtmi(1),dtmi(2)))
         dtm = MIN(dtm,tsave-tphys)
         if(output) write(*,*)'nxt t, after:',tphys,dtm,dtmi(1),dtmi(2)
         if(iter.eq.0) dtm0 = dtm
      endif
      if(sgl) goto 98
*
* Set j1 to the donor - the primary
* and j2 to the accretor - the secondary.
*
      if(intpol.eq.0)then
         if(rad(1)/rol(1).ge.rad(2)/rol(2))then
            j1 = 1
            j2 = 2
         else
            j1 = 2
            j2 = 1
         endif
      endif
*
* Test whether Roche lobe overflow has begun.
*
      if(rad(j1).gt.rol(j1))then
*
* Interpolate back until the primary is just filling its Roche lobe.
*
         if(rad(j1).ge.1.002d0*rol(j1))then
            if(intpol.eq.0) tphys00 = tphys
            intpol = intpol + 1
            if(iter.eq.0) goto 7
            if(inttry) goto 7
            if(intpol.ge.100)then
               WRITE(99,*)' INTPOL EXCEEDED ',mass1i,mass2i,tbi,ecci
               goto 140
            endif
            dr = rad(j1) - 1.001d0*rol(j1)
            if(ABS(rdot(j1)).lt.tiny.or.prec)then
               goto 7
            endif
            dtm = -dr/ABS(rdot(j1))
            if(ABS(tphys0-tphys).gt.tiny) dtm = MAX(dtm,tphys0-tphys)
            if(kstar(1).ne.kw1)then
               kstar(1) = kw1
               mass0(1) = mass00(1)
               epoch(1) = tphys - aj0(1)
            endif
            if(kstar(2).ne.kw2)then
               kstar(2) = kw2
               mass0(2) = mass00(2)
               epoch(2) = tphys - aj0(2)
            endif
            change = .false.
         else
*
* Enter Roche lobe overflow
*
            if(tphys.ge.tphysf) goto 140
            goto 7
         endif
      else
*
* Check if already interpolating.
*
         if(intpol.gt.0)then
            intpol = intpol + 1
            if(intpol.ge.80)then
               inttry = .true.
            endif
            if(ABS(rdot(j1)).lt.tiny)then
               prec = .true.
               dtm = 1.0d-07*tphys
            else
               dr = rad(j1) - 1.001d0*rol(j1)
               dtm = -dr/ABS(rdot(j1))
            endif
            if((tphys+dtm).ge.tphys00)then
*
* If this occurs then most likely the star is a high mass type 4
* where the radius can change very sharply or possibly there is a
* discontinuity in the radius as a function of time and HRDIAG
* needs to be checked!
*
               dtm = 0.5d0*(tphys00 - tphys0)
               dtm = MAX(dtm,1.0d-10)
               prec = .true.
            endif
            tphys0 = tphys
         endif
      endif
*
* Check for collision at periastron.
*
      pd = sep*(1.d0 - ecc)
      if(pd.lt.(rad(1)+rad(2)).and.intpol.eq.0) goto 130
*
* Go back for the next step or interpolation.
*
 98   continue
      if(tphys.ge.tphysf.and.intpol.eq.0) goto 140
      if(change)then
         change = .false.
         evolve_type = 2.d0
         rrl1 = rad(1)/rol(1)
         rrl2 = rad(2)/rol(2)
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
         if(B_0(1).eq.0.d0)then !PK.
            b01_bcm = 0.d0
         elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
            b01_bcm = B_0(1)
         else
            b01_bcm = B(1)
         endif
         if(B_0(2).eq.0.d0)then
            b02_bcm = 0.d0
         elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
            b02_bcm = B_0(2)
         else
            b02_bcm = B(2)
         endif

         CALL writetab(jp,tphys,evolve_type,
     &                 mass(1),mass(2),kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2),
     &                 mass0(1),mass0(2),lumin(1),lumin(2),
     &                 teff1,teff2,radc(1),radc(2),
     &                 menv(1),menv(2),renv(1),renv(2),
     &                 ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                 bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                 epoch(2),bhspin(1),bhspin(2),
     &                 deltam1_bcm,deltam2_bcm,formation(1),
     &                 formation(2),binstate,mergertype,'bpp')
      endif
*
      iter = iter + 1
*
      if(iter.ge.loop)then
         WRITE(99,*)' MAXIMUM ITER EXCEEDED ',mass1i,mass2i,tbi,ecci,
     & tphysf,id1_pass,id2_pass
         goto 140
      endif
      goto 5
*
* Set the nuclear timescale in years and slow-down factor.
*
 7    km0 = dtm0*1.0d+03/tb
      if(km0.lt.tiny) km0 = 0.5d0
      
* Check for collision at periastron for a stable RLOF 
      pd = sep*(1.d0 - ecc)
      if(pd.lt.(rad(1)+rad(2))) goto 130
      
*      
* Force co-rotation of primary and orbit to ensure that the tides do not
* lead to unstable Roche (not currently used).
*
*     if(ospin(j1).gt.1.05d0*oorb)then
*        ospin(j1) = oorb
*        jspin(j1) = (k2str(j1)*rad(j1)*rad(j1)*(mass(j1)-massc(j1))+
*    &                k3*radc(j1)*radc(j1)*massc(j1))*ospin(j1)
*     endif
*
      sep = sep*(1-ecc)
      ecc = 0.d0
      tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
      oorb = twopi/tb
      jorb = (mass(1)*mass(2)/(mass(1)+mass(2)))*
     &        sqrt(1.d0-ecc*ecc)*sep*sep*oorb
* Note: this will modify pulsar spin period
      if(kstar(1).lt.13)then
         ospin(1) = oorb
         jspin(1) = (k2str(1)*rad(1)*rad(1)*(mass(1)-massc(1))+
     &               k3*radc(1)*radc(1)*massc(1))*ospin(1)
      endif
      if(kstar(2).lt.13)then
         ospin(2) = oorb
         jspin(2) = (k2str(2)*rad(2)*rad(2)*(mass(2)-massc(2))+
     &               k3*radc(2)*radc(2)*massc(2))*ospin(2)
      endif
      km0 = dtm0*1.0d+03/tb
      if(km0.lt.tiny) km0 = 0.5d0
      rol(1) = rl(q(1))*sep !okay like this 'cos sep is peri. dist.
      rol(2) = rl(q(2))*sep
      iter = 0
      coel = .false.
      change = .false.
      radx(j1) = MAX(radc(j1),rol(j1))
      radx(j2) = rad(j2)
*
      evolve_type = 3.0
      rrl1 = rad(1)/rol(1)
      rrl2 = rad(2)/rol(2)
      teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
      teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
      if(B_0(1).eq.0.d0)then !PK.
         b01_bcm = 0.d0
      elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
         b01_bcm = B_0(1)
      else
         b01_bcm = B(1)
      endif
      if(B_0(2).eq.0.d0)then
         b02_bcm = 0.d0
      elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
         b02_bcm = B_0(2)
      else
         b02_bcm = B(2)
      endif

      CALL writetab(jp,tphys,evolve_type,
     &              mass(1),mass(2),kstar(1),kstar(2),sep,
     &              tb,ecc,rrl1,rrl2,
     &              aj(1),aj(2),tms(1),tms(2),
     &              massc(1),massc(2),rad(1),rad(2),
     &              mass0(1),mass0(2),lumin(1),lumin(2),
     &              teff1,teff2,radc(1),radc(2),
     &              menv(1),menv(2),renv(1),renv(2),
     &              ospin(1),ospin(2),b01_bcm,b02_bcm,
     &              bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &              epoch(2),bhspin(1),bhspin(2),
     &              deltam1_bcm,deltam2_bcm,formation(1),
     &              formation(2),binstate,mergertype,'bpp')
*
      if(check_dtp.eq.1)then
          CALL checkstate(dtp,dtp_original,tsave,tphys,tphysf,
     &                      iplot,isave,binstate,evolve_type,
     &                      mass(1),mass(2),kstar(1),kstar(2),sep,
     &                      tb,ecc,rrl1,rrl2,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2),
     &                      mass0(1),mass0(2),lumin(1),lumin(2),
     &                      radc(1),radc(2),menv(1),menv(2),
     &                      renv(1),renv(2),
     &                      ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                      bacc(1),bacc(2),
     &                      tacc(1),tacc(2),epoch(1),epoch(2),
     &                      bhspin(1),bhspin(2),teff1,teff2)
      endif

      if(iplot.and.tphys.gt.tiny)then
          if(B_0(1).eq.0.d0)then !PK.
              b01_bcm = 0.d0
          elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
              b01_bcm = B_0(1)
          else
              b01_bcm = B(1)
          endif
          if(B_0(2).eq.0.d0)then
              b02_bcm = 0.d0
          elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
              b02_bcm = B_0(2)
          else
              b02_bcm = B(2)
          endif
          teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
          teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
          rrl1 = rad(1)/rol(1)
          rrl2 = rad(2)/rol(2)
          deltam1_bcm = 0.0
          deltam2_bcm = 0.0
* Check if PISN occurred, and if so overwrite formation
          if(pisn_track(1).ne.0) formation(1) = pisn_track(1)
          if(pisn_track(2).ne.0) formation(2) = pisn_track(2)
          CALL writetab(ip,tphys,evolve_type,
     &                  mass(1),mass(2),kstar(1),kstar(2),
     &                  sep,tb,ecc,rrl1,rrl2,
     &                  aj(1),aj(2),tms(1),tms(2),
     &                  massc(1),massc(2),rad(1),rad(2),
     &                  mass0(1),mass0(2),lumin(1),lumin(2),
     &                  teff1,teff2,radc(1),radc(2),
     &                  menv(1),menv(2),renv(1),renv(2),
     &                  ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                  bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                  epoch(2),bhspin(1),bhspin(2),
     &                  deltam1_bcm,deltam2_bcm,formation(1),
     &                  formation(2),binstate,mergertype,'bcm')
         if(output) write(*,*)'bcm2:',kstar(1),kstar(2),mass(1),
     & mass(2),rad(1),rad(2),ospin(1),ospin(2),jspin(1)
*     & mass(2),rad(1),rad(2),ospin(1),ospin(2),b01_bcm,b02_bcm,jspin(1)
      endif
*
* Eddington limit for accretion on to the secondary in one orbit.
*
 8    dme = 2.08d-03*eddfac*(1.d0/(1.d0 + zpars(11)))*rad(j2)*tb
* For BHs, follow Marchant et al. 2017
      if(kstar(j2).eq.14)then
         maxspinBH = 6.d0**(1.d0/2.d0) * Mbh_initial
         if(mass(j2).lt.maxspinBH)then
            etaBH = 1.d0 -
     &    (1.d0 - (mass(j2)/(3.d0*Mbh_initial))**(2.d0))**(1.d0/2.d0)
         else
            etaBH = 0.42
         endif
         dme = 1.04e-3*eddfac*(1.d0/(1.d0 + zpars(11)))
     &    *(1.d0/etaBH)*rad(j2)*tb
      endif

      supedd = .false.
      novae = .false.
      disk = .false.
*
* Determine whether the transferred material forms an accretion
* disk around the secondary or hits the secondary in a direct
* stream, by using eq.(1) of Ulrich & Burger (1976, ApJ, 206, 509)
* fitted to the calculations of Lubow & Shu (1974, ApJ, 198, 383).
*
*     if(kstar(j2).ge.10) disk = .true.
      rmin = 0.0425d0*sep*(q(j2)*(1.d0+q(j2)))**(1.d0/4.d0)
      if(rmin.gt.rad(j2)) disk = .true.
*
* Kelvin-Helmholtz time from the modified classical expression.
*
      do 13 , k = 1,2
         tkh(k) = 3.13d+07*mass(k)/(rad(k)*lumin(k))
         if(kstar(k).le.1.or.kstar(k).eq.7.or.kstar(k).ge.10)then
            tkh(k) = tkh(k)*mass(k)
         else
            tkh(k) = tkh(k)*(mass(k) - massc(k))
         endif
 13   continue
*
* Dynamical timescale for the primary.
*
      tdyn = 5.05d-05*SQRT(rad(j1)**3/mass(j1))

*
* Set default qcrit values and identify special cases.
*

      if(qcflag.eq.0)then
*
* Use the BSE equations and defaults:
* If q1 = m_donor/m_acc > qc then common envelope
*

         if(kstar(j1).eq.0)then
            qc = 0.695
         elseif(kstar(j1).eq.1)then
            qc = 3.d0
         elseif(kstar(j1).eq.2)then
            qc = 4.d0
         elseif(kstar(j1).eq.3)then
            qc = (1.67d0-zpars(7)+2.d0*(massc(j1)/mass(j1))**5)/2.13d0
         elseif(kstar(j1).eq.4)then
            qc = 3.d0
         elseif(kstar(j1).eq.5)then
            qc = (1.67d0-zpars(7)+2.d0*(massc(j1)/mass(j1))**5)/2.13d0
         elseif(kstar(j1).eq.6)then
            qc = (1.67d0-zpars(7)+2.d0*(massc(j1)/mass(j1))**5)/2.13d0
         elseif(kstar(j1).eq.7)then
            qc = 3.0d0
         elseif(kstar(j1).eq.8)then
            qc = 0.784d0
         elseif(kstar(j1).eq.9)then
            qc = 0.784d0
         elseif(kstar(j1).ge.10)then
            qc = 0.628
         endif
      elseif(qcflag.eq.1)then
*
* Use the BSE equations and Hjellming & Webbink, 1987, ApJ, 318, 794.
* for the GB/AGB:
* If q1 = m_donor/m_acc > qc then common envelope
*
         if(kstar(j1).eq.0)then
            qc = 0.695
         elseif(kstar(j1).eq.1)then
            qc = 3.d0
         elseif(kstar(j1).eq.2)then
            qc = 4.d0
         elseif(kstar(j1).eq.3)then
            qc = 0.362 + 1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
         elseif(kstar(j1).eq.4)then
            qc = 3.d0
         elseif(kstar(j1).eq.5)then
            qc = 0.362 + 1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
         elseif(kstar(j1).eq.6)then
            qc = 0.362 + 1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
         elseif(kstar(j1).eq.7)then
            qc = 3.0d0
         elseif(kstar(j1).eq.8)then
            qc = 0.784d0
         elseif(kstar(j1).eq.9)then
            qc = 0.784d0
         elseif(kstar(j1).ge.10)then
            qc = 0.628
         endif

      elseif(qcflag.eq.2)then
*
* Use the binary_c prescriptions taken from Claeys+2014 Table 2
* If q1 = m_donor/m_acc > qc then common envelope
*
         if(kstar(j2).lt.10)then
             if(kstar(j1).eq.0)then
                qc = 0.695
             elseif(kstar(j1).eq.1)then
                qc = 1.6d0
             elseif(kstar(j1).eq.2)then
                qc = 4.d0
             elseif(kstar(j1).eq.3)then
               qc = (1.67d0-zpars(7)+
     &               2.d0*(massc(j1)/mass(j1))**5)/2.13d0
             elseif(kstar(j1).eq.4)then
                qc = 3.d0
             elseif(kstar(j1).eq.5)then
               qc = (1.67d0-zpars(7)+
     &               2.d0*(massc(j1)/mass(j1))**5)/2.13d0
             elseif(kstar(j1).eq.6)then
               qc = (1.67d0-zpars(7)+
     &               2.d0*(massc(j1)/mass(j1))**5)/2.13d0
             elseif(kstar(j1).eq.7)then
                qc = 3.0d0
             elseif(kstar(j1).eq.8)then
                qc = 4.0d0
             elseif(kstar(j1).eq.9)then
                qc = 0.784d0
             elseif(kstar(j1).ge.10)then
                qc = 3.0d0
             endif
         elseif(kstar(j2).ge.10)then
             if(kstar(j1).eq.0)then
                qc = 1.0d0
             elseif(kstar(j1).eq.1)then
                qc = 1.0d0
             elseif(kstar(j1).eq.2)then
                qc = 4.7619d0
             elseif(kstar(j1).eq.3)then
                qc = 1.15d0
             elseif(kstar(j1).eq.4)then
                qc = 3.d0
             elseif(kstar(j1).eq.5)then
                qc = 1.15d0
             elseif(kstar(j1).eq.6)then
                qc = 1.15d0
             elseif(kstar(j1).eq.7)then
                qc = 3.0d0
             elseif(kstar(j1).eq.8)then
               qc = 4.7619d0
             elseif(kstar(j1).eq.9)then
                qc = 1.15d0
             elseif(kstar(j1).ge.10)then
                qc = 0.625d0
             endif
         endif
      elseif(qcflag.eq.3)then
*
* Use the binary_c prescriptions taken from Claeys+2014 Table 2
* but w/ Hjellming & Webbink for GB/AGB
* If q1 = m_donor/m_acc > qc then common envelope
*
         if(kstar(j2).lt.10)then
             if(kstar(j1).eq.0)then
                qc = 0.695
             elseif(kstar(j1).eq.1)then
                qc = 1.6d0
             elseif(kstar(j1).eq.2)then
                qc = 4.d0
             elseif(kstar(j1).eq.3)then
               qc = 0.362 +
     &              1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
             elseif(kstar(j1).eq.4)then
                qc = 3.d0
             elseif(kstar(j1).eq.5)then
               qc = 0.362 +
     &              1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
             elseif(kstar(j1).eq.6)then
               qc = 0.362 +
     &              1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
             elseif(kstar(j1).eq.7)then
                qc = 3.0d0
             elseif(kstar(j1).eq.8)then
                qc = 4.0d0
             elseif(kstar(j1).eq.9)then
                qc = 0.784d0
             elseif(kstar(j1).ge.10)then
                qc = 3.0d0
             endif
         elseif(kstar(j2).ge.10)then
             if(kstar(j1).eq.0)then
                qc = 1.0d0
             elseif(kstar(j1).eq.1)then
                qc = 1.0d0
             elseif(kstar(j1).eq.2)then
                qc = 4.7619d0
             elseif(kstar(j1).eq.3)then
                qc = 1.15d0
             elseif(kstar(j1).eq.4)then
                qc = 3.d0
             elseif(kstar(j1).eq.5)then
                qc = 1.15d0
             elseif(kstar(j1).eq.6)then
                qc = 1.15d0
             elseif(kstar(j1).eq.7)then
                qc = 3.0d0
             elseif(kstar(j1).eq.8)then
               qc = 4.7619d0
             elseif(kstar(j1).eq.9)then
                qc = 1.15d0
             elseif(kstar(j1).ge.10)then
                qc = 0.625d0
             endif
         endif
      elseif(qcflag.eq.4)then
*
* Use the StarTrack prescriptions taken from Belczynski+2008
* section 5.1
* If q1 = m_donor/m_acc > qc then common envelope
*
* Note: this does not do the WD mass ratios exactly the same.
* We do the standard 0.628 mass ratio from BSE since we don't
* compute the mass transfer rates the same
         if(kstar(j1).eq.0)then
            qc = 3.d0
         elseif(kstar(j1).eq.1)then
            qc = 3.d0
         elseif(kstar(j1).eq.2)then
            qc = 3.d0
         elseif(kstar(j1).eq.3)then
            qc = 3.d0
         elseif(kstar(j1).eq.4)then
            qc = 3.d0
         elseif(kstar(j1).eq.5)then
            qc = 3.d0
         elseif(kstar(j1).eq.6)then
            qc = 3.d0
         elseif(kstar(j1).eq.7)then
            qc = 1.7d0
         elseif(kstar(j1).eq.8)then
            qc = 3.5
         elseif(kstar(j1).eq.9)then
            qc = 3.5
         elseif(kstar(j1).ge.10)then
            qc = 0.628
         endif
      elseif(qcflag.eq.5)then
*
* Use the COMPAS prescriptions taken from Neijssel+2020,
* section 2.3
* We convert from radial response to qcrit for MS and HG,
* which assumes conservative mass transfer
* Stable MT is always assumed for stripped stars
* Assume standard qcrit from BSE for kstar>=10
* If q1 = m_donor/m_acc > qc then common envelope
*
         if(kstar(j1).eq.0)then
            qc = 1.717d0
         elseif(kstar(j1).eq.1)then
            qc = 1.717d0
         elseif(kstar(j1).eq.2)then
            qc = 3.825d0
         elseif(kstar(j1).eq.3)then
           qc = 0.362 + 1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
         elseif(kstar(j1).eq.4)then
            qc = 3.d0
         elseif(kstar(j1).eq.5)then
           qc = 0.362 + 1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
         elseif(kstar(j1).eq.6)then
           qc = 0.362 + 1.0/(3.0*(1.0 - massc(j1)/mass(j1)))
         elseif(kstar(j1).eq.7)then
            qc = 1000.d0
         elseif(kstar(j1).eq.8)then
            qc = 1000.d0
         elseif(kstar(j1).eq.9)then
            qc = 1000.d0
         elseif(kstar(j1).ge.10)then
            qc = 0.628
         endif
      endif
*
* Allow for manually overriding qcrit values with fixed
* values supplied from ini file.
*
      qc_fixed = qcrit_array(kstar(j1)+1)
      if(qc_fixed.ne.0)then
         qc = qc_fixed
      endif

      if((kstar(j1).le.1.or.kstar(j1).eq.7).and.q(j1).gt.qc)then
*
* KB 20 jul 23: This will lead to a merger of the two MS stars.
* The result is always a single star placed in *2.
*
         CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
         taum = SQRT(tkh(j1)*tdyn)
         dm1 = mass(j1)
         if(kstar(j2).le.1)then
*
* Assume perfect accretion efficiency
*
            dm2 = dm1
            mass(j2) = mass(j2) + dm2
*
* Rejuvenate if the star is still on the main sequence.
*
            mass0(j2) = mass(j2)
            CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,
     &                tscls,lums,GB,zpars)
* If the star has no convective core then the effective age decreases,
* otherwise it will become younger still.
            if(mass(j2).lt.0.35d0.or.mass(j2).gt.1.25d0)then
               aj(j2) = tmsnew/tms(j2)*aj(j2)*(mass(j2) - dm2)/mass(j2)
            else
               aj(j2) = tmsnew/tms(j2)*aj(j2)
            endif
            epoch(j2) = tphys - aj(j2)
         elseif(kstar(j2).le.6)then
*
* Add all the material to the giant's envelope.
*
            dm2 = dm1
            mass(j2) = mass(j2) + dm2
            if(kstar(j2).eq.2)then
               mass0(j2) = mass(j2)
               CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,tscls,
     &                   lums,GB,zpars)
               aj(j2) = tmsnew + tscls(1)*(aj(j2)-tms(j2))/tbgb(j2)
               epoch(j2) = tphys - aj(j2)
            endif
         elseif(kstar(j2).le.12)then
*
* Form a new giant envelope.
*
            dm2 = dm1
            kst = ktype(kstar(j1),kstar(j2))
            if(kst.gt.100) kst = kst - 100
            if(kst.eq.4)then
               aj(j2) = aj(j2)/tms(j2)
               massc(j2) = mass(j2)
            endif
*
* Check for planets or low-mass WDs.
*
            if((kstar(j2).eq.10.and.mass(j2).lt.0.05d0).or.
     &         (kstar(j2).ge.11.and.mass(j2).lt.0.1d0))then
               kst = kstar(j1)
               mass(j1) = mass(j2) + dm2
               mass(j2) = 0.d0
            else
               mass(j2) = mass(j2) + dm2
               CALL gntage(massc(j2),mass(j2),kst,zpars,
     &                     mass0(j2),aj(j2))
               epoch(j2) = tphys - aj(j2)
            endif
            kstar(j2) = kst
         else
*
* The neutron star or black hole simply accretes at the Eddington rate.
*
            dm2 = MIN(dme*taum/tb,dm1)
            if(dm2.lt.dm1) supedd = .true.
            mass(j2) = mass(j2) + dm2
         endif
         coel = .true.
         binstate = 1
         if(mass(j2).gt.0.d0)then
            mass(j1) = 0.d0
            kstar(j1) = 15
         else
            kstar(j1) = kstar(j2)
            kstar(j2) = 15
         endif
         goto 135
*
*KB added RRLO_1 flag to send RRLO_1 > 10 into CE for post-MS binaries
*
      elseif(((kstar(j1).eq.3.or.kstar(j1).eq.5.or.kstar(j1).eq.6.or.
     &        kstar(j1).eq.8.or.kstar(j1).eq.9)
     &        .and.(q(j1).gt.qc.or.radx(j1).le.radc(j1))).or.
     &       (kstar(j1).eq.2.and.q(j1).gt.qc).or.
     &       (kstar(j1).eq.4.and.q(j1).gt.qc))then
*
* Common-envelope evolution.
*
         m1ce = mass(j1)
         m2ce = mass(j2)
         kcomp1 = kstar(j1) !PDK
         kcomp2 = kstar(j2)
         if(j1.eq.2)then
             switchedCE = .true.
         else
             switchedCE = .false.
         endif
         evolve_type = 7.d0
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
         if(B_0(1).eq.0.d0)then !PK.
            b01_bcm = 0.d0
         elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
            b01_bcm = B_0(1)
         else
            b01_bcm = B(1)
         endif
         if(B_0(2).eq.0.d0)then
            b02_bcm = 0.d0
         elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
            b02_bcm = B_0(2)
         else
            b02_bcm = B(2)
         endif

         CALL writetab(jp,tphys,evolve_type,
     &                 mass(1),mass(2),
     &                 kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2),
     &                 mass0(1),mass0(2),lumin(1),lumin(2),
     &                 teff1,teff2,radc(1),radc(2),
     &                 menv(1),menv(2),renv(1),renv(2),
     &                 ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                 bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                 epoch(2),bhspin(1),bhspin(2),
     &                 deltam1_bcm,deltam2_bcm,formation(1),
     &                 formation(2),binstate,mergertype,'bpp')

         CALL comenv(mass0(j1),mass(j1),massc(j1),aj(j1),jspin(j1),
     &               kstar(j1),mass0(j2),mass(j2),massc(j2),aj(j2),
     &               jspin(j2),kstar(j2),zpars,ecc,sep,jorb,coel,j1,j2,
     &               vk,kick_info,formation(j1),formation(j2),sigmahold,
     &               bhspin(j1),bhspin(j2),binstate,mergertype,
     &               jp,tphys,switchedCE,rad,tms,evolve_type,disrupt,
     &               lumin,B_0,bacc,tacc,epoch,menv,renv,bkick,
     &               deltam1_bcm,deltam2_bcm)
         if(j1.eq.2.and.kcomp2.eq.13.and.kstar(j2).eq.15.and.
     &      kstar(j1).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j1) = formation(j2)
         endif
         if(j1.eq.1.and.kcomp2.eq.13.and.kstar(j2).eq.15.and.
     &      kstar(j1).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j1) = formation(j2)
         endif
         com = .true.
         if(com.and..not.coel.and..not.disrupt)then
* if it went through common envelope
* did not disrupt (from one of the objects going SN)
* and did not merge in common envelope
* then system is still in binary
            binstate = 0
            mergertype = -1
         elseif(com.and..not.coel.and.disrupt)then
* if it went through common envelope
* and did disrupt (from one of the objects going SN)
* and did not merge in common envelope
* then system should be marked as disrupted
            binstate = 2
            mergertype = -1
         endif
         if(binstate.eq.1.d0)then
             sep = 0.d0
             tb = 0.d0
         elseif(binstate.eq.2.d0)then
             sep = -1.d0
             tb = -1.d0
         endif
         if(j1.eq.2.and.kcomp2.eq.13.and.kstar(j2).eq.15.and.
     &      kstar(j1).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j1) = formation(j2)
         endif
         if(j1.eq.1.and.kcomp2.eq.13.and.kstar(j2).eq.15.and.
     &      kstar(j1).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j1) = formation(j2)
         endif

*
         evolve_type = 8.0
         
         
         mc = massc(1)
         rc = radc(1)
         CALL star(kstar(1),mass0(1),mass(1),tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(mass0(1),aj(1),mass(1),tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kstar(1),mc,rc,me,re,k2,bhspin(1),1)
     
         rad(1) = rm
         lumin(1) = lum  
         massc(1) = mc
         radc(1) = rc
         menv(1) = me
         renv(1) = re
         
         
         mc = massc(2)
         rc = radc(2)
         CALL star(kstar(2),mass0(2),mass(2),tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(mass0(2),aj(2),mass(2),tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kstar(2),mc,rc,me,re,k2,bhspin(2),2)
     
         rad(2) = rm
         lumin(2) = lum  
         massc(2) = mc
         radc(2) = rc
         menv(2) = me
         renv(2) = re

         mass1_bpp = mass(1)
         mass2_bpp = mass(2)
         if(kstar(1).eq.15) mass1_bpp = mass0(1)
         if(kstar(2).eq.15) mass2_bpp = mass0(2)
         rrl1 = rad(1)/rol(1)
         rrl2 = rad(2)/rol(2)
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
         if(B_0(1).eq.0.d0)then !PK.
            b01_bcm = 0.d0
         elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
            b01_bcm = B_0(1)
         else
            b01_bcm = B(1)
         endif
         if(B_0(2).eq.0.d0)then
            b02_bcm = 0.d0
         elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
            b02_bcm = B_0(2)
         else
            b02_bcm = B(2)
         endif

         CALL writetab(jp,tphys,evolve_type,
     &                 mass1_bpp,mass2_bpp,
     &                 kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2),
     &                 mass0(1),mass0(2),lumin(1),lumin(2),
     &                 teff1,teff2,radc(1),radc(2),
     &                 menv(1),menv(2),renv(1),renv(2),
     &                 ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                 bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                 epoch(2),bhspin(1),bhspin(2),
     &                 deltam1_bcm,deltam2_bcm,formation(1),
     &                 formation(2),binstate,mergertype,'bpp')
*
         epoch(j1) = tphys - aj(j1)
         com = .false.
         if(coel)then
            com = .true.
            goto 135
         endif
         epoch(j2) = tphys - aj(j2)
         if(ecc.gt.1.d0)then
            if(kstar(1).ge.13)then
               rc = corerd(kstar(1),mass(1),mass(1),zpars(2))
               ospin(1) = jspin(1)/(k3*rc*rc*mass(1))
            endif
            if(kstar(2).ge.13)then
               rc = corerd(kstar(2),mass(2),mass(2),zpars(2))
               ospin(2) = jspin(2)/(k3*rc*rc*mass(2))
            endif
            goto 135
         endif
*
* Next step should be made without changing the time.
*
         dm1 = m1ce - mass(j1)
         dm2 = mass(j2) - m2ce
         dm22 = dm2
         dtm = 0.d0
*
* Reset orbital parameters as separation may have changed.
*
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
      elseif(kstar(j1).ge.10.and.kstar(j1).le.12.and.
     &       q(j1).gt.qc)then
*
* Dynamic transfer from a white dwarf.  Secondary will have KW > 9.
*
         CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
         taum = SQRT(tkh(j1)*tdyn)
         dm1 = mass(j1)
         if(eddfac.lt.10.d0)then
*           dm2 = MIN(dme*taum/tb,dm1)
            if(wd_mass_lim.eq.1)then
               dm2 = MIN(dme*taum/tb,dm1)
            elseif(wd_mass_lim.eq.0)then
               dm2 = dm1
            endif
            if(dm2.lt.dm1) supedd = .true.
         else
            dm2 = dm1
         endif
         mass(j2) = mass(j2) + dm2
*
         if(kstar(j1).eq.10.and.kstar(j2).eq.10)then
*
* Assume the energy released by ignition of the triple-alpha reaction
* is enough to destroy the star.
*
            kstar(j2) = 15
            mass(j2) = 0.d0
         elseif(kstar(j1).eq.10.and.kstar(j2).gt.10)then
*
* Should be helium overflowing onto a CO or ONe core in which case the
* helium swells up to form a giant envelope so a HeGB star is formed.
* Allowance for the rare case of CO or ONe flowing onto He is made.
*
            kst = 9
            if(kstar(j2).eq.10) massc(j2) = dm2
            CALL gntage(massc(j2),mass(j2),kst,zpars,mass0(j2),aj(j2))
            kstar(j2) = kst
            epoch(j2) = tphys - aj(j2)
         elseif(kstar(j2).le.12)then
            mass0(j2) = mass(j2)
            if(kstar(j1).eq.12.and.kstar(j2).eq.11)then
*
* Mixture of ONe and CO will result in an ONe product.
*
               kstar(j2) = 12
            endif
            if(kstar(j1).eq.11.and.kstar(j2).eq.11)then !PK.
*
* Following Startrack of merger of two CO will result in an ONe or NS product
* (depending upon mass, if kstar = 12 and mass > Mecsn then hrdiag will update
* accordingly).
*
               kstar(j2) = 12
            endif
            formation(j2) = 11
         endif
         kstar(j1) = 15
         mass(j1) = 0.d0
*
* Might be a supernova that destroys the system.
*
         if(kstar(j2).le.11.and.mass(j2).gt.mch)then
            kstar(j2) = 15
            mass(j2) = 0.d0
         endif
         coel = .true.
         binstate = 1
         goto 135
      elseif(kstar(j1).eq.13)then
*
* Gamma ray burster?
*
         CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
         dm1 = mass(j1)
         mass(j1) = 0.d0
         kstar(j1) = 15
         dm2 = dm1
         mass(j2) = mass(j2) + dm2
         kstar(j2) = 14
         coel = .true.
         binstate = 1
         goto 135
      elseif(kstar(j1).eq.14)then
*
* Both stars are black holes.  Let them merge quietly.
*
         CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
         dm1 = mass(j1)
         mass(j1) = 0.d0
         kstar(j1) = 15
         dm2 = dm1
         mass(j2) = mass(j2) + dm2
         coel = .true.
         binstate = 1
         goto 135
      else
*
* Mass transfer in one Kepler orbit.
*
*
* KB: adding in stable mass transfer factor from
*     eqs 10-11 of Claeys+2014 as don_lim flag instead
*     of qcflag (10/12/20)
*
         if(don_lim.eq.-2)then
            if(q(j1).gt.1)then
               f_fac=1000.d0
            else
               f_fac=1000*q(j1)*
     &               EXP(-0.5d0*(-LOG(q(j1))/0.15d0)**2)
               if(f_fac.lt.1)then
                  f_fac=1
               endif
            endif
            dm1 = f_fac*3.0d-06*tb*(LOG(rad(j1)/rol(j1))**3)*
     &            MIN(mass(j1),5.d0)**2
         elseif(don_lim.eq.-1)then
            dm1 = 3.0d-06*tb*(LOG(rad(j1)/rol(j1))**3)*
     &            MIN(mass(j1),5.d0)**2
         endif
*         dm1 = MIN(dm1, mass(j1)*tb/tkh(j1))
         if(kstar(j1).eq.2)then
            mew = (mass(j1) - massc(j1))/mass(j1)
            dm1 = MAX(mew,0.01d0)*dm1
         elseif(kstar(j1).ge.10)then
*           dm1 = dm1*1.0d+03/MAX(rad(j1),1.0d-04)
            dm1 = dm1*1.0d+03*mass(j1)/MAX(rad(j1),1.0d-04)
         endif
         kst = kstar(j2)
*
* Possibly mass transfer needs to be reduced if primary is rotating
* faster than the orbit (not currently implemented).
*
*        spnfac = MIN(3.d0,MAX(ospin(j1)/oorb,1.d0))
*        dm1 = dm1/spnfac**2
*
* Limit mass transfer to the thermal rate for all fusing stars
* and to the dynamical rate for all others.
*
         if(kstar(j1).ge.0.and.kstar(j1).le.9)then
***
* JH_temp ... this may be good for HG RLOF??
*           if(kstar(j1).eq.2)then
*              mew = rad(j1)/rol(j1) - 1.d0
*              mew = 2.d0*mew
*              dm1 = dm1*10.d0**mew
*           endif
***
            dm1 = MIN(dm1,mass(j1)*tb/tkh(j1))
         endif
*
* Now we will initiate a CE for giants or merger for MS
* if RRLO_1 > 10. Previously a MS + MS & q > c conditional
* existed here, but it is completely defunct at this point
*

         if(rad(j1).gt.10.d0*rol(j1).and.kstar(j1).le.1.and.
     &      kstar(j2).le.1)then
*
* Allow the stars to merge with the product in *1.
*
            CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
            m1ce = mass(j1)
            m2ce = mass(j2)
            if((kstar(1).ge.10.and.kstar(1).le.12).and.
     &         (kstar(2).ge.10.and.kstar(2).le.12))then
               formation(1) = 11
               formation(2) = 11
            endif
            CALL mix(mass0,mass,aj,kstar,zpars,bhspin)
            dm1 = m1ce - mass(j1)
            dm2 = mass(j2) - m2ce
*
* Next step should be made without changing the time.
*
            dtm = 0.d0
            epoch(1) = tphys - aj(1)
            coel = .true.
            binstate = 1
            goto 135
         endif
         if(kstar(j1).gt.9)then
            dm1 = MIN(dm1,mass(j1)*tb/tdyn)
         endif
*
* Calculate wind mass loss from the stars during one orbit.
*
         vorb2 = acc1*(mass(1)+mass(2))/sep
         ivsqm = 1.d0/SQRT(1.d0-ecc*ecc)
         do 14 , k = 1,2
*
* Determine the eddington limit for the accretor (3-k)
* Just in case the wind mass loss rates are *very* high
*
            dme = 2.08d-03*eddfac*(1.d0/(1.d0 + zpars(11)))*rad(3-k)*tb
* For BHs, follow Marchant et al. 2017
            if(kstar(3-k).eq.14)then
               maxspinBH = 6.d0**(1.d0/2.d0) * Mbh_initial
               if(mass(3-k).lt.maxspinBH)then
                  etaBH = 1.d0 -
     &    (1.d0 - (mass(3-k)/(3.d0*Mbh_initial))**(2.d0))**(1.d0/2.d0)
               else
                  etaBH = 0.42
               endif
               dme = 1.04e-3*eddfac*(1.d0/(1.d0 + zpars(11)))
     &    *(1.d0/etaBH)*rad(3-k)*tb
            endif

            !check for kstar added by PA
            if(neta.gt.tiny .and. kstar(k)<15)then
               if(beta.lt.0.d0)then !PK. following startrack
                  beta = 0.125
                  if(kstar(k).le.1)then
                     if(mass(k).gt.120.d0)then
                        beta = 7.d0
                     elseif(mass(k).le.1.4d0)then
                        beta = 0.5
                     else
                        beta = 7.d0*((mass(k)-1.4d0)/(120.d0-1.4d0))
     &                         + 0.5d0
                     endif
                  elseif(kstar(k).ge.7.and.kstar(k).le.9)then
                     if(mass(k).gt.120.d0)then
                        beta = 7.d0
                     elseif(mass(k).le.10.d0)then
                        beta = 0.125
                     else
                        beta = 7.d0*((mass(k)-10.d0)/(120.d0-10.d0))
     &                               + 0.125d0
                     endif
                  endif
               endif
               rlperi = rol(k)*(1.d0-ecc)
               dmr(k) = mlwind(kstar(k),lumin(k),radx(k),
     &                         mass(k),massc(k),rlperi,z)
               vwind2 = 2.d0*beta*acc1*mass(k)/radx(k)
               omv2 = (1.d0 + vorb2/vwind2)**(3.d0/2.d0)
               dmt(3-k) = ivsqm*acc2*dmr(k)*((acc1*mass(3-k)/vwind2)**2)
     &                    /(2.d0*sep*sep*omv2)
               dmt(3-k) = MIN(dmt(3-k),dmr(k))
*
* Apply Eddington limit
*
               dmt(3-k) = MIN(dmt(3-k),dme/tb)
               if(dmt(3-k).eq.dme/tb) supedd = .true.
               beta = betahold
            else
               dmr(k) = 0.d0
               dmt(3-k) = 0.d0
            endif
 14      continue
*
         do 15 , k = 1,2
            dms(k) = (dmr(k)-dmt(k))*tb
 15      continue
*
* Increase time-scale to relative mass loss of 0.5% but not more than twice.
* KM is the number of orbits for the timestep.
*
         km = MIN(2.d0*km0,5.0d-03/
     &            MAX(ABS(dm1+dms(j1))/mass(j1),dms(j2)/mass(j2)))
         km0 = km
*
*       Modify time-step & mass loss terms by speed-up factor.
*
         dt = km*tb
         dtm = dt/1.0d+06
*
* Take the stellar evolution timestep into account but don't let it
* be overly restrictive for long lived phases.
*

* NOTE: This can cause NaN values! If you get NaNs, check what happens
*       when you increase `loop` (see PR #647) - TW
*
         if(iter.le.loop) dtm = MIN(dtm,dtmi(1),dtmi(2))

         dtm = MIN(dtm,tsave-tphys)
         dt = dtm*1.0d+06
         km = dt/tb
*
* Decide between accreted mass by secondary and/or system mass loss.
*
         taum = mass(j2)/dm1*tb


*
* KB 4/Jan/21: adding in acc_lim flags
* MZ 30/Mar/21: slight adjustment to flag designations
* acc_lim >= 0: fraction of donor mass loss accreted; supersceded by
*              eddington limits and/or novae on WDs.
* acc_lim = -1: standard BSE w/ MS/HG/CHeB assumed to have thermal
*              limit of 10*tkh while giants are unlimited. If the
*              accretor is He-rich (>=7), limit is 10*tkh if accretor
*              is He-MS/HeHG/HeAGB and unlimited if donor is H-rich
* acc_lim = -2: same as acc_lim = -1, but for 1*tkh instead
* acc_lim = -3: accretor kw=0-6 have thermal limit of 10*tkh. If the
*               acretor is He-rich (>=7), limit is 10*tkh if donor
*               is He-MS/HeHG/HeAGB and unlimited if donor is H-rich
* acc_lim = -4: accretor kw=0-6 have thermal limit of tkh. If the
*               accretor is He-rich (>=7), limit is 1*tkh if donor
*               is He-MS/HeHG/HeAGB and unlimited if donor is H-rich
*
* Note that acc_lim >= 0 means that the thermal limit is not considered
*


         if(kstar(j2).le.2.or.kstar(j2).eq.4)then
            if(acc_lim.eq.-1.or.acc_lim.eq.-3)then
               dm2 = MIN(1.d0,10.d0*taum/tkh(j2))*dm1
            elseif(acc_lim.eq.-2.or.acc_lim.eq.-4)then
               dm2 = MIN(1.d0,taum/tkh(j2))*dm1
            elseif(acc_lim.ge.0.d0)then
               dm2 = acc_lim*dm1
            endif
         elseif(kstar(j2).ge.7.and.kstar(j2).le.9)then
*
* Naked helium star secondary swells up to a core helium burning star
* or SAGB star unless the primary is also a helium star.
*
            if(kstar(j1).ge.7)then
               if(acc_lim.eq.-1.or.acc_lim.eq.-3)then
                  dm2 = MIN(1.d0,10.d0*taum/tkh(j2))*dm1
               elseif(acc_lim.eq.-2.or.acc_lim.eq.-4)then
                  dm2 = MIN(1.d0,taum/tkh(j2))*dm1
               elseif(acc_lim.ge.0.d0)then
                  dm2 = acc_lim*dm1
               endif
            else
               if(acc_lim.lt.0.d0)then
                  dm2 = dm1
               elseif(acc_lim.ge.0.d0)then
                  dm2 = acc_lim*dm1
               endif
               dmchk = dm2 - 1.05d0*dms(j2)
               if(dmchk.gt.0.d0.and.dm2/mass(j2).gt.1.0d-04)then
                  kst = MIN(6,2*kstar(j2)-10)
                  if(kst.eq.4)then
                     aj(j2) = aj(j2)/tms(j2)
                     mcx = mass(j2)
                  else
                     mcx = massc(j2)
                  endif
                  mt2 = mass(j2) + km*(dm2 - dms(j2))
                  CALL gntage(mcx,mt2,kst,zpars,mass0(j2),aj(j2))
                  epoch(j2) = tphys + dtm - aj(j2)
               endif
            endif
         elseif(kstar(j1).le.6.and.
     &           (kstar(j2).ge.10.and.kstar(j2).le.12))then
*
* White dwarf secondary.
*
            if(dm1/tb.lt.2.71d-07)then
               if(dm1/tb.lt.1.03d-07)then
*
* Accrete until a nova explosion blows away most of the accreted material.
*
                  novae = .true.
                  if(acc_lim.lt.0.d0)then
                     dm2 = MIN(dm1,dme)
                     if(dm2.lt.dm1) supedd = .true.
                  elseif(acc_lim.ge.0.d0)then
                     dm2 = MIN(dm2,acc_lim*dm1)
                     if(dm2.lt.acc_lim*dm1) supedd = .true.
                  endif
                  dm22 = epsnov*dm2
               else
*
* Steady burning at the surface
*
                  if(acc_lim.lt.0.d0)then
                     dm2 = dm1
                  elseif(acc_lim.ge.0.d0)then
                     dm2 = acc_lim*dm1
                  endif
               endif
            else
*
* Make a new giant envelope.
*
               if(acc_lim.lt.0.d0)then
                  dm2 = dm1
               elseif(acc_lim.ge.0.d0)then
                  dm2 = MIN(dm2,acc_lim*dm1)
               endif
*
* Check for planets or low-mass WDs.
*
               if((kstar(j2).eq.10.and.mass(j2).lt.0.05d0).or.
     &            (kstar(j2).ge.11.and.mass(j2).lt.0.5d0))then
                  kst = kstar(j2)
               else
                  kst = MIN(6,3*kstar(j2)-27)
                  mt2 = mass(j2) + km*(dm2 - dms(j2))
                  CALL gntage(massc(j2),mt2,kst,zpars,mass0(j2),aj(j2))
                  epoch(j2) = tphys + dtm - aj(j2)
*
               endif
*
            endif
         elseif(kstar(j2).eq.3.or.kstar(j2).eq.5.or.kstar(j2).eq.6)then
* We have a giant w/ kstar(j2) = 3,5,6
*
            if(acc_lim.eq.-1.or.acc_lim.eq.-2)then
               dm2 = dm1
            elseif(acc_lim.eq.-3)then
               dm2 = MIN(1.d0,10*taum/tkh(j2))*dm1
            elseif(acc_lim.eq.-4)then
               dm2 = MIN(1.d0,taum/tkh(j2))*dm1
            elseif(acc_lim.ge.0.d0)then
               dm2 = MIN(dm2,acc_lim*dm1)
            endif

         endif

*
* Impose the Eddington limit.
*
         if(kstar(j2).ge.10)then
            if(acc_lim.lt.0.d0)then
*
* If there is wind accretion the total amount of mass change is
* dms(j2) = dmr(j2) - dmt(j2), where dmt(j2) is the accretion
* from the companion. We should limit to the Eddington limit minus
* the amount of accretion that is already coming in from Winds
*
               dm2 = MIN(dm1,dme + dms(j2))
*
* If we already hit supereddington wind accretion, don't add
* any more mass through RLO
*
               if(supedd.eqv..true.) dm2 = 0.d0
               if(dm2.lt.dm1) supedd = .true.
            elseif(acc_lim.ge.0.d0)then
*
* If there is wind accretion the total amount of mass change is
* dms(j2) = dmr(j2) - dmt(j2), where dmt(j2) is the accretion
* from the companion. We should limit to the Eddington limit minus
* the amount of accretion that is already coming in from Winds
*
               dm2 = MIN(acc_lim*dm1,dme + dms(j2))
*
* If we already hit supereddington wind accretion, don't add
* any more mass through RLO
*
               if(supedd.eqv..true.) dm2 = 0.d0
               if(dm2.lt.acc_lim*dm1) supedd = .true.
            endif

*
* Can add pulsar propeller evolution here if need be. PK.
*
         endif


         if(.not.novae) dm22 = dm2
*
         if(kst.ge.10.and.kst.le.12)then
            mt2 = mass(j2) + km*(dm22 - dms(j2))
            if(kstar(j1).le.10.and.kst.eq.10.and.mt2.ge.0.7d0)then
*
* HeWD can only accrete helium-rich material up to a mass of 0.7 when
* it is destroyed in a possible Type 1a SN.
*
               mass(j1) = mass(j1) - km*(dm1 + dms(j1))
               mass(j2) = 0.d0
               kstar(j2) = 15
               goto 135
            elseif(kstar(j1).le.10.and.kst.ge.11)then
*
* CO and ONeWDs accrete helium-rich material until the accumulated
* material exceeds a mass of 0.15 when it ignites. For a COWD with
* mass less than 0.95 the system will be destroyed as an ELD in a
* possible Type 1a SN. COWDs with mass greater than 0.95 and ONeWDs
* will survive with all the material converted to ONe (JH 30/09/99).
*
** Now changed to an ELD for all COWDs when 0.15 accreted (JH 11/01/00).
*
               if((mt2-mass0(j2)).ge.0.15d0)then
                  if(kst.eq.11)then
                     mass(j1) = mass(j1) - km*(dm1 + dms(j1))
                     mass(j2) = 0.d0
                     kstar(j2) = 15
                     goto 135
                  endif
                  mass0(j2) = mt2
               endif
            else
               mass0(j2) = mt2
            endif
*
* If the Chandrasekhar limit is exceeded for a white dwarf then destroy
* the white dwarf in a supernova. If the WD is ONe then a neutron star
* will survive the supernova and we let HRDIAG take care of this when
* the stars are next updated.
*
            if(kst.eq.10.or.kst.eq.11)then
               if(mt2.ge.mch)then
                  dm1 = mch - mass(j2) + km*dms(j2)
                  mass(j1) = mass(j1) - dm1 - km*dms(j1)
                  mass(j2) = 0.d0
                  kstar(j2) = 15
                  goto 135
               endif
            endif
         endif
*
*       Modify mass loss terms by speed-up factor.
*
         dm1 = km*dm1
         dm2 = km*dm2
         dm22 = km*dm22
         dme = km*dme

*
* Calculate orbital angular momentum change due to system mass loss.
*
         djorb = ((dmr(1)+q(1)*dmt(1))*mass(2)*mass(2) +
     &            (dmr(2)+q(2)*dmt(2))*mass(1)*mass(1))/
     &           (mass(1)+mass(2))**2
         djorb = djorb*dt
*
* For super-Eddington mass transfer rates, for gamma == -2,
* and for novae systems, assume that material is lost from
* the system as if a wind from the secondary.
*
         if(supedd.or.novae.or.int(gamma).eq.-2)then
            djorb = djorb + (dm1 - dm22)*mass(j1)*mass(j1)/
     &              (mass(1)+mass(2))**2
* If gamma == -3: Assume mass is lost through the outer 
* Lagrangian point, forming a circumbinary disk. See
* Zapartas+17 Eq. 9 and Artymowicz & Lubow (1994).
* Set rmin=2a, which is consistent with A&L94 simulations.
         elseif(int(gamma).eq.-3)then
            gammadisc = (mass(1) + mass(2))**2
     &                / (mass(1) * mass(2)) * sqrt(2.d0)
            djorb = djorb + gammadisc * (dm1 - dm2)
* If gamma == -1 then assume the lost material carries with it
* the specific angular momentum of the primary and for all
         elseif(int(gamma).eq.-1) then
            djorb = djorb + (dm1 - dm2)*mass(j2)*mass(j2)/
     &              (mass(1)+mass(2))**2
* gamma > 0.0 assume that it takes away a fraction gamma of
* the orbital angular momentum.
         elseif(gamma.ge.0.d0)then
            djorb = djorb + gamma*(dm1 - dm2)
         endif
*
         ecc2 = ecc*ecc
         omecc2 = 1.d0 - ecc2
         sqome2 = SQRT(omecc2)
*
         djorb = djorb*sep*sep*sqome2*oorb
         delet = 0.d0
*
* For very close systems include angular momentum loss mechanisms.
*
         if(sep.le.100000.d0.and.grflag.eq.1)then
            djgr = 8.315d-10*mass(1)*mass(2)*(mass(1)+mass(2))/
     &             (sep*sep*sep*sep)
            f1 = (19.d0/6.d0) + (121.d0/96.d0)*ecc2
            sqome5 = sqome2**5
            delet1 = djgr*ecc*f1/sqome5
            djgr = djgr*jorb*(1.d0+0.875d0*ecc2)/sqome5
            djorb = djorb + djgr*dt
            delet = delet + delet1*dt
         endif
*
         do 602 , k = 1,2
*
            dms(k) = km*dms(k)
*            WRITE(*,*)dme/tb,dms(j2)/tb/km,dmt(j2),dms(j1)/tb/km,dmr(j1)

            if(kstar(k).lt.10) dms(k) = MIN(dms(k),mass(k) - massc(k))
*
* Calculate change in the intrinsic spin of the star.
*
* Spin up via wind accretion. NSs are allowed to vary the angular momentum accretion efficiency. PK.
            if(kstar(k).eq.13.and.xip.eq.1.and.pulsar.gt.0)then
               if(B(k).gt.0.d0)then
                  xi = MIN(1.d0,(0.01d0*(2.0d+11/B(k)))+0.01d0)
                  xi = 0.01
               else
                  xi = 0.01
               endif
            else
               xi = xihold
            endif
            djspint(k) = (2.d0/3.d0)*(dmr(k)*radx(k)*radx(k)*ospin(k) -
     &                   xi*dmt(k)*radx(3-k)*radx(3-k)*ospin(3-k))
            djspint(k) = djspint(k)*dt
*
* Evaluate convective/radiative limits for a variety of stars as based
* on the work of Belczynski et al. (2008). As option.
* Note only certain stars of type k = 0, 1, 2, 4, 5, 6, 9 **double check
* 0, 1 have range of 0.35-Mms,conv. Mms,conv is function of metalicity.
* 2 & 4 have a temperature dependence. Convective if Teff < 10**3.73
* 3, 5 & 6 are giants and have no radiative envelopes.
* 9's envelope is convective when M < Mhe,conv, Mhe,conv = 3.0Msun.
*
            if(ST_cr.le.0)then
               if(kstar(k).le.1)then
                  convradcomp(k) = 1.25d0
               else
                  convradcomp(k) = 9999999999.d0 !doesn't work well with startrack_tide = .false.
               endif
            else
               if(kstar(k).le.1)then
*                 Main sequence mass limit varying with metallicity
                  convradcomp(k) = 1.25d0
                  if(z.gt.0.001d0.and.z.lt.zsun)then
                     convradcomp(k) = 0.747d0 + 55.73d0*z - 1532*z*z
                  elseif(z.le.0.001d0)then
                     convradcomp(k) = 0.8d0
                  endif
               elseif(kstar(k).eq.2.or.kstar(k).eq.4)then
*                 H-rich HG and CHeB temperature limit
                  convradcomp(k) = 10.d0**3.73d0
               elseif(kstar(k).le.6)then
*                 No limit or all other giant stars
*                 (compare this large value to mass).
                  convradcomp(k) = 9999999999.d0
               elseif(kstar(k).eq.9)then
*                 Mass limit for evolved He star
                  convradcomp(k) = 3.d0
               endif
            endif
*
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
*               djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
*               djspint(k) = djspint(k) + djmb*dt
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
*     &              menv(k).gt.0.0d0)then
*                if (ospin(k) .le. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &              (ospin(k)/wsun)**3.0d0
*                if (ospin(k) .gt. wx) djmb = kw3 * rad(k)**4.0d0 *
*     &             (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
*                djspint(k) = djspint(k) + djmb
*            endif
* MB
            djmb = 0.d0
            if(htpmb.eq.0)then
* HTP02 method
               if(mass(k).gt.0.35d0.and.kstar(k).lt.10)then
                  djmb = 5.83d-16*menv(k)*(rad(k)*ospin(k))**3/mass(k)
                  djspint(k) = djspint(k) + djmb*dt
               endif
            elseif(htpmb.eq.1)then
               if(ST_cr.le.0.and.
     &            (mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
     &            menv(k).gt.0.0d0))then
* Ivanova & Taam (2003)
                   if (ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                 (ospin(k)/wsun)**3.0d0
                   if (ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                   djspint(k) = djspint(k) + djmb
               elseif(ST_cr.gt.0.and.(menv(k).gt.0.d0.and.
     &            ((kstar(k).le.1.and.mass(k).gt.0.35d0.and.
     &              mass(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.2.and.teff(k).le.convradcomp(k)).or.
     &              (kstar(k).eq.4.and.teff(k).le.convradcomp(k)).or.
     &              ((kstar(k).eq.3).or.(kstar(k).eq.5).or.
     &              (kstar(k).eq.6)))))then
* MB given in Ivanova & Taam (2003)
*            if(mass(k).gt.0.35d0.and.kstar(k).lt.10.and.
*     &              menv(k).gt.0.0d0)then
                  if(ospin(k).le.wx) djmb = kw3 * rad(k)**4.0d0 *
     &                (ospin(k)/wsun)**3.0d0
                  if(ospin(k).gt.wx) djmb = kw3 * rad(k)**4.0d0 *
     &               (ospin(k)/wsun)**1.3d0 * (wx/wsun)**1.7d0
                  djspint(k) = djspint(k) + djmb
               endif
            endif
            if(kstar(k).eq.13.and.pulsar.gt.0)then
               if(bdecayfac.eq.0)then
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).le.tiny)then
                     B(k) = B_0(k)*exp(-CK*bacc(k)) + Bbot
                  else
                     B(k) = B_0(k)*
     &                      exp(-(tphys-epoch(k)-tacc(k))/bconst)*
     &                      exp(-CK*bacc(k)) + Bbot
                  endif
               else
                  if(B_0(k).eq.0.d0)then
                     B(k) = 0.d0
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny.and.
     &                bacc(k).eq.0.d0)then
                     B(k) = B_0(k) + Bbot
                  elseif((tphys-epoch(k)-tacc(k)).lt.tiny)then
                     B(k) = B_0(k)/(1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  elseif(bacc(k).eq.0.d0)then
                     B(k) = B_0(k)*EXP(-(tphys-epoch(k)-tacc(k))/bconst)
     &                       + Bbot
                  else
                     B(k) = B_0(k)*
     &                       EXP(-(tphys-epoch(k)-tacc(k))/bconst)/
     &                       (1.d0 + (bacc(k)/1.0d-6)) + Bbot
                  endif
               endif
            endif
*
 602     continue
*
* Adjust the spin angular momentum of each star owing to mass transfer
* and conserve total angular momentum.
*
         djt = dm1*radx(j1)*radx(j1)*ospin(j1)
         djspint(j1) = djspint(j1) + djt
         djorb = djorb - djt
         if(disk)then
*
* Alter spin of the degenerate secondary by assuming that material
* falls onto the star from the inner edge of a Keplerian accretion
* disk and that the system is in a steady state.
*
            djt = dm2*twopi*aursun*SQRT(aursun*mass(j2)*radx(j2))
            djspint(j2) = djspint(j2) - djt
            djorb = djorb + djt
*
         else
*
* No accretion disk.
* Calculate the angular momentum of the transferred material by
* using the radius of the disk (see Ulrich & Burger) that would
* have formed if allowed.
*
            rdisk = 1.7d0*rmin
            djt = dm2*twopi*aursun*SQRT(aursun*mass(j2)*rdisk)
            djspint(j2) = djspint(j2) - djt
            djorb = djorb + djt
*
         endif
         djtx(2) = djt
*
* Adjust the secondary spin if a nova eruption has occurred.
*
         if(novae)then
            djt = (dm2 - dm22)*radx(j2)*radx(j2)*ospin(j2)
            djspint(j2) = djspint(j2) + djt
            djtx(2) = djtx(2) - djt
         endif
*
* Calculate circularization, orbital shrinkage and spin up.
*
         do 603 , k = 1,2
*
* Evaluate convective/radiative limits for a variety of stars as based
* on the work of Belczynski et al. (2008). As option.
* Note only certain stars of type k = 0, 1, 2, 4, 5, 6, 9 **double check
* 0, 1 have range of 0.35-Mms,conv. Mms,conv is function of metalicity.
* 2 & 4 have a temperature dependence. Convective if Teff < 10**3.73
* 3, 5 & 6 are giants and have no radiative envelopes.
* 9's envelope is convective when M < Mhe,conv, Mhe,conv = 3.0Msun.
*
            if(ST_cr.le.0)then
               if(kstar(k).le.1)then
                  convradcomp(k) = 1.25d0
               else
                  convradcomp(k) = 99999999.d0
               endif
            else
               if(kstar(k).le.1)then
*                 Main sequence mass limit varying with metallicity
                  convradcomp(k) = 1.25d0
                  if(z.gt.0.001d0.and.z.lt.zsun)then
                     convradcomp(k) = 0.747d0 + 55.73d0*z - 1532*z*z
                  elseif(z.le.0.001d0)then
                     convradcomp(k) = 0.8d0
                  endif
               elseif(kstar(k).eq.2.or.kstar(k).eq.4)then
*                 H-rich HG and CHeB temperature limit
                  convradcomp(k) = 10.d0**3.73d0
               elseif(kstar(k).le.6)then
*                 No limit or all other giant stars
*                 (compare this large value to mass).
                  convradcomp(k) = 99999999.d0
               elseif(kstar(k).eq.9)then
*                 Mass limit for evolved He star
                  convradcomp(k) = 3.d0
               endif
            endif
*
            dspint(k) = 0.d0
            if(((kstar(k).le.9.and.rad(k).ge.0.01d0*rol(k)).or.
     &         (kstar(k).ge.10.and.k.eq.j1)).and.tflag.gt.0)then
*
               raa2 = (radx(k)/sep)**2
               raa6 = raa2**3
*
               f5 = 1.d0+ecc2*(3.d0+ecc2*0.375d0)
               f4 = 1.d0+ecc2*(1.5d0+ecc2*0.125d0)
               f3 = 1.d0+ecc2*(3.75d0+ecc2*(1.875d0+ecc2*7.8125d-02))
               f2 = 1.d0+ecc2*(7.5d0+ecc2*(5.625d0+ecc2*0.3125d0))
               f1 = 1.d0+ecc2*(15.5d0+ecc2*(31.875d0+ecc2*(11.5625d0
     &                  +ecc2*0.390625d0)))
*
               if(ST_cr.le.0.and.
     &            ((kstar(k).eq.1.and.mass(k).ge.1.25d0).or.
     &            kstar(k).eq.4.or.kstar(k).eq.7))then
*
* Radiative damping (Zahn, 1977, A&A, 57, 383 and 1975, A&A, 41, 329).
*
                  tc = 1.592d-09*(mass(k)**2.84d0)
                  f = 1.9782d+04*SQRT((mass(k)*radx(k)*radx(k))/sep**5)*
     &                tc*(1.d0+q(3-k))**(5.d0/6.d0)
                  tcqr = f*q(3-k)*raa6
                  rg2 = k2str(k)
               elseif(ST_cr.gt.0.and.
     &                ((kstar(k).le.1.and.mass(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.2.and.teff(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.4.and.teff(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.9.and.mass(k).gt.convradcomp(k)).or.
     &           (kstar(k).eq.7).or.(kstar(k).eq.8)))then
*
* Radiative damping (Zahn, 1977, A&A, 57, 383 and 1975, A&A, 41, 329).
*
                  tc = 1.592d-09*(mass(k)**2.84d0)
                  f = 1.9782d+04*SQRT((mass(k)*rad(k)*rad(k))/sep**5)*
     &                tc*(1.d0+q(3-k))**(5.d0/6.d0)
                  tcqr = f*q(3-k)*raa6
                  rg2 = k2str(k)
               elseif(kstar(k).le.9)then
* Convective damping

* In BSE paper Equation 30, the default scaling coefficient is 2./21
* the fprimc_array kstar dependent array that is fed in
* keeps this same coefficient by default but allows user to
* specify their own
*
                  renv(k) = MIN(renv(k),radx(k)-radc(k))
                  renv(k) = MAX(renv(k),1.0d-10)
                  tc = mr23yr*(menv(k)*renv(k)*(radx(k)-0.5d0*renv(k))/
     &                 (3.d0*lumin(k)))**(1.d0/3.d0)
                  ttid = twopi/(1.0d-10 + ABS(oorb - ospin(k)))
                  f = MIN(1.d0,(ttid/(2.d0*tc))**2)
                  !kstar(k) to kstar(k)+1 by PA for kstar(k)=0
                  tcqr = fprimc_array(kstar(k)+1)*
     &                 f*q(3-k)*raa6*menv(k)/
     &                 (tc*mass(k))
                  rg2 = (k2str(k)*(mass(k)-massc(k)))/mass(k)
               elseif(ST_tide.le.0)then
*Degenerate damping
                  f = 7.33d-09*(lumin(k)/mass(k))**(5.d0/7.d0)
                  tcqr = f*q(3-k)*q(3-k)*raa2*raa2/(1.d0+q(3-k))
                  rg2 = k3
               endif
               sqome3 = sqome2**3
               delet1 = 27.d0*tcqr*(1.d0+q(3-k))*raa2*(ecc/sqome2**13)*
     &                  (f3 - (11.d0/18.d0)*sqome3*f4*ospin(k)/oorb)
               tcirc = ecc/(ABS(delet1) + 1.0d-20)
               delet = delet + delet1*dt
               dspint(k) = (3.d0*q(3-k)*tcqr/(rg2*omecc2**6))*
     &                     (f2*oorb - sqome3*f5*ospin(k))
               eqspin = oorb*f2/(sqome3*f5)
               if(dt.gt.0.d0)then
                  if(dspint(k).ge.0.d0)then
                     dspint(k) = MIN(dt*dspint(k),eqspin-ospin(k))/dt
                  else
                     dspint(k) = MAX(dt*dspint(k),eqspin-ospin(k))/dt
                  endif
               endif
               djt = (k2str(k)*(mass(k)-massc(k))*radx(k)*radx(k) +
     &                k3*massc(k)*radc(k)*radc(k))*dspint(k)
               djorb = djorb + djt*dt
               djspint(k) = djspint(k) - djt*dt
*
            endif
*
            jspin(k) = MAX(1.0d-10,jspin(k) - djspint(k))
*
* Ensure that the star does not spin up beyond break-up, and transfer
* the excess angular momentum back to the orbit.
*
            ospbru = twopi*SQRT(mass(k)*aursun**3/radx(k)**3)
            jspbru = (k2str(k)*(mass(k)-massc(k))*radx(k)*radx(k) +
     &                k3*massc(k)*radc(k)*radc(k))*ospbru
            if(jspin(k).gt.jspbru)then
               mew = 1.d0
               if(djtx(2).gt.0.d0)then
                  mew = MIN(mew,(jspin(k) - jspbru)/djtx(2))
               endif
               djorb = djorb - (jspin(k) - jspbru)
               jspin(k) = jspbru
* If excess material should not be accreted, activate next line.
*              dm22 = (1.d0 - mew)*dm22
            endif
*
 603     continue
*
* Update the masses.
*
         kstar(j2) = kst
         mass(j1) = mass(j1) - dm1 - dms(j1)
         if(kstar(j1).le.1.or.kstar(j1).eq.7) mass0(j1) = mass(j1)
         mass(j2) = mass(j2) + dm22 - dms(j2)
         if(kstar(j2).le.1.or.kstar(j2).eq.7) mass0(j2) = mass(j2)
         if(kstar(j2).eq.13.and.pulsar.gt.0)then
* if propeller add and if(.not.prop)then here... PK.
            b_mdot = (dm2-dms(j2))/dt
            if(b_mdot_lim.gt.0.d0.and.b_mdot.gt.b_mdot_lim)then
               bacc(j2) = bacc(j2) + (dm2-dms(j2))
               tacc(j2) = tacc(j2) + dtm
            elseif(b_mdot_lim.le.0.d0)then
               bacc(j2) = bacc(j2) + (dm2-dms(j2))
               tacc(j2) = tacc(j2) + dtm
            endif
         endif
*
* For a HG star check if the initial mass can be reduced.
*
         if(kstar(j1).eq.2.and.mass0(j1).le.zpars(3))then
            m0 = mass0(j1)
            mass0(j1) = mass(j1)
            CALL star(kstar(j1),mass0(j1),mass(j1),tmsnew,tn,tscls,
     &                lums,GB,zpars)
            if(GB(9).lt.massc(j1))then
               mass0(j1) = m0
            endif
         endif
         if(kstar(j2).eq.2.and.mass0(j2).le.zpars(3))then
            m0 = mass0(j2)
            mass0(j2) = mass(j2)
            CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,tscls,
     &                lums,GB,zpars)
            if(GB(9).lt.massc(j2))then
               mass0(j2) = m0
            endif
         endif
*
         ecc = ecc - delet
         ecc = MAX(ecc,0.d0)
         if(ecc.lt.1.0d-10) ecc = 0.d0
*
         if(ecc.ge.1.d0) goto 135
*
* Ensure that Jorb does not become negative which could happen if the
* primary overfills its Roche lobe initially. In this case we simply
* allow contact to occur.
*
* NOTE: there is a possibility that if contact occurs and we're at/past
* the current tphysf, then the binary will spiral in and we don't catch
* it.  If that happens, we could return an impossibly small binary which
* will break energy conservation in CMC.  Flag this here
         if((jorb-djorb).lt.1.d0) inspiral=.true.
         jorb = MAX(1.d0,jorb - djorb)
         sep = (mass(1) + mass(2))*jorb*jorb/
     &         ((mass(1)*mass(2)*twopi)**2*aursun**3*(1.d0-ecc*ecc))
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb
*
      endif
*
* Always rejuvenate the secondary and age the primary if they are on
* the main sequence.
*
      if(kstar(j1).le.2.or.kstar(j1).eq.7)then
         CALL star(kstar(j1),mass0(j1),mass(j1),tmsnew,tn,tscls,
     &             lums,GB,zpars)
         if(kstar(j1).eq.2)then
            aj(j1) = tmsnew + (tscls(1) - tmsnew)*(aj(j1)-tms(j1))/
     &                        (tbgb(j1) - tms(j1))
         else
            aj(j1) = tmsnew/tms(j1)*aj(j1)
         endif
         epoch(j1) = tphys - aj(j1)
      endif
*
      if(kstar(j2).le.2.or.kstar(j2).eq.7)then
         CALL star(kstar(j2),mass0(j2),mass(j2),tmsnew,tn,tscls,
     &             lums,GB,zpars)
         if(kstar(j2).eq.2)then
            aj(j2) = tmsnew + (tscls(1) - tmsnew)*(aj(j2)-tms(j2))/
     &                        (tbgb(j2) - tms(j2))
         elseif((mass(j2).lt.0.35d0.or.mass(j2).gt.1.25d0).
     &           and.kstar(j2).ne.7)then
            aj(j2) = tmsnew/tms(j2)*aj(j2)*(mass(j2) - dm22)/mass(j2)
         else
            aj(j2) = tmsnew/tms(j2)*aj(j2)
         endif
         epoch(j2) = tphys - aj(j2)
      endif
*
* Obtain the stellar parameters for the next step.
*
      tphys = tphys + dtm
      do 90 , k = 1,2
         age = tphys - epoch(k)
         m0 = mass0(k)
         mt = mass(k)
         mc = massc(k)
*
* Masses over 100Msun should probably not be trusted in the
* evolution formulae.
*
         if(mt.gt.100.d0)then
*            WRITE(99,*)' MASS EXCEEDED ',mass1i,mass2i,tbi,ecci,mt,
*     & tphysf,id1_pass,id2_pass
*            goto 140
         endif
         kw = kstar(k)
         CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(m0,age,mt,tm,tn,tscls,lums,GB,zpars,
     &               rm,lum,kw,mc,rc,me,re,k2,bhspin(k),k)
         pd = sep*(1.d0 - ecc)
         if(pd.lt.(rad(1)+rad(2))) goto 130


     
*
* Check for a supernova and correct the semi-major axis if so.
*
         if(kw.ne.kstar(k).and.kstar(k).le.12.and.
     &      (kw.eq.13.or.kw.eq.14))then
            dms(k) = mass(k) - mt
            if(formation(k).ne.11) formation(k) = 1
            if(kw.eq.13.and.ecsn.gt.0.d0)then
               if(kstar(k).le.6)then
                  if(mass0(k).le.zpars(5))then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation(k) = 2
                  endif
               elseif(kstar(k).ge.7.and.kstar(k).le.9)then
                  if(mass(k).gt.ecsn_mlow.and.mass(k).le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation(k) = 2
                  endif
               elseif(formation(k).eq.11)then
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = -sigmahold/sigmadiv
                  elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                     sigma = sigmadiv
                  endif
                  formation(k) = 5
               elseif(kstar(k).ge.10.or.kstar(k).eq.12)then
* AIC formation, will never happen here but...
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = -sigmahold/sigmadiv
                  elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                     sigma = sigmadiv
                  endif
                  formation(k) = 4
               endif
            endif

            evolve_type = 14.d0 + FLOAT(k)
            teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
            teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
            if(B_0(1).eq.0.d0)then !PK.
               b01_bcm = 0.d0
            elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
               b01_bcm = B_0(1)
            else
               b01_bcm = B(1)
            endif
            if(B_0(2).eq.0.d0)then
               b02_bcm = 0.d0
            elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
               b02_bcm = B_0(2)
            else
               b02_bcm = B(2)
            endif
            CALL writetab(jp,tphys,evolve_type,
     &                    mass(1),mass(2),kstar(1),kstar(2),
     &                    sep,tb,ecc,rrl1,rrl2,
     &                    aj(1),aj(2),tms(1),tms(2),
     &                    massc(1),massc(2),rad(1),rad(2),
     &                    mass0(1),mass0(2),lumin(1),lumin(2),
     &                    teff1,teff2,radc(1),radc(2),
     &                    menv(1),menv(2),renv(1),renv(2),
     &                    ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                    bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                    epoch(2),bhspin(1),bhspin(2),
     &                    deltam1_bcm,deltam2_bcm,formation(1),
     &                    formation(2),binstate,mergertype,'bpp')
            CALL kick(kw,mass(k),mt,mass(3-k),ecc,sep,jorb,vk,k,
     &              rad(3-k),fallback,sigmahold,kick_info,disrupt,bkick)
            sigma = sigmahold !reset sigma after possible ECSN kick dist. Remove this if u want some kick link to the intial pulsar values...

            if(mass(3-k).lt.0.d0)then
               if(kstar(3-k).lt.0.d0) mt = mt-mass(3-k)
               if(kw.eq.13.and.mt.gt.mxns) kw = 14
               CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
               kstar(k) = kw
               mass(k) = mt
               epoch(k) = tphys - age
               kstar(3-k) = 15
               mass(3-k) = 0.d0
               coel = .true.
               binstate = 1
            endif
            if(ecc.gt.1.d0)then
               kstar(k) = kw
               mass(k) = mt
               epoch(k) = tphys - age
               goto 135
            endif
            tb = (sep/aursun)*SQRT(sep/(aursun*(mt+mass(3-k))))
            oorb = twopi/tb
         endif
         if(kw.ne.kstar(k))then
            change = .true.
            if((kw.eq.13.or.kw.eq.14).and.kstar(k).le.12)then
               snova = .true.
            endif
            mass(k) = mt
            if(kw.eq.15)then
               kstar(k) = kw
               goto 135
            endif
            mass0(k) = m0
            epoch(k) = tphys - age
         endif
*
*     Determine stellar evolution timescale for nuclear burning types.
*
         if(kw.le.9)then
            CALL deltat(kw,age,tm,tn,tscls,dt,dtr)
            dtmi(k) = MIN(dt,dtr)
*           dtmi(k) = dtr
            dtmi(k) = MAX(1.0d-07,dtmi(k))
         else
            dtmi(k) = 1.0d+10
         endif
*        dtmi(k) = MAX((tn-age),1.0d-07)
*
* Save relevent solar quantities.
*
         aj(k) = age
         kstar(k) = kw
         rad(k) = rm
         radx(k) = rm
         lumin(k) = lum
         teff(k) = 1000.d0*((1130.d0*lumin(k)/
     &                    (rad(k)**2.d0))**(1.d0/4.d0))
         massc(k) = mc
         radc(k) = rc
         menv(k) = me
         renv(k) = re
         k2str(k) = k2
         tms(k) = tm
         tbgb(k) = tscls(1)
*
 90   continue
*
      do 100 , k = 1,2
         q(k) = mass(k)/mass(3-k)
         rol(k) = rl(q(k))*sep*(1.d0-ecc)
 100  continue
      if(rad(j1).gt.rol(j1)) radx(j1) = MAX(radc(j1),rol(j1))
      do 110 , k = 1,2
         ospin(k) = jspin(k)/(k2str(k)*(mass(k)-massc(k))*radx(k)*
     &              radx(k) + k3*massc(k)*radc(k)*radc(k))
 110  continue

      if(check_dtp.eq.1)then
          CALL checkstate(dtp,dtp_original,tsave,tphys,tphysf,
     &                      iplot,isave,binstate,evolve_type,
     &                      mass(1),mass(2),kstar(1),kstar(2),sep,
     &                      tb,ecc,rrl1,rrl2,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2),
     &                      mass0(1),mass0(2),lumin(1),lumin(2),
     &                      radc(1),radc(2),menv(1),menv(2),
     &                      renv(1),renv(2),
     &                      ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                      bacc(1),bacc(2),
     &                      tacc(1),tacc(2),epoch(1),epoch(2),
     &                      bhspin(1),bhspin(2),teff1,teff2)
      endif
*
      if((isave.and.tphys.ge.tsave).or.iplot)then
          if(B_0(1).eq.0.d0)then !PK.
              b01_bcm = 0.d0
          elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
              b01_bcm = B_0(1)
          else
              b01_bcm = B(1)
          endif
          if(B_0(2).eq.0.d0)then
              b02_bcm = 0.d0
          elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
              b02_bcm = B_0(2)
          else
              b02_bcm = B(2)
          endif
          teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
          teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
          rrl1 = rad(1)/rol(1)
          rrl2 = rad(2)/rol(2)
          dt = MAX(dtm,1.0d-12)*1.0d+06
          if(j1.eq.1)then
              deltam1_bcm = (-1.0*dm1 - dms(1))/dt
              deltam2_bcm = (dm2 - dms(2))/dt
          else
              deltam1_bcm = (dm2 - dms(1))/dt
              deltam2_bcm = (-1.0*dm1 - dms(2))/dt
          endif
* Check if PISN occurred, and if so overwrite formation
          if(pisn_track(1).ne.0) formation(1) = pisn_track(1)
          if(pisn_track(2).ne.0) formation(2) = pisn_track(2)
          CALL writetab(ip,tphys,evolve_type,
     &                  mass(1),mass(2),kstar(1),kstar(2),
     &                  sep,tb,ecc,rrl1,rrl2,
     &                  aj(1),aj(2),tms(1),tms(2),
     &                  massc(1),massc(2),rad(1),rad(2),
     &                  mass0(1),mass0(2),lumin(1),lumin(2),
     &                  teff1,teff2,radc(1),radc(2),
     &                  menv(1),menv(2),renv(1),renv(2),
     &                  ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                  bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                  epoch(2),bhspin(1),bhspin(2),
     &                  deltam1_bcm,deltam2_bcm,formation(1),
     &                  formation(2),binstate,mergertype,'bcm')
         if(isave) tsave = tsave + dtp
         if(output) write(*,*)'bcm3:',kstar(1),kstar(2),mass(1),
     & mass(2),rad(1),rad(2),ospin(1),ospin(2),jspin(1)
*     & mass(2),rad(1),rad(2),ospin(1),ospin(2),b01_bcm,b02_bcm,jspin(1)
      endif
*
      if(tphys.ge.tphysf.and..not.inspiral) goto 140
*
      if(change)then
         change = .false.
         evolve_type = 2.0
         rrl1 = rad(1)/rol(1)
         rrl2 = rad(2)/rol(2)
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
         if(B_0(1).eq.0.d0)then !PK.
            b01_bcm = 0.d0
         elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
            b01_bcm = B_0(1)
         else
            b01_bcm = B(1)
         endif
         if(B_0(2).eq.0.d0)then
            b02_bcm = 0.d0
         elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
            b02_bcm = B_0(2)
         else
            b02_bcm = B(2)
         endif

         CALL writetab(jp,tphys,evolve_type,
     &                    mass(1),mass(2),kstar(1),kstar(2),
     &                    sep,tb,ecc,rrl1,rrl2,
     &                    aj(1),aj(2),tms(1),tms(2),
     &                    massc(1),massc(2),rad(1),rad(2),
     &                    mass0(1),mass0(2),lumin(1),lumin(2),
     &                    teff1,teff2,radc(1),radc(2),
     &                    menv(1),menv(2),renv(1),renv(2),
     &                    ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                    bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                    epoch(2),bhspin(1),bhspin(2),
     &                    deltam1_bcm,deltam2_bcm,formation(1),
     &                    formation(2),binstate,mergertype,'bpp')
      endif

*
* Test whether the primary still fills its Roche lobe.
*
      if(rad(j1).gt.rol(j1).and..not.snova)then
*
* Test for a contact system
*
         if(rad(j2).gt.rol(j2)) goto 130
         iter = iter + 1
         goto 8
      else
         evolve_type = 4.0
         rrl1 = rad(1)/rol(1)
         rrl2 = rad(2)/rol(2)
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
         if(B_0(1).eq.0.d0)then !PK.
            b01_bcm = 0.d0
         elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
            b01_bcm = B_0(1)
         else
            b01_bcm = B(1)
         endif
         if(B_0(2).eq.0.d0)then
            b02_bcm = 0.d0
         elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
            b02_bcm = B_0(2)
         else
            b02_bcm = B(2)
         endif

         CALL writetab(jp,tphys,evolve_type,
     &                 mass(1),mass(2),kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2),
     &                 mass0(1),mass0(2),lumin(1),lumin(2),
     &                 teff1,teff2,radc(1),radc(2),
     &                 menv(1),menv(2),renv(1),renv(2),
     &                 ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                 bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                 epoch(2),bhspin(1),bhspin(2),
     &                 deltam1_bcm,deltam2_bcm,formation(1),
     &                 formation(2),binstate,mergertype,'bpp')
         dtm = 0.d0
         goto 4
      endif
*
 130  continue
*
* Contact system.
*
      coel = .true.
      binstate = 1
      CALL CONCATKSTARS(kstar(j1), kstar(j2), mergertype)
*
* If *1 or *2 is giant-like this will be common-envelope evolution.
*
      m1ce = mass(j1)
      m2ce = mass(j2)
      rrl1 = MIN(999.999d0,rad(1)/rol(1))
      rrl2 = MIN(999.999d0,rad(2)/rol(2))
*
      evolve_type = 5.0
      teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
      teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
      if(B_0(1).eq.0.d0)then !PK.
         b01_bcm = 0.d0
      elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
         b01_bcm = B_0(1)
      else
         b01_bcm = B(1)
      endif
      if(B_0(2).eq.0.d0)then
         b02_bcm = 0.d0
      elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
         b02_bcm = B_0(2)
      else
         b02_bcm = B(2)
      endif
      CALL writetab(jp,tphys,evolve_type,
     &              mass(1),mass(2),kstar(1),kstar(2),sep,
     &              tb,ecc,rrl1,rrl2,
     &              aj(1),aj(2),tms(1),tms(2),
     &              massc(1),massc(2),rad(1),rad(2),
     &              mass0(1),mass0(2),lumin(1),lumin(2),
     &              teff1,teff2,radc(1),radc(2),
     &              menv(1),menv(2),renv(1),renv(2),
     &              ospin(1),ospin(2),b01_bcm,b02_bcm,
     &              bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &              epoch(2),bhspin(1),bhspin(2),
     &              deltam1_bcm,deltam2_bcm,formation(1),
     &              formation(2),binstate,mergertype,'bpp')
*
      kcomp1 = kstar(j1)
      kcomp2 = kstar(j2)
*
      if(output) write(*,*)'coal r/rl1 & r/rl2 > 0',tphys,kcomp1,kcomp2,
     & m1ce,m2ce
*
      if(kstar(j1).ge.2.and.kstar(j1).le.9.and.kstar(j1).ne.7)then
         if(j1.eq.2)then
             switchedCE = .true.
         else
             switchedCE = .false.
         endif
         evolve_type = 7.d0
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
         if(B_0(1).eq.0.d0)then !PK.
            b01_bcm = 0.d0
         elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
            b01_bcm = B_0(1)
         else
            b01_bcm = B(1)
         endif
         if(B_0(2).eq.0.d0)then
            b02_bcm = 0.d0
         elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
            b02_bcm = B_0(2)
         else
            b02_bcm = B(2)
         endif

         CALL writetab(jp,tphys,evolve_type,
     &                 mass(1),mass(2),
     &                 kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2),
     &                 mass0(1),mass0(2),lumin(1),lumin(2),
     &                 teff1,teff2,radc(1),radc(2),
     &                 menv(1),menv(2),renv(1),renv(2),
     &                 ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                 bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                 epoch(2),bhspin(1),bhspin(2),
     &                 deltam1_bcm,deltam2_bcm,formation(1),
     &                 formation(2),binstate,mergertype,'bpp')
         CALL comenv(mass0(j1),mass(j1),massc(j1),aj(j1),jspin(j1),
     &               kstar(j1),mass0(j2),mass(j2),massc(j2),aj(j2),
     &               jspin(j2),kstar(j2),zpars,ecc,sep,jorb,coel,j1,j2,
     &               vk,kick_info,formation(j1),formation(j2),sigmahold,
     &               bhspin(j1),bhspin(j2),binstate,mergertype,
     &               jp,tphys,switchedCE,rad,tms,evolve_type,disrupt,
     &               lumin,B_0,bacc,tacc,epoch,menv,renv,bkick,
     &               deltam1_bcm,deltam2_bcm)
         if(output) write(*,*)'coal1:',tphys,kstar(j1),kstar(j2),coel,
     & mass(j1),mass(j2)
         if(j1.eq.2.and.kcomp2.eq.13.and.kstar(j2).eq.15.and.
     &      kstar(j1).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j1) = formation(j2)
         endif
         if(j1.eq.1.and.kcomp2.eq.13.and.kstar(j2).eq.15.and.
     &      kstar(j1).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j1) = formation(j2)
         endif
         com = .true.
         if(com.and..not.coel.and..not.disrupt)then
* if it went through common envelope
* did not disrupt (from one of the objects going SN)
* and did not merge in common envelope
* then system is still in binary
            binstate = 0
            mergertype = -1
         elseif(com.and..not.coel.and.disrupt)then
* if it went through common envelope
* and did disrupt (from one of the objects going SN)
* and did not merge in common envelope
* then system should be marked as disrupted
            binstate = 2
            mergertype = -1
         endif
* else it merged in the common envelope
         if(binstate.eq.1.d0)then
             sep = 0.d0
             tb = 0.d0
         elseif(binstate.eq.2.d0)then
             sep = -1.d0
             tb = -1.d0
         endif
      elseif(kstar(j2).ge.2.and.kstar(j2).le.9.and.kstar(j2).ne.7)then
         if(j1.eq.1)then
             switchedCE = .true.
         else
             switchedCE = .false.
         endif
         evolve_type = 7.d0
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
         if(B_0(1).eq.0.d0)then !PK.
            b01_bcm = 0.d0
         elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
            b01_bcm = B_0(1)
         else
            b01_bcm = B(1)
         endif
         if(B_0(2).eq.0.d0)then
            b02_bcm = 0.d0
         elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
            b02_bcm = B_0(2)
         else
            b02_bcm = B(2)
         endif

         CALL writetab(jp,tphys,evolve_type,
     &                 mass(1),mass(2),
     &                 kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2),
     &                 mass0(1),mass0(2),lumin(1),lumin(2),
     &                 teff1,teff2,radc(1),radc(2),
     &                 menv(1),menv(2),renv(1),renv(2),
     &                 ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                 bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                 epoch(2),bhspin(1),bhspin(2),
     &                 deltam1_bcm,deltam2_bcm,formation(1),
     &                 formation(2),binstate,mergertype,'bpp')
         CALL comenv(mass0(j2),mass(j2),massc(j2),aj(j2),jspin(j2),
     &               kstar(j2),mass0(j1),mass(j1),massc(j1),aj(j1),
     &               jspin(j1),kstar(j1),zpars,ecc,sep,jorb,coel,j2,j1,
     &               vk,kick_info,formation(j2),formation(j1),sigmahold,
     &               bhspin(j2),bhspin(j1),binstate,mergertype,
     &               jp,tphys,switchedCE,rad,tms,evolve_type,disrupt,
     &               lumin,B_0,bacc,tacc,epoch,menv,renv,bkick,
     &               deltam1_bcm,deltam2_bcm)
         if(output) write(*,*)'coal2:',tphys,kstar(j1),kstar(j2),coel,
     & mass(j1),mass(j2)
         if(j2.eq.2.and.kcomp1.eq.13.and.kstar(j1).eq.15.and.
     &      kstar(j2).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j2) = formation(j1)
         endif
         if(j2.eq.1.and.kcomp1.eq.13.and.kstar(j1).eq.15.and.
     &      kstar(j2).eq.13)then !PK.
* In CE the NS got switched around. Do same to formation.
            formation(j2) = formation(j1)
         endif
         com = .true.
         if(com.and..not.coel.and..not.disrupt)then
* if it went through common envelope
* did not disrupt (from one of the objects going SN)
* and did not merge in common envelope
* then system is still in binary
            binstate = 0
            mergertype = -1
         elseif(com.and..not.coel.and.disrupt)then
* if it went through common envelope
* and did disrupt (from one of the objects going SN)
* and did not merge in common envelope
* then system should be marked as disrupted
            binstate = 2
            mergertype = -1
         endif
* else it merged in the common envelope
         if(binstate.eq.1.d0)then
             sep = 0.d0
             tb = 0.d0
         elseif(binstate.eq.2.d0)then
             sep = -1.d0
             tb = -1.d0
         endif
      else
         CALL mix(mass0,mass,aj,kstar,zpars,bhspin)
      endif

      if(com)then
          evolve_type = 8.0
          mass1_bpp = mass(1)
          mass2_bpp = mass(2)
          if(kstar(1).eq.15) mass1_bpp = mass0(1)
          if(kstar(2).eq.15) mass2_bpp = mass0(2)
          rrl1 = MIN(rrl1,0.99d0)
          rrl2 = MIN(rrl2,0.99d0)
          teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
          teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
          if(B_0(1).eq.0.d0)then !PK.
             b01_bcm = 0.d0
          elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
             b01_bcm = B_0(1)
          else
             b01_bcm = B(1)
          endif
          if(B_0(2).eq.0.d0)then
             b02_bcm = 0.d0
          elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
             b02_bcm = B_0(2)
          else
             b02_bcm = B(2)
          endif

          CALL writetab(jp,tphys,evolve_type,
     &                  mass1_bpp,mass2_bpp,
     &                  kstar(1),kstar(2),sep,
     &                  tb,ecc,rrl1,rrl2,
     &                  aj(1),aj(2),tms(1),tms(2),
     &                  massc(1),massc(2),rad(1),rad(2),
     &                  mass0(1),mass0(2),lumin(1),lumin(2),
     &                  teff1,teff2,radc(1),radc(2),
     &                  menv(1),menv(2),renv(1),renv(2),
     &                  ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                  bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                  epoch(2),bhspin(1),bhspin(2),
     &                  deltam1_bcm,deltam2_bcm,formation(1),
     &                  formation(2),binstate,mergertype,'bpp')
      endif
      epoch(1) = tphys - aj(1)
      epoch(2) = tphys - aj(2)
      if(.not.coel)then
*
* Next step should be made without changing the time.
*
         if(ecc.gt.1.d0)then
            if(kstar(1).ge.13)then
               rc = corerd(kstar(1),mass(1),mass(1),zpars(2))
               ospin(1) = jspin(1)/(k3*rc*rc*mass(1))
            endif
            if(kstar(2).ge.13)then
               rc = corerd(kstar(2),mass(2),mass(2),zpars(2))
               ospin(2) = jspin(2)/(k3*rc*rc*mass(2))
            endif
            goto 135
         endif
*
* Need to confirm that RLO is over
*

         evolve_type = 4.0
         rrl1 = rad(1)/rol(1)
         rrl2 = rad(2)/rol(2)
         teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
         teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
         if(B_0(1).eq.0.d0)then !PK.
            b01_bcm = 0.d0
         elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
            b01_bcm = B_0(1)
         else
            b01_bcm = B(1)
         endif
         if(B_0(2).eq.0.d0)then
            b02_bcm = 0.d0
         elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
            b02_bcm = B_0(2)
         else
            b02_bcm = B(2)
         endif

         CALL writetab(jp,tphys,evolve_type,
     &                 mass(1),mass(2),kstar(1),kstar(2),sep,
     &                 tb,ecc,rrl1,rrl2,
     &                 aj(1),aj(2),tms(1),tms(2),
     &                 massc(1),massc(2),rad(1),rad(2),
     &                 mass0(1),mass0(2),lumin(1),lumin(2),
     &                 teff1,teff2,radc(1),radc(2),
     &                 menv(1),menv(2),renv(1),renv(2),
     &                 ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                 bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                 epoch(2),bhspin(1),bhspin(2),
     &                 deltam1_bcm,deltam2_bcm,formation(1),
     &                 formation(2),binstate,mergertype,'bpp')
         dtm = 0.d0
*
* Reset orbital parameters as separation may have changed.
*
         tb = (sep/aursun)*SQRT(sep/(aursun*(mass(1)+mass(2))))
         oorb = twopi/tb

         goto 4
      endif
*
 135  continue
*
      sgl = .true.
      if(kstar(1).eq.13.and.mergemsp.eq.1.and.
     &   notamerger.eq.0)then
         s = (twopi*yearsc)/ospin(1)
         if(s.lt.0.03d0.and.B(1).gt.0.d0)then
            merge_mem = 1
         endif
      endif
      if(kstar(2).eq.13.and.mergemsp.eq.1.and.
     &   notamerger.eq.0)then
         s = (twopi*yearsc)/ospin(2)
         if(s.lt.0.03d0.and.B(2).gt.0.d0)then
            merge_mem = 1
         endif
      endif
      if(kstar(1).ne.15.or.kstar(2).ne.15)then
         if(com)then
            com = .false.
         else
            mass1_bpp = mass(1)
            mass2_bpp = mass(2)
*
* KB remove these 20 jul 23: we want the stars to not have mass
* if they are kstar=15
*
*            if(kstar(1).eq.15) mass1_bpp = mass0(1)
*            if(kstar(2).eq.15) mass2_bpp = mass0(2)
            if(coel)then
                evolve_type = 6.0
                teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
                teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
                if(B_0(1).eq.0.d0)then !PK.
                   b01_bcm = 0.d0
                elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
                   b01_bcm = B_0(1)
                else
                   b01_bcm = B(1)
                endif
                if(B_0(2).eq.0.d0)then
                   b02_bcm = 0.d0
                elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
                   b02_bcm = B_0(2)
                else
                   b02_bcm = B(2)
                endif
                CALL writetab(jp,tphys,evolve_type,
     &                        mass1_bpp,mass2_bpp,
     &                        kstar(1),kstar(2),0.d0,
     &                        0.d0,-1.d0,0.d0,ngtv,
     &                        aj(1),aj(2),tms(1),tms(2),
     &                        massc(1),massc(2),rad(1),rad(2),
     &                        mass0(1),mass0(2),lumin(1),lumin(2),
     &                        teff1,teff2,radc(1),radc(2),
     &                        menv(1),menv(2),renv(1),renv(2),
     &                        ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                        bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                        epoch(2),bhspin(1),bhspin(2),
     &                        deltam1_bcm,deltam2_bcm,formation(1),
     &                        formation(2),binstate,mergertype,'bpp')
            elseif(ecc.gt.1.d0)then
*
* Binary dissolved by a supernova or tides.
*
                evolve_type = 11.0
                binstate = 2
                mergertype = -1
                tb = -1.d0
                sep = -1.d0
                ecc = -1.d0
                teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
                teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
                if(B_0(1).eq.0.d0)then !PK.
                   b01_bcm = 0.d0
                elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
                   b01_bcm = B_0(1)
                else
                   b01_bcm = B(1)
                endif
                if(B_0(2).eq.0.d0)then
                   b02_bcm = 0.d0
                elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
                   b02_bcm = B_0(2)
                else
                   b02_bcm = B(2)
                endif
                CALL writetab(jp,tphys,evolve_type,
     &                        mass1_bpp,mass2_bpp,
     &                        kstar(1),kstar(2),sep,
     &                        tb,ecc,0.d0,ngtv2,
     &                        aj(1),aj(2),tms(1),tms(2),
     &                        massc(1),massc(2),rad(1),rad(2),
     &                        mass0(1),mass0(2),lumin(1),lumin(2),
     &                        teff1,teff2,radc(1),radc(2),
     &                        menv(1),menv(2),renv(1),renv(2),
     &                        ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                        bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                        epoch(2),bhspin(1),bhspin(2),
     &                        deltam1_bcm,deltam2_bcm,formation(1),
     &                        formation(2),binstate,mergertype,'bpp')
            else
                evolve_type = 9.0
                teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
                teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
                if(B_0(1).eq.0.d0)then !PK.
                   b01_bcm = 0.d0
                elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
                   b01_bcm = B_0(1)
                else
                   b01_bcm = B(1)
                endif
                if(B_0(2).eq.0.d0)then
                   b02_bcm = 0.d0
                elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
                   b02_bcm = B_0(2)
                else
                   b02_bcm = B(2)
                endif
                CALL writetab(jp,tphys,evolve_type,
     &                        mass1_bpp,mass2_bpp,
     &                        kstar(1),kstar(2),0.d0,
     &                        0.d0,0.d0,0.d0,ngtv,
     &                        aj(1),aj(2),tms(1),tms(2),
     &                        massc(1),massc(2),rad(1),rad(2),
     &                        mass0(1),mass0(2),lumin(1),lumin(2),
     &                        teff1,teff2,radc(1),radc(2),
     &                        menv(1),menv(2),renv(1),renv(2),
     &                        ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                        bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                        epoch(2),bhspin(1),bhspin(2),
     &                        deltam1_bcm,deltam2_bcm,formation(1),
     &                        formation(2),binstate,mergertype,'bpp')
            endif
         endif
         if(kstar(2).eq.15)then
            kmax = 1
            rol(2) = -1.d0*rad(2)
            dtmi(2) = tphysf
         elseif(kstar(1).eq.15)then
            kmin = 2
            rol(1) = -1.d0*rad(1)
            dtmi(1) = tphysf
         endif
* Makes sure coalesced NSs are reset. PK.
         if(kstar(1).eq.13.and.ecc.le.1.d0.and.pulsar.gt.0.and.
     &      notamerger.eq.0)then
            age = 0.d0
            epoch(1) = tphys
         endif
         if(kstar(2).eq.13.and.ecc.le.1.d0.and.pulsar.gt.0.and.
     &      notamerger.eq.0)then
            age = 0.d0
            epoch(2) = tphys
         endif
         ecc = -1.d0
         if(binstate.eq.2)then
*            Check if disrupted then we want sep=ecc=porb=-1
             sep = -1.d0
         elseif(binstate.eq.1)then
*            check if merge then sep=0
             tb = 0.d0
             sep = 0.d0
         endif
         dtm = 0.d0
         coel = .false.
         goto 4
      endif
*
 140  continue
*
      if(com)then
         com = .false.
      else
          mass1_bpp = mass(1)
          mass2_bpp = mass(2)

          !added by PA for systems that manage to reach here
          !without encountering write bpp at all
          if (jp<1) then
              evolve_type = 1.d0
              rrl1 = rad(1)/rol(1)
              rrl2 = rad(2)/rol(2)
              teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
              teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
              if(B_0(1).eq.0.d0)then !PK.
                 b01_bcm = 0.d0
              elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
                 b01_bcm = B_0(1)
              else
                 b01_bcm = B(1)
              endif
              if(B_0(2).eq.0.d0)then
                 b02_bcm = 0.d0
              elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
                 b02_bcm = B_0(2)
              else
                 b02_bcm = B(2)
              endif

              CALL writetab(jp,tphys,evolve_type,
     &                  mass(1),mass(2),kstar(1),kstar(2),sep,
     &                  tb,ecc,rrl1,rrl2,
     &                  aj(1),aj(2),tms(1),tms(2),
     &                  massc(1),massc(2),rad(1),rad(2),
     &                  mass0(1),mass0(2),lumin(1),lumin(2),
     &                  teff1,teff2,radc(1),radc(2),
     &                  menv(1),menv(2),renv(1),renv(2),
     &                  ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                  bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                  epoch(2),bhspin(1),bhspin(2),
     &                  deltam1_bcm,deltam2_bcm,formation(1),
     &                  formation(2),binstate,mergertype,'bpp')
          endif
          
*          if(kstar(1).eq.15.and.bpp(jp,4).lt.15.0)then
*              mass1_bpp = mass0(1)
*          endif

*          if(kstar(2).eq.15.and.bpp(jp,5).lt.15.0)then
*              mass2_bpp = mass0(2)
*          endif
          
          if(coel)then
              evolve_type = 6.0
              teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
              teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
              if(B_0(1).eq.0.d0)then !PK.
                 b01_bcm = 0.d0
              elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
                 b01_bcm = B_0(1)
              else
                 b01_bcm = B(1)
              endif
              if(B_0(2).eq.0.d0)then
                 b02_bcm = 0.d0
              elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
                 b02_bcm = B_0(2)
              else
                 b02_bcm = B(2)
              endif
              CALL writetab(jp,tphys,evolve_type,
     &                      mass1_bpp,mass2_bpp,
     &                      kstar(1),kstar(2),0.d0,
     &                      0.d0,-1.d0,0.d0,ngtv,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2),
     &                      mass0(1),mass0(2),lumin(1),lumin(2),
     &                      teff1,teff2,radc(1),radc(2),
     &                      menv(1),menv(2),renv(1),renv(2),
     &                      ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin(1),bhspin(2),
     &                      deltam1_bcm,deltam2_bcm,formation(1),
     &                      formation(2),binstate,mergertype,'bpp')
          elseif(kstar(1).eq.15.and.kstar(2).eq.15)then
*
* Cases of accretion induced supernova or single star supernova.
* No remnant is left in either case.
*
              evolve_type = 9.0
              teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
              teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
              if(B_0(1).eq.0.d0)then !PK.
                 b01_bcm = 0.d0
              elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
                 b01_bcm = B_0(1)
              else
                 b01_bcm = B(1)
              endif
              if(B_0(2).eq.0.d0)then
                 b02_bcm = 0.d0
              elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
                 b02_bcm = B_0(2)
              else
                 b02_bcm = B(2)
              endif
              CALL writetab(jp,tphys,evolve_type,
     &                      mass1_bpp,mass2_bpp,
     &                      kstar(1),kstar(2),0.d0,
     &                      0.d0,0.d0,0.d0,ngtv2,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2),
     &                      mass0(1),mass0(2),lumin(1),lumin(2),
     &                      teff1,teff2,radc(1),radc(2),
     &                      menv(1),menv(2),renv(1),renv(2),
     &                      ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin(1),bhspin(2),
     &                      deltam1_bcm,deltam2_bcm,formation(1),
     &                      formation(2),binstate,mergertype,'bpp')
          else
              evolve_type = 10.0
              !added by PA for systems that stop evolving halfway
              if(iter.ge.loop) evolve_type = 100.0
              rrl1 = rad(1)/rol(1)
              rrl2 = rad(2)/rol(2)
              teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
              teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
              if(B_0(1).eq.0.d0)then !PK.
                 b01_bcm = 0.d0
              elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
                 b01_bcm = B_0(1)
              else
                 b01_bcm = B(1)
              endif
              if(B_0(2).eq.0.d0)then
                 b02_bcm = 0.d0
              elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
                 b02_bcm = B_0(2)
              else
                 b02_bcm = B(2)
              endif
              CALL writetab(jp,tphys,evolve_type,
     &                      mass1_bpp,mass2_bpp,
     &                      kstar(1),kstar(2),sep,
     &                      tb,ecc,rrl1,rrl2,
     &                      aj(1),aj(2),tms(1),tms(2),
     &                      massc(1),massc(2),rad(1),rad(2),
     &                      mass0(1),mass0(2),lumin(1),lumin(2),
     &                      teff1,teff2,radc(1),radc(2),
     &                      menv(1),menv(2),renv(1),renv(2),
     &                      ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin(1),bhspin(2),
     &                      deltam1_bcm,deltam2_bcm,formation(1),
     &                      formation(2),binstate,mergertype,'bpp')
          endif
      endif
*
*      CALL checkstate(dtp,dtp_original,tsave,tphys,tphysf,
*     &                      iplot,isave,binstate,evolve_type,
*     &                      mass(1),mass(2),kstar(1),kstar(2),sep,
*     &                      tb,ecc,rrl1,rrl2,
*     &                      aj(1),aj(2),tms(1),tms(2),
*     &                      massc(1),massc(2),rad(1),rad(2),
*     &                      mass0(1),mass0(2),lumin(1),lumin(2),
*     &                      radc(1),radc(2),menv(1),menv(2),
*     &                      renv(1),renv(2),
*     &                      ospin(1),ospin(2),b01_bcm,b02_bcm,
*     &                      bacc(1),bacc(2),
*     &                      tacc(1),tacc(2),epoch(1),epoch(2),
*     &                      bhspin(1),bhspin(2))
      if((isave.and.tphys.ge.tsave).or.iplot)then
          if(B_0(1).eq.0.d0)then !PK.
              b01_bcm = 0.d0
          elseif(B_0(1).gt.0.d0.and.B(1).eq.0.d0)then
              b01_bcm = B_0(1)
          else
              b01_bcm = B(1)
          endif
          if(B_0(2).eq.0.d0)then
              b02_bcm = 0.d0
          elseif(B_0(2).gt.0.d0.and.B(2).eq.0.d0)then
              b02_bcm = B_0(2)
          else
              b02_bcm = B(2)
          endif
          teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad(1)**2.d0))**(1.d0/4.d0))
          teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad(2)**2.d0))**(1.d0/4.d0))
          rrl1 = rad(1)/rol(1)
          rrl2 = rad(2)/rol(2)
          dt = MAX(dtm,1.0d-12)*1.0d+06
          if(j1.eq.1)then
              deltam1_bcm = (-1.0*dm1 - dms(1))/dt
              deltam2_bcm = (dm2 - dms(2))/dt
          else
              deltam1_bcm = (dm2 - dms(1))/dt
              deltam2_bcm = (-1.0*dm1 - dms(2))/dt
          endif
* Check if PISN occurred, and if so overwrite formation
          if(pisn_track(1).ne.0) formation(1) = pisn_track(1)
          if(pisn_track(2).ne.0) formation(2) = pisn_track(2)
          CALL writetab(ip,tphys,evolve_type,
     &                  mass(1),mass(2),kstar(1),kstar(2),
     &                  sep,tb,ecc,rrl1,rrl2,
     &                  aj(1),aj(2),tms(1),tms(2),
     &                  massc(1),massc(2),rad(1),rad(2),
     &                  mass0(1),mass0(2),lumin(1),lumin(2),
     &                  teff1,teff2,radc(1),radc(2),
     &                  menv(1),menv(2),renv(1),renv(2),
     &                  ospin(1),ospin(2),b01_bcm,b02_bcm,
     &                  bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                  epoch(2),bhspin(1),bhspin(2),
     &                  deltam1_bcm,deltam2_bcm,formation(1),
     &                  formation(2),binstate,mergertype,'bcm')
         if(output) write(*,*)'bcm4:',kstar(1),kstar(2),mass(1),
     & mass(2),rad(1),rad(2),ospin(1),ospin(2),jspin(1),
     & tphys,tphysf
*     & mass(2),rad(1),rad(2),ospin(1),ospin(2),b01_bcm,b02_bcm,jspin(1),
         if(isave) tsave = tsave + dtp
         if(tphysf.le.0.d0)then
            ip = ip + 1
            do 145 , k = 1,38
               bcm(ip,k) = bcm(ip-1,k)
 145        continue
         endif
*
      elseif((kstar(1).eq.15.and.kstar(2).eq.15))then
         tphys = tphysf
         evolve_type = 10.0
         goto 135
      endif
      tphysfhold = tphysf
      tphysf = tphys
      if(sgl)then
         if(ecc.ge.0.d0.and.ecc.le.1.d0) ecc = -1.d0
         tb = -1.d0
      endif
      tb = tb*yeardy

      if(jp.ge.1000)then
         WRITE(*,*)' STOP: EVOLV2 ARRAY ERROR '
*         CALL exit(0)
*         STOP
      elseif(jp.ge.40)then
         WRITE(99,*)' EVOLV2 ARRAY WARNING ',mass1i,mass2i,tbi,ecci,jp
      endif
      if(iter.ge.loop)then
         WRITE(99,*)'ITER>=LOOP:',jp,tphys,tphysfhold,dtp,kstar,age,kst,
     & id1_pass,id2_pass,mass(1),mass(2),iter,loop
*         CALL exit(0)
*         STOP
      endif
      bcm(ip+1,1) = -1.0
      bpp(jp+1,1) = -1.0

      if(using_cmc.eq.0)then
          bcm_index_out = ip
          bpp_index_out = jp
          kick_info_out = kick_info
      endif
*

      END SUBROUTINE evolv2
***

***
        SUBROUTINE WRITETAB(jp,tphys,evolve_type,
     &                      mass1,mass2,kstar1,kstar2,sep,
     &                      tb,ecc,rrl1,rrl2,
     &                      aj1,aj2,tms1,tms2,
     &                      massc1,massc2,rad1,rad2,
     &                      mass0_1,mass0_2,lumin1,lumin2,
     &                      teff1,teff2,radc1,radc2,menv1,
     &                      menv2,renv1,renv2,ospin1,ospin2,
     &                      b_0_1,b_0_2,bacc1,bacc2,tacc1,tacc2,
     &                      epoch1,epoch2,bhspin1,bhspin2,
     &                      deltam_1,deltam_2,SN_1,SN_2,
     &                      bin_state,merger_type,tabname)
        IMPLICIT NONE
        INCLUDE 'const_bse.h'

*
* Write results to bpp or bcm array.
*
*     Author : Scott Coughlin, Tom Wagg
*     Date :   12th March 2019, September 2024
*
        REAL*8 mass1,mass2
        REAL*8 evolve_type,sep,tb,ecc,tphys,rrl1,rrl2
        REAL*8 aj1,aj2,tms1,tms2,massc1,massc2,rad1,rad2
        REAL*8 mass0_1,mass0_2,lumin1,lumin2,radc1,radc2
        REAL*8 menv1,menv2,renv1,renv2,ospin1,ospin2
        REAL*8 b_0_1,b_0_2,bacc1,bacc2,tacc1,tacc2,epoch1,epoch2
        REAL*8 bhspin1,bhspin2,teff1,teff2
        REAL*8 deltam_1,deltam_2
        INTEGER SN_1,SN_2,bin_state,merger_type
        REAL*8 tb_write,sep_cubed
        INTEGER jp, col_ind
        INTEGER kstar1,kstar2
        REAL*8 yeardy,aursun,rsunau
        REAL*8 all_cols(49)
        CHARACTER*3 tabname
        PARAMETER(yeardy=365.24d0,aursun=214.95d0)

        all_cols(1) = tphys
        all_cols(2) = mass1
        all_cols(3) = mass2
        all_cols(4) = float(kstar1)
        all_cols(5) = float(kstar2)
        all_cols(6) = sep
        if(tb.le.0.d0)then
* system was disrupted and tb=-1 and should stay that way
            all_cols(7) = tb
        else
            rsunau = 1/aursun
            sep_cubed = (sep*rsunau)*(sep*rsunau)*(sep*rsunau)
            tb_write = sqrt(sep_cubed/(mass1+mass2))
            all_cols(7) = tb_write*yeardy
        endif
        all_cols(8) = ecc
        all_cols(9) = rrl1
        all_cols(10) = rrl2
        all_cols(11) = evolve_type
        all_cols(12) = aj1
        all_cols(13) = aj2
        all_cols(14) = tms1
        all_cols(15) = tms2
        all_cols(16) = massc1
        all_cols(17) = massc2
        all_cols(18) = rad1
        all_cols(19) = rad2
        all_cols(20) = mass0_1
        all_cols(21) = mass0_2
        all_cols(22) = lumin1
        all_cols(23) = lumin2
        all_cols(24) = teff1
        all_cols(25) = teff2
        all_cols(26) = radc1
        all_cols(27) = radc2
        all_cols(28) = menv1
        all_cols(29) = menv2
        all_cols(30) = renv1
        all_cols(31) = renv2
        all_cols(32) = ospin1
        all_cols(33) = ospin2
        all_cols(34) = b_0_1
        all_cols(35) = b_0_2
        all_cols(36) = bacc1
        all_cols(37) = bacc2
        all_cols(38) = tacc1
        all_cols(39) = tacc2
        all_cols(40) = epoch1
        all_cols(41) = epoch2
        all_cols(42) = bhspin1
        all_cols(43) = bhspin2
        all_cols(44) = deltam_1
        all_cols(45) = deltam_2
        all_cols(46) = float(SN_1)
        all_cols(47) = float(SN_2)
        all_cols(48) = bin_state
        all_cols(49) = merger_type

* check which table we are writing to and write the appropriate columns
        if (tabname .eq. 'bpp') then
            jp = MIN(900,jp + 1)        ! Why is the 900 limit here??
            do 117, col_ind = 1, n_col_bpp
                bpp(jp,col_ind) = all_cols(col_inds_bpp(col_ind))
117         continue
        else if (tabname .eq. 'bcm') then
            jp = jp + 1
            do 118, col_ind = 1, n_col_bcm
                bcm(jp,col_ind) = all_cols(col_inds_bcm(col_ind))
118         continue
        end if
        END

***
      SUBROUTINE hrdiag(mass,aj,mt,tm,tn,tscls,lums,GB,zpars,
     &                  r,lum,kw,mc,rc,menv,renv,k2,
     &                  bhspin,kidx)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
*
*       H-R diagram for population I stars.
*       -----------------------------------
*
*       Computes the new mass, luminosity, radius & stellar type.
*       Input (MASS, AJ, TM, TN, LUMS & TSCLS) supplied by routine STAR.
*       Ref: P.P. Eggleton, M.J. Fitchett & C.A. Tout (1989) Ap.J. 347, 998.
*
*       Revised 27th March 1995 by C. A. Tout;
*       24th October 1995 to include metallicity;
*       14th November 1996 to include naked helium stars;
*       28th February 1997 to allow accretion induced supernovae.
*
*       Revised 5th April 1997 by J. R. Hurley
*       to include Z=0.001 as well as Z=0.02, convective overshooting,
*       MS hook and more elaborate CHeB
*
*
      integer kw,kwp,kidx
*
      real*8 mass,aj,mt,tm,tn,tscls(20),lums(10),GB(10),zpars(20),met
      real*8 bhspin
      real*8 r,lum,rc,menv,renv,k2,mc
      real*8 mch,mlp,tiny
*      parameter(mch=1.44d0,mlp=12.d0,tiny=1.0d-14)
      parameter(mlp=12.d0,tiny=1.0d-14)
      real*8 mass0,mt0,mtc
      common /fall/fallback
      REAL*8 fallback
      REAL ran3
      EXTERNAL ran3
*
*      real*8 mchold
*
*      real*8 avar,bvar
      real*8 thook,thg,tbagb,tau,tloop,taul,tauh,tau1,tau2,dtau,texp
      real*8 lx,ly,dell,alpha,betahrdiag,eta
      real*8 rx,ry,delr,rzams,rtms,gammahrdiag,rmin,taumin,rg
      parameter(taumin=5.0d-08)
      real*8 mcmax,mcx,mcy,mcbagb,lambdahrdiag
*      real*8 frac,kappa,sappa,alphap,polyfit
      real*8 am,xx,fac,rdgen,mew,lum0,kap,zeta,ahe,aco
      parameter(lum0=7.0d+04,kap=-0.5d0,ahe=4.d0,aco=16.d0)
*
      real*8 thookf,tblf
      real*8 lalphf,lbetaf,lnetaf,lhookf,lgbtf,lmcgbf,lzhef,lpertf
      real*8 rzamsf,rtmsf,ralphf,rbetaf,rgammf,rhookf
      real*8 rgbf,rminf,ragbf,rzahbf,rzhef,rhehgf,rhegbf,rpertf
      real*8 mctmsf,mcgbtf,mcgbf,mcheif,mcagbf,lzahbf
      logical stripped_during_hrdiag
      external thookf,tblf
      external lalphf,lbetaf,lnetaf,lhookf,lgbtf,lmcgbf,lzhef,lpertf
      external rzamsf,rtmsf,ralphf,rbetaf,rgammf,rhookf
      external rgbf,rminf,ragbf,rzahbf,rzhef,rhehgf,rhegbf,rpertf
      external mctmsf,mcgbtf,mcgbf,mcheif,mcagbf,lzahbf
*
*
*       ---------------------------------------------------------------------
*       MASS    Stellar mass in solar units (input: old; output: new value).
*       AJ      Current age in Myr.
*       MT      Current mass in solar units (used for R).
*       TM      Main sequence time.
*       TN      Nuclear burning time.
*       TSCLS   Time scale for different stages.
*       LUMS    Characteristic luminosity.
*       GB      Giant Branch parameters
*       ZPARS   Parameters for distinguishing various mass intervals.
*       R       Stellar radius in solar units.
*       TE      Effective temperature (suppressed).
*       KW      Classification type (0 - 15).
*       MC      Core mass.
*       ---------------------------------------------------------------------
*
*
* Make evolutionary changes to stars that have not reached KW > 5.
*
      ! track whether a star stripped during hrdiag
      stripped_during_hrdiag = .false.
      mch = 1.44d0 !set here owing to AIC ECSN model.
*
      mass0 = mass
C      if(mass0.gt.100.d0) mass = 100.d0
      mt0 = mt
C      if(mt0.gt.100.d0) mt = 100.d0
*
      if(kw.gt.6) goto 90
*
      tbagb = tscls(2) + tscls(3)
      thg = tscls(1) - tm
*
      rzams = rzamsf(mass)
* calculate metallicity using the zpars(14) parameter.
      met = 10**(LOG10(zpars(14))/0.4)
      rtms = rtmsf(mass, met)
*
      if(aj.lt.tscls(1))then
*
*        Either on MS or HG
*
         rg = rgbf(mt,lums(3))
*
         if(aj.lt.tm)then
*
*           Main sequence star.
*
            mc = 0.d0
            mc_he(kidx) = 0.d0
            mc_co(kidx) = 0.d0
            tau = aj/tm
            thook = thookf(mass)*tscls(1)
            zeta = 0.01d0
            tau1 = MIN(1.d0,aj/thook)
            tau2 = MAX(0.d0,
     &             MIN(1.d0,(aj-(1.d0-zeta)*thook)/(zeta*thook)))
*
            dell = lhookf(mass,zpars(1))
            dtau = tau1**2 - tau2**2
            alpha = lalphf(mass)
            betahrdiag = lbetaf(mass)
            eta = lnetaf(mass)
            lx = LOG10(lums(2)/lums(1))
            if(tau.gt.taumin)then
               xx = alpha*tau + betahrdiag*tau**eta +
     &              (lx - alpha - betahrdiag)*tau**2 - dell*dtau
            else
               xx = alpha*tau + (lx - alpha)*tau**2 - dell*dtau
            endif
            lum = lums(1)*10.d0**xx
*
            delr = rhookf(mass,zpars(1))
            dtau = tau1**3 - tau2**3
            alpha = ralphf(mass)
            betahrdiag = rbetaf(mass)
            gammahrdiag = rgammf(mass)
            rx = LOG10(rtms/rzams)
* Note that the use of taumin is a slightly pedantic attempt to
* avoid floating point underflow. It IS overkill!
            if(tau.gt.taumin)then
               xx = alpha*tau + betahrdiag*tau**10 +
     &              gammahrdiag*tau**40 + (rx - alpha - betahrdiag -
     &              gammahrdiag)*tau**3 - delr*dtau
            else
               xx = alpha*tau + (rx - alpha)*tau**3 - delr*dtau
            endif
            r = rzams*10.d0**xx
*
            if(mass.lt.(zpars(1)-0.3d0))then
               kw = 0
* This following is given by Chris for low mass MS stars which will be
* substantially degenerate. We need the Hydrogen abundance, X, which we
* calculate from Z assuming that the helium abundance, Y, is calculated
* according to Y = 0.24 + 2*Z
               rdgen = 0.0258d0*((1.d0+zpars(11))**(5.d0/3.d0))*
     &                          (mass**(-1.d0/3.d0))
               r = MAX(rdgen,r)
            else
               kw = 1
            endif
* planets
            if(mass.lt.0.005d0.and.mass.ge.tiny)then
               r = 0.16d0
            endif
*
         else
*
*           Star is on the HG
*
            mcx = mc
            if(mass.le.zpars(2))then
               mc = mcgbf(lums(3),GB,lums(6))
            elseif(mass.le.zpars(3))then
               mc = mcheif(mass,zpars(2),zpars(9))
            else
               mc = mcheif(mass,zpars(2),zpars(10))
            endif
            eta = mctmsf(mass)
            tau = (aj - tm)/thg
            
            mc = ((1.d0 - tau)*eta + tau)*mc
            mc = MAX(mc,mcx)

            mc_he(kidx) = mc
            mc_co(kidx) = 0.0
*
* Test whether core mass has reached total mass.
*
            if(mc.ge.mt)then
               aj = 0.d0
               if(mass.gt.zpars(2))then
*
* Zero-age helium star
*
                  mc = 0.d0
                  mc_he(kidx) = 0.d0
                  mc_co(kidx) = 0.d0
                  mass = mt
                  kw = 7
                  CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)

                  ! flag to return so that bpp logs the stellar type change
                  stripped_during_hrdiag = .true.
               else
*
* Zero-age helium white dwarf.
*
                  mc = mt
                  mc_he(kidx) = 0.d0
                  mc_co(kidx) = 0.d0
                  mass = mt
                  kw = 10
               endif
            else
               lum = lums(2)*(lums(3)/lums(2))**tau
               if(mass.le.zpars(3))then
                  rx = rg
               else
* He-ignition and end of HG occur at Rmin
                  rmin = rminf(mass)
                  ry = ragbf(mt,lums(4),zpars(2))
                  rx = MIN(rmin,ry)
                  if(mass.le.mlp)then
                     texp = log(mass/mlp)/log(zpars(3)/mlp)
                     rx = rg
                     rx = rmin*(rx/rmin)**texp
                  endif
                  tau2 = tblf(mass,zpars(2),zpars(3))
                  if(tau2.lt.tiny) rx = ry
               endif
               r = rtms*(rx/rtms)**tau
               kw = 2
            endif
*
         endif
*
* Now the GB, CHeB and AGB evolution.
*
      elseif(aj.lt.tscls(2))then
*
*        Red Giant.
*
         kw = 3
         lum = lgbtf(aj,GB(1),GB,tscls(4),tscls(5),tscls(6))
         if(mass.le.zpars(2))then
* Star has a degenerate He core which grows on the GB
            mc = mcgbf(lum,GB,lums(6))
            mc_he(kidx) = mc
            mc_co(kidx) = 0.0
         else
* Star has a non-degenerate He core which may grow, but
* only slightly, on the GB
            tau = (aj - tscls(1))/(tscls(2) - tscls(1))
            mcx = mcheif(mass,zpars(2),zpars(9))
            mcy = mcheif(mass,zpars(2),zpars(10))
            mc = mcx + (mcy - mcx)*tau

            mc_he(kidx) = mc
            mc_co(kidx) = 0.0
         endif
         r = rgbf(mt,lum)
         rg = r
         if(mc.ge.mt)then
            aj = 0.d0
            if(mass.gt.zpars(2))then
*
* Zero-age helium star
*
               mc = 0.d0
               mc_he(kidx) = mc
               mc_co(kidx) = 0.0
               mass = mt
               kw = 7
               CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)

               ! flag to return so that bpp logs the stellar type change
               stripped_during_hrdiag = .true.
            else
*
* Zero-age helium white dwarf.
*
               mc = mt
               mc_he(kidx) = mc
               mc_co(kidx) = 0.0
               mass = mt
               kw = 10
            endif
         endif
*
      elseif(aj.lt.tbagb)then
*
*       Core helium burning star.
*
         if(kw.eq.3.and.mass.le.zpars(2))then
            mass = mt
            CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
            aj = tscls(2)
         endif
         if(mass.le.zpars(2))then
            mcx = mcgbf(lums(4),GB,lums(6))
         else
            mcx = mcheif(mass,zpars(2),zpars(10))
         endif
         tau = (aj - tscls(2))/tscls(3)
*        here, mcx is the helium core mass at helium ignition
         mc = mcx + (mcagbf(mass) - mcx)*tau
         mc_he(kidx) = mc
         mc_co(kidx) = 0.0
*
         if(mass.le.zpars(2))then
            lx = lums(5)
            ly = lums(7)
            rx = rzahbf(mt,mc,zpars(2))
            rg = rgbf(mt,lx)
            rmin = rg*zpars(13)**(mass/zpars(2))
            texp = MIN(MAX(0.4d0,rmin/rx),2.5d0)
            ry = ragbf(mt,ly,zpars(2))
            if(rmin.lt.rx)then
               taul = (log(rx/rmin))**(1.d0/3.d0)
            else
               rmin = rx
               taul = 0.d0
            endif
            tauh = (log(ry/rmin))**(1.d0/3.d0)
            tau2 = taul*(tau - 1.d0) + tauh*tau
            r = rmin*exp(abs(tau2)**3)
            rg = rg + tau*(ry - rg)
            lum = lx*(ly/lx)**(tau**texp)
         elseif(mass.gt.zpars(3))then
*
* For HM stars He-ignition takes place at Rmin in the HG, and CHeB
* consists of a blue phase (before tloop) and a RG phase (after tloop).
*
            tau2 = tblf(mass,zpars(2),zpars(3))
            tloop = tscls(2) + tau2*tscls(3)
            rmin = rminf(mass)
            rg = rgbf(mt,lums(4))
            rx = ragbf(mt,lums(4),zpars(2))
            rmin = MIN(rmin, rx)
            if(mass.le.mlp) then
               texp = log(mass/mlp)/log(zpars(3)/mlp)
               rx = rg
               rx = rmin*(rx/rmin)**texp
            else
               rx = rmin
            endif
            texp = MIN(MAX(0.4d0,rmin/rx),2.5d0)
            lum = lums(4)*(lums(7)/lums(4))**(tau**texp)
            if(aj.lt.tloop)then
               ly = lums(4)*(lums(7)/lums(4))**(tau2**texp)
               ry = ragbf(mt,ly,zpars(2))
               taul = 0.d0
               if(ABS(rmin-rx).gt.tiny)then
                  taul = (log(rx/rmin))**(1.d0/3.d0)
               endif
               tauh = 0.d0
               if(ry.gt.rmin) tauh = (log(ry/rmin))**(1.d0/3.d0)
               tau = (aj - tscls(2))/(tau2*tscls(3))
               tau2 = taul*(tau - 1.d0) + tauh*tau
               r = rmin*exp(abs(tau2)**3)
               rg = rg + tau*(ry - rg)
            else
               r = ragbf(mt,lum,zpars(2))
               rg = r
            endif
         else
*
* For IM stars CHeB consists of a RG phase (before tloop) and a blue
* loop (after tloop).
*
            tau2 = 1.d0 - tblf(mass,zpars(2),zpars(3))
            tloop = tscls(2) + tau2*tscls(3)
            if(aj.lt.tloop)then
               tau = (tloop - aj)/(tau2*tscls(3))
               lum = lums(5)*(lums(4)/lums(5))**(tau**3)
               r = rgbf(mt,lum)
               rg = r
            else
               lx = lums(5)
               ly = lums(7)
               rx = rgbf(mt,lx)
               rmin = rminf(mt)
               texp = MIN(MAX(0.4d0,rmin/rx),2.5d0)
               ry = ragbf(mt,ly,zpars(2))
               if(rmin.lt.rx)then
                  taul = (log(rx/rmin))**(1.d0/3.d0)
               else
                  rmin = rx
                  taul = 0.d0
               endif
               tauh = (log(ry/rmin))**(1.d0/3.d0)
               tau = (aj - tloop)/(tscls(3) - (tloop - tscls(2)))
               tau2 = taul*(tau - 1.d0) + tauh*tau
               r = rmin*exp(abs(tau2)**3)
               rg = rx + tau*(ry - rx)
               lum = lx*(ly/lx)**(tau**texp)
            endif
         endif
*
* Test whether core mass exceeds total mass.
*
         if(mc.ge.mt)then
*
* Evolved MS naked helium star.
*
            kw = 7
            xx = (aj - tscls(2))/tscls(3)
            mass = mt
            CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
            aj = xx*tm

            ! flag to return so that bpp logs the stellar type change
            stripped_during_hrdiag = .true.
         else
            kw = 4
         endif
*
      else
*
*        Asymptotic Red Giant.
*
* On the AGB the He core mass remains constant until at Ltp it
* is caught by the C core mass and they grow together.
*
         mcbagb = mcagbf(mass)
         mcx = mcgbtf(tbagb,GB(8),GB,tscls(7),tscls(8),tscls(9))
         mcmax = MAX(MAX(mch,0.773d0*mcbagb-0.35d0),1.05d0*mcx)
*
         if(aj.lt.tscls(13))then
            mcx = mcgbtf(aj,GB(8),GB,tscls(7),tscls(8),tscls(9))
            mc = mcbagb
            mc_co(kidx) = mcx
            mc_he(kidx) = mc - mcx
            lum = lmcgbf(mcx,GB)
            if(mt.le.mc)then
*
* Evolved naked helium star as the envelope is lost but the
* star has not completed its interior burning. The star becomes
* a post-HeMS star.
*
               kw = 9
               mt = mc
               mass = mt
               mc = mcx
               mc_co(kidx) = mc
               mc_he(kidx) = mt - mc
               CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
               if(mc.le.GB(7))then
                  aj = tscls(4) - (1.d0/((GB(5)-1.d0)*GB(8)*GB(4)))*
     &                            (mc**(1.d0-GB(5)))
               else
                  aj = tscls(5) - (1.d0/((GB(6)-1.d0)*GB(8)*GB(3)))*
     &                            (mc**(1.d0-GB(6)))
               endif
               aj = MAX(aj,tm)

               ! flag to return so that bpp logs the stellar type change
               stripped_during_hrdiag = .true.
            else
               kw = 5
            endif
         else
            kw = 6
            mc = mcgbtf(aj,GB(2),GB,tscls(10),tscls(11),tscls(12))
            lum = lmcgbf(mc,GB)
*
* Approximate 3rd Dredge-up on AGB by limiting Mc.
*
            lambdahrdiag = MIN(0.9d0,0.3d0+0.001d0*mass**5)
* Tau is the time at the start of the TP-AGB
            tau = tscls(13)
* mcx is M_c,DU in the equation *between* 73 and 74 of Hurley et al. 2000
            mcx = mcgbtf(tau,GB(2),GB,tscls(10),tscls(11),tscls(12))
* mcy is M_c' in the same equation; it is defined in line 464 above for the current age. 
            mcy = mc
* The current core mass is then M_c' - lambda*(M_c' - M_c,DU)  
            mc = mcy - lambdahrdiag*(mcy-mcx)
            mcx = mc
            mc_co(kidx) = mc
            mc_he(kidx) = 0.0
            mcmax = MIN(mt,mcmax)
         endif
         r = ragbf(mt,lum,zpars(2))
         rg = r
*
* Mc,x represents the C core mass and we now test whether it
* exceeds either the total mass or the maximum allowed core mass.
*
         if(mcmax-mcx.lt.tiny)then
            aj = 0.d0

            ! adjust core masses in case we overshot the maximum allowed core mass
            mc = mcmax
            mc_co(kidx) = mc
            call assign_remnant(zpars,mc,mcbagb,mass,
     &                          kidx,mt,kw,bhspin)
         endif
*
      endif
*
 90   continue
*
      if(kw.ge.7.and.kw.le.9)then
*
* Naked Helium Star
*
         rzams = rzhef(mt)
         rx = rzams
         if(aj.lt.tm)then
*
* Main Sequence
*
            kw = 7
            tau = aj/tm

*   TW: Linearly increase the core mass of HeMS stars from zero at the start of HeMS
*       to the core mass at the start of HeHG
            lum = lgbtf(tm,GB(8),GB,tscls(4),tscls(5),tscls(6))
            mc = tau * mcgbf(lum,GB,lums(6))

            am = MAX(0.d0,0.85d0-0.08d0*mass)
            lum = lums(1)*(1.d0+0.45d0*tau+am*tau**2)
            am = MAX(0.d0,0.4d0-0.22d0*LOG10(mt))
            r = rx*(1.d0+am*(tau-tau**6))
            rg = rx

            if(mt.lt.zpars(10)) kw = 10
         else
*
* Helium Shell Burning
*
            kw = 8
            lum = lgbtf(aj,GB(8),GB,tscls(4),tscls(5),tscls(6))
            r = rhehgf(mt,lum,rx,lums(2))
            rg = rhegbf(lum)
            if(r.ge.rg)then
               kw = 9
               r = rg
            endif
            mc = mcgbf(lum,GB,lums(6))
         endif

*
*KB: helium core mass is remaining total mass for all He stars
*
         mc_he(kidx) = mt - mc
         mc_co(kidx) = mc

         if(stripped_during_hrdiag)then
            return
         endif

         ! core mass for a He star to become a COWD (Hurley 2000, Eq. 89)
         mtc = MIN(mt,1.45d0*mt-0.31d0)

         ! core mass for He to result in a SN (Hurley 2000, Eq. 75)
         mcmax = MIN(mtc,MAX(mch,0.773d0*mass-0.35d0))
         if(mcmax-mc.lt.tiny)then
             aj = 0.d0

             ! adjust core masses if we overshot the maximum allowed core mass
             mc = mcmax
             mc_he(kidx) = mt - mc
             mc_co(kidx) = mc

             ! He stars use the mass at start of HeMS instead of McBAGB (Hurley 2000, just before Eq. 89)
             mcbagb = mass
             call assign_remnant(zpars,mc,mcbagb,mass,kidx,mt,kw,bhspin)

             ! TW: This seems to be an adjustment for COWD based on Hurley Eq. 89, I don't fully understand though, seems to be potentially adding envelope mass?
             if(kw.eq.11) mt = MAX(mc,(mc+0.31d0)/1.45d0)
         endif
      endif
*
      call hrdiag_remnant(zpars,mt,mc,lum,r,aj,kw)
*
* Calculate the core radius and the luminosity and radius of the
* remnant that the star will become.
*
      tau = 0.d0
      if(kw.le.1.or.kw.eq.7)then
         rc = 0.d0
      elseif(kw.le.3)then
         if(mass.gt.zpars(2))then
            lx = lzhef(mc)
            rx = rzhef(mc)
            rc = rx
         else
            if(wdflag.eq.0)then
               lx = 635.d0*mc*zpars(14)/((ahe*0.1d0)**1.4d0)
            elseif(wdflag.ge.1)then
               lx = 300.d0*mc*zpars(14)/((ahe*0.1d0)**1.18d0)
            endif
            rx = 0.0115d0*SQRT(MAX(1.48204d-06,
     &           (mch/mc)**(2.d0/3.d0)-(mc/mch)**(2.d0/3.d0)))
            rc = 5.d0*rx
         endif
      elseif(kw.eq.4)then
         tau = (aj - tscls(2))/tscls(3)
         kwp = 7
         CALL star(kwp,mc,mc,tm,tn,tscls,lums,GB,zpars)
         am = MAX(0.d0,0.85d0-0.08d0*mc)
         lx = lums(1)*(1.d0+0.45d0*tau+am*tau**2)
         rx = rzhef(mc)
         am = MAX(0.d0,0.4d0-0.22d0*LOG10(mc))
         rx = rx*(1.d0+am*(tau-tau**6))
         CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
         rc = rx
      elseif(kw.eq.5)then
         kwp = 9
         if(tn.gt.tbagb) tau = 3.d0*(aj-tbagb)/(tn-tbagb)
         CALL star(kwp,mc,mc,tm,tn,tscls,lums,GB,zpars)
         lx = lmcgbf(mcx,GB)
         if(tau.lt.1.d0) lx = lums(2)*(lx/lums(2))**tau
         rx = rzhef(mc)
         rx = MIN(rhehgf(mc,lx,rx,lums(2)),rhegbf(lx))
         CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
         rc = rx
      elseif(kw.le.9)then
         if(wdflag.eq.0)then
            lx = 635.d0*mc*zpars(14)/((aco*0.1d0)**1.4d0)
         elseif(wdflag.ge.1)then
            lx = 300.d0*mc*zpars(14)/((aco*0.1d0)**1.18d0)
         endif
         rx = 0.0115d0*SQRT(MAX(1.48204d-06,
     &        (mch/mc)**(2.d0/3.d0) - (mc/mch)**(2.d0/3.d0)))
         rc = 5.d0*rx
      else
         rc = r
         menv = 1.0d-10
         renv = 1.0d-10
         k2 = 0.21d0
      endif
*
* Perturb the luminosity and radius due to small envelope mass.
*
      if(kw.ge.2.and.kw.le.9.and.kw.ne.7)then
         mew = ((mt-mc)/mt)*MIN(5.d0,MAX(1.2d0,(lum/lum0)**kap))
         if(kw.ge.8) mew = ((mtc-mc)/mtc)*5.d0
         if(mew.lt.1.d0)then
            xx = lpertf(mt,mew)
            lum = lx*(lum/lx)**xx
            if(r.le.rx)then
               xx = 0.d0
            else
               xx = rpertf(mt,mew,r,rx)
            endif
            r = rx*(r/rx)**xx
         endif
         rc = MIN(rc,r)
      endif
*
* Calculate mass and radius of convective envelope, and envelope
* gyration radius.
*
      if(kw.lt.10)then
         CALL mrenv(kw,mass,mt,mc,lum,r,rc,aj,tm,lums(2),lums(3),
     &              lums(4),rzams,rtms,rg,menv,renv,k2)
      endif
*
      if(ST_tide.gt.0)then
         if(kw.le.2.or.kw.eq.7.or.kw.ge.10)then
            if(mt.le.1.d0)then
               k2 = 0.205d0
            else
               k2 = 0.075d0
            endif
         else
           k2 = 0.1d0
         endif
      endif

*
C      if(mass.gt.99.99d0)then
C         mass = mass0
C      endif
C      if(mt.gt.99.99d0)then
C         mt = mt0
C      endif
*
      return
      end
***

***
      SUBROUTINE MIX(M0,M,AJ,KS,ZPARS,bhspin)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
*     Author : J. R. Hurley
*     Date :   7th July 1998
*
*       Evolution parameters for mixed star.
*       ------------------------------------
*
*
      INTEGER KS(2),I1,I2,K1,K2,KW,ICASE
      REAL*8 M0(2),M(2),AJ(2),ZPARS(20),bhspin(2)
      REAL*8 TSCLS(20),LUMS(10),GB(10),TMS1,TMS2,TMS3,TN
      REAL*8 M01,M02,M03,M1,M2,M3,AGE1,AGE2,AGE3,MC3,MCH
      REAL*8 M_CORE_BGB_1,M_CORE_BGB_2,M_CORE_BGB_3,HE_3_current
      PARAMETER(MCH=1.44D0)
*
*
*       Define global indices with body #I1 being most evolved.
      IF(KS(1).GE.KS(2))THEN
          I1 = 1
          I2 = 2
      ELSE
          I1 = 2
          I2 = 1
      END IF
*
*       Specify case index for collision treatment.
      K1 = KS(I1)
      K2 = KS(I2)
      ICASE = KTYPE(K1,K2)
*     if(icase.gt.100) WRITE(66,*)' MIX ERROR ICASE>100 ',icase,k1,k2
*
*       Determine evolution time scales for first star.
      M01 = M0(I1)
      M1 = M(I1)
      AGE1 = AJ(I1)
      CALL star(K1,M01,M1,TMS1,TN,TSCLS,LUMS,GB,ZPARS)
      IF(REJUVFLAG.EQ.1.AND.KS(1).LE.2.0.AND.KS(2).LE.2.0)THEN
          M_CORE_BGB_1 = GB(9)
      ENDIF
*
*       Obtain time scales for second star.
      M02 = M0(I2)
      M2 = M(I2)
      AGE2 = AJ(I2)
      CALL star(K2,M02,M2,TMS2,TN,TSCLS,LUMS,GB,ZPARS)
      IF(REJUVFLAG.EQ.1.AND.KS(1).LE.2.0.AND.KS(2).LE.2.0)THEN
          M_CORE_BGB_2 = GB(9)
      ENDIF
*
*       Check for planetary systems - defined as HeWDs and low-mass WDs!
      IF(K1.EQ.10.AND.M1.LT.0.05)THEN
         ICASE = K2
         IF(K2.LE.1)THEN
            ICASE = 1
            AGE1 = 0.D0
         ENDIF
      ELSEIF(K1.GE.11.AND.M1.LT.0.5.AND.ICASE.EQ.6)THEN
         ICASE = 9
      ENDIF
      IF(K2.EQ.10.AND.M2.LT.0.05)THEN
         ICASE = K1
         IF(K1.LE.1)THEN
            ICASE = 1
            AGE2 = 0.D0
         ENDIF
      ENDIF
*
*       Specify total mass.
      M3 = M1 + M2
      M03 = M01 + M02
      KW = ICASE
      AGE3 = 0.d0
*
*       Restrict merged stars to masses less than 100 Msun.
C      IF(M3.GE.100.D0)THEN
C         M3 = 99.D0
C         M03 = MIN(M03,M3)
C      ENDIF
*
*       Evaluate apparent age and other parameters.
*
      IF(ICASE.EQ.1)THEN
*       Specify new age based on complete mixing.
*       The above line is ~supsicious~ and probably the 0.1
*       factor is more likely to be over mixing than complete
*       mixing. We will now make it a parameter so that it can
*       be partial mixing.
         IF(K1.EQ.7) KW = 7
         CALL star(KW,M03,M3,TMS3,TN,TSCLS,LUMS,GB,ZPARS)
         IF(REJUVFLAG.EQ.1.AND.KS(1).LE.2.0.AND.KS(2).LE.2.0)THEN
             M_CORE_BGB_3 = GB(9)
             HE_3_current =AGE1*M_CORE_BGB_1/TMS1+AGE2*M_CORE_BGB_2/TMS2
             AGE3 = TMS3*He_3_current/M_CORE_BGB_3
         ELSE
             AGE3 = REJUV_FAC*TMS3*(AGE1*M1/TMS1 + AGE2*M2/TMS2)/M3
         ENDIF
      ELSEIF(ICASE.EQ.3.OR.ICASE.EQ.6.OR.ICASE.EQ.9)THEN
         MC3 = M1
         CALL gntage(MC3,M3,KW,ZPARS,M03,AGE3)
      ELSEIF(ICASE.EQ.4)THEN
         MC3 = M1
         AGE3 = AGE1/TMS1
         CALL gntage(MC3,M3,KW,ZPARS,M03,AGE3)
      ELSEIF(ICASE.EQ.7)THEN
         CALL star(KW,M03,M3,TMS3,TN,TSCLS,LUMS,GB,ZPARS)
         AGE3 = TMS3*(AGE2*M2/TMS2)/M3
      ELSEIF(ICASE.LE.12)THEN
*       Ensure that a new WD has the initial mass set correctly.
         M03 = M3
         IF(ecsn.gt.0.d0.and.ICASE.EQ.11.AND.M3.GE.1.38d0)then
            KW = 12 !will let hrdiag update accordingly...
         ELSEIF(ICASE.LT.12.AND.M3.GE.MCH)THEN
            M3 = 0.D0
            KW = 15
         ENDIF
      ELSEIF(ICASE.EQ.13.OR.ICASE.EQ.14)THEN
*       Set unstable Thorne-Zytkow object with fast mass loss of envelope
*       unless the less evolved star is a WD, NS or BH.
         IF(K2.LT.10)THEN
            M03 = M1
            M3 = M1
         ENDIF
         IF(ICASE.EQ.13.AND.M3.GT.MXNS)then
            KW = 14
         ENDIF
*       Special case for NSNS mergers below MXNS
         IF(K1.EQ.13.AND.K2.EQ.13.AND.M3.LE.MXNS)then
            KW = 13
         ENDIF
      ELSEIF(ICASE.EQ.15)THEN
         M3 = 0.D0
      ELSEIF(ICASE.GT.100)THEN
*       Common envelope case which should only be used after COMENV.
         KW = K1
         AGE3 = AGE1
         M3 = M1
         M03 = M01
      ELSE
*       This should not be reached.
        KW = 1
        M03 = M3
      ENDIF

      IF(bhms_coll_flag.eq.1)THEN
          IF(K1.EQ.14.AND.K2.LT.10.AND.M2.GT.M1)THEN
             KW = K2
             M03 = M2
             M3 = M2
             AGE3 = AGE2
          ENDIF
      ENDIF
*
* Put the result in *1.
*
* CLR - If the secondary is a BH and the primary is not, then copy the
* spin of the secondary into the primary

* If you ever want to consider spin-up in combined stars, this is the
* palce
      IF(KS(2).EQ.14)then
          bhspin(1) = bhspin(2)
      ENDIF
      KS(1) = KW
      KS(2) = 15
      M(1) = M3
      M(2) = 0.D0
      M0(1) = M03
      AJ(1) = AGE3
*
      RETURN
      END
***

***
      SUBROUTINE COMENV(M01,M1,MC1,AJ1,JSPIN1,KW1,
     &                  M02,M2,MC2,AJ2,JSPIN2,KW2,
     &                  ZPARS,ECC,SEP,JORB,COEL,star1,star2,vk,
     &                  kick_info,formation1,formation2,sigmahold,
     &                  bhspin1,bhspin2,binstate,mergertype,
     &                  jp,tphys,switchedCE,rad,tms,evolve_type,disrupt,
     &                  lumin,B_0,bacc,tacc,epoch,menv_bpp,renv_bpp,
     &                  bkick,deltam_1,deltam_2)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
* Common Envelope Evolution.
*
*     Author : C. A. Tout
*     Date :   18th September 1996
*
*     Redone : J. R. Hurley
*     Date :   7th July 1998
*
*     Update : P. D. Kiel (for ECSN, fallback and bugs)
*     Date : cmc version mid 2010
*
*     Update : V. E. Delfavero (bugs in bpp reporting)
*     Date : 20th, April 2025
*
* Note on indexing binary components:
*
* M01, M1, MC1, AJ1, JSPIN1, KW1, formation1, bhspin1 are selected with star1
* M02, M2, MC2, AJ2, JSPIN2, KW2, formation2, bhspin1 are selected with star2
*
* deltam_1 and deltam_2 are calculated before being passed into comenv
*
* teff, radc, and ospin are calculated inside comenv (or a function)
*
* Other quantities are passed as vectors.
* These are lumin, menv_bpp, tms, rad, renv, bacc, tacc, epoch, and B_0.
* tms and rad are immediately separated into tms1/2_bpp and rad1/2_bpp
*
      INTEGER KW1,KW2,KW,KW1i,KW2i,snp
      INTEGER star1,star2
      INTEGER binstate,mergertype
*
      REAL*8 M01,M1,MC1,AJ1,JSPIN1,R1,L1,K21
      REAL*8 M02,M2,MC2,AJ2,JSPIN2,R2,L2,K22,MC22
      REAL*8 TSCLS1(20),TSCLS2(20),LUMS(10),GB(10),TM1,TM2,TN,ZPARS(20)
      REAL*8 EBINDI,EBINDF,EORBI,EORBF,ECIRC,SEPF,SEPL,MF,XX
      REAL*8 SEP_postCE, M_postCE
      REAL*8 CONST,DELY,DERI,DELMF,MC3,FAGE1,FAGE2
      REAL*8 ECC,SEP,JORB,TB,OORB,OSPIN1,OSPIN2,TWOPI
      REAL*8 RC1,RC2,Q1,Q2,RL1,RL2,LAMB1,LAMB2
      REAL*8 MENV,RENV,MENVD,RZAMS,vk
      REAL*8 Porbi,Porbf,Mcf,Menvf,qi,qf,G
      REAL*8 kick_info(2,18),fallback,M1i,M2i
      REAL*8 bkick(20)
      REAL*8 bhspin1,bhspin2
      REAL*8 deltam_1,deltam_2
      common /fall/fallback
      INTEGER formation1,formation2
      REAL*8 sigmahold
      REAL*8 AURSUN,K3
      PARAMETER (AURSUN = 214.95D0,K3 = 0.21D0)
      LOGICAL COEL,output
      REAL*8 CELAMF,RL,RZAMSF
      EXTERNAL CELAMF,RL,RZAMSF
      INTEGER jp
      REAL*8 tphys
      LOGICAL switchedCE,disrupt
      INTEGER kstar1_bpp,kstar2_bpp
      REAL*8 mass1_bpp,mass2_bpp
      REAL*8 rrl1_bpp,rrl2_bpp,evolve_type
      REAL*8 aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp
      REAL*8 massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp
      REAL*8 q1_bpp,q2_bpp,teff1,teff2
      REAL*8 KW1_TEMP, KW2_TEMP
      REAL*8 rad(2),tms(2),lumin(2),B_0(2),bacc(2),tacc(2),epoch(2)
      REAL*8 menv_bpp(2),renv_bpp(2)
*
* Initialize
*

      aj1_bpp = 0.d0
      aj2_bpp = 0.d0
      massc1_bpp = 0.d0
      massc2_bpp = 0.d0

      if(using_cmc.eq.0) then
         tms1_bpp = tms(1)
         tms2_bpp = tms(2)
         rad1_bpp = rad(1)
         rad2_bpp = rad(2)
      endif

*
* Common envelope evolution - entered only when KW1 = 2, 3, 4, 5, 6, 8 or 9.
*
* For simplicity energies are divided by -G.
*
      TWOPI = 2.D0*ACOS(-1.D0)
      COEL = .FALSE.
      snp = 0
      output = .false.
*
* Obtain the core masses and radii.
*
      KW = KW1
      CALL star(KW1,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
      CALL hrdiag(M01,AJ1,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS,
     &            R1,L1,KW1,MC1,RC1,MENV,RENV,K21,
     &            bhspin1,star1)
      OSPIN1 = JSPIN1/(K21*R1*R1*(M1-MC1)+K3*RC1*RC1*MC1)
      MENVD = MENV/(M1-MC1)
      RZAMS = RZAMSF(M01)
*
* Decide which CE prescription to use based on LAMBDA flag
* MJZ: NOTE - Nanjing lambda prescription DOES NOT WORK!
*
      LAMB1 = CELAMF(KW,M01,L1,R1,RZAMS,MENVD,LAMBDAF)
      KW = KW2
      CALL star(KW2,M02,M2,TM2,TN,TSCLS2,LUMS,GB,ZPARS)
      CALL hrdiag(M02,AJ2,M2,TM2,TN,TSCLS2,LUMS,GB,ZPARS,
     &            R2,L2,KW2,MC2,RC2,MENV,RENV,K22,
     &            bhspin2,star2)
      OSPIN2 = JSPIN2/(K22*R2*R2*(M2-MC2)+K3*RC2*RC2*MC2)
*
* Calculate the binding energy of the giant envelope (multiplied by lambda).
*
      EBINDI = M1*(M1-MC1)/(LAMB1*R1)
*
* If the secondary star is also giant-like add its envelopes energy.
* Determine EORBI based on CEFLAG (CEFLAG=1 for de Kool prescription)
*
      IF(KW2.GE.2.AND.KW2.LE.9.AND.KW2.NE.7)THEN
         MENVD = MENV/(M2-MC2)
         RZAMS = RZAMSF(M02)
         LAMB2 = CELAMF(KW,M02,L2,R2,RZAMS,MENVD,LAMBDAF)
         EBINDI = EBINDI + M2*(M2-MC2)/(LAMB2*R2)
*
* Calculate the initial orbital energy
*
         IF(CEFLAG.EQ.0) EORBI = MC1*MC2/(2.D0*SEP)
         IF(CEFLAG.EQ.1) EORBI = M1*M2/(2.D0*SEP)
      ELSE
         IF(CEFLAG.EQ.0) EORBI = MC1*M2/(2.D0*SEP)
         IF(CEFLAG.EQ.1) EORBI = M1*M2/(2.D0*SEP)
      ENDIF
      if(output) write(*,*)'Init CE:',M01,M1,R1,M02,M2,R2,EBINDI,EORBI
*
* Allow for an eccentric orbit.
*
      ECIRC = EORBI/(1.D0 - ECC*ECC)
*
* Calculate the final orbital energy without coalescence.
*
      EORBF = EORBI + EBINDI/ALPHA1
*
* If the secondary is on the main sequence see if it fills its Roche lobe.
*
      IF(KW2.LE.1.OR.KW2.EQ.7)THEN
         SEPF = MC1*M2/(2.D0*EORBF)
         Q1 = MC1/M2
         Q2 = 1.D0/Q1
         RL1 = RL(Q1)
         RL2 = RL(Q2)
*
* If cemergeflag is set, cause kstars without clear core-envelope
* structure to merge automatically if they enter a CE
*
         IF(cemergeflag.eq.1)THEN
            if(KW1.eq.0.or.KW1.eq.1.or.KW1.eq.2.or.KW1.eq.7.or.
     &         KW1.eq.8.or.KW1.eq.10.or.KW1.eq.11.or.KW1.eq.12)then
                  COEL = .TRUE.
                  SEPL = RC1/RL1
                  binstate = 1
                  CALL CONCATKSTARS(KW1, KW2, mergertype)
            endif
         ENDIF
*
* The helium core of a very massive star of type 4 may actually fill
* its Roche lobe in a wider orbit with a very low-mass secondary.
*
         IF(RC1/RL1.GE.R2/RL2)THEN
            IF(RC1.GT.RL1*SEPF)THEN
               COEL = .TRUE.
               SEPL = RC1/RL1
               binstate = 1
               CALL CONCATKSTARS(KW1, KW2, mergertype)
            ENDIF
         ELSE
            IF(R2.GT.RL2*SEPF)THEN
               COEL = .TRUE.
               SEPL = R2/RL2
               binstate = 1
               CALL CONCATKSTARS(KW1, KW2, mergertype)
            ENDIF
         ENDIF
         IF(COEL)THEN
*
            KW = KTYPE(KW1,KW2) - 100
            MC3 = MC1
            IF(KW2.EQ.7.AND.KW.EQ.4) MC3 = MC3 + M2
*
* Coalescence - calculate final binding energy.
*
            EORBF = MAX(MC1*M2/(2.D0*SEPL),EORBI)
            EBINDF = EBINDI - ALPHA1*(EORBF - EORBI)
            KW1_TEMP = KW
            KW2_TEMP = 15
         ELSE
*
* Primary becomes a black hole, neutron star, white dwarf or helium star.
*
            MF = M1
            M1 = MC1
            KW1i = KW1
            KW2i = KW2
            M1i = M1
*
* Choose which masses and separations to use in SN based on cekickflag
*
            IF(cekickflag.eq.0)then
               SEP_postCE=SEPF
               M_postCE=MF
            ELSEIF(cekickflag.eq.1)then
               SEP_postCE=SEP
               M_postCE=MF
            ELSEIF(cekickflag.eq.2)then
               SEP_postCE=SEPF
               M_postCE=MC1
            ENDIF

            CALL star(KW1,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
            CALL hrdiag(M01,AJ1,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS,
     &                  R1,L1,KW1,MC1,RC1,MENV,RENV,K21,
     &                  bhspin1,star1)
            IF(KW1.GE.13)THEN
               formation1 = 1
               if(KW1.eq.13.and.ecsn.gt.0.d0)then
                  if(KW1i.le.6)then
                     if(M1i.le.zpars(5))then
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation1 = 2
                     endif
                  elseif(KW1i.ge.7.and.KW1i.le.9)then
                     if(M1i.gt.ecsn_mlow.and.M1i.le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation1 = 2
                     endif
                  elseif(formation1.eq.11)then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 5
                  elseif(KW1i.ge.10.or.KW1i.eq.12)then
* AIC formation, will never happen here but...
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 4
                  endif
               endif
*              Check if M1 and M2 were switched on pass to comenv
               if(switchedCE)then
                   mass1_bpp = M2
                   mass2_bpp = M_postCE
                   massc1_bpp = MC2
                   massc2_bpp = MC1

                   kstar1_bpp = KW2i
                   kstar2_bpp = KW1i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = R2/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = RC1/(RL(q2_bpp)*SEP_postCE)
                   aj1_bpp = AJ2
                   aj2_bpp = AJ1

                   evolve_type = 16.0d0

               else
                   mass1_bpp = M_postCE
                   mass2_bpp = M2
                   massc1_bpp = MC1
                   massc2_bpp = MC2

                   kstar1_bpp = KW1i
                   kstar2_bpp = KW2i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = RC1/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = R2/(RL(q2_bpp)*SEP_postCE)
                   evolve_type = 15.0d0
                   aj1_bpp = AJ1
                   aj2_bpp = AJ2
               endif
               TB = (SEP_postCE/AURSUN)*
     &               SQRT(SEP_postCE/(AURSUN*(M_postCE+M2)))
               if(using_cmc.eq.0)then
                   if(switchedCE)then
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0)) 
                       CALL writetab(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M02,M01,lumin(1),lumin(2),teff1,teff2,
     &                      RC2,RC1,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN2,OSPIN1,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin2,bhspin1,
     &                      deltam_2,deltam_1,formation2,formation1,
     &                      binstate,mergertype,'bpp')
                   else
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writetab(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M01,M02,lumin(1),lumin(2),teff1,teff2,
     &                      RC1,RC2,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN1,OSPIN2,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin1,bhspin2,
     &                      deltam_1,deltam_2,formation1,formation2,
     &                      binstate,mergertype,'bpp')
                   endif
               endif
               CALL kick(KW1,M_postCE,M1,M2,ECC,SEP_postCE,
     &                   JORB,vk,star1,R2,fallback,sigmahold,
     &                   kick_info,disrupt,bkick)
* Returning variable state to original naming convention
               MF = M_postCE
               SEPF = SEP_postCE
               snp = 1
               if(M2.lt.0.d0)then
                  if(KW2.ge.10) M1 = M1-M2
                  MC1 = M1
                  MC2 = 0.D0
                  bhspin2 = 0.D0
                  M2 = 0.D0
                  KW2 = 15
                  AJ1 = 0.D0
                  COEL = .true.
                  GOTO 30
               endif
               IF(ECC.GT.1.D0) GOTO 30
            ENDIF
         ENDIF
      ELSE
*
* Degenerate or giant secondary. Check if the least massive core fills its
* Roche lobe.
*
         SEPF = MC1*MC2/(2.D0*EORBF)
         Q1 = MC1/MC2
         Q2 = 1.D0/Q1
         RL1 = RL(Q1)
         RL2 = RL(Q2)
*
* If cemergeflag is set, cause kstars without clear core-envelope
* structure to merge automatically if they enter a CE
*
         IF(cemergeflag.eq.1)THEN
            if(KW1.eq.0.or.KW1.eq.1.or.KW1.eq.2.or.KW1.eq.7.or.
     &         KW1.eq.8.or.KW1.eq.10.or.KW1.eq.11.or.KW1.eq.12)then
                  COEL = .TRUE.
                  SEPL = RC1/RL1
                  binstate = 1
                  CALL CONCATKSTARS(KW1, KW2, mergertype)
            endif
         ENDIF
         IF(RC1/RL1.GE.RC2/RL2)THEN
            IF(RC1.GT.RL1*SEPF)THEN
               COEL = .TRUE.
               SEPL = RC1/RL1
               binstate = 1
               CALL CONCATKSTARS(KW1, KW2, mergertype)
            ENDIF
         ELSE
            IF(RC2.GT.RL2*SEPF)THEN
               COEL = .TRUE.
               SEPL = RC2/RL2
               binstate = 1
               CALL CONCATKSTARS(KW1, KW2, mergertype)
            ENDIF
         ENDIF
*
         IF(COEL)THEN
*
* If the secondary was a neutron star or black hole the outcome
* is an unstable Thorne-Zytkow object that leaves only the core.
*
            SEPF = 0.D0
            IF(KW2.GE.13)THEN
               MC1 = MC2
               M1 = MC1
               MC2 = 0.D0
               M2 = 0.D0
               KW1 = KW2
               KW2 = 15
               bhspin1 = bhspin2
               bhspin2 = 0.d0
               AJ1 = 0.D0
*
* The envelope mass is not required in this case.
*
               GOTO 30
            ENDIF
*
            KW = KTYPE(KW1,KW2) - 100
            MC3 = MC1 + MC2
*
* Calculate the final envelope binding energy.
*
            EORBF = MAX(MC1*MC2/(2.D0*SEPL),EORBI)
            EBINDF = EBINDI - ALPHA1*(EORBF - EORBI)
            if(output) write(*,*)'In dg or giant 1:',M01,M1,R1,M02,M2,
     & R2,MC1,MC2,MC3,KW1,KW2,KW,EORBF,EBINDF
*
* Check if we have the merging of two degenerate cores and if so
* then see if the resulting core will survive or change form.
*
            IF(KW1.EQ.6.AND.(KW2.EQ.6.OR.KW2.GE.11))THEN
               CALL dgcore(KW1,KW2,KW,MC1,MC2,MC3,EBINDF)
               if(output) write(*,*)'dg/giant 2:',KW,MC1,MC2,MC3,EBINDF
            ENDIF
            IF(KW1.LE.3.AND.M01.LE.ZPARS(2))THEN
               IF((KW2.GE.2.AND.KW2.LE.3.AND.M02.LE.ZPARS(2)).OR.
     &             KW2.EQ.10)THEN
                  CALL dgcore(KW1,KW2,KW,MC1,MC2,MC3,EBINDF)
                  if(output) write(*,*)'dg/giant 2:',KW,MC1,MC2,MC3,
     & EBINDF
                  IF(KW.GE.10)THEN
                     KW1 = KW
                     M1 = MC3
                     MC1 = MC3
                     IF(KW.LT.15) M01 = MC3
                     AJ1 = 0.D0
                     MC2 = 0.D0
                     M2 = 0.D0
                     KW2 = 15
                     binstate = 2
                     mergertype = -1
                     GOTO 30
                  ENDIF
               ENDIF
            ENDIF
*
         ELSE
*
* The cores do not coalesce - assign the correct masses and ages.
*
            MF = M1
            M1 = MC1
            KW1i = KW1
            KW2i = KW2
            M1i = M1
*
* Choose which masses and separations to use in SN based on cekickflag
*
            IF(cekickflag.eq.0)then
               SEP_postCE=SEPF
               M_postCE=MF
            ELSEIF(cekickflag.eq.1)then
               SEP_postCE=SEP
               M_postCE=MF
            ELSEIF(cekickflag.eq.2)then
               SEP_postCE=SEPF
               M_postCE=MC1
            ENDIF
*
* If cehestarflag is specified, determine the post-CE separation and/or
* mass for He-star/compact object system according to Tauris+2015
*
            IF(KW1.ge.7.and.KW1.le.9.and.KW2.ge.13)THEN
                if(cehestarflag.ne.0)then
* calculate G in Rsun/Msun/days, and initial Porb in days
                    G = 2957.45d+0
                    Porbi = (TWOPI/(G*(MF+M2))**(1d0/2d0)) *
     &                  SEP**(3d0/2d0)
                    Mcf = (1d0/(400d0*Porbi)+0.49d0)*MF -
     &                  ((0.016d0/Porbi) - 0.106d0)
                    if(Porbi.le.2d0.and.Porbi.gt.0.06d0)then
                        Menvf = 0.18d0*Porbi**(0.45d0) *
     &                      (LOG(Mcf**4d0) - 1.05d0)
                    elseif(Porbi.gt.2.d0)then
                        Menvf = Mcf*(LOG(Porbi**(-0.2d0))+1) +
     &                      LOG(Porbi**(0.5d0))-1.5d0
                    elseif(Porbi.le.0.06d0)then
*                       outside range of validity, use BSE masses
                        Menvf = 0d0
                        Mcf = MC1
                    endif
                    qi = MF/M2
* if cehestarflag is 1, use BSEs calculation of post-CE core mass
                    if(cehestarflag.eq.1)then
                        M_postCE = MC1
                        qf = MC1/M2
* elseif cehestarflag is 2, use Tauris fitting formula for post-CE mass
                    elseif(cehestarflag.eq.2)then
*                   first, check that the mass is more than core mass
                        if((Mcf+Menvf).lt.MC1)then
                           M_postCE = MC1
                        else
                           M_postCE = (Mcf+Menvf)
                        endif
                        qf = (Mcf+Menvf)/M2
                    endif
                    Porbf = (((qi+1)/(qf+1))**(2d0) * (qi/qf)**(3d0) *
     &                      EXP(3d0*(qf-qi))) * Porbi
                    SEP_postCE = (G*(M_postCE+M2) / (TWOPI**(2d0)) *
     &                      Porbf**(2d0))**(1d0/3d0)
                endif
            ENDIF

            CALL star(KW1,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
            CALL hrdiag(M01,AJ1,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS,
     &                  R1,L1,KW1,MC1,RC1,MENV,RENV,K21,
     &                  bhspin1,star1)
            IF(KW1.GE.13)THEN
               formation1 = 1
               if(KW1.eq.13.and.ecsn.gt.0.d0)then
                  if(KW1i.le.6)then
                     if(M1i.le.zpars(5))then
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation1 = 2
                     endif
                  elseif(KW1i.ge.7.and.KW1i.le.9)then
                     if(M1i.gt.ecsn_mlow.and.M1i.le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation1 = 2
                     endif
                  elseif(formation1.eq.11)then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 5
                  elseif(KW1i.ge.10.or.KW1i.eq.12)then
* AIC formation, will never happen here but...
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 4
                  endif
               endif
*              Check if M1 and M2 were switched on pass to comenv
               if(switchedCE)then
                   mass1_bpp = M2
                   mass2_bpp = M_postCE
                   massc1_bpp = MC2
                   massc2_bpp = MC1

                   kstar1_bpp = KW2i
                   kstar2_bpp = KW1i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = R2/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = RC1/(RL(q2_bpp)*SEP_postCE)
                   aj1_bpp = AJ2
                   aj2_bpp = AJ1
                   evolve_type = 16.d0

               else
                   mass1_bpp = M_postCE
                   mass2_bpp = M2
                   massc1_bpp = MC1
                   massc2_bpp = MC2

                   kstar1_bpp = KW1i
                   kstar2_bpp = KW2i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = RC1/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = R2/(RL(q2_bpp)*SEP_postCE)
                   aj1_bpp = AJ1
                   aj2_bpp = AJ2
                   evolve_type = 15.0d0
               endif
               TB = (SEP_postCE/AURSUN)*
     &               SQRT(SEP_postCE/(AURSUN*(M_postCE+M2)))
               if(using_cmc.eq.0)then
                   if(switchedCE)then
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writetab(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M02,M01,lumin(1),lumin(2),teff1,teff2,
     &                      RC2,RC1,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN2,OSPIN1,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin2,bhspin1,
     &                      deltam_2,deltam_1,formation2,formation1,
     &                      binstate,mergertype,'bpp')
                   else
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writetab(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M01,M02,lumin(1),lumin(2),teff1,teff2,
     &                      RC1,RC2,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN1,OSPIN2,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin1,bhspin2,
     &                      deltam_1,deltam_2,formation1,formation2,
     &                      binstate,mergertype,'bpp')
                   endif
               endif
* USSN: if ussn flag is set, have reduced kicks for stripped He stars (SN=8)
               if(KW1.eq.13.and.KW2.ge.13.and.ussn.eq.1)then
                  if(KW1i.ge.7.and.KW1i.le.9)then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                  formation1 = 3
                  endif
               endif
               CALL kick(KW1,M_postCE,M1,M2,ECC,SEP_postCE,
     &                   JORB,vk,star1,R2,fallback,sigmahold,
     &                   kick_info,disrupt,bkick)
* Returning variable state to original naming convention
               MF = M_postCE
               SEPF = SEP_postCE
               snp = 1
               if(M2.lt.0.d0)then
                  if(KW2.ge.10) M1 = M1-M2
                  MC1 = M1
                  MC2 = 0.D0
                  M2 = 0.D0
                  KW2 = 15
                  AJ1 = 0.D0
                  COEL = .true.
                  GOTO 30
               endif
               IF(ECC.GT.1.D0) GOTO 30
            ENDIF
            MF = M2
            KW = KW2
            M2 = MC2
            KW1i = KW1
            KW2i = KW2
            M2i = M2
*
* Choose which masses and separations to use in SN based on cekickflag
*
            IF(cekickflag.eq.0)then
               SEP_postCE=SEPF
               M_postCE=MF
            ELSEIF(cekickflag.eq.1)then
               SEP_postCE=SEP
               M_postCE=MF
            ELSEIF(cekickflag.eq.2)then
               SEP_postCE=SEPF
               M_postCE=MC2
            ENDIF

            CALL star(KW2,M02,M2,TM2,TN,TSCLS2,LUMS,GB,ZPARS)
            CALL hrdiag(M02,AJ2,M2,TM2,TN,TSCLS2,LUMS,GB,ZPARS,
     &                  R2,L2,KW2,MC2,RC2,MENV,RENV,K22,
     &                  bhspin2,star2)
            IF(KW2.GE.13.AND.KW.LT.13)THEN
               formation2 = 1
               if(KW2.eq.13.and.ecsn.gt.0.d0)then
                  if(KW2i.le.6)then
                     if(M2i.le.zpars(5))then
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation2 = 2
                     endif
                  elseif(KW2i.ge.7.and.KW2i.le.9)then
                     if(M2i.gt.ecsn_mlow.and.M2i.le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                        if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                           sigma = -sigmahold/sigmadiv
                        elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                           sigma = sigmadiv
                        endif
                        formation2 = 2
                     endif
                  elseif(formation2.eq.11)then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation2 = 5
                  elseif(KW2i.ge.10.or.KW2i.eq.12)then
* AIC formation, will never happen here but...
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation2 = 4
                  endif
               endif
*              Check if M1 and M2 were switched on pass to comenv
               if(switchedCE)then
                   mass1_bpp = M_postCE
                   mass2_bpp = M1
                   massc1_bpp = MC2
                   massc2_bpp = MC1

                   kstar1_bpp = KW2i
                   kstar2_bpp = KW1i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = RC2/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = R1/(RL(q2_bpp)*SEP_postCE)
                   evolve_type = 15.0d0
                   aj1_bpp = AJ2
                   aj2_bpp = AJ1
*              M2, which here is mass(1), undergoes SN

               else
                   mass1_bpp = M1
                   mass2_bpp = M_postCE
                   massc1_bpp = MC1
                   massc2_bpp = MC2

                   kstar1_bpp = KW1i
                   kstar2_bpp = KW2i
                   q1_bpp = mass1_bpp/mass2_bpp
                   q2_bpp = 1.d0/q1_bpp
                   rrl1_bpp = R1/(RL(q1_bpp)*SEP_postCE)
                   rrl2_bpp = RC2/(RL(q2_bpp)*SEP_postCE)
                   evolve_type = 16.0d0
                   aj1_bpp = AJ1
                   aj2_bpp = AJ2
*              M2, which here is mass(2), undergoes SN
               endif
               TB = (SEP_postCE/AURSUN)*
     &               SQRT(SEP_postCE/(AURSUN*(M_postCE+M1)))
               if(using_cmc.eq.0)then
                   if(switchedCE)then
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writetab(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M02,M01,lumin(1),lumin(2),teff1,teff2,
     &                      RC2,RC1,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN2,OSPIN1,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin2,bhspin1,
     &                      deltam_2,deltam_1,formation2,formation1,
     &                      binstate,mergertype,'bpp')
                   else
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writetab(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,SEP_postCE,TB,ECC,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M01,M02,lumin(1),lumin(2),teff1,teff2,
     &                      RC1,RC2,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN1,OSPIN2,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin1,bhspin2,
     &                      deltam_1,deltam_2,formation1,formation2,
     &                      binstate,mergertype,'bpp')
                   endif
               endif
               CALL kick(KW2,M_postCE,M2,M1,ECC,SEP_postCE,
     &                   JORB,vk,star2,R1,fallback,sigmahold,
     &                   kick_info,disrupt,bkick)
* Returning variable state to original naming convention
               MF = M_postCE
               SEPF = SEP_postCE
               snp = 1
               if(M1.lt.0.d0)then
                  if(KW2.ge.10) M2 = M2-M1
                  MC2 = M2
                  MC1 = 0.D0
                  M1 = 0.D0
                  bhspin1 = 0.D0
                  KW1 = 15
                  AJ2 = 0.D0
                  COEL = .true.
                  GOTO 30
               endif
               IF(ECC.GT.1.D0) GOTO 30
            ENDIF
         ENDIF
      ENDIF
*
      IF(COEL)THEN
         MC22 = MC2
         IF(KW.EQ.4.OR.KW.EQ.7)THEN
* If making a helium burning star calculate the fractional age
* depending on the amount of helium that has burnt.
            IF(KW1.LE.3)THEN
               FAGE1 = 0.D0
            ELSEIF(KW1.GE.6)THEN
               FAGE1 = 1.D0
            ELSE
               FAGE1 = (AJ1 - TSCLS1(2))/(TSCLS1(13) - TSCLS1(2))
            ENDIF
            IF(KW2.LE.3.OR.KW2.EQ.10)THEN
               FAGE2 = 0.D0
            ELSEIF(KW2.EQ.7)THEN
               FAGE2 = AJ2/TM2
               MC22 = M2
            ELSEIF(KW2.GE.6)THEN
               FAGE2 = 1.D0
            ELSE
               FAGE2 = (AJ2 - TSCLS2(2))/(TSCLS2(13) - TSCLS2(2))
            ENDIF
         ENDIF
         if(output) write(*,*)'coel 1:',KW,MC1,MC2,MC3,MC22,FAGE1,FAGE2
      ENDIF
*
* Now calculate the final mass following coelescence.  This requires a
* Newton-Raphson iteration.
*
      IF(COEL)THEN
*
* Calculate the orbital spin just before coalescence.
*
         TB = (SEPL/AURSUN)*SQRT(SEPL/(AURSUN*(MC1+MC2)))
         OORB = TWOPI/TB
*
         XX = 1.D0 + ZPARS(7)
         IF(EBINDF.LE.0.D0)THEN
            MF = MC3
            GOTO 20
         ELSE
            CONST = ((M1+M2)**XX)*(M1-MC1+M2-MC22)*EBINDF/EBINDI
         ENDIF
*
* Initial Guess.
*
         MF = MAX(MC1 + MC22,(M1 + M2)*(EBINDF/EBINDI)**(1.D0/XX))
   10    DELY = (MF**XX)*(MF - MC1 - MC22) - CONST
*        IF(ABS(DELY/MF**(1.D0+XX)).LE.1.0D-02) GOTO 20
         IF(ABS(DELY/MF).LE.1.0D-03) GOTO 20
         DERI = MF**ZPARS(7)*((1.D0+XX)*MF - XX*(MC1 + MC22))
         DELMF = DELY/DERI
         MF = MF - DELMF
         GOTO 10
*
* Set the masses and separation.
*
   20    IF(MC22.EQ.0.D0) MF = MAX(MF,MC1+M2)
         M2 = 0.D0
         M1 = MF
         KW2 = 15
         bhspin2 = 0.d0
*
* Combine the core masses.
*
         if(output) write(*,*)'coel 2 1:',KW,KW1,KW2,M1,M2,MF,MC22,
     & TB,OORB
         IF(KW.EQ.2)THEN
            CALL star(KW,M1,M1,TM2,TN,TSCLS2,LUMS,GB,ZPARS)
            IF(GB(9).GE.MC1)THEN
               M01 = M1
               AJ1 = TM2 + (TSCLS2(1) - TM2)*(AJ1-TM1)/(TSCLS1(1) - TM1)
               CALL star(KW,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
            ENDIF
            if(output) write(*,*)'coel 2 2:',KW,KW1,KW2,M1,M01,MC22,
     & TB,OORB
         ELSEIF(KW.EQ.7)THEN
            M01 = M1
            CALL star(KW,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
            AJ1 = TM1*(FAGE1*MC1 + FAGE2*MC22)/(MC1 + MC22)
            if(output) write(*,*)'coel 2 3:',KW,KW1,KW2,M1,M01,MC22,
     & TB,OORB
         ELSEIF(KW.EQ.4.OR.MC2.GT.0.D0.OR.KW.NE.KW1)THEN
            IF(KW.EQ.4) AJ1 = (FAGE1*MC1 + FAGE2*MC22)/(MC1 + MC22)
            MC1 = MC1 + MC2
            MC2 = 0.D0
*
* Obtain a new age for the giant.
*
            CALL gntage(MC1,M1,KW,ZPARS,M01,AJ1)
            CALL star(KW,M01,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS)
            if(output) write(*,*)'coel 2 4:',KW,KW1,KW2,M1,M01,MC22,
     & TB,OORB
         ENDIF
         MF = M1
         KW1i = KW
         KW2i = KW2
         M1i = M1
         CALL hrdiag(M01,AJ1,M1,TM1,TN,TSCLS1,LUMS,GB,ZPARS,
     &               R1,L1,KW,MC1,RC1,MENV,RENV,K21,
     &               bhspin1,star1)
         if(output) write(*,*)'coel 2 5:',KW,M1,M01,R1,MENV,RENV
         IF(KW1i.LE.12.and.KW.GE.13)THEN
            formation1 = 1
            if(KW.eq.13.and.ecsn.gt.0.d0)then
               if(KW1i.le.6)then
                  if(M1i.le.zpars(5))then
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 2
                  endif
               elseif(KW1i.ge.7.and.KW1i.le.9)then
                  if(M1i.gt.ecsn_mlow.and.M1i.le.ecsn)then
* BSE orgi: 1.6-2.25, Pod: 1.4-2.5, StarTrack: 1.83-2.25 (all in Msun)
                     if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                        sigma = -sigmahold/sigmadiv
                     elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                        sigma = sigmadiv
                     endif
                     formation1 = 2
                  endif
               elseif(formation1.eq.11)then
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = -sigmahold/sigmadiv
                  elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                     sigma = sigmadiv
                  endif
                  formation1 = 5
               elseif(KW1i.ge.10.or.KW1i.eq.12)then
* AIC formation, will never happen here but...
                  if(sigma.gt.0.d0.and.sigmadiv.gt.0.d0)then
                     sigma = -sigmahold/sigmadiv
                  elseif(sigma.gt.0.d0.and.sigmadiv.lt.0.d0)then
                     sigma = sigmadiv
                  endif
                  formation1 = 4
               endif
            endif
*              Check if M1 and M2 were switched on pass to comenv
            if(switchedCE)then
                mass1_bpp = 0.d0
                mass2_bpp = MF
                massc1_bpp = 0.d0
                massc2_bpp = MC1

                kstar1_bpp = KW2i
                kstar2_bpp = KW1i
                rrl1_bpp = 0.d0
                rrl2_bpp = 0.d0
                evolve_type = 16.0d0
                aj1_bpp = AJ2
                aj2_bpp = AJ1
            else
                mass1_bpp = MF
                mass2_bpp = 0.d0
                massc1_bpp = MC1
                massc2_bpp = 0.d0

                kstar1_bpp = KW1i
                kstar2_bpp = KW2i
                rrl1_bpp = 0.d0
                rrl2_bpp = 0.d0
                evolve_type = 15.0d0
                aj1_bpp = AJ1
                aj2_bpp = AJ2
            endif
            TB = 0.d0
            if(using_cmc.eq.0)then
                   if(switchedCE)then
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writetab(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,-1.d0,TB,0.d0,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M02,M01,lumin(1),lumin(2),teff1,teff2,
     &                      RC2,RC1,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN2,OSPIN1,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin2,bhspin1,
     &                      deltam_2,deltam_1,formation2,formation1,
     &                      binstate,mergertype,'bpp')
                   else
                       teff1 = 1000.d0*((1130.d0*lumin(1)/
     &                       (rad1_bpp**2.d0))**(1.d0/4.d0))
                       teff2 = 1000.d0*((1130.d0*lumin(2)/
     &                       (rad2_bpp**2.d0))**(1.d0/4.d0))
                       CALL writetab(jp,tphys,evolve_type,
     &                       mass1_bpp,mass2_bpp,kstar1_bpp,
     &                       kstar2_bpp,-1.d0,TB,0.d0,
     &                       rrl1_bpp,rrl2_bpp,
     &                       aj1_bpp,aj2_bpp,tms1_bpp,tms2_bpp,
     &                       massc1_bpp,massc2_bpp,rad1_bpp,rad2_bpp,
     &                      M01,M02,lumin(1),lumin(2),teff1,teff2,
     &                      RC1,RC2,menv_bpp(1),menv_bpp(2),renv_bpp(1),
     &                      renv_bpp(2),OSPIN1,OSPIN2,B_0(1),B_0(2),
     &                      bacc(1),bacc(2),tacc(1),tacc(2),epoch(1),
     &                      epoch(2),bhspin1,bhspin2,
     &                      deltam_1,deltam_2,formation1,formation2,
     &                      binstate,mergertype,'bpp')
                   endif
            endif
            CALL kick(KW,MF,M1,0.d0,0.d0,-1.d0,0.d0,vk,star1,
     &                0.d0,fallback,sigmahold,kick_info,disrupt,bkick)
            if(output) write(*,*)'coel 2 6:',KW,M1,M01,R1,MENV,RENV
         ENDIF
         JSPIN1 = OORB*(K21*R1*R1*(M1-MC1)+K3*RC1*RC1*MC1)
         KW1 = KW
         ECC = 0.D0
         if(output) write(*,*)'coel 2 7:',KW1,M1,M01,R1,MENV,RENV
      ELSE
*
* Check if any eccentricity remains in the orbit by first using
* energy to circularise the orbit before removing angular momentum.
* (note this should not be done in case of CE SN ... fixed PDK).
*
         IF(snp.EQ.0)THEN
            IF(EORBF.LT.ECIRC)THEN
               ECC = SQRT(1.D0 - EORBF/ECIRC)
            ELSE
               ECC = 0.D0
            ENDIF
         ENDIF
*
* Set both cores in co-rotation with the orbit on exit of CE,
*
         TB = (SEPF/AURSUN)*SQRT(SEPF/(AURSUN*(M1+M2)))
         OORB = TWOPI/TB
         JORB = M1*M2/(M1+M2)*SQRT(1.D0-ECC*ECC)*SEPF*SEPF*OORB
*        JSPIN1 = OORB*(K21*R1*R1*(M1-MC1)+K3*RC1*RC1*MC1)
*        JSPIN2 = OORB*(K22*R2*R2*(M2-MC2)+K3*RC2*RC2*MC2)
*
* or, leave the spins of the cores as they were on entry.
* Tides will deal with any synchronization later.
*
         JSPIN1 = OSPIN1*(K21*R1*R1*(M1-MC1)+K3*RC1*RC1*MC1)
         JSPIN2 = OSPIN2*(K22*R2*R2*(M2-MC2)+K3*RC2*RC2*MC2)
      ENDIF
   30 SEP = SEPF
      if(output) write(*,*)'end of CE1:',KW1,M1,M01,R1,MENV,RENV
      if(output) write(*,*)'end of CE1:',KW2,M2,M02,R2,MENV,RENV
      sigma = sigmahold
      RETURN
      END
***

***
      SUBROUTINE dgcore(kw1,kw2,kw3,m1,m2,m3,ebinde)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
* A routine to determine the outcome of a collision or coalescence
* of two degenerate cores.
* Entered with kw1,kw2 = 2 or 3 with M <= Mflash, 6, 10, 11 or 12
*
*
      integer kw1,kw2,kw3
*
      real*8 m1,m2,m3,ebinde
      real*8 r1,r2,r3,mhe,mc,mne,ebindi,ebindf,deleb,de,enuc
      real*8 temp,x,y,m0,mflash
      real*8 cvhe,cvc,cvne
      parameter(cvhe=3.1d+07,cvc=8.27d+06,cvne=7.44d+06)
      real*8 ehe,ec,ene
      parameter(ehe=5.812d+17,ec=2.21d+17,ene=2.06d+17)
      real*8 the,tc,gmr,mch
      parameter(the=1.0d+08,tc=1.0d+09,gmr=1.906d+15,mch=1.44d0)
*
      real*8 corerd
      external corerd
*
* Calculate the core radii setting m0 < mflash using dummy values as we
* know it to be true if kw = 2 or 3.
      m0 = 1.d0
      mflash = 2.d0
      r1 = corerd(kw1,m1,m0,mflash)
      r2 = corerd(kw2,m2,m0,mflash)
      r3 = corerd(kw3,m3,m0,mflash)
* Calculate the initial binding energy of the two seperate cores and the
* difference between this and the final binding energy of the new core.
      ebindi = m1*m1/r1 + m2*m2/r2
      ebindf = m3*m3/r3
      deleb = ABS(ebindi - ebindf)
* If an envelope is present reduce its binding energy by the amount
* of energy liberated by the coalescence.
      ebinde = MAX(0.d0,ebinde - deleb)
      if(kw1.gt.3) goto 90
* Distribute the mass into core mass groups where mhe represents Helium
* core mass, mc represents Carbon core mass and mne represents a Neon
* core mass or any mass that is all converted Carbon.
      mhe = 0.d0
      mc = 0.d0
      mne = 0.d0
      if(kw1.le.3.or.kw1.eq.10)then
         mhe = mhe + m1
      elseif(kw1.eq.12)then
         mne = mne + m1
      else
         mc = mc + m1
      endif
      if(kw2.le.3.or.kw2.eq.10)then
         mhe = mhe + m2
      elseif(kw2.eq.12)then
         mne = mne + m2
      else
         mc = mc + m2
      endif
* Calculate the temperature generated by the merging of the cores.
      temp = (deleb/(cvhe*mhe+cvc*mc+cvne*mne))*gmr
*
* To decide if He is converted to C we use:
*    3He4 -> C12 , T > 10^8 K , 7.274 Mev released,
* to decide if C is converted further we use:
*    2C12 -> Ne20 + alpha , T > 10^9 K , 4.616 Mev released.
* and to decide if O is converted further we use:
*    2O16 -> P31 + p , T > 10^9 K , 7.677 Mev released.
* To obtain the heat capacity of an O/Ne WD and to gain an idea of the
* energy released from the further processing of an O/Ne WD we use:
*    2Ne20 + gamma -> O16 + Mg24 +gamma , T > 10^9 K , 4.583 Mev released.
* For a CO core the composition is assumed to be 20% C, 80% O and for
* an ONe core 80% O, 20% Ne.
*
* Decide if conversion of elements can take place.
*     if(temp.gt.the)then
         x = 1.d0
*     else
*        x = 0.d0
*     endif
*     if(temp.gt.tc)then
*        y = 1.d0
*     else
         y = 0.d0
*     endif
* Calculate the nuclear energy generated from any element conversion.
      enuc = (x*ehe*mhe + y*(ec*mc + ene*mne))/gmr
* Calculate the difference between the binding energy of the star
* (core + envelope) and the nuclear energy. The new star will be
* destroyed in a SN if dE < 0.
      de = (ebindf + ebinde) - enuc
* If the star survives and an envelope is present then reduce the
* envelope binding energy by the amount of liberated nuclear energy.
* The envelope will not survive if its binding energy is reduced to <= 0.
      if(de.ge.0.d0) ebinde = MAX(0.d0,ebinde - enuc)
* Now determine the final evolution state of the merged core.
      if(de.lt.0.d0) kw3 = 15
      if(kw3.eq.3)then
         if(x.gt.0.5d0)then
            kw3 = 6
         elseif(ebinde.le.0.d0)then
            kw3 = 10
         endif
      elseif(kw3.eq.4)then
         if(x.gt.0.5d0)then
            kw3 = 6
         elseif(ebinde.le.0.d0)then
            kw3 = 7
         endif
      endif
      if(kw3.eq.6.and.y.lt.0.5d0)then
         if(ebinde.le.0.d0) kw3 = 11
      elseif(kw3.eq.6.and.y.gt.0.5d0)then
         if(ebinde.le.0.d0) kw3 = 12
      endif
      if(kw3.eq.10.and.x.gt.0.5d0) kw3 = 11
      if(kw3.eq.11.and.y.gt.0.5d0) kw3 = 12
      if(kw3.ge.10.and.kw3.le.12.and.m3.ge.mch) kw3 = 15
*
      if(kw3.eq.15) m3 = 0.d0
 90   continue
*
      return
      end
***

***
      SUBROUTINE CONCATKSTARS(int1,int2,int3)
*
* Concatenate Strings.
*
*     Author : Scott Coughlinn
*     Date :   11th December 2018
*
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
      INTEGER int1,int2,int3
      CHARACTER(len=2) str1,str2
      CHARACTER(len=4) str3

      IF(USING_CMC.EQ.0)THEN

          WRITE(str1,'(i2.2)') int1
          WRITE(str2,'(i2.2)') int2

          str3 = trim(adjustl(str1))//trim(adjustl(str2))

          READ(str3,*)int3
      ELSE
          int3 = -1
      ENDIF

      END

***
      SUBROUTINE assign_remnant(zpars,mc,mcbagb,mass,kidx,mt,kw,bhspin)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
      
      common /fall/fallback
      REAL*8 fallback
      real*8 zpars(20)

      real*8 avar,bvar
      real*8 mc,mcbagb,mass,mt,mc_tot,met
      real*8 frac,kappa,sappa,alphap,polyfit
      real*8 m_proto,m_FeNi,m_fb,bhspin,mrem,mch,dMppi
      integer kw,kidx

* Inputs
*       zpars      : Array of metallicity dependent parameters
*       mc         : CO core mass before SN
*       mcbagb     : Core mass at the base of the AGB
*       mass       : Previous epoch mass of the star
*       kidx       : Index of the star in the pisn track arrays

* Outputs
*       mt         : Remnant mass after SN
*       kw         : Stellar (remnant) type
*       bhspin     : Dimensionless spin parameter of BH remnant

* total core mass before SN (CO + He layers)
      mc_tot = mc_co(kidx) + mc_he(kidx)

* Set the Chandrasekhar mass
      mch = 1.44d0 !set here owing to AIC ECSN model.

* Check if remnant is below Chandrasekhar mass
      if(mc_co(kidx).lt.mch)then
         if(ifflag.ge.1)then
*
* Invoke WD IFMR from HPE, 1995, MNRAS, 272, 800.
*
            if(zpars(14).ge.1.0d-08)then
               mc = MIN(0.36d0+0.104d0*mass,0.58d0+0.061d0*mass)
               mc = MAX(0.54d0+0.042d0*mass,mc)
               if(mass.lt.1.d0) mc = 0.46d0
            else
               mc = MIN(0.29d0+0.178d0*mass,0.65d0+0.062d0*mass)
               mc = MAX(0.54d0+0.073d0*mass,mc)
            endif
            mc = MIN(mch,mc)
         endif
         
         mt = mc
         if(ecsn.gt.0.d0.and.mcbagb.lt.ecsn_mlow)then
            kw = 11
         elseif(ecsn.eq.0.d0.and.mcbagb.lt.1.6d0)then !double check what this should be. should be ecsn_mlow. Remember need to add option if ecsn = 0 (i.e. no ECSN!!!)
*
* Zero-age Carbon/Oxygen White Dwarf
*
            kw = 11
         elseif(ecsn.gt.0.d0.and.mcbagb.ge.ecsn_mlow.and.
     &          mcbagb.le.ecsn.and.mc.lt.1.08d0)then
            kw = 11
*               elseif(mcbagb.ge.1.6d0.and.mcbagb.le.2.5d0.and.
*                      mc.lt.1.08d0)then !can introduce this into code at some point.
*                  kw = 11

         else
*
* Zero-age Oxygen/Neon White Dwarf
*
            kw = 12
         endif
         mass = mt
*
      else
         if(ecsn.gt.0.d0.and.mcbagb.lt.ecsn_mlow)then
*
* Star is not massive enough to ignite C burning.
* so no remnant is left after the SN
*
            kw = 15
         elseif(ecsn.eq.0.d0.and.mcbagb.lt.1.6d0)then
*
* Star is not massive enough to ignite C burning.
* so no remnant is left after the SN
*
            kw = 15
         else
*
* Use remnant mass given by Hurley+2000
            if(remnantflag.eq.0)then
               mt = 1.17d0 + 0.09d0*mc_co(kidx)
            elseif(remnantflag.eq.1)then
*
* Use NS/BH mass given by Belczynski et al. 2002, ApJ, 572, 407. Equation 1
*
*   TW: Belczynski+02 states that FeNi core mass comes from Woosley 1986 (Nucleosynthesis and Stellar Evolution)
*   As far I can tell, this is a linear fit to Table 6. But that table is He core mass, not CO core mass.
*   I also get a different slope, so I imagine there was a conversion to CO core mass somewhere in their fit?
               if(mc_co(kidx).lt.2.5d0)then
                  m_FeNi = 0.161767d0*mc_co(kidx) + 1.067055d0
               else
                  m_FeNi = 0.314154d0*mc_co(kidx) + 0.686088d0
               endif
               if(mc_co(kidx).le.5.d0)then
                  mt = m_FeNi
                  fallback = 0.d0
               elseif(mc_co(kidx).lt.7.6d0)then
*   TW: the fallback fraction is assumed to linearly increase from 0 to 1 between MCO=5 and MCO=7.6, hence the 2.6
                  fallback = (mc_co(kidx) - 5.d0)/2.6d0
                  mt = m_FeNi + fallback * (mt - m_FeNi)
               elseif(mc_co(kidx).gt.7.60)then
                  fallback = 1.d0
               endif
            elseif(remnantflag.eq.2)then
*
* Use NS/BH masses given by Belczynski+08. PK.
*
               ! calculate m_FeNi following Eq. 1 (fit to Timmes+1996)
               if(ecsn.gt.0.d0.and.mcbagb.le.ecsn.and.
     &                             mcbagb.ge.ecsn_mlow)then
                  m_FeNi = 1.38d0
               elseif(mc_co(kidx).lt.4.82d0)then
                  m_FeNi = 1.5d0
               elseif(mc_co(kidx).ge.4.82d0
     &                .and.mc_co(kidx).lt.6.31d0)then
                  m_FeNi = 2.11d0
               elseif(mc_co(kidx).ge.6.31d0
     &                .and.mc_co(kidx).lt.6.75d0)then
                  m_FeNi = 0.69*mc_co(kidx) - 2.26d0
               elseif(mc_co(kidx).ge.6.75d0)then
                  m_FeNi = 0.37*mc_co(kidx) - 0.07d0
               endif
               ! now calculate the remnant mass after fallback (Eq. 2)
               if(mc_co(kidx).le.5.d0)then
                  mt = m_FeNi
                  fallback = 0.d0
               elseif(mc_co(kidx).lt.7.6d0)then
                  fallback = (mc_co(kidx) - 5.d0) / 2.6d0
                  mt = m_FeNi + fallback * (mt - m_FeNi)
               elseif(mc_co(kidx).gt.7.60)then
                  fallback = 1.d0
               endif
            elseif(remnantflag.eq.3)then
*
* Use the "Rapid" SN Prescription (Fryer et al. 2012, APJ, 749,91)
*
*              We use the updated proto-core mass from Giacobbo & Mapelli 2020
               m_proto = 1.1d0

               ! Calculate remnant mass from Eq. 16 + 17
               if(ecsn.gt.0.d0.and.mcbagb.le.ecsn.and.
     &                             mcbagb.ge.ecsn_mlow)then
                  mt = 1.38d0   ! ECSN fixed mass, no fallback
               elseif(mc_co(kidx).lt.2.5d0)then
                  fallback = 0.2d0 / (mt - m_proto)
                  mt = m_proto + 0.2d0
               elseif(mc_co(kidx).lt.6.d0)then
                  m_fb = 0.286d0 * mc_co(kidx) - 0.514d0
                  fallback = m_fb / (mt - m_proto)
                  mt = m_proto + m_fb
               elseif(mc_co(kidx).lt.7.d0)then
                  fallback = 1.d0
               elseif(mc_co(kidx).lt.11.d0)then
                  avar = 0.25d0 - (1.275 / (mt - m_proto))
                  bvar = 1.d0 - 11.d0*avar
                  fallback = avar*mc_co(kidx) + bvar
                  mt = m_proto + fallback*(mt - m_proto)
               elseif(mc_co(kidx).ge.11.d0)then
                  fallback = 1.d0
               endif
*              if the user requests it, limit the final remnant mass to
*              is the total **core** mass, not the total stellar mass
               if(fryer_mass_limit.eq.1)then
                  mt = min(mt, mc_tot)
               endif
            elseif(remnantflag.eq.4)then
*
* Use the "Delayed" SN Prescription (Fryer et al. 2012, APJ, 749,91)
*
*              Calculate the proto-core mass following Eq. 18
               if(mc_co(kidx).lt.3.5d0)then
                  m_proto = 1.2d0
               elseif(mc_co(kidx).lt.6.d0)then
                  m_proto = 1.3d0
               elseif(mc_co(kidx).lt.11.d0)then
                  m_proto = 1.4d0
               elseif(mc_co(kidx).ge.11.d0)then
                  m_proto = 1.6d0
               endif

               ! Calculate remnant mass from Eq. 19 + 20
               if(ecsn.gt.0.d0.and.mcbagb.le.ecsn.and.
     &                             mcbagb.ge.ecsn_mlow)then
                  mt = 1.38d0   ! ECSN fixed mass, no fallback
               elseif(mc_co(kidx).lt.2.5d0)then
                  fallback = 0.2d0 / (mt - m_proto)
                  mt = m_proto + 0.2d0
               elseif(mc_co(kidx).lt.3.5d0)then
                  m_fb = 0.5d0 * mc_co(kidx) - 1.05d0
                  fallback = m_fb / (mt - m_proto)
                  mt = m_proto + m_fb
               elseif(mc_co(kidx).lt.11.d0)then
                  avar = 0.133d0 - (0.093d0 / (mt - m_proto))
                  bvar = 1.d0 - 11.d0*avar
                  fallback = avar*mc_co(kidx) + bvar
                  mt = m_proto + fallback*(mt - m_proto)
               elseif(mc_co(kidx).ge.11.d0)then
                  fallback = 1.d0
               endif
*              if the user requests it, limit the final remnant mass to
*              is the total **core** mass, not the total stellar mass
               if(fryer_mass_limit.eq.1)then
                  mt = min(mt, mc_tot)
               endif
            elseif(remnantflag.eq.5)then
               call assign_remnant_mandel_muller(mc, mc_tot, mt)
            elseif(remnantflag.eq.6)then
                met = 10**(LOG10(zpars(14))/0.4)
               call assign_remnant_maltsev(mc,mc_tot,met,kidx,kw,mt)
            endif
            
* Assign the BH spin based on the chosen prescription
            call assign_remnant_spin(mc, bhspin)

            ! convert from baryonic to gravitational mass
            call baryonic_to_gravitational_mass(mt, mrem)

* Determine whether a zero-age NS or BH is formed
            if(mrem.le.mxns)then
               mt = mrem
               mc = mt
               kw = 13
            else
               mt = mrem
               mc = mt
               kw = 14

* CLR - (Pulsational) Pair-Instability Supernova

* Belczynski+2016 prescription: just shrink any BH with a He core mass
* between 45 and 65 solar masses (provided the pisn flag is set at 45),
* and blow up anything between 65 and 135 solar masses.
* Cheap, but effective
               if(pisn.gt.0)then
                  if(mc_tot.ge.pisn.and.mc_tot.lt.65.d0)then
                     mt = pisn

                     ! convert from baryonic to gravitational mass
                     call baryonic_to_gravitational_mass(mt, mrem)
                     mt = mrem

                     pisn_track(kidx)=6
                  elseif(mc_tot.ge.65.d0.and.mc_tot.lt.135.d0)then
                     mt = 0.d0
                     mc = 0.d0
                     kw = 15
                     pisn_track(kidx)=7
                  endif
* The Spera+Mapelli2017 prescription is a tad more sophisticated:
* complex fitting formula to Stan Woosley's PSN models.  HOWEVER, these
* were done using the ZAMS mass/core mass/remnant mass relationships for
* SEVN, not BSE.  In other words, I woud be careful using this (and in
* practice, it doesn't vary that much from Belczynski's prescription,
* since the He core masses are the same in both)
               elseif(pisn.eq.-1)then
                  frac = mc_tot/mass
                  kappa = 0.67d0*frac + 0.1d0
                  sappa = 0.5226d0*frac - 0.52974d0
                  if(mc_tot.le.32.d0)then
                     alphap = 1.0d0
                  elseif(frac.lt.0.9d0.and.mc_tot.le.37.d0)then
                     alphap = 0.2d0*(kappa-1.d0)*mc_tot +
     &                        0.2d0*(37.d0 - 32.d0*kappa)
                     pisn_track(kidx)=6
                  elseif(frac.lt.0.9d0.and.mc_tot.le.60.d0)then
                     alphap = kappa
                     pisn_track(kidx)=6
                  elseif(frac.lt.0.9d0.and.mc_tot.lt.64.d0)then
                     alphap = kappa*(-0.25d0)*mc_tot + kappa*16.d0
                     pisn_track(kidx)=6
                  elseif(frac.ge.0.9d0.and.mc_tot.le.37.d0)then
                     alphap = sappa*(mc_tot - 32.d0) + 1.d0
                     pisn_track(kidx)=6
                  elseif(frac.ge.0.9d0.and.mc_tot.le.56.d0.and.
     &                   sappa.lt.-0.034168d0)then
                     alphap = 5.d0*sappa + 1.d0
                     pisn_track(kidx)=6
                  elseif(frac.ge.0.9d0.and.mc_tot.le.56.d0.and.
     &                   sappa.ge.-0.034168d0)then
                     alphap = (-0.1381d0*frac + 0.1309d0)*
     &                        (mc_tot - 56.d0) + 0.82916d0
                     pisn_track(kidx)=6
                  elseif(frac.ge.0.9d0.and.mc_tot.lt.64.d0)then
                     alphap = -0.103645d0*mc_tot + 6.63328d0
                     pisn_track(kidx)=6
                  elseif(mc_tot.ge.64.d0.and.mc_tot.lt.135.d0)then
                     alphap = 0.d0
                     kw = 15
                     pisn_track(kidx)=7
                  elseif(mc_tot.ge.135.d0)then
                     alphap = 1.0d0
                  endif
                  mt = alphap*mt

                  ! convert from baryonic to gravitational mass
                  call baryonic_to_gravitational_mass(mt, mrem)
                  mt = mrem

* Fit (8th order polynomial) to Table 1 in Marchant+2018.
               elseif(pisn.eq.-2)then
                  if(mc_tot.ge.31.99d0.and.mc_tot.le.61.10d0)then
                     polyfit = -6.29429263d5
     &                      + 1.15957797d5*mc_tot
     &                      - 9.28332577d3*mc_tot**2d0
     &                      + 4.21856189d2*mc_tot**3d0
     &                      - 1.19019565d1*mc_tot**4d0
     &                      + 2.13499267d-1*mc_tot**5d0
     &                      - 2.37814255d-3*mc_tot**6d0
     &                      + 1.50408118d-5*mc_tot**7d0
     &                      - 4.13587235d-8*mc_tot**8d0
                     mt = polyfit
                     pisn_track(kidx)=6

                     ! convert from baryonic to gravitational mass
                     call baryonic_to_gravitational_mass(mt, mrem)
                     mt = mrem

                  elseif(mc_tot.gt.61.10d0.and.
     &                   mc_tot.lt.124.12d0)then
                     mt = 0.d0
                     kw = 15
                     pisn_track(kidx)=7
                  endif

* Fit (8th order polynomial) to Table 5 in Woosley2019.
               elseif(pisn.eq.-3)then
                  if(mc_tot.ge.29.53d0.and.mc_tot.le.60.12d0)then
                     polyfit = -3.14610870d5
     &                      + 6.13699616d4*mc_tot
     &                      - 5.19249710d3*mc_tot**2d0
     &                      + 2.48914888d2*mc_tot**3d0
     &                      - 7.39487537d0*mc_tot**4d0
     &                      + 1.39439936d-1*mc_tot**5d0
     &                      - 1.63012111d-3*mc_tot**6d0
     &                      + 1.08052344d-5*mc_tot**7d0
     &                      - 3.11019088d-8*mc_tot**8d0
                     mt = polyfit
                     pisn_track(kidx)=6

                     ! convert from baryonic to gravitational mass
                     call baryonic_to_gravitational_mass(mt, mrem)
                     mt = mrem

                  elseif(mc_tot.gt.60.12d0.and.
     &                   mc_tot.lt.135.d0)then
                     mt = 0.d0
                     kw = 15
                     pisn_track(kidx)=7
                  endif
* Apply the PPISN prescription from Renzo+2022 (https://ui.adsabs.harvard.edu/abs/2022RNAAS...6...25R/abstract)
* with the adaptations from Hendriks+2023 (https://scixplorer.org/abs/2023MNRAS.526.4130H/abstract)
* This is a top-down prescription, where we subtract mass from the total core mass
               elseif(pisn.eq.-4)then
                  if(mc_co(kidx).ge.38.d0+ppi_co_shift
     &               .and.mc_co(kidx).le.114.d0)then
*       Calculate DeltaM_PPI using Eq.6 from Hendriks+2023 (equivalently Eq.2 from Renzo+2022)
                     met = 10**(LOG10(zpars(14))/0.4)
                     dMppi = (0.0006d0 * LOG10(met) + 0.0054)
     &                      * (mc_co(kidx) - ppi_co_shift - 34.8d0)**3
     &                      - 0.0013 * (mc_co(kidx)
     &                                  - ppi_co_shift - 34.8d0)**2
     &                      + ppi_extra_ml
*       Set the remnant mass equal to the total core mass minus the PPI mass loss.
*       We use core mass not total mass because envelopes are expected to be removed by the first PPI pulse (e.g. Renzo+2020b)
                     mt = mc_tot - dMppi
                     
                     call baryonic_to_gravitational_mass(mt, mrem)
                     mt = mrem

*       If the remnant mass is reduced below 10 Msun, assume a full PISN with no remnant
                     if(mt.lt.10.d0)then
                        mt = 0.0d0
                        kw = 15
                        pisn_track(kidx)=7
*       Otherwise we have a PPISN
                     else
                        pisn_track(kidx)=6
                     endif
*       For very large cores, we assume a full PISN with no remnant
                  elseif(mc_co(kidx).gt.114.d0)then
                     mt = 0.d0
                     kw = 15
                     pisn_track(kidx)=7
                  endif
               endif

               mc = mt
* Store the initial BH mass for calculating the ISCO later
               if(Mbh_initial.eq.0)then
                  Mbh_initial = mt
               endif
            endif
         endif
      endif
*
      end


      SUBROUTINE baryonic_to_gravitational_mass(mt, mrem)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'

      real*8 mt, mrem

      ! remnantflag 0 and 1 already calculate gravitational mass
      if(remnantflag.le.1)then
         mrem = mt
      else
         ! negative values set the absolute maximum mass loss
         if(rembar_massloss.ge.0d0)then
            ! calculate Mrem from mt using quadratic formula
            ! mt - mrem = 0.075 mrem^2 (Lattimer & Yahil 1989, Timmes+1996)
            mrem = 6.6666667d0*(SQRT(1.d0 + 0.3d0*mt) - 1.d0)

            ! limit to maximum mass loss
            mrem = MAX(mrem, mt - rembar_massloss)

         ! positive values set the fractional mass loss
         else
            mrem = (1.d0 + rembar_massloss) * mt
         endif
      endif

      end


      SUBROUTINE assign_remnant_mandel_muller(mc, mc_tot, mt)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
      
      real ran3
      EXTERNAL ran3
      EXTERNAL RandomTruncatedNormal

      real*8 mc, mc_tot, mt

      real*8 mm_m1, mm_m2, mm_m3, mm_m4, min_ns_mass
      real*8 pBH, pCF
      real*8 u_pBH, u_pCF, u_rem
      real*8 ns_mu, ns_sigma

* Use the Mandel & Mueller 2020 prescription
*
      pBH = 0.0d0
      mm_m1 = 2.0d0
      mm_m2 = 3.0d0
      mm_m3 = 7.0d0
      mm_m4 = 8.0d0
      min_ns_mass = 1.13d0

* Determine probability of forming a BH based on core mass
      if(mc.lt.mm_m1)then
         pBH = 0.0d0
      elseif(mc.ge.mm_m1.and.mc.lt.mm_m3)then
         pBH = (mc - mm_m1)/(mm_m3 - mm_m1)
      else
         pBH = 1.0d0
      endif

* Draw random numbers for BH/NS decision, complete fallback decision
* and remnant mass assignment
      u_pBH = ran3(idum1)
      u_pCF = ran3(idum1)
      u_rem = ran3(idum1)

* Determine remnant type based on pBH
      if(u_pBH.le.pBH)then
* BH formed
         pCF = 0.0d0
         if (mc.ge.mm_m1.and.mc.lt.mm_m4) then
            pCF = (mc - mm_m1)/(mm_m4 - mm_m1)
         else
            pCF = 1.0d0
         endif

         if (u_pCF.le.pCF) then
* Complete fallback occurred, remnant mass equals pre-SN core mass
            mt = mc_tot
         else
* Partial fallback occurred, remnant mass drawn from Normal,
* but truncated to always be between max NS mass and CO core mass
            call RandomTruncatedNormal(0.8d0 * mc, 0.5d0 * 0.5d0,
     &                                 idum1, mxns, mc, mt)
         endif
      else
* NS formed, determine mu and sigma for random normal draw
* normal is truncated to be between min/max NS mass
         if (mc.lt.mm_m1) then
             ns_mu = 1.2d0
             ns_sigma = 0.02d0
         elseif (mc.ge.mm_m1.and.mc.lt.mm_m2) then
             ns_mu = 1.4d0 + 0.5d0 * (mc - mm_m1) / (mm_m2 - mm_m1)
             ns_sigma = 0.05d0
         else
             ns_mu = 1.4d0 + 0.4d0 * (mc - mm_m2) / (mm_m3 - mm_m2)
             ns_sigma = 0.05d0
         endif
         call RandomTruncatedNormal(ns_mu, ns_sigma, idum1, min_ns_mass,
     &                              mxns, mt)
      endif

      end


      SUBROUTINE assign_remnant_maltsev(mc, mc_tot, met, kidx, kw, mt)
* Assign remnant mass using the Maltsev et al. 2025 prescription,
* with additional details from Willcox et al. 2025
*
* Inputs:
*       mc         : CO core mass before SN
*       mc_tot     : Total core mass before SN (CO + He layers)
*       met        : Metallicity of the star
*       kidx       : Index of the star
*       kw         : Stellar (remnant) type
*
* Outputs:
*       mt         : Remnant mass after SN


      IMPLICIT NONE
      INCLUDE 'const_bse.h'

      common /fall/fallback
      REAL*8 fallback

      real ran3
      EXTERNAL ran3

      real*8 mc, mc_tot, mt, met, u_NS
      real*8 log10Z_bounded
      integer mt_type, kidx, kw
      integer first_mt_type_as_donor
      EXTERNAL first_mt_type_as_donor

* Use the Maltsev+25 prescription with additional details from Willcox+25

      real*8 M1, M2, M3
      real*8 M1S, M2S, M3S, M1S_Z01, M2S_Z01, M3S_Z01
      real*8 M1A, M2A, M3A, M1A_Z01, M2A_Z01, M3A_Z01
      real*8 M1B, M2B, M3B, M1B_Z01, M2B_Z01, M3B_Z01
      real*8 M1C, M2C, M3C, M1C_Z01, M2C_Z01, M3C_Z01
      real*8 M_min, M_max, M_NS
      real*8 log10_1, log10_1_div_10, log10_1_div_50

* Taken from summary in Table A1 of Willcox+25
      PARAMETER(M1S=6.6d0, M2S=7.2d0, M3S=13.0d0,
     &          M1A=7.4d0, M2A=8.4d0, M3A=15.4d0,
     &          M1B=7.7d0, M2B=8.3d0, M3B=15.2d0,
     &          M1C=6.6d0, M2C=7.1d0, M3C=13.2d0,
     &          M1S_Z01=6.1d0, M2S_Z01=6.6d0, M3S_Z01=12.9d0,
     &          M1A_Z01=7.0d0, M2A_Z01=7.4d0, M3A_Z01=13.7d0,
     &          M1B_Z01=6.9d0, M2B_Z01=7.9d0, M3B_Z01=13.7d0,
     &          M1C_Z01=6.3d0, M2C_Z01=7.1d0, M3C_Z01=12.3d0,
     &          M_min=5.62d0, M_max=16.18d0,
     &          log10_1=0, log10_1_div_10=-1, log10_1_div_50=-1.69897d0,
     &          M_NS=1.4d0)

* Save some computation by immediately producing either a NS or a direct
collapse BH if the CO core mass is outside the Maltsev+25 range
      if(mc.lt.M_min)then
         fallback = 0.d0
         mt = M_NS
         return
      elseif(mc.gt.M_max)then
         fallback = 1.d0
         mt = mc_tot
         return
      endif

* Determine the mass transfer type of the donor star at first mass transfer
      mt_type = first_mt_type_as_donor(kidx)

* If star has not undergone mass transfer as donor, but has
* self-stripped (kw in [7,8,9]), assume case B mass transfer
      if(mt_type.eq.-1.and.(kw.eq.7.or.kw.eq.8.or.kw.eq.9))then
         mt_type = 1
      endif

* Normalize metallicity to solar
      met = met / zsun

* Bound log10Z based on maltsev_mode choice from user
      if (maltsev_mode.eq.0) then
        log10Z_bounded = log10(met)
      elseif (maltsev_mode.eq.1) then
        log10Z_bounded = min(max(log10(met), log10_1_div_50), log10_1)
      elseif (maltsev_mode.eq.2) then
        log10Z_bounded = min(max(log10(met), log10_1_div_10), log10_1)
      endif

* Determine the mass boundaries based on MT type and metallicity
      if(mt_type.eq.-1)then
         M1 = M1S + (M1S - M1S_Z01) * log10Z_bounded
         M2 = M2S + (M2S - M2S_Z01) * log10Z_bounded
         M3 = M3S + (M3S - M3S_Z01) * log10Z_bounded
      elseif(mt_type.eq.0)then
         M1 = M1A + (M1A - M1A_Z01) * log10Z_bounded
         M2 = M2A + (M2A - M2A_Z01) * log10Z_bounded
         M3 = M3A + (M3A - M3A_Z01) * log10Z_bounded
      elseif(mt_type.eq.1)then
         M1 = M1B + (M1B - M1B_Z01) * log10Z_bounded
         M2 = M2B + (M2B - M2B_Z01) * log10Z_bounded
         M3 = M3B + (M3B - M3B_Z01) * log10Z_bounded
      elseif(mt_type.eq.2)then
         M1 = M1C + (M1C - M1C_Z01) * log10Z_bounded
         M2 = M2C + (M2C - M2C_Z01) * log10Z_bounded
         M3 = M3C + (M3C - M3C_Z01) * log10Z_bounded
      endif

* Determine fallback and remnant mass based on CO core mass
*   Direct collapse:    if m1 <= mc <= m2 or mc >= m3
*   Partial fallback:   maltsev_pf_prob fraction of the time if m2 < mc < m3
*   NS:                 otherwise
      u_NS = ran3(idum1)
      if ((mc.ge.M1.and.mc.le.M2).or.(mc.ge.M3)) then
         fallback = 1.0d0
         mt = mc_tot
      elseif (mc.gt.M2.and.mc.lt.M3.and.u_NS.lt.maltsev_pf_prob) then
         fallback = maltsev_fallback
         mt = (mc_tot - M_NS) * fallback + M_NS
      else
         fallback = 0.0d0
         mt = M_NS
      endif

      return
      end


      SUBROUTINE assign_remnant_spin(mc, bhspin)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'

      real*8 ran3, mc, bhspin
      EXTERNAL ran3

* Set all BH spins equal to bhspinmag
      if(bhspinflag.eq.0)then
         bhspin = bhspinmag
* Randomly assign BH spins between 0 and bhspinmag
      elseif(bhspinflag.eq.1)then
         bhspin = ran3(idum1) * bhspinmag
* Assign BH spins based on Belczynski+17 prescription
      elseif(bhspinflag.eq.2)then
         if(mc.le.13.d0)then
            bhspin = 0.9d0
         elseif(mc.lt.27.d0)then
            bhspin = -0.064d0*mc + 1.736d0
         else
            bhspin = 0.0d0
         endif
      endif

      end

      integer function first_mt_type_as_donor(star)
* Find the first occurrence of mass transfer where a star is the donor
* and return the type
*
*     inputs:
*       star : integer (1 or 2) indicating which star to check
*
*     return value:
*       mt_type : integer indicating the stellar type at first mass
*                 transfer as donor for the specified star
*                 -1 if no mass transfer as donor found
*                 0 if case A mass transfer found
*                 1 if case B mass transfer found
*                 2 if case C mass transfer found
*
      INCLUDE 'const_bse.h'

      integer star
      integer i, col, kstar
      integer kstar1_col, kstar2_col, evol_type_col

* This part is tricky, because we allow users to change bpp_columns,
* nothing is in a fixed order. So we need to find them!
* Determine which column to find kstar1, kstar2, evolve_type based on
* col_inds_bpp. kstar1 col is the index of col_inds_bpp where value = 4,
* kstar2 same with 5, evol_type same with 11
      kstar1_col = -1
      kstar2_col = -1
      evol_type_col = -1
      do 5 i = 1, n_col_bpp
         if (col_inds_bpp(i).eq.4) then
            kstar1_col = i
         else if (col_inds_bpp(i) .eq. 5) then
            kstar2_col = i
         else if (col_inds_bpp(i) .eq. 11) then
            evol_type_col = i
         endif
   5  continue

      if (kstar1_col.eq.-1.or.kstar2_col.eq.-1..or.
     &    evol_type_col.eq.-1) then
         WRITE(*,*) 'Error in first_mt_type_as_donor: could not find '//
     &      'necessary columns in bpp (kstar1, kstar2, evol_type)'
         first_mt_type_as_donor = -1
         return
      endif

* If either star is a massless remnant (i.e. this is a merger product
* that's becoming a remnant), treat as no mass transfer and return -1
      if (int(bpp(bpp_ind,kstar1_col)).eq.15.or.
     &    int(bpp(bpp_ind,kstar2_col)).eq.15) then
            first_mt_type_as_donor = -1
            return
      endif

* work out which kstar column to use based on which star this is
      if (star.eq.1) then
         col = kstar1_col
      else if (star.eq.2) then
         col = kstar2_col
      endif

      kstar = -1
      do 10 i = 1, bpp_ind
         if (int(bpp(i,evol_type_col)).eq.3
     &   .or.int(bpp(i,evol_type_col)).eq.7) then
            kstar = int(bpp(i,col))
            goto 20
         endif
   10 continue

   20 if (kstar.eq.-1) then
         first_mt_type_as_donor = -1
      else if (kstar.ge.0.and.kstar.le.1.or.kstar.eq.7) then
         first_mt_type_as_donor = 0
      else if (kstar.eq.2.or.kstar.eq.8) then
         first_mt_type_as_donor = 1
      else if (kstar.ge.3.and.kstar.le.6.or.kstar.eq.9) then
         first_mt_type_as_donor = 2
      else
         first_mt_type_as_donor = -1
      endif

      return
      end

C ====================================================================
C     This function is a drop-in replacement for the ran3 random
C     number generator from Numerical Recipes, Press et al.
C     It is based on E'cuyer's combined Tausworth generator with
C     period 2**113.
C
C ====================================================================
      real function ran3(IDUM)
        implicit none
        include "tausworth.h"
        integer(kind=int64) state(4), rnumber, taus113_gen_int
        integer i, IDUM, first, tid
c$      integer OMP_GET_THREAD_NUM
        COMMON/Taus113State/ state, first
        SAVE /Taus113State/
!$OMP THREADPRIVATE(/Taus113State/)
        EXTERNAL taus113_gen_int

        if(IDUM.lt.0) then
          call taus113_seeding(state, -IDUM)
C         The "warm-up" that has been left out in the seeding routine:
          print*, "Combined Tausworth 113 Generator warming up."
          do i=1,10
            call taus113_next_state(state)
          end do
          IDUM= -IDUM
        endif

        call taus113_next_state(state)
        rnumber= taus113_gen_int(state)

        if (first.eq.1) then
          tid= 1
c$        tid= OMP_GET_THREAD_NUM()
          first=0
          print("('taus-ran3: TID',I2,' The first random number is ',
     &    G16.8)"), tid, real(dble(rnumber)/dble(umax))
        endif

        ran3= real(dble(rnumber)/dble(umax))
      end function

      subroutine taus113_ran3_tester()
        integer i, failcount
        logical passed
        real rnumber, ran3
        external ran3

        passed=.true.
        failcount=0
        rnumber=ran3(-123456)
        do i=1,1000000000
          if (rnumber>=1.e0) then
            passed=.false.
            failcount= failcount + 1
            print*, "FOUL!!", rnumber-1.0e0, rnumber==1.e0, failcount, i
          end if
          rnumber=ran3(123456)
        end do
      end subroutine

***
      PROGRAM sse
c-------------------------------------------------------------c
c
c     Evolves a single star.
c     Mass loss is an option.
c     The timestep is not constant but determined by certain criteria.
c
c     Written by Jarrod Hurley 26/08/97 at the Institute of
c     Astronomy, Cambridge.
c
c-------------------------------------------------------------c
c
c     STELLAR TYPES - KW
c
c        0 - deeply or fully convective low mass MS star
c        1 - Main Sequence star
c        2 - Hertzsprung Gap
c        3 - First Giant Branch
c        4 - Core Helium Burning
c        5 - First Asymptotic Giant Branch
c        6 - Second Asymptotic Giant Branch
c        7 - Main Sequence Naked Helium star
c        8 - Hertzsprung Gap Naked Helium star
c        9 - Giant Branch Naked Helium star
c       10 - Helium White Dwarf
c       11 - Carbon/Oxygen White Dwarf
c       12 - Oxygen/Neon White Dwarf
c       13 - Neutron Star
c       14 - Black Hole
c       15 - Massless Supernova
c
c-------------------------------------------------------------c
      implicit none
*
      INCLUDE 'const_bse.h'
*
      integer i,kw,j,k
*
      real*8 mass,mt,z,zpars(20),vs(3),kick_info(12)
      real*8 epoch,tms,tphys,tphysf,dtp
      real*8 r,lum,ospin
      real*8 mc,rc,menv,renv
      character*50 text1,text2,text3
      character*30 label(16)
      data label /' Low Mass MS Star ',' Main sequence Star ',
     &            ' Hertzsprung Gap ',' Giant Branch ',
     &            ' Core Helium Burning ',
     &            ' First AGB ',' Second AGB ',
     &            ' Naked Helium MS ',' Naked Helium HG ',
     &            ' Naked Helium GB ',' Helium WD ',
     &            ' Carbon/Oxygen WD ',' Oxygen/Neon WD ',
     &            ' Neutron Star ',' Black Hole ',
     &            ' Massless Supernova '/
*
************************************************************************
* Input:
*
* mass is in solar units.
* z is metallicity in the range 0.0001 -> 0.03 where 0.02 is Population I.
* tphysf is the maximum evolution time in Myr.
*
* neta is the Reimers mass-loss coefficent (neta*4x10^-13; 0.5 normally).
* bwind is the binary enhanced mass loss parameter (inactive for single).
* hewind is a helium star mass loss factor (1.0 normally). 
* sigma is the dispersion in the Maxwellian for the SN kick speed (190 km/s). 
*
* ifflag > 0 uses WD IFMR of HPE, 1995, MNRAS, 272, 800 (0). 
* wdflag > 0 uses modified-Mestel cooling for WDs (0). 
* bhflag > 0 allows velocity kick at BH formation (0). 
* rtmsflag > 0 uses rtms from simulation data (1=[Boost], 2=[Bpass]) (0)
* remnantflag > 0 takes NS/BH mass from Belczynski et al. 2002, ApJ, 572, 407 (1). 
* mxns is the maximum NS mass (1.8, remnantflag=0; 3.0, remnantflag=1). 
* idum is the random number seed used in the kick routine. 
*
* Next come the parameters that determine the timesteps chosen in each
* evolution phase:
*                 pts1 - MS                  (0.05)
*                 pts2 - GB, CHeB, AGB, HeGB (0.01)
*                 pts3 - HG, HeMS            (0.02)
* as decimal fractions of the time taken in that phase.
*
* If you enter a negative mass then parameters for an evolved star are
* required in the order of:
* initial mass, current mass, type, current time & epoch,
* otherwise the star will start on the ZAMS.
*
      OPEN(22,file='evolve.in',status='old')
      READ(22,*)mass,z,tphysf
      READ(22,*)neta,bwind,hewind,sigma,windflag
      READ(22,*)ifflag,wdflag,bhflag,rtmsflag,remnantflag,mxns,idum
      READ(22,*)pts1,pts2,pts3
*
************************************************************************
*
* Set parameters which depend on the metallicity 
*
      CALL zcnsts(z,zpars)
      if(idum.gt.0) idum = -idum
      do i=1,12
         kick_info(i) = 0.d0
      enddo
*
      if(mass.gt.0.0)then
*
* Initialize the star to begin on the ZAMS.
*
         mt = mass
         kw = 1
         tphys = 0.d0
         epoch = 0.d0
      else
*
* Obtain parameters of evolved star.
*
         READ(22,*)mass,mt,kw,tphys,epoch
      endif
      CLOSE(22)
      WRITE(*,*)
*
* Set the initial spin of the star. If ospin is less than or equal to 
* zero at time zero then evolv1 will set an appropriate ZAMS spin. If 
* ospin is greater than zero then it will start with that spin regardless
* of the time. If you want to start at time zero with negligible spin 
* then I suggest using a negligible value (but greater than 0.001).
*
      ospin = 0.d0
*
* Set the data-save parameter. If dtp is zero then the parameters of the 
* star will be stored in the scm array at each timestep otherwise they 
* will be stored at intervals of dtp. Setting dtp equal to tphysf will 
* store data only at the start and end while a value of dtp greater than 
* tphysf will mean that no data is stored.
*
      dtp = 0.d0
* 
      CALL evolv1(kw,mass,mt,r,lum,mc,rc,menv,renv,ospin,
     &            epoch,tms,tphys,tphysf,dtp,z,zpars,kick_info)
*
************************************************************************
* Output:
*
      j = 0
      if(scm(1,1).lt.0.0) goto 50
*
* The scm array stores the stellar parameters at the specified output 
* times. The parameters are (in order of storage):
*    
*    Time, stellar type, initial mass, current mass, log10(L), log10(r),
*    log10(Teff), core mass, epoch and spin.
*
      OPEN(23,file='evolve.dat',status='unknown')
      text1 = ' Tev(Myr)    type      Mo        Mt      log10(L) '
      text2 = ' log10(R) log10(Teff)  Mc        Menv     ' 
      text3 = ' epoch      spin' 
      WRITE(23,'(a,a,a)')text1,text2,text3
 30   j = j + 1
      if(scm(j,1).lt.0.0)then
         scm(j-1,1) = scm(j,1)
         j = j - 1
      endif
      WRITE(23,99)(scm(j,k),k=1,8),scm(j,10),scm(j,12),scm(j,13)
      if(scm(j,1).ge.0.0) goto 30
      CLOSE(23)
 99   FORMAT(8f10.4,1p,e12.4,0p,f12.4,1p,e12.4)
*
* The spp array acts as a log, storing the time and mass at each change
* of evolution stage.
*
      j = 0
 50   j = j + 1
      if(spp(j,1).lt.0.0) goto 60
      kw = INT(spp(j,2))
      WRITE(*,100)label(kw+1),spp(j,1),spp(j,3)
      goto 50
 60   continue
 100  format(a30,' Time ',f10.1,' Mass ',f7.3)
      WRITE(*,*)
*
************************************************************************
*
      STOP
      END
***

***
      SUBROUTINE evolv1(kw,mass,mt,r,lum,mc,rc,menv,renv,ospin,
     &                  epoch,tm,tphys,tphysf,dtp,z,zpars,kick_info)
c-------------------------------------------------------------c
c
c     Evolves a single star.
c     Mass loss is an option.
c     The timestep is not constant but determined by certain criteria.
c     Plots the HRD and variables as a function of time.
c
c     Written by Jarrod Hurley 26/08/97 at the Institute of
c     Astronomy, Cambridge.
c
c-------------------------------------------------------------c
c
c     STELLAR TYPES - KW
c
c        0 - deeply or fully convective low mass MS star
c        1 - Main Sequence star
c        2 - Hertzsprung Gap
c        3 - First Giant Branch
c        4 - Core Helium Burning
c        5 - First Asymptotic Giant Branch
c        6 - Second Asymptotic Giant Branch
c        7 - Main Sequence Naked Helium star
c        8 - Hertzsprung Gap Naked Helium star
c        9 - Giant Branch Naked Helium star
c       10 - Helium White Dwarf
c       11 - Carbon/Oxygen White Dwarf
c       12 - Oxygen/Neon White Dwarf
c       13 - Neutron Star
c       14 - Black Hole
c       15 - Massless Supernova
c
c-------------------------------------------------------------c
      implicit none
*
      integer kw,it,ip,jp,j,kwold,rflag,fb
      integer nv
      parameter(nv=50000)
*
      real*8 mass,z,aj
      real*8 epoch,tphys,tphys2,tmold,tbgold
      real*8 mt,tm,tn,tphysf,dtp,tsave
      real*8 tscls(20),lums(10),GB(10),zpars(20)
      real*8 r,lum,mc,teff,rc,menv,renv,kick_info(12)
      real*8 ospin,jspin,djt,djmb,k2,k3
      parameter(k3=0.21d0)
      real*8 m0,r1,lum1,mc1,rc1,menv1,renv1,k21
      real*8 dt,dtm,dtr,dr,dtdr,dms,dml,mt2,rl
      real*8 tol,tiny
      parameter(tol=1.0d-10,tiny=1.0d-14)
      real*8 ajhold,rm0,eps,alpha2
      parameter(eps=1.0d-06,alpha2=0.09d0)
      real*8 mlwind,vrotf
      external mlwind,vrotf
      logical iplot,isave
      common /fall/fallback
*
      REAL*8 fallback,vk !PDK
*
      REAL*8 neta,bwind,hewind,mxns
      COMMON /VALUE1/ neta,bwind,hewind,mxns
      REAL*8 pts1,pts2,pts3
      COMMON /POINTS/ pts1,pts2,pts3
      REAL scm(50000,14),spp(20,3)
      COMMON /SINGLE/ scm,spp
*
      dtm = 0.d0
      r = 0.d0
      lum = 0.d0
      mc = 0.d0
      mc1 = 0.d0
      rc = 0.d0
      rl = 0.d0
      if(ospin.le.0.d0)then
         ospin = 1.0d-10
         jspin = 1.0d-10
      endif
      k2 = 0.15d0
      rflag = 0
* PDK additions
      fb = 1 !turns kick velocity limit owning to fallback on (1) or off (0).
      vk = 0.d0 !gets passed to and from kick(), is kick mag. can be used to set initial pulsar particulars.
*
* Setup variables which control the output (if it is required).
*
      ip = 0
      jp = 0
      tsave = tphys
      isave = .true.
      iplot = .false.
      if(dtp.le.0.d0)then
         iplot = .true.
         isave = .false.
         tsave = tphysf
      elseif(dtp.gt.tphysf)then
         isave = .false.
         tsave = tphysf
      endif
* 
      do 10 , j = 1,nv
*
         if(neta.gt.tiny.and.j.gt.1)then
*
* Calculate mass loss from the previous timestep.
*
            dt = 1.0d+06*dtm
            dms = mlwind(kw,lum,r,mt,mc,rl,z,tphys)*dt
            if(kw.lt.10)then
               dml = mt - mc
               if(dml.lt.dms)then
                  dtm = (dml/dms)*dtm
                  dms = dml
               endif
            endif
         else
            dms = 0.d0
         endif
*
* Limit to 1% mass loss.
*
         if(dms.gt.0.01d0*mt)then
            dtm = 0.01d0*mt*dtm/dms
            dms = 0.01d0*mt
         endif
*
* Calculate the rate of angular momentum loss due to magnetic braking 
* and/or mass loss.
*
         if(j.gt.1)then
            djt = (2.d0/3.d0)*(dms/(1.0d+06*dtm))*r*r*ospin
            if(mt.gt.0.35d0.and.kw.lt.10)then
               djmb = 5.83d-16*menv*(r*ospin)**3/mt
               djt = djt + djmb
            endif
         endif
*
* Update mass and time and reset epoch for a MS (and possibly a HG) star.
*
         if(dms.gt.0.d0)then
            mt = mt - dms
            if(kw.le.2.or.kw.eq.7)then
               m0 = mass
               mc1 = mc
               mass = mt
               tmold = tm
               tbgold = tscls(1)
               CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
               if(kw.eq.2)then
                  if(GB(9).lt.mc1.or.m0.gt.zpars(3))then
                     mass = m0
                  else
                     epoch = tm + (tscls(1) - tm)*(ajhold-tmold)/
     &                            (tbgold - tmold)
                     epoch = tphys - epoch
                  endif
               else
                  epoch = tphys - ajhold*tm/tmold
               endif
            endif
         endif
         tphys2 = tphys
         tphys = tphys + dtm
*
* Find the landmark luminosities and timescales as well as setting
* the GB parameters.
*
         write(*,*) aj,tphys,epoch
         aj = tphys - epoch
         CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
*
* Find the current radius, luminosity, core mass and stellar type
* given the initial mass, current mass, metallicity and age
         kwold = kw
         CALL hrdiag(mass,aj,mt,tm,tn,tscls,lums,GB,zpars,
     &               r,lum,kw,mc,rc,menv,renv,k2,1)
*
* If mass loss has occurred and no type change then check that we
* have indeed limited the radius change to 10%.
*
         if(kw.eq.kwold.and.dms.gt.0.d0.and.rflag.ne.0)then
            mt2 = mt + dms
            dml = dms/dtm
            it = 0
 20         dr = r - rm0
            if(ABS(dr).gt.0.1d0*rm0)then
               it = it + 1
               if(it.eq.20.and.kw.eq.4) goto 30
               if(it.gt.30)then
                  WRITE(99,*)' DANGER1! ',it,kw,mass,dr,rm0
                  CALL FLUSH(99)
                  WRITE(*,*)' STOP: EVOLV1 FATAL ERROR '
                  CALL exit(0)
                  STOP 
               endif
               dtdr = dtm/ABS(dr)
               dtm = alpha2*MAX(rm0,r)*dtdr
               if(it.ge.20) dtm = 0.5d0*dtm
               if(dtm.lt.1.0d-07*aj) goto 30
               dms = dtm*dml
               mt = mt2 - dms
               if(kw.le.2.or.kw.eq.7)then
                  mass = mt
                  CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
                  if(kw.eq.2)then
                     if(GB(9).lt.mc1.or.m0.gt.zpars(3))then
                        mass = m0
                     else
                        epoch = tm + (tscls(1) - tm)*(ajhold-tmold)/
     &                               (tbgold - tmold)
                        epoch = tphys2 - epoch
                     endif
                  else
                     epoch = tphys2 - ajhold*tm/tmold
                  endif
               endif
               tphys = tphys2 + dtm
               aj = tphys - epoch
               mc = mc1
               CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
               CALL hrdiag(mass,aj,mt,tm,tn,tscls,lums,GB,zpars,
     &                     r,lum,kw,mc,rc,menv,renv,k2,1)
               goto 20
            endif
 30         continue
         endif
*
* Initialize or adjust the spin of the star.
*
         if(j.eq.1)then
            if(tphys.lt.tiny.and.ospin.lt.0.001d0)then
*               write (*,*) vrotf(mt,0),mt,r
               ospin = 45.35d0*vrotf(mt,0)/r
            endif
            jspin = ospin*(k2*r*r*(mt-mc)+k3*rc*rc*mc)
         else
            jspin = MAX(1.0d-10,jspin - djt*1.0d+06*dtm)
            ospin = jspin/(k2*r*r*(mt-mc)+k3*rc*rc*mc)
         endif
*
* Test for changes in evolution type.
*
         if(j.eq.1.or.kw.ne.kwold)then
*
* Force new NS or BH to have a one second period. 
* 
            if((kw.eq.13.or.kw.eq.14).and.kw.ne.kwold)then
               ospin = 2.0d+08
               jspin = k3*rc*rc*mc*ospin
               CALL kick(kw,mass,mt,0.d0,0.d0,-1.d0,0.d0,vk,1,
     &                   0.d0,fallback,kick_info)
            endif
            jp = jp + 1
            spp(jp,1) = tphys
            spp(jp,2) = float(kw)
            if(kw.eq.15)then
               spp(jp,3) = mass 
               goto 90
            else
               spp(jp,3) = mt
            endif
         endif
*
* Record values for plotting and reset epoch.
*
         epoch = tphys - aj
         if((isave.and.tphys.ge.tsave).or.iplot)then
            ip = ip + 1
            scm(ip,1) = tphys
            scm(ip,2) = float(kw)
            scm(ip,3) = mass
            scm(ip,4) = mt
            scm(ip,5) = log10(lum)
            scm(ip,6) = log10(r)
            teff = 1000.d0*((1130.d0*lum/(r**2.d0))**(1.d0/4.d0))
            scm(ip,7) = log10(teff)
            scm(ip,8) = mc
            scm(ip,9) = rc
            scm(ip,10) = menv
            scm(ip,11) = renv
            scm(ip,12) = epoch
            scm(ip,13) = ospin
            if(isave) tsave = tsave + dtp
            if(tphysf.lt.tiny)then
               ip = ip + 1
               do 35 , it = 1,13
                  scm(ip,it) = scm(ip-1,it)
 35            continue
            endif
         endif
*
         if(tphys.ge.tphysf)then
            jp = jp + 1
            spp(jp,1) = tphys
            spp(jp,2) = float(kw)
            spp(jp,3) = mt
            goto 90
         endif
*
* Record radius and current age.
*
         rm0 = r
         ajhold = aj
         if(kw.ne.kwold) kwold = kw
         CALL deltat(kw,aj,tm,tn,tscls,dtm,dtr)
*
* Check for type change.
*
         it = 0
         m0 = mass
         if((dtr-dtm).le.tol.and.kw.le.9)then
*
* Check final radius for too large a jump.
*
            aj = MAX(aj,aj*(1.d0-eps)+dtr)
            mc1 = mc 
            CALL hrdiag(mass,aj,mt,tm,tn,tscls,lums,GB,zpars,
     &                  r1,lum1,kw,mc1,rc1,menv1,renv1,k21,1)
            dr = r1 - rm0
            if(ABS(dr).gt.0.1d0*rm0)then
               dtm = dtr - ajhold*eps
               dtdr = dtm/ABS(dr)
               dtm = alpha2*MAX(r1,rm0)*dtdr
               goto 40
            else
               dtm = dtr
               goto 50
            endif
         endif
*
* Limit to a 10% increase in radius assuming no further mass loss
* and thus that the pertubation functions due to small envelope mass
* will not change the radius.
*
 40      aj = ajhold + dtm
         mc1 = mc 
         CALL hrdiag(mass,aj,mt,tm,tn,tscls,lums,GB,zpars,
     &               r1,lum1,kw,mc1,rc1,menv1,renv1,k21,1)
         dr = r1 - rm0
         it = it + 1
         if(it.eq.20.and.kw.eq.4) goto 50
         if(it.gt.30)then
            WRITE(99,*)' DANGER2! ',it,kw,mass,dr,rm0
            CALL FLUSH(99)
            WRITE(*,*)' STOP: EVOLV1 FATAL ERROR '
            CALL exit(0)
            STOP 
         endif
         if(ABS(dr).gt.0.1d0*rm0)then
            dtdr = dtm/ABS(dr)
            dtm = alpha2*MAX(rm0,r1)*dtdr
            if(it.ge.20) dtm = 0.5d0*dtm
            goto 40
         endif
*
 50      continue
*
* Ensure that change of type has not occurred during radius check. 
* This is rare but may occur for HG stars of ZAMS mass > 50 Msun. 
*
         if(kw.ne.kwold)then
            kw = kwold
            mass = m0
            CALL star(kw,mass,mt,tm,tn,tscls,lums,GB,zpars)
         endif

*
* Choose minimum of time-scale and remaining interval (> 100 yrs).
*
         dtm = MAX(dtm,1.0d-07*aj)
         dtm = MIN(dtm,tsave-tphys)
*
 10   continue
*
 90   continue
*
      tphysf = tphys
      scm(ip+1,1) = -1.0
      spp(jp+1,1) = -1.0
      if(ip.ge.nv)then
         WRITE(99,*)' EVOLV1 ARRAY ERROR ',mass
         WRITE(*,*)' STOP: EVOLV1 ARRAY ERROR '
*         CALL exit(0)
*         STOP
      endif
*
      RETURN
      END
***

***
      SUBROUTINE mrenv(kw,mass,mt,mc,lum,rad,rc,aj,tm,ltms,lbgb,lhei,
     &                 rzams,rtms,rg,menv,renv,k2e)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
      integer kw
      real*8 mass,mt,mc,lum,rad,rc,aj,tm
      real*8 k2e,menv,menvg,menvt,menvz,renv,renvg,renvt,renvz
      real*8 A,B,C,D,E,F,x,y
      real*8 k2bgb,k2g,k2z,logm,logmt,lbgb,ltms,lhei,rg,rtms,rzams
      real*8 teff,tebgb,tetms,tau,tauenv,tautms
*
* A function to estimate the mass and radius of the convective envelope,
* as well as the gyration radius of the envelope.
* N.B. Valid only for Z=0.02!
*
* The following input is needed from HRDIAG:
*   kw = stellar type
*   mass = zero-age stellar mass
*   mt = actual mass
*   mc = core mass (not really needed, can also be done outside subroutine)
*   lum = luminosity
*   rad = radius
*   rc = core radius (not really needed...)
*   aj = age
*   tm = main-sequence lifetime
*   ltms = luminosity at TMS, lums(2)
*   lbgb = luminosity at BGB, lums(3)
*   lhei = luminosity at He ignition, lums(4)
*   rzams = radius at ZAMS
*   rtms = radius at TMS
*   rg = giant branch or Hayashi track radius, approporaite for the type.
*        For kw=1 or 2 this is radius at BGB, and for kw=4 either GB or
*        AGB radius at present luminosity.
*
      tebgb = 0.d0
      logm = log10(mass)
      A = MIN(0.81d0,MAX(0.68d0,0.68d0+0.4d0*logm))
      C = MAX(-2.5d0,MIN(-1.5d0,-2.5d0+5.d0*logm))
      D = -0.1d0
      E = 0.025d0
*
* Zero-age and BGB values of k^2.
*
      k2z = MIN(0.21d0,MAX(0.09d0-0.27d0*logm,0.037d0+0.033d0*logm))
      if(logm.gt.1.3d0) k2z = k2z - 0.055d0*(logm-1.3d0)**2
      k2bgb = MIN(0.15d0,MIN(0.147d0+0.03d0*logm,0.162d0-0.04d0*logm))
*
      if(kw.ge.3.and.kw.le.6)then
*
* Envelope k^2 for giant-like stars; this will be modified for non-giant
* CHeB stars or small envelope mass below.
* Formula is fairly accurate for both FGB and AGB stars if M <= 10, and
* gives reasonable values for higher masses. Mass dependence is on actual
* rather than ZA mass, expected to work for mass-losing stars (but not
* tested!). The slightly complex appearance is to insure continuity at
* the BGB, which depends on the ZA mass.
*
         logmt = log10(mt)
         F = 0.208d0 + 0.125d0*logmt - 0.035d0*logmt**2
         B = 1.0d+04*mt**(3.d0/2.d0)/(1.d0+0.1d0*mt**(3.d0/2.d0))
         x = ((lum-lbgb)/B)**2
         y = (F - 0.033d0*log10(lbgb))/k2bgb - 1.d0
         k2g = (F - 0.033d0*log10(lum) + 0.4d0*x)/(1.d0+y*(lbgb/lum)+x)
      elseif(kw.eq.9)then
*
* Rough fit for for HeGB stars...
*
         B = 3.0d+04*mt**(3.d0/2.d0)
         x = (MAX(0.d0,lum/B-0.5d0))**2
         k2g = (k2bgb + 0.4d0*x)/(1.d0 + 0.4d0*x)
      else
         k2g = k2bgb
      endif
*
      if(kw.le.2)then
         menvg = 0.5d0
         renvg = 0.65d0
      elseif(kw.eq.3.and.lum.lt.3.d0*lbgb)then
*
* FGB stars still close to the BGB do not yet have a fully developed CE.
*
         x = MIN(3.d0,lhei/lbgb)
         tau = MAX(0.d0,MIN(1.d0,(x-lum/lbgb)/(x-1.d0)))
         menvg = 1.d0 - 0.5d0*tau**2
         renvg = 1.d0 - 0.35d0*tau**2
      else
         menvg = 1.d0
         renvg = 1.d0
      endif
*
      if(rad.lt.rg)then
*
* Stars not on the Hayashi track: MS and HG stars, non-giant CHeB stars,
* HeMS and HeHG stars, as well as giants with very small envelope mass.
*

         if(kw.le.6)then
*
* Envelope k^2 fitted for MS and HG stars.
* Again, pretty accurate for M <= 10 but less so for larger masses.
* [Note that this represents the whole star on the MS, so there is a
* discontinuity in stellar k^2 between MS and HG - okay for stars with a
* MS hook but low-mass stars should preferably be continous...]
*
* For other types of star not on the Hayashi track we use the same fit as
* for HG stars, this is not very accurate but has the correct qualitative
* behaviour. For CheB stars this is an overestimate because they appear
* to have a more centrally concentrated envelope than HG stars.
*
            k2e = (k2z-E)*(rad/rzams)**C + E*(rad/rzams)**D
         elseif(kw.eq.7)then
* Rough fit for naked He MS stars.
            tau = aj/tm
            k2e = 0.08d0 - 0.03d0*tau
         elseif(kw.le.9)then
* Rough fit for HeHG stars.
            k2e = 0.08d0*rzams/rad
         endif
*
* tauenv measures proximity to the Hayashi track in terms of Teff.
* If tauenv>0 then an appreciable convective envelope is present, and
* k^2 needs to be modified.
*
         if(kw.le.2)then
            teff = sqrt(sqrt(lum)/rad)
            tebgb = sqrt(sqrt(lbgb)/rg)
            tauenv = MAX(0.d0,MIN(1.d0,(tebgb/teff-A)/(1.d0-A)))
         else
            tauenv = MAX(0.d0,MIN(1.d0,(sqrt(rad/rg)-A)/(1.d0-A)))
         endif
*
         if(tauenv.gt.0.d0)then
            menv = menvg*tauenv**5
            renv = renvg*tauenv**(5.d0/4.d0)
            if(kw.le.1)then
* Zero-age values for CE mass and radius.
               x = MAX(0.d0,MIN(1.d0,(0.1d0-logm)/0.55d0))
               menvz = 0.18d0*x + 0.82d0*x**5
               renvz = 0.4d0*x**(1.d0/4.d0) + 0.6d0*x**10
               y = 2.d0 + 8.d0*x
* Values for CE mass and radius at start of the HG.
               tetms = sqrt(sqrt(ltms)/rtms)
               tautms = MAX(0.d0,MIN(1.d0,(tebgb/tetms-A)/(1.d0-A)))
               menvt = menvg*tautms**5
               renvt = renvg*tautms**(5.d0/4.d0)
* Modified expressions during MS evolution.
               tau = aj/tm
               if(tautms.gt.0.d0)then
                  menv = menvz + tau**y*menv*(menvt - menvz)/menvt
                  renv = renvz + tau**y*renv*(renvt - renvz)/renvt
               else
                  menv = 0.d0
                  renv = 0.d0
               endif
               k2e = k2e + tau**y*tauenv**3*(k2g - k2e)
            else
               k2e = k2e + tauenv**3*(k2g - k2e)
            endif
         else
            menv = 0.d0
            renv = 0.d0
         endif
      else
*
* All other stars should be true giants.
*
         menv = menvg
         renv = renvg
         k2e = k2g
      endif
*
      menv = menv*(mt - mc)
      renv = renv*(rad - rc)
      menv = MAX(menv,1.0d-10)
      renv = MAX(renv,1.0d-10)
*
      return
      end
***

***
      SUBROUTINE hrdiag_remnant(zpars,mt,mc,lum,r,aj,kw)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
      
      real*8 zpars(20)

      real*8 mt,mc,lum,r,aj
      integer kw

      real*8 mch,mchold
      real*8 xx,fac,ahe,aco
      parameter(ahe=4.d0,aco=16.d0)

      
* input mc(or mcmax),mass
* output mt, kw, mc, mass,bhspin
* common: mch, mxns,
* ifflag,ecsn (or mc1), ecsn_low(mc2), bhspinflag,
*  bhspinmag,  Mbh_initial

         mch = 1.44d0 !set here owing to AIC ECSN model.

         if(kw.ge.10.and.kw.le.12)then
*
*        White dwarf.
*
         mc = mt
         mchold = mch
         if(ecsn.gt.0.d0.and.kw.eq.12) mch = 1.38d0
         if(mc.ge.mch)then
*
* Accretion induced supernova with no remnant
* unless WD is ONe in which case we assume a NS
* of minimum mass is the remnant.
*
            if(kw.eq.12)then
               kw = 13
               aj = 0.d0
               mt = 1.3d0
               if(ecsn.gt.0.d0)then
*                  mt = 1.38d0
                  if(wd_mass_lim.eq.1)then
                      mt = 1.38d0
                  else
                      mt = mc
                  endif
                  mt = 0.9d0*mt !in ST this is a quadratic, will add in later.
               endif
            else
               kw = 15
               aj = 0.d0
               mt = 0.d0
               lum = 1.0d-10
               r = 1.0d-10
            endif
         else
*
            if(kw.eq.10)then
               xx = ahe
            else
               xx = aco
            endif
*
            if(wdflag.eq.0)then
*
* Mestel cooling
*
               lum = 635.d0*mt*zpars(14)/(xx*(aj+0.1d0))**1.4d0
*
            elseif(wdflag.ge.1)then
*
* modified-Mestel cooling
*
               if(aj.lt.9000.0)then
                  lum = 300.d0*mt*zpars(14)/(xx*(aj+0.1d0))**1.18d0
               else
                  fac = (9000.1d0*xx)**5.3d0
                  lum = 300.d0*fac*mt*zpars(14)/(xx*(aj+0.1d0))**6.48d0
               endif
*
            endif
*
            r = 0.0115d0*SQRT(MAX(1.48204d-06,(mch/mt)**(2.d0/3.d0)
     &                                      - (mt/mch)**(2.d0/3.d0)))
            r = MIN(0.1d0,r)
            if(mt.lt.0.0005d0) r = 0.09d0
            if(mt.lt.0.000005d0) r = 0.009d0
*
         endif
         mch = mchold !added for AIC ECSN stuff.
      endif
*
      if(kw.eq.13)then
*
*        Neutron Star.
*
         mc = mt
         if(mc.gt.mxns)then
*
* Accretion induced Black Hole?
*
            kw = 14
            aj = 0.d0
         else
            lum = 0.02d0*(mt**0.67d0)/(MAX(aj,0.1d0))**2
            r = 1.4d-05
         endif
      endif
*
      if(kw.eq.14)then
*
*        Black hole
*
         mc = mt
* Store the initial BH mass for calculating the ISCO later
         if(Mbh_initial.eq.0)then
            Mbh_initial = mt
         endif
         lum = 1.0d-10
         r = 4.24d-06*mt
      endif
*
      !added by PA
      if(kw .eq.15) then
*
*         Massless remnant
*
          aj = 0.d0
          mt = 0.d0
          lum = 1.0d-10
          r = 1.0d-10
      endif
*
      end

***
      SUBROUTINE compute_r(mass,z,num,rad)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'

***
* In Fortran, we can't dynamically allocate arrays
* Instead, we declare a stanard array with 10^5 elements
* and pass everything from cosmic 10^5 at a time
*
* for safety, we'll pass the number of stars, num, and stop the
* for loops there
***


      integer loop
      PARAMETER(loop=100000)
      real*8 mass(loop),rad(loop),z
      integer k,kstar,num
      real*8 mt,tm,tn,mass0,age,lum,mc,rc,me,re
      REAL*8 tscls(20),lums(10),GB(10),zpars(20),k2,bhspin

***
* f2py directives go here; we'll return the radii as a 10^5 array
***

Cf2py intent(in) mass
Cf2py intent(in) z
Cf2py intent(in) num
Cf2py intent(out) rad

      CALL zcnsts(z,zpars)
      
***
* Then just loop through everything 
***
      do 10 , k = 1,num
         age = 0.0
         mc = 0.d0 
         tm = 0.d0
         me = 0.d0 
         re = 0.d0 
         lum = 1.0d-10
         mass0 = mass(k) 
         mt = mass(k)
         kstar = 0
         if(mt.ge.0.7) kstar = 1
         bhspin = 0.d0
         rc = 0.d0 
         CALL star(kstar,mass0,mt,tm,tn,tscls,lums,GB,zpars)
         CALL hrdiag(mass0,age,mt,tm,tn,tscls,lums,GB,zpars,
     &               rad(k),lum,kstar,mc,rc,me,re,k2,bhspin,k)

  10  continue

      END SUBROUTINE compute_r

***
      SUBROUTINE instar
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
*
*       Initialization of collision matrix.
*       ------------------------
*
      integer i,j
*
*       Initialize stellar collision matrix.
*
      ktype(0,0) = 1
      do 10 , j = 1,6
         ktype(0,j) = j
         ktype(1,j) = j
 10   continue
      ktype(0,7) = 4
      ktype(1,7) = 4
      do 15 , j = 8,12
         if(j.ne.10)then
            ktype(0,j) = 6
         else
            ktype(0,j) = 3
         endif
         ktype(1,j) = ktype(0,j)
 15   continue
      ktype(2,2) = 3
      do 20 , i = 3,14
         ktype(i,i) = i
 20   continue
      ktype(5,5) = 4
      ktype(7,7) = 7
      ktype(10,10) = 15
      ktype(13,13) = 14
      do 25 , i = 2,5
         do 30 j = i+1,12
            ktype(i,j) = 4
 30      continue
 25   continue
      ktype(2,3) = 3
      ktype(2,6) = 5
      ktype(2,10) = 3
      ktype(2,11) = 5
      ktype(2,12) = 5
      ktype(3,6) = 5
      ktype(3,10) = 3
      ktype(3,11) = 5
      ktype(3,12) = 5
      ktype(6,7) = 4
      ktype(6,8) = 6
      ktype(6,9) = 6
      ktype(6,10) = 5
      ktype(6,11) = 6
      ktype(6,12) = 6
      ktype(7,8) = 8
      ktype(7,9) = 9
      ktype(7,10) = 7
      ktype(7,11) = 9
      ktype(7,12) = 9
      ktype(8,9) = 9
      ktype(8,10) = 7
      ktype(8,11) = 9
      ktype(8,12) = 9
      ktype(9,10) = 7
      ktype(9,11) = 9
      ktype(9,12) = 9
      ktype(10,11) = 9
      ktype(10,12) = 9
      ktype(11,12) = 12
      do 35 , i = 0,12
         ktype(i,13) = 13
         ktype(i,14) = 14
 35   continue
      ktype(13,14) = 14
*
* Increase common-envelope cases by 100.
      do 40 , i = 0,9
         do 45 , j = i,14
            if(i.le.1.or.i.eq.7)then
               if(j.ge.2.and.j.le.9.and.j.ne.7)then
                  ktype(i,j) = ktype(i,j) + 100
               endif
            else
               ktype(i,j) = ktype(i,j) + 100
            endif
 45      continue
 40   continue
*
*       Assign the remaining values by symmetry.
      do 50 , i = 1,14
         do 55 , j = 0,i-1
            ktype(i,j) = ktype(j,i)
 55      continue
 50   continue
*
      return
      end
***

***
      PROGRAM bse
***
*
* Evolves a binary by calling evolv2.f 
* (see header of subroutine for algorithm description). 
*
* Required input is described below. 
***
* See Tout et al., MNRAS, 1997, 291, 732 for a description of many of the
* processes in this code as well as the relevant references mentioned
* within the code.
* Updated reference is:
*           Hurley J.R., Tout C.A., & Pols O.R., 2002, MNRAS, 329, 897
* (please use this one).
***
* For single star evolution see Hurley, Pols & Tout, 2000, MNRAS, 315, 543.
* or Hurley, 2000, PhD Thesis, University of Cambridge (Chapter 2).
* The binary evolution algorithm is described in Chapter 3 of the thesis.
***
*
*           B I N A R Y
*           ***********
*
*       Roche lobe overflow.
*       --------------------
*
*       Developed by Jarrod Hurley, IOA, Cambridge.
*       .........................................................
*
*       Advice by Christopher Tout, Onno Pols & Sverre Aarseth.
*       ++++++++++++++++++++++++++++++++++++++++++++++++++
***
      implicit none
*
      INCLUDE 'const_bse.h'
*
      integer i,kw,kw2,kstar(2),j,k,time,idum
      integer bpp_index_out, bcm_index_out
      real*8 kick_info_out(2,17)
*
      real*8 mass0(2),mass(2),z,zpars(20),vs(3),kick_info(2,18)
      real*8 epoch(2),tms(2),tphys,tphysf,dtp,aj
      real*8 rad(2),lum(2),ospin(2)
      real*8 massc(2),radc(2),menv(2),renv(2)
      real*8 tb,ecc,yearsc
      real*8 B_0(2),bacc(2),tacc(2),bhspin(2),bkick(20)
      PARAMETER(yearsc=3.1557d+07)
      CHARACTER*8 label(16)
*
************************************************************************
* Input:
*
* mass is in solar units.
* tphysf is the maximum evolution time in Myr.
* tb is the orbital period in days.
* kstar is the stellar type: 0 or 1 on the ZAMS - unless in evolved state. 
* z is metallicity in the range 0.0001 -> 0.03 where 0.02 is Population I.
* eccentricity can be anywhere in the range 0.0 -> 1.0.
*
* neta is the Reimers mass-loss coefficent (neta*4x10^-13: 0.5 normally). 
* bwind is the binary enhanced mass loss parameter (inactive for single).
* hewind is a helium star mass loss factor (1.0 normally).
* alpha1 is the common-envelope efficiency parameter (1.0).  
* lambda is the binding energy factor for common envelope evolution (0.5).
*
* ceflag = 0 activates spin-energy correction in common-envelope (0). 
* ceflag = 1 activates de Kool common-envelope model (0). 
* tflag > 0 activates tidal circularisation (1).
* ifflag > 0 uses WD IFMR of HPE, 1995, MNRAS, 272, 800 (0). 
* wdflag > 0 uses modified-Mestel cooling for WDs (0). 
* bhflag > 0 allows velocity kick at BH formation (0). 
* rtmsflag > 0 uses rtms from simulation data (1=[Boost], 2=[Bpass]) (0)
* remnantflag > 0 takes NS/BH mass from Belczynski et al. 2002, ApJ, 572, 407 (1). 
* mxns is the maximum NS mass (1.8, remnantflag=0; 3.0, remnantflag=1). 
* idum is the random number seed used by the kick routine. 
*
* Next come the parameters that determine the timesteps chosen in each
* evolution phase:
*                 pts1 - MS                  (0.05) 
*                 pts2 - GB, CHeB, AGB, HeGB (0.01)
*                 pts3 - HG, HeMS            (0.02)
* as decimal fractions of the time taken in that phase.
*
* sigma is the dispersion in the Maxwellian for the SN kick speed (190 km/s). 
* beta is wind velocity factor: proportional to vwind**2 (1/8). 
* xi is the wind accretion efficiency factor (1.0). 
* acc2 is the Bondi-Hoyle wind accretion factor (3/2). 
* epsnov is the fraction of accreted matter retained in nova eruption (0.001). 
* eddfac is Eddington limit factor for mass transfer (1.0).
* gamma is the angular momentum factor for mass lost during Roche (-1.0). 
*
* If you enter a negative kstar then parameters for an evolved star are
* required in the order of:
* current age, initial mass and spin rate, 
* otherwise the star will start on the ZAMS.
*
      OPEN(22,file='binary.in', status='old')
      READ(22,*)mass0(1),mass0(2),tphysf,tb,kstar(1),kstar(2),z,ecc
      READ(22,*)neta,bwind,hewind,alpha1,lambdaf,windflag,rtmsflag
      READ(22,*)ceflag,tflag,ifflag,wdflag,bhflag,remnantflag,mxns,idum
      READ(22,*)pts1,pts2,pts3
      READ(22,*)sigma,beta,xi,acc2,epsnov,eddfac,gamma,kickflag
      READ(22,*)pisn,cekickflag,cehestarflag,grflag,bhms_coll_flag
      READ(22,*)wd_mass_lim,ecsn,ecsn_mlow,aic,ussn,sigmadiv,bhsigmafrac
      READ(22,*)don_lim,acc_lim,bdecayfac,bconst,ck,qcflag,eddlimflag
      READ(22,*)bhspinflag,bhspinmag,rejuv_fac,rejuvflag,htpmb,st_cr
      READ(22,*)st_tide,rembar_massloss,zsun

      if(kstar(1).lt.0.or.kstar(2).lt.0)then
         READ(22,*)tphys
         READ(22,*)aj,mass(1),ospin(1)
         epoch(1) = tphys - aj
         kstar(1) = ABS(kstar(1))
         READ(22,*)aj,mass(2),ospin(2)
         epoch(2) = tphys - aj
         kstar(2) = ABS(kstar(2))
      else

*
* Initialize the parameters.
* Set the initial spin of the stars. If ospin is zero (actually < 0.001)
* at time zero then evolv2 will set an appropriate ZAMS spin. If 
* ospin is greater than zero then it will start with that spin regardless
* of the time. If you want to start at time zero with negligible spin 
* then I suggest using a negligible value (but greater than 0.001).
* If ospin is negative then the stars will be in co-rotation with the orbit.
*
         tphys = 0.d0
         mass(1) = mass0(1)
         epoch(1) = 0.d0
         ospin(1) = 0.d0
         mass(2) = mass0(2)
         epoch(2) = 0.d0
         ospin(2) = 0.d0

         B_0(1) = 0.d0
         B_0(2) = 0.d0
         bacc(1) = 0.d0
         bacc(2) = 0.d0
         tacc(1) = 0.d0
         tacc(2) = 0.d0
         bhspin(1) = 0.d0
         bhspin(2) = 0.d0
         tms(1) = 0.d0
         tms(2) = 0.d0
*
* NOTE: The following parameters are set to current default values (v3.4.10).
* They should really be included in binary.in and copied from an initC
* file. This is a temporary measure until the input file is updated.
*
        polar_kick_angle = 90
        do i = 1,4
            do j = 1,2
               natal_kick_array(j, i) = -100.d0
            enddo
        enddo
        natal_kick_array(1,5) = 0.0
        natal_kick_array(2,5) = 0.0
        do i = 1,8
            qcrit_array(i) = 0.0
        enddo
        do i = 1,16
            fprimc_array(i) = 2.0/21.0
        enddo
        using_cmc = 0


         do i=1,20
            bkick(i) = 0.d0
         enddo 
         

      endif
      do i=1,17
        do j=1,2
          kick_info(j,i) = 0.d0
        enddo
      enddo
* If you would like to enter the seperation as input in place of the binary
* orbital period uncomment these lines (depending upon which units you wish
* to use).
*      tb = sqrt((tb/aursun)**3/(mass0(1)+mass0(2))) !if input was separation [Rsun] use this line.
*      tb = sqrt((tb)**3/(mass0(1)+mass0(2))) !if input was separation [AU] use this line.
*      tb = tb*yeardy
      if(idum.gt.0) idum = -idum
      CLOSE(22)
      WRITE(*,*)
*
* Note that this routine can be used to evolve a single star if you 
* simply set mass(2) = 0.0 or tb = 0.0 (setting both is advised as  
* well as some dummy value for ecc). 
*
************************************************************************
*
* Set parameters which depend on the metallicity 
*
      CALL zcnsts(z,zpars)
*
* Set the collision matrix.
*
      CALL instar
*
      label(1) = 'INITIAL '
      label(2) = 'KW CHNGE'
      label(3) = 'BEG RCHE'
      label(4) = 'END RCHE'
      label(5) = 'CONTACT '
      label(6) = 'COELESCE'
      label(7) = 'COMENV  '
      label(8) = 'GNTAGE  '
      label(9) = 'NO REMNT'
      label(10) = 'MAX TIME'
      label(11) = 'DISRUPT '
      label(12) = 'BEG SYMB'
      label(13) = 'END SYMB'
      label(14) = 'BEG BSS'
      label(15) = 'SN PRIM'
      label(16) = 'SN SEC'
*
* Set the data-save parameter. If dtp is zero then the parameters of the 
* star will be stored in the bcm array at each timestep otherwise they 
* will be stored at intervals of dtp. Setting dtp equal to tphysf will 
* store data only at the start and end while a value of dtp greater than 
* tphysf will mean that no data is stored.
*
      dtp = 0
*
* Evolve the binary.
* 
      CALL evolv2(kstar,mass,tb,ecc,z,tphysf,dtp,mass0,rad,lum,
     &            massc,radc,menv,renv,ospin,B_0,bacc,tacc,
     &            epoch,tms,bhspin,tphys,zpars,bkick,kick_info,
     &            bcm_index_out,bpp_index_out,kick_info_out)
*
************************************************************************
* Output:
* First check that bcm is not empty.
*
      if(bcm(1,1).lt.0.0) goto 50
*
* The bcm array stores the stellar and orbital parameters at the 
* specified output times. The parameters are (in order of storage):
*
*    Time, 
*    [stellar type, initial mass, current mass, log10(L), log10(r),
*    log10(Teff), core mass, core radius, mass of any convective 
*    envelope, radius of the envelope, epoch, spin, mass loss rate and 
*    ratio of radius to roche lobe radius (repeated for secondary)],
*    period, separation, eccentricity.
*
      OPEN(23,file='binary.dat', status='unknown')
      j = 0
 30   j = j + 1
      if(bcm(j,1).lt.0.0)then
         bcm(j-1,1) = bcm(j,1)
         j = j - 1
      endif
      kw = INT(bcm(j,2))
      kw2 = INT(bcm(j,16))
      WRITE(23,99)bcm(j,1),kw,kw2,bcm(j,4),bcm(j,18),
     &            bcm(j,8),bcm(j,22), 
     &            bcm(j,6),bcm(j,20),bcm(j,15),bcm(j,29),
     &            bcm(j,5),bcm(j,19),bcm(j,13),bcm(j,27),
     &            bcm(j,14),bcm(j,28),
     &            bcm(j,31),bcm(j,32)
      if(bcm(j,1).ge.0.0) goto 30
      CLOSE(23)
 99   FORMAT(g30.18,2i3,10g30.18,5e30.18,g30.18)
 999  FORMAT(g30.18,2g30.18,1p,2e30.18)
*
* The bpp array acts as a log, storing parameters at each change
* of evolution stage.
*
 50   j = 0
      WRITE(*,*)'     TIME      M1       M2   K1 K2        SEP    ECC',  
     &          '  R1/ROL1 R2/ROL2  TYPE'
 52   j = j + 1
      if(bpp(j,1).lt.0.0) goto 60
      kstar(1) = INT(bpp(j,4))
      kstar(2) = INT(bpp(j,5))
      kw = INT(bpp(j,11))
      WRITE(*,100)(bpp(j,k),k=1,3),kstar,(bpp(j,k),k=6,9),label(kw)
      goto 52
 60   continue
 100  FORMAT(g30.18,2g30.18,2i3,g30.18,g30.18,2g30.18,2x,a8)
      WRITE(*,*)
*
************************************************************************
*
      WRITE(*,*) bcm(2,31), bpp(j, 6)

      STOP
      END
***

      SUBROUTINE kick(kw,m1,m1n,m2,ecc,sep,jorb,vk,sn,
     &                r2,fallback,sigmahold,kick_info,disrupt,bkick)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
* Variables
* ---------
* kw: integer
*    Stellar type of the exploding star
* m1: real*8
*    Mass of the exploding star
* m1n: real*8
*    Mass of the compact remnant post-SN
* m2: real*8
*    Mass of the companion star
* ecc: real*8
*    Eccentricity of the binary pre-SN
* sep: real*8
*    Semi-major axis of the binary pre-SN
* sn: integer
*    Which star is going supernova (1 or 2)
* r2: real*8
*    Radius of the companion star
* fallback: real*8
*    Fallback mass fraction
* sigmahold: real*8
*    Original sigma value for the kick
* kick_info: real*8
*    Array with information about the supernova kicks (details below)
* bkick: real*8
*    Array with information about the kicks for CMC (details below)
* jorb: real*8, output
*    Total orbital angular momentum of the binary
* vk: real*8, output
*    Magnitude of the natal kick
* disrupt: logical, output
*    Whether the system is disrupted by the supernova

      integer kw,sn
      real*8 m1,m2,m1n,ecc,sep,jorb,vk,r2,fallback,sigmahold
      real*8 kick_info(2,18), bkick(20)
      logical disrupt

* Use one of the two kick prescriptions based on the kickflag
      if(kickflag.lt.0)then
* Original Kiel & Hurley 2009 prescription
         call kick_kiel(kw,m1,m1n,m2,ecc,sep,jorb,vk,sn,
     &                  r2,fallback,sigmahold,kick_info,disrupt,bkick)
      else
* New Pfahl et al. 2002 prescription
         call kick_pfahl(kw,m1,m1n,m2,ecc,sep,jorb,vk,sn,
     &                   r2,fallback,sigmahold,kick_info,disrupt,bkick)
      end if
      RETURN
      END


      SUBROUTINE kick_pfahl(kw,m1,m1n,m2,ecc,sep,jorb,vk,sn,r2,
     &                      fallback,sigmahold,kick_info,disrupt,bkick)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
* This function is implements an entirely new kick prescription based
* on Appendix B of Pfahl et al. 2002
* https://ui.adsabs.harvard.edu/abs/2002ApJ...573..283P/abstract
* instead of Kiel & Hurley 2009.
*
* This prescription better accounts for how secondary stars are ejected
* from disrupted binaries and also corrects a few minor bugs in the
* implementation of K&H09.
*
* Specific kick magnitudes, angles, eccentric anomaly, and random seeds
* can be supplied in the initialization file with natal_kick_array, a
* (2,5) array with the first row being for sn=1 and second for sn=2
*
* kick_info[i,1]: sn of exploding star
* kick_info[i,2]: disrupted (0=no, 1=yes)
* kick_info[i,3]: magnitude of the natal kick
* kick_info[i,4-5]: phi and theta (in the frame of the exploding star)
* kick_info[i,6]: eccentric anamoly
* kick_info[i,7-9]: change in 3D systemic velocity of the binary, or the
*       change in 3D velocity of sn=1 if the system is disrupted
* kick_info[i,10]: magnitude of systemic velocity of the binary if bound
*       or magnitude of total velocity of sn=1 if disrupted,
*       accounting for both SNe
* kick_info[i,11-13]: change in 3D velocity of the sn=2 if system
*       is disrupted
* kick_info[i,14]: magnitude of velocity of sn=2 if disrupted,
*       accounting for both SNe
* kick_info[i,15]: First Euler angle of rotation of orbital plane after each SN
* kick_info[i,16]: Second Euler angle of rotation of orbital plane after each SN
* kick_info[i,17]: Third Euler angle of rotation of orbital plane after each SN
* kick_info[i,18]: random seed at the start of call to kick.f
*
* For cmc kick_info array is zero, not negative.
      integer kw,k,sn,safety,abskickflag

      real*8 m1,m2,m1n
      real*8 ecc,ecc_2,sep
      real*8 pi,twopi,yearsc,rsunkm,G_const
      parameter(yearsc=3.1557d+07,rsunkm=6.96d+05)
      real*8 mean_anom,ecc_anom,dif,der,del
      real*8 u1,u2,vk,vk2,v(4),s,sigmah
      real*8 theta,phi,sin_phi,cos_phi,sin_theta,cos_theta
      real*8 fallback,sigmahold,bound
      real*8 mean_mns,mean_mej,alphakick,betakick
      real*8 bkick(20),r2,jorb
      real*8 ecc_prev,a_prev,mtot,mtot_prev
      real*8 natal_kick(3), sep_vec(3), v_rel(3), v_rel_prev(3)
      real*8 a_prev_2, a_prev_3, cos_ecc_anom, sin_ecc_anom
      real*8 sqrt_1m_ecc_prev_2, sep_prev, prefactor, omega
      real*8 h_prev(3),h(3), h_hat(3), h_mag
      real*8 LRL_prev(3), LRL(3), e_hat(3)
      real*8 v_cm(3), v_sn(3), v_comp(3), v_inf_vec(3), v_inf
      real*8 v_sn_rot(3), v_comp_rot(3), v_cm_rot(3)
      real*8 h_cross_e_hat(3)
      real*8 thetaE, phiE, psiE
      real*8 psiplusphi, orbital_pivot_axis(3), unsigned_phi
      real*8 LRL_prev_dot_h, LRL_dot_h_prev, unsigned_psi
      real*8 disberg_mean
      integer i
      logical ECSN_or_USSN
* Output
      logical output,disrupt,collide
*
      real*8 kick_info(2,18)
      real ran3,xx
      external ran3
*
      output = .false. !useful for debugging...
      collide = .false.
      ECSN_or_USSN = .false.
      safety = 0
      abskickflag = ABS(kickflag)

* ----------------------------------------------------------------------
* -------------- Initialise variables and constants --------------------
* ----------------------------------------------------------------------

* Set up empty arrays and constants
      u1 = 0.d0
      u2 = 0.d0
      vk = 0.d0
      disberg_mean = 5.60d0
      pi = ACOS(-1.d0)
      twopi = 2.d0*pi
* Gravitational constant in units of km^3 / (Msun * s^2)
      G_const = 1.3271244d+11

* Set values for mean NS mass and mean ejecta as in Giacobbo & Mapelli 2020
      mean_mns = 1.2d0
      mean_mej = 9.0d0
* Set values for alpha and beta as in Bray & Eldridge 2016
      alphakick = 70.0d0
      betakick = 120.0d0

      if(using_cmc.eq.0)then
* check if we have supplied a randomseed for this SN from kick_info
* already
          if(natal_kick_array(sn,5).gt.0.d0)then
* if we have we need to run ran3 enough times until
* we are at the same state of the random number generator
* as we were before
              do while (natal_kick_array(sn,5).ne.idum1
     &                          .and.safety.le.20)
                  xx = RAN3(idum1)
                  safety = safety + 1
              end do
          endif
      endif
* save the current idum1
      natal_kick_array(sn,5) = idum1
      kick_info(sn,18) = idum1

* set the sn of the exploding object in the kick_info array
      kick_info(sn,1) = sn

* if the system was disrupted from the first supernova, marked as disrupted
      if(kick_info(1,2).eq.1) kick_info(2,2)=1

* sigma is negative for ECSN
      if((sigma.lt.0.d0).and.(abskickflag.eq.1.or.abskickflag.eq.5))then
         sigma = -1.d0*sigma
         ECSN_or_USSN = .true.
* for kick prescriptions other than default, revert to original sigma
      elseif((sigma.lt.0.d0).and.(abskickflag.gt.1))then
         sigma = sigmahold
      endif
      sigmah = sigma

* scale down BH kicks if bhsigmafrac is specified
      if(abskickflag.eq.1.or.abskickflag.eq.5)then
         if(kw.eq.14.or.(kw.eq.13.and.(m1n.ge.mxns)))then
            sigma = sigmah*bhsigmafrac
            disberg_mean = disberg_mean * bhsigmafrac
         endif
      endif


* ----------------------------------------------------------------------
* ----- Draw and scale a natal kick magnitude based on input dists -----
* ----------------------------------------------------------------------

* Before we draw the kick from the maxwellian and then scale it
* as desired, let us see if a pre-supplied natal kick magnitude
* was passed.
      if(natal_kick_array(sn,1).ge.0.d0)then
          vk = natal_kick_array(sn,1)
          vk2 = vk*vk
* per supplied kick value we mimic a call to random number generator
          xx = RAN3(idum1)
          xx = RAN3(idum1)
          xx = RAN3(idum1)
          xx = RAN3(idum1)
      else
* If no pre-supplied kick magnitude, we draw a kick from a distribution
* If the kickflag is 5 then use the log-normal distribution described
* by Disberg & Mandel 2025
          if(abskickflag.eq.5.and..not.ECSN_or_USSN)then
             call RandomLogNormal(disberg_mean,0.69d0,vk,idum1,twopi)
             vk2 = vk*vk
          else
* Otherwise use the Hobbs et al. 2005 Maxwellian distribution
* Generate Kick Velocity using Maxwellian Distribution (Phinney 1992).
* Use Henon's method for pairwise components (Douglas Heggie 22/5/97).
            do 25 k = 1,2
                u1 = RAN3(idum1)
                u2 = RAN3(idum1)
                if(u1.gt.0.9999d0) u1 = 0.9999d0
                if(u2.gt.1.d0) u2 = 1.d0
* Generate two velocities from polar coordinates S & THETA.
                s = -2.d0*LOG(1.d0 - u1)
                s = sigma*SQRT(s)
                theta = twopi*u2
                v(2*k-1) = s*COS(theta)
                v(2*k) = s*SIN(theta)
25          continue
            vk2 = v(1)*v(1) + v(2)*v(2) + v(3)*v(3)
            vk = SQRT(vk2)
          endif

          if(abskickflag.eq.1.or.abskickflag.eq.5)then
* Limit BH kick with fallback mass fraction.
             if(kw.eq.14.and.bhflag.eq.0)then
                vk2 = 0.d0
                vk = 0.d0
             elseif(kw.eq.14.and.bhflag.eq.1)then
                 fallback = MIN(fallback,1.d0)
                 vk = MAX((1.d0-fallback)*vk,0.d0)
                 vk2 = vk*vk
             elseif(kw.eq.14.and.bhflag.eq.2)then
                vk = vk * mxns / m1n
                vk2 = vk*vk
             endif
          elseif(abskickflag.eq.2)then
* Use kick scaling from Giacobbo & Mapelli 2020, Eq. 1
             vk = vk * ((m1-m1n)/mean_mej) * (mean_mns/m1n)
             vk2 = vk*vk
          elseif(abskickflag.eq.3)then
* Use kick scaling from Giacobbo & Mapelli 2020, Eq. 2
             vk = vk * ((m1-m1n)/mean_mej)
             vk2 = vk*vk
          elseif(abskickflag.eq.4)then
* Use kick scaling from Bray & Eldridge 2016, Eq. 1
             vk = alphakick * ((m1-m1n)/m1n) + betakick
             vk2 = vk*vk
          endif

* If a massless remnant is produced then artificially set the kick to
* a large value that will cause a disruption. This avoids infinite kicks
* for prescriptions that scale with the mass of the remnant.
* See Issue #687
          if(m1n.le.0.d0)then
             vk = 10000.d0
             vk2 = vk * vk
          endif

      endif
      sigma = sigmah

* save natal kick velocity in the kick_info array and natal_kick_array
      kick_info(sn,3) = vk
      if(using_cmc.eq.0)then
          natal_kick_array(sn,1) = vk
      endif

* ----------------------------------------------------------------------
* --------- Now input or draw supernova natal kick angles --------------
* ----------------------------------------------------------------------

* Before we randomly draw a phi and theta for the natal kick,
* see if a pre-supplied set of phi/theta is passed
      if((natal_kick_array(sn,2).ge.(-90.d0)).and.
     &       (natal_kick_array(sn,2).le.(90.d0)))then
          phi = natal_kick_array(sn,2)*pi/180.d0
          sin_phi = SIN(phi)
* per supplied kick value we mimic a call to random number generator
          xx = RAN3(idum1)
          xx = RAN3(idum1)
      else
* CLR - Allow for a restricted opening angle for SN kicks
*       Only relevant for binaries, obviously
*       Default value for polar_kick_angle = 90.0
          bound = SIN((90.d0 - polar_kick_angle)*pi/180.d0)
          sin_phi = (1.d0-bound)*ran3(idum1) + bound
          phi = ASIN(sin_phi)
* MJZ - The constrained kick will hit at either the north
*       or south pole, so randomly choose the hemisphere
          if(RAN3(idum1).ge.0.5)then
            phi = -phi
            sin_phi = SIN(phi)
          endif
      endif
      cos_phi = COS(phi)

      if((natal_kick_array(sn,3).ge.(0.d0)).and.
     &       (natal_kick_array(sn,3).le.(360.d0)))then
          theta = natal_kick_array(sn,3)*pi/180.d0
* per supplied kick value we mimic a call to random number generator
           xx = RAN3(idum1)
      else
          theta = twopi*ran3(idum1)
      endif
      sin_theta = SIN(theta)
      cos_theta = COS(theta)

*     save theta and phi in the kick_info and
*     natal_kick_array
      kick_info(sn,4) = phi*180/pi
      kick_info(sn,5) = theta*180/pi
      if(using_cmc.eq.0)then
          natal_kick_array(sn,2) = phi*180/pi
          natal_kick_array(sn,3) = theta*180/pi
      endif

* create a vector for the natal kick
      natal_kick(1) = vk * cos_phi * cos_theta
      natal_kick(2) = vk * cos_phi * sin_theta
      natal_kick(3) = vk * sin_phi

* ----------------------------------------------------------------------
* ----- Natal kick all done, check for pre-disruption as quick exit ----
* ----------------------------------------------------------------------

* Check if the system is already not a bound binary
      if((sn.eq.2.and.kick_info(1,2).eq.1)
     &   .or.sep.le.0.or.ecc.lt.0
     &   .or.sep.ne.sep.or.ecc.ne.ecc)then
* if so, only apply kick to the current star
         disrupt = .true.
         kick_info(sn,2) = 1
         if(sn.eq.1)then
            kick_info(sn,7) = natal_kick(1)
            kick_info(sn,8) = natal_kick(2)
            kick_info(sn,9) = natal_kick(3)
         elseif(sn.eq.2)then
            kick_info(sn,11) = natal_kick(1)
            kick_info(sn,12) = natal_kick(2)
            kick_info(sn,13) = natal_kick(3)
         endif
         goto 78
      endif

* ----------------------------------------------------------------------
* ------ Draw or input mean anomaly, solve for eccentric anomaly -------
* ----------------------------------------------------------------------

* Find the initial separation by randomly choosing a mean anomaly.
* check is user supplied mean anomaly
      xx = RAN3(idum1)
      if((natal_kick_array(sn,4).ge.(0.d0)).and.
     &   (natal_kick_array(sn,4).le.(360.d0)))then

         mean_anom = natal_kick_array(sn,4) * pi / 180.d0
      else
         mean_anom = xx * twopi
      endif
* Solve Kepler's equation for the eccentric anomaly from mean anomaly
* https://en.wikipedia.org/wiki/Eccentric_anomaly
      ecc_anom = mean_anom

      if(mean_anom.eq.0.d0) goto 8

  9   dif = ecc_anom - ecc * SIN(ecc_anom) - mean_anom
      if(ABS(dif / mean_anom).le.1.0d-04) goto 8
      der = 1.d0 - ecc * COS(ecc_anom)
      del = dif/der
      ecc_anom = ecc_anom - del
      goto 9

 8    continue

* ----------------------------------------------------------------------
* ------ Calculate whether system disrupts and CM velocity change ------
* ----------------------------------------------------------------------

* Some helper variables for calculations below
      mtot_prev = m1 + m2
      mtot = m1n + m2
      ecc_prev = ecc
* Convert the separation to km
      a_prev = sep * rsunkm
      a_prev_2 = a_prev * a_prev
      a_prev_3 = a_prev_2 * a_prev
      cos_ecc_anom = COS(ecc_anom)
      sin_ecc_anom = SIN(ecc_anom)
      sqrt_1m_ecc_prev_2 = SQRT(1.d0 - ecc_prev * ecc_prev)

* Orbital frequency pre-SN (in 1/s)
      omega = SQRT(G_const * mtot_prev / a_prev_3)

* Separation vector before the supernova (in km)
      sep_vec(1) = a_prev * (cos_ecc_anom - ecc_prev)
      sep_vec(2) = a_prev * sqrt_1m_ecc_prev_2 * sin_ecc_anom
      sep_vec(3) = 0.d0
      call VectorMagnitude(sep_vec, sep_prev)

* Relative velocity vector before the supernova (in km/s)
      prefactor = omega * a_prev_2 / sep_prev
      v_rel_prev(1) = -prefactor * sin_ecc_anom
      v_rel_prev(2) = prefactor * sqrt_1m_ecc_prev_2 * cos_ecc_anom
      v_rel_prev(3) = 0.d0

* Specific angular momentum vector pre-SN (in km^2/s)
      call CrossProduct(sep_vec, v_rel_prev, h_prev)

* Laplace-Runge-Lenz vector pre-SN (unitless)
      call CrossProduct(v_rel_prev, h_prev, LRL_prev)
      do i = 1, 3
         LRL_prev(i) = LRL_prev(i) / (G_const * mtot_prev)
     &               - sep_vec(i) / sep_prev
      end do

* Calculate the new systemic velocity of the center of mass (in km/s)
      do i = 1, 3
         v_cm(i) = (-m2 * (m1 - m1n) / mtot_prev / mtot)
     &           * v_rel_prev(i)
     &           + (m1n / mtot * natal_kick(i))
      end do

* New velocity vectors after SN (in km/s)
      v_rel(1) = v_rel_prev(1) + natal_kick(1)
      v_rel(2) = v_rel_prev(2) + natal_kick(2)
      v_rel(3) = v_rel_prev(3) + natal_kick(3)

* Updated specific orbital angular momentum vector (in km^2/s)
      call CrossProduct(sep_vec, v_rel, h)

* Updated Laplace-Runge-Lenz vector (unitless)
      call CrossProduct(v_rel, h, LRL)
      DO i = 1, 3
         LRL(i) = LRL(i) / (G_const * mtot)
     &          - sep_vec(i) / sep_prev
      END DO

* Get the Euler angles from previous kick for the rotation matrix
      thetaE = kick_info(1,15) * pi / 180.d0
      phiE = kick_info(1,16) * pi / 180.d0
      psiE = kick_info(1,17) * pi / 180.d0

* Get the new eccentricity
      call VectorMagnitude(LRL, ecc)
      ecc_2 = ecc * ecc

* Set the new semi-major axis (back in Rsun now)
      call VectorMagnitude(h, h_mag)
      sep = h_mag * h_mag / (G_const * mtot * (1 - ecc_2)) / rsunkm

* ----------------------------------------------------------------------
* -------- Split based on whether this kick disrupts the system --------
* ----------------------------------------------------------------------

      if(ecc.gt.1.d0)then
* System is now disrupted
         disrupt = .true.
* Set that it is disrupted in the kick_info array
         kick_info(sn,2) = 1
         call VectorHat(LRL, ecc, e_hat)
         call VectorHat(h, h_mag, h_hat)
         call CrossProduct(h_hat, e_hat, h_cross_e_hat)

* Velocity at infinity (in km/s)
         v_inf = G_const * mtot / h_mag * sqrt(ecc_2 - 1.d0)
         do i = 1, 3
            v_inf_vec(i) = v_inf * ((-1.d0 * e_hat(i) / ecc)
     &          + SQRT(1 - 1.d0 / ecc_2) * h_cross_e_hat(i))
         end do

* Velocity of the star going supernova post-SN (in km/s)
         do i = 1, 3
            v_sn(i) = (m2 / mtot) * v_inf_vec(i) + v_cm(i)
         end do

* Velocity of the companion star post-SN (in km/s)
         do i = 1, 3
            v_comp(i) = -(m1n / mtot) * v_inf_vec(i) + v_cm(i)
         end do

* if second supernova, need to change basis to the original orbital plane
         if(sn.eq.2)then
            call ChangeBasis(v_sn, thetaE, phiE, psiE, v_sn_rot)
            call ChangeBasis(v_comp, thetaE, phiE, psiE, v_comp_rot)
         else
            v_sn_rot = v_sn
            v_comp_rot = v_comp
         endif

* save the velocities to the kick_info table
         if(sn.eq.1)then
            kick_info(sn,7) = v_sn_rot(1)
            kick_info(sn,8) = v_sn_rot(2)
            kick_info(sn,9) = v_sn_rot(3)
            kick_info(sn,11) = v_comp_rot(1)
            kick_info(sn,12) = v_comp_rot(2)
            kick_info(sn,13) = v_comp_rot(3)

            bkick(1) = float(sn)
            bkick(2) = kick_info(sn,7)
            bkick(3) = kick_info(sn,8)
            bkick(4) = kick_info(sn,9)
            bkick(5) = float(sn)
            bkick(6) = kick_info(sn,11)
            bkick(7) = kick_info(sn,12)
            bkick(8) = kick_info(sn,13)
*
         elseif(sn.eq.2)then
            kick_info(sn,11) = v_sn_rot(1)
            kick_info(sn,12) = v_sn_rot(2)
            kick_info(sn,13) = v_sn_rot(3)
            kick_info(sn,7) = v_comp_rot(1)
            kick_info(sn,8) = v_comp_rot(2)
            kick_info(sn,9) = v_comp_rot(3)

            bkick(5) = float(sn)
            bkick(6) = kick_info(sn,11)
            bkick(7) = kick_info(sn,12)
            bkick(8) = kick_info(sn,13)
            bkick(9) = float(sn)
            bkick(10) = kick_info(sn,7)
            bkick(11) = kick_info(sn,8)
            bkick(12) = kick_info(sn,9)
         endif

* lastly, check if this supernova results in a collision between stars
         call CollisionCheck(sep_vec, v_sn_rot, v_comp_rot, r2, collide)
* if it does, assume the supernova star plows right through the
* companion and obliterates it
         if(collide)then
            kick_info(sn,7) = v_sn_rot(1)
            kick_info(sn,8) = v_sn_rot(2)
            kick_info(sn,9) = v_sn_rot(3)
            kick_info(sn,11) = 0.d0
            kick_info(sn,12) = 0.d0
            kick_info(sn,13) = 0.d0
            bkick(6) = v_sn_rot(1)
            bkick(7) = v_sn_rot(2)
            bkick(8) = v_sn_rot(3)
            bkick(10) = 0.d0
            bkick(11) = 0.d0
            bkick(12) = 0.d0
            m2 = -1.d0*m2
         endif

         call AngleBetweenVectors(h, h_prev, thetaE)
         phiE = ran3(idum1) * twopi
         psiE = ran3(idum1) * twopi

* ----------------------------------------------------------------------
* The system is still bound
      else
* Record the mean anomaly in the arrays
         kick_info(sn,6) = mean_anom * 180 / pi
         if (using_cmc.eq.0) then
            natal_kick_array(sn,4) = mean_anom * 180 / pi
         endif

* Update the total orbital angular momentum (in Msun Rsun^2/yr)
         jorb = m1n * m2 / mtot * h_mag / rsunkm / rsunkm * yearsc

         if (sn.eq.2) then
            call ChangeBasis(v_cm, thetaE, phiE, psiE, v_cm_rot)
         else
            v_cm_rot = v_cm
         endif

*
* If system survives the SN, save the components of the change in
* centre-of-mass velocity
         kick_info(sn,7) = v_cm_rot(1)
         kick_info(sn,8) = v_cm_rot(2)
         kick_info(sn,9) = v_cm_rot(3)
         kick_info(sn,11) = 0
         kick_info(sn,12) = 0
         kick_info(sn,13) = 0

* 1st time with kick.
         if(bkick(1).le.0.d0)then
            bkick(1) = float(sn)
            bkick(2) = v_cm_rot(1)
            bkick(3) = v_cm_rot(2)
            bkick(4) = v_cm_rot(3)
* 2nd time with kick.
         elseif(bkick(5).le.0.d0)then
            bkick(5) = float(sn)
            bkick(6) = v_cm_rot(1)
            bkick(7) = v_cm_rot(2)
            bkick(8) = v_cm_rot(3)
* 2nd time with kick if already disrupted.
* MJZ - would this if statement ever be hit?
         elseif(bkick(5).gt.0.d0)then
            bkick(9) = float(sn)
            bkick(10) = v_cm_rot(1)
            bkick(11) = v_cm_rot(2)
            bkick(12) = v_cm_rot(3)
         endif
* In the impossible chance that the system is exactly parabolic...
         if(ecc.eq.1.d0.and.sn.eq.1)then
            kick_info(sn,7) = v_cm_rot(1)
            kick_info(sn,8) = v_cm_rot(2)
            kick_info(sn,9) = v_cm_rot(3)
            kick_info(sn,11) = -v_cm_rot(1)
            kick_info(sn,12) = -v_cm_rot(2)
            kick_info(sn,13) = -v_cm_rot(3)
            bkick(1) = float(sn)
            bkick(2) = v_cm_rot(1)
            bkick(3) = v_cm_rot(2)
            bkick(4) = v_cm_rot(3)
            bkick(5) = float(sn)
            bkick(6) = -v_cm_rot(1)
            bkick(7) = -v_cm_rot(2)
            bkick(8) = -v_cm_rot(3)
         elseif(ecc.eq.1.d0.and.sn.eq.2)then
            kick_info(sn,7) = -v_cm_rot(1)
            kick_info(sn,8) = -v_cm_rot(2)
            kick_info(sn,9) = -v_cm_rot(3)
            kick_info(sn,11) = v_cm_rot(1)
            kick_info(sn,12) = v_cm_rot(2)
            kick_info(sn,13) = v_cm_rot(3)
            bkick(5) = float(sn)
            bkick(6) = v_cm_rot(1)
            bkick(7) = v_cm_rot(2)
            bkick(8) = v_cm_rot(3)
            bkick(9) = float(sn)
            bkick(10) = -v_cm_rot(1)
            bkick(11) = -v_cm_rot(2)
            bkick(12) = -v_cm_rot(3)
         endif

* Update the Euler angles for the orbital plane rotation
         call AngleBetweenVectors(h, h_prev, thetaE)

* first two special cases for orbital A.M. remaining unchanged in angle
* since the cross product is not well defined in this case
         if(thetaE.eq.0.d0)then
            xx = ran3(idum1)
            phiE = twopi * xx
            xx = ran3(idum1)
* we can only calculate the angle if the eccentricity is nonzero
            if (ecc_prev.gt.0.d0.and.ecc.gt.0.d0)then
               call AngleBetweenVectors(LRL, LRL_prev, psiPlusPhi)
               psiE = psiPlusPhi - phiE
            else
               psiE = twopi * xx
            end if            
         else if(thetaE.eq.pi)then
            xx = ran3(idum1)
            phiE = twopi * xx
            xx = ran3(idum1)
* we can only calculate the angle if the eccentricity is nonzero
            if (ecc_prev.gt.0.d0.and.ecc.gt.0.d0)then
               call AngleBetweenVectors(LRL, LRL_prev, psiPlusPhi)
               psiE = phiE + psiPlusPhi
            else
               psiE = twopi * xx
            end if
* now we can actually use the cross product to get the pivot axis
         else
            call CrossProduct(h_prev, h, orbital_pivot_axis)

* first handled phiE, need to check ecc_prev is nonzero
* since otherwise LRL_prev is not well-defined
            xx = ran3(idum1)
            if(ecc_prev.eq.0.d0)then
               phiE = twopi * xx
            else
               call DotProduct(LRL_prev, h, LRL_prev_dot_h)
               call AngleBetweenVectors(LRL_prev, orbital_pivot_axis,
     &                                  unsigned_phi)
               if (LRL_prev_dot_h.ge.0.d0) then
                  phiE = unsigned_phi
               else
                  phiE = -unsigned_phi
               endif
            endif

* repeat for psi, now focusing on ecc instead of ecc_prev
            xx = ran3(idum1)
            if(ecc.eq.0.d0)then
               psiE = twopi * xx
            else
               call DotProduct(LRL, h_prev, LRL_dot_h_prev)
               call AngleBetweenVectors(LRL, orbital_pivot_axis,
     &                                  unsigned_psi)
               if (LRL_dot_h_prev.ge.0.d0) then
                  psiE = unsigned_psi
               else
                  psiE = -unsigned_psi
               endif
            endif
         endif
      endif

* TODO: Does Katie want to randomise the Psi angle same as COMPAS?

* save Euler angles in the kick_info array
      kick_info(sn,15) = thetaE * 180 / pi
      kick_info(sn,16) = phiE * 180 / pi
      kick_info(sn,17) = psiE * 180 / pi

* For systems that were distrupted in the first SN, skip to here
 78   continue
*
* Set systemic velocity magnitudes in the kick_info array
* For first SN, this should be identical to the magnitude
* of the three component vectors. For the second SN, this
* will be the systemic velocity relative to the initial frame.
      if(sn.eq.1)then
         kick_info(sn,10) = SQRT(kick_info(sn,7)*kick_info(sn,7) +
     &              kick_info(sn,8)*kick_info(sn,8) +
     &              kick_info(sn,9)*kick_info(sn,9))
         kick_info(sn,14) = SQRT(kick_info(sn,11)*kick_info(sn,11) +
     &              kick_info(sn,12)*kick_info(sn,12) +
     &              kick_info(sn,13)*kick_info(sn,13))
      elseif(sn.eq.2)then
         kick_info(sn,10) = SQRT(
     &      (kick_info(1,7)+kick_info(2,7))*
     &      (kick_info(1,7)+kick_info(2,7)) +
     &      (kick_info(1,8)+kick_info(2,8))*
     &      (kick_info(1,8)+kick_info(2,8)) +
     &      (kick_info(1,9)+kick_info(2,9))*
     &      (kick_info(1,9)+kick_info(2,9)))
         kick_info(sn,14) = SQRT(
     &      (kick_info(1,11)+kick_info(2,11))*
     &      (kick_info(1,11)+kick_info(2,11)) +
     &      (kick_info(1,12)+kick_info(2,12))*
     &      (kick_info(1,12)+kick_info(2,12)) +
     &      (kick_info(1,13)+kick_info(2,13))*
     &      (kick_info(1,13)+kick_info(2,13)))
      endif
      
      RETURN
      END

* ======================================================================
* ================== Old kick routine follows ==========================
* ======================================================================
***
      SUBROUTINE kick_kiel(kw,m1,m1n,m2,ecc,sep,jorb,vk,snstar,r2,
     &                     fallback,sigmahold,kick_info,disrupt,bkick)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
* WARNINGS (from Tom Wagg)
* ------------------------
* Here there be dragons...this prescription seems to have some issues.
*     1. Natal kick strongly affects ejection velocity of secondaries
*     2. Some coordinate transformations seem to be incorrect
*     3. Criteria for collisions are a little peculiar
* I recommend that the kick_pfahl routine be used instead
* ----------------------------------------------------------------------
*
* Updated JRH kick routine by PDK (see Kiel & Hurley 2009).
*
* Here theta is the \omega angle within the HTP02 paper (thus phi is phi).
* Also, mu is the \nu angle in the HTP02 paper and omega its azimuth
*
* Produces a random SN kick.
* Evolution was added for binaries in which the kick creates
* an eccentricity of greater than unity (i.e. hyperbolic orbit).
*
* Specific kick magnitudes, angles, eccentric anomaly, and random seeds
* can be supplied in the initialization file with natal_kick_array, a
* (2,5) array with the first row being for snstar=1 and second for snstar=2
*
* SBC (September 2020)
* put bkick array back in for compatibility with CMC. bkick array is not used
* for COSMIC BSE in anyway
*
* MJZ/SBC (April 2020)
* kick_info is a (2,17) array that tracks information about the supernova
* kicks. This allows us to track the total change to the systemic
* velocity and the total change in the orbital plane tilt after both
* supernovae, as well as reproduce systems.
* The first row contains information about the first supernova that
* occurs, the second row the second supernova.
* Note that some values the second row will take into account the
* effect of the first SN (e.g., kick_info[2,10] is the total systemic
* velocity after both supernovae).
*
* kick_info[i,1]: snstar of exploding star
* kick_info[i,2]: disrupted (0=no, 1=yes)
* kick_info[i,3]: magnitude of the natal kick
* kick_info[i,4-5]: phi and theta (in the frame of the exploding star)
* kick_info[i,6]: eccentric anamoly
* kick_info[i,7-9]: change in 3D systemic velocity of the binary, or the
*       change in 3D velocity of snstar=1 if the system is disrupted
* kick_info[i,10]: magnitude of systemic velocity of the binary if bound
*       or magnitude of total velocity of snstar=1 if disrupted,
*       accounting for both SNe
* kick_info[i,11-13]: change in 3D velocity of the snstar=2 if system
*       is disrupted
* kick_info[i,14]: magnitude of velocity of snstar=2 if disrupted,
*       accounting for both SNe
* kick_info[i,15]: (total) tilt of the orbital plane after each SN
*       w.r.t. the original angular momentum axis after each SN
* kick_info[i,16]: azimuthal angle of the orbital plane w.r.t. spins
* kick_info[i,18]: random seed at the start of call to kick.f
*
* For cmc kick_info array is zero, not negative.
      integer kw,k,snstar,sn,safety,abskickflag

      real*8 m1,m2,m1n,mbi,mbf,mdif
      real*8 ecc,sep,sepn,jorb,ecc2
      real*8 pi,twopi,gmrkm,yearsc,rsunkm
      parameter(yearsc=3.1557d+07,rsunkm=6.96d+05)
      real*8 mm,em,dif,der,del,r
      real*8 u1,u2,vk,v(4),s,theta,phi
      real*8 sphi,cphi,stheta,ctheta,salpha,calpha
      real*8 x_tilt,y_tilt,z_tilt
      real*8 mu,cmu,smu,omega,comega,somega
      real*8 cmu1,smu1,comega1,somega1
      real*8 vr,vr2,vk2,vn2,hn2
      real*8 vs(3),v1,v2,v3
      real*8 mx1,mx2,r2
      real*8 sigmah,RotInvX
      real*8 signs,sigc,psins,psic,cpsins,spsins,cpsic,spsic
      real*8 csigns
      real*8 semilatrec,cangleofdeath,angleofdeath,energy
      real*8 fallback,sigmahold,bound
      real*8 mean_mns,mean_mej,alphakick,betakick
      real*8 bkick(20)
* Output
      logical output,disrupt
*
      real*8 kick_info(2,18)
      real ran3,xx
      external ran3
*
      output = .false. !useful for debugging...
      safety = 0
      abskickflag = ABS(kickflag)

* Set up empty arrays and constants
      do k = 1,3
         vs(k) = 0.d0
      enddo
      u1 = 0.d0
      u2 = 0.d0
      vk = 0.d0
      pi = ACOS(-1.d0)
      twopi = 2.d0*pi
* Conversion factor to ensure velocities are in km/s using mass and
* radius in solar units.
      gmrkm = 1.906125d+05

* Set values for mean NS mass and mean ejecta as in Giacobbo & Mapelli 2020
      mean_mns = 1.2d0
      mean_mej = 9.0d0
* Set values for alpha and beta as in Bray & Eldridge 2016
      alphakick = 70.0d0
      betakick = 120.0d0

* find whether this is the first or second supernova
      if(using_cmc.eq.0)then
          if(kick_info(1,1).eq.0) sn=1
          if(kick_info(1,1).gt.0) sn=2
      else
          if(bkick(1).eq.0) sn=1
          if(bkick(1).gt.0) sn=2
      endif

      if(using_cmc.eq.0)then
* check if we have supplied a randomseed for this SN from kick_info
* already
          if(natal_kick_array(snstar,5).gt.0.d0)then
* if we have we need to run ran3 enough times until
* we are at the same state of the random number generator
* as we were before
              do while (natal_kick_array(snstar,5).ne.idum1
     &                          .and.safety.le.20)
                  xx = RAN3(idum1)
                  safety = safety + 1
              end do
          endif
      endif
* save the current idum1
      natal_kick_array(snstar,5) = idum1
      kick_info(sn,18) = idum1
* add a blank column (not used in this prescription)
      kick_info(sn,17) = 0.d0

* set the SNstar of the exploding object in the kick_info array
      kick_info(sn,1) = snstar

* if the system was disrupted from the first supernova, marked as disrupted
      if(kick_info(1,2).eq.1) kick_info(2,2)=1

* sigma is negative for ECSN
      if((sigma.lt.0.d0).and.(abskickflag.eq.1))then
         sigma = -1.d0*sigma
* for kick prescriptions other than default, revert to original sigma
      elseif((sigma.lt.0.d0).and.(abskickflag.gt.1))then
         sigma = sigmahold
      endif
      sigmah = sigma

* scale down BH kicks if bhsigmafrac is specified
      if(abskickflag.eq.1)then
         if(kw.eq.14.or.(kw.eq.13.and.(m1n.ge.mxns)))then
            sigma = sigmah*bhsigmafrac
         endif
      endif

*
* Find the initial separation by randomly choosing a mean anomaly.
      if(sep.gt.0.d0.and.ecc.ge.0.d0)then

* check is user supplied mean anomaly
         if((natal_kick_array(snstar,4).ge.(0.d0)).and.
     &       (natal_kick_array(snstar,4).le.(360.d0)))then

             mm = natal_kick_array(snstar,4)*pi/180.d0
* per supplied kick value we mimic a call to random number generator
             xx = RAN3(idum1)

* Solve for the eccentric anomaly from the mean anomaly
* https://en.wikipedia.org/wiki/Eccentric_anomaly
             em = mm

             if(mm.eq.0.d0) goto 3

  4          dif = em - ecc*SIN(em) - mm
             if(ABS(dif/mm).le.1.0d-04) goto 3
             der = 1.d0 - ecc*COS(em)
             del = dif/der
             em = em - del
             goto 4

         endif

         xx = RAN3(idum1)
         mm = xx*twopi
         em = mm
 2       dif = em - ecc*SIN(em) - mm
         if(ABS(dif/mm).le.1.0d-04) goto 3
         der = 1.d0 - ecc*COS(em)
         del = dif/der
         em = em - del
         goto 2
 3       continue
         r = sep*(1.d0 - ecc*COS(em))
*
* Find the initial relative velocity vector.
* With a randomly selected quadrant of the orbit.
         salpha = SQRT((sep*sep*(1.d0-ecc*ecc))/(r*(2.d0*sep-r)))
         calpha = (-1.d0*ecc*SIN(em))/SQRT(1.d0-ecc*ecc*COS(em)*COS(em))
         vr2 = gmrkm*(m1+m2)*(2.d0/r - 1.d0/sep)
         vr = SQRT(vr2)
      else
         vr = 0.d0
         vr2 = 0.d0
         salpha = 0.d0
         calpha = 0.d0
      endif
* Before we draw the kick from the maxwellian and then scale it
* as desired, let us see if a pre-supplied natal kick maganitude
* was passed.
      if(natal_kick_array(snstar,1).ge.0.d0)then
          vk = natal_kick_array(snstar,1)
          vk2 = vk*vk
* per supplied kick value we mimic a call to random number generator
          xx = RAN3(idum1)
          xx = RAN3(idum1)
          xx = RAN3(idum1)
          xx = RAN3(idum1)
      else
* Generate Kick Velocity using Maxwellian Distribution (Phinney 1992).
* Use Henon's method for pairwise components (Douglas Heggie 22/5/97).
          do 20 k = 1,2
             u1 = RAN3(idum1)
             u2 = RAN3(idum1)
             if(u1.gt.0.9999d0) u1 = 0.9999d0
             if(u2.gt.1.d0) u2 = 1.d0
* Generate two velocities from polar coordinates S & THETA.
             s = -2.d0*LOG(1.d0 - u1)
             s = sigma*SQRT(s)
             theta = twopi*u2
             v(2*k-1) = s*COS(theta)
             v(2*k) = s*SIN(theta)
 20          continue
          vk2 = v(1)*v(1) + v(2)*v(2) + v(3)*v(3)
          vk = SQRT(vk2)

          if(abskickflag.eq.1)then
* Limit BH kick with fallback mass fraction.
             if(kw.eq.14.and.bhflag.eq.0)then
                vk2 = 0.d0
                vk = 0.d0
             elseif(kw.eq.14.and.bhflag.eq.1)then
                 fallback = MIN(fallback,1.d0)
                 vk = MAX((1.d0-fallback)*vk,0.d0)
                 vk2 = vk*vk
             elseif(kw.eq.14.and.bhflag.eq.2)then
                vk = vk * mxns / m1n
                vk2 = vk*vk
             endif
          elseif(abskickflag.eq.2)then
* Use kick scaling from Giacobbo & Mapelli 2020, Eq. 1
             vk = vk * ((m1-m1n)/mean_mej) * (mean_mns/m1n)
             vk2 = vk*vk
          elseif(abskickflag.eq.3)then
* Use kick scaling from Giacobbo & Mapelli 2020, Eq. 2
             vk = vk * ((m1-m1n)/mean_mej)
             vk2 = vk*vk
          elseif(abskickflag.eq.4)then
* Use kick scaling from Bray & Eldridge 2016, Eq. 1
             vk = alphakick * ((m1-m1n)/m1n) + betakick
             vk2 = vk*vk
          endif

      endif
      sigma = sigmah

* save natal kick velocity in the kick_info array and natal_kick_array
      kick_info(sn,3) = vk
      if(using_cmc.eq.0)then
          natal_kick_array(snstar,1) = vk
      endif
* Before we randomly draw a phi and theta for the natal kick,
* see if a pre-supplied set of phi/theta is passed
      if((natal_kick_array(snstar,2).ge.(-90.d0)).and.
     &       (natal_kick_array(snstar,2).le.(90.d0)))then
          phi = natal_kick_array(snstar,2)*pi/180.d0
          sphi = SIN(phi)
* per supplied kick value we mimic a call to random number generator
          xx = RAN3(idum1)
          xx = RAN3(idum1)
      else
* CLR - Allow for a restricted opening angle for SN kicks
*       Only relevant for binaries, obviously
*       Default value for polar_kick_angle = 90.0
          bound = SIN((90.d0 - polar_kick_angle)*pi/180.d0)
          sphi = (1.d0-bound)*ran3(idum1) + bound
          phi = ASIN(sphi)
* MJZ - The constrained kick will hit at either the north
*       or south pole, so randomly choose the hemisphere
          if(RAN3(idum1).ge.0.5)then
            phi = -phi
            sphi = SIN(phi)
          endif
      endif
      cphi = COS(phi)

      if((natal_kick_array(snstar,3).ge.(0.d0)).and.
     &       (natal_kick_array(snstar,3).le.(360.d0)))then
          theta = natal_kick_array(snstar,3)*pi/180.d0
* per supplied kick value we mimic a call to random number generator
           xx = RAN3(idum1)
      else
          theta = twopi*ran3(idum1)
      endif
      stheta = SIN(theta)
      ctheta = COS(theta)

*     save theta and phi (exploding star frame) in the kick_info and
*     natal_kick_array
      kick_info(sn,4) = phi*180/pi
      kick_info(sn,5) = theta*180/pi
      if(using_cmc.eq.0)then
          natal_kick_array(snstar,2) = phi*180/pi
          natal_kick_array(snstar,3) = theta*180/pi
      endif

* If the system is already disrupted, apply this kick only to the
* exploding star, and skip ahead.
      if(sn.eq.2.and.kick_info(1,2).eq.1)then
         if(snstar.eq.1)then
            kick_info(sn,7) = vk*COS(theta)*SIN(phi)
            kick_info(sn,8) = vk*SIN(theta)*SIN(phi)
            kick_info(sn,9) = vk*COS(phi)
         elseif(snstar.eq.2)then
            kick_info(sn,11) = vk*COS(theta)*SIN(phi)
            kick_info(sn,12) = vk*SIN(theta)*SIN(phi)
            kick_info(sn,13) = vk*COS(phi)
         endif
         GOTO 73
      endif

* CLR - if the orbit has already been kicked, then any polar kick
*       needs to be tilted as well (since L_hat and S_hat are no longer
*       aligned).
* MJZ - to track the total angular change in the binary's orbital plane,
*       we use both the value of \mu and \omega from the first SN.
*       We first rotate by \mu about the x-axis, then by \omega
*       about the z-axis.
*       We do this when the system has already had one SN (sn=2)
*  NOTE: This prescription does not account for realignment between SNe!
      if(sn.eq.2)then
        cmu = COS(kick_info(1,15)*pi/180)
        smu = SIN(kick_info(1,15)*pi/180)
        comega = COS(kick_info(1,16)*pi/180)
        somega = SIN(kick_info(1,16)*pi/180)

        x_tilt = ctheta*cphi*comega + smu*sphi*somega -
     &                   cmu*cphi*stheta*somega
        y_tilt = cmu*cphi*comega*stheta + ctheta*cphi*somega -
     &                   comega*smu*sphi
        z_tilt = cmu*sphi + cphi*smu*stheta

        phi = ASIN(z_tilt)
        sphi = z_tilt
        cphi = COS(phi)
        theta = ATAN(y_tilt/x_tilt)
        stheta = SIN(theta)
        ctheta = COS(theta)
      endif

      if(sep.le.0.d0.or.ecc.lt.0.d0) goto 90

*
* Determine the magnitude of the new relative velocity.
* CLR - fixed a spurious minus sign in the parenthesis here; only
*       relevant for eccentric orbits
      vn2 = vk2+vr2-2.d0*vk*vr*(ctheta*cphi*salpha+stheta*cphi*calpha)
* Calculate the new semi-major axis.
      sep = 2.d0/r - vn2/(gmrkm*(m1n+m2))
      sep = 1.d0/sep
* Determine the magnitude of the cross product of the separation vector
* and the new relative velocity.
      v1 = vk2*sphi*sphi
      v2 = (vk*ctheta*cphi-vr*salpha)**2
      v3 = vk2*stheta*stheta*cphi*cphi
      hn2 = r*r*(v1 + v2)
* Calculate the new eccentricity.
      ecc2 = 1.d0 - hn2/(gmrkm*sep*(m1n+m2))
      ecc2 = MAX(0.d0,ecc2)
      ecc = SQRT(ecc2)
* Calculate the new orbital angular momentum taking care to convert
* hn to units of Rsun^2/yr.
      jorb = (m1n*m2/(m1n+m2))*SQRT(hn2)*(yearsc/rsunkm)
* Determine the polar angle (mu) and azimuthal angle (omega)
* between the new and old orbital angular momentum vectors
      cmu = (vr*salpha-vk*ctheta*cphi)/SQRT(v1 + v2)
      mu = ACOS(cmu)
      smu = SIN(mu)

      comega = (vr*salpha-vk*ctheta*cphi)/SQRT(v3 + v2)
      omega = ACOS(comega)
      somega = SIN(omega)

* Write angle between initial and current orbital angular momentum vectors
* and mean anomaly if system is still bound
      if(sn.eq.1.and.ecc.le.1)then
        kick_info(sn,15) = mu*180/pi
        kick_info(sn,16) = omega*180/pi
        kick_info(sn,6) = mm*180/pi
        if(using_cmc.eq.0)then
            natal_kick_array(snstar,4) = mm*180/pi
        endif
      elseif(sn.eq.2)then
* MJZ - Here we calculate the total change in the orbital plane
*       from both SN. Note that these angles mu and omega are in
*       typical spherical coordinates rather than colateral coordinates,
*       so the rotations are slightly different than above.
*       We rotate about z-axis by omega1 then y-axis by mu1
        cmu1 = COS(kick_info(1,15)*pi/180)
        smu1 = SIN(kick_info(1,15)*pi/180)
        comega1 = COS(kick_info(1,16)*pi/180)
        somega1 = SIN(kick_info(1,16)*pi/180)

        x_tilt = cmu1*comega*comega1*smu + cmu*smu1
     &                - cmu1*smu*somega*somega1
        y_tilt = comega1*smu*somega + comega*smu*somega1
        z_tilt = cmu*cmu1 + smu*smu1*somega*somega1
     &               - comega*comega1*smu*smu1

        kick_info(sn,15) = ACOS(z_tilt)*180/pi
* If both kicks were 0 then x_tilt for SN2 will be 0 since smu=0
        if(x_tilt.eq.0)then
          kick_info(sn,16) = 0
        else
          kick_info(sn,16) = ATAN(y_tilt/x_tilt)*180/pi
        endif
        kick_info(sn,6) = mm*180/pi
        if(using_cmc.eq.0)then
            natal_kick_array(snstar,4) = mm*180/pi
        endif

      endif

* Determine if orbit becomes hyperbolic.
 90   continue

* Calculate systemic velocity
      mx1 = vk*m1n/(m1n+m2)
      mx2 = vr*(m1-m1n)*m2/((m1n+m2)*(m1+m2))
      vs(1) = mx1*ctheta*cphi + mx2*salpha
      vs(2) = mx1*stheta*cphi + mx2*calpha
      vs(3) = mx1*sphi
*
* See if system was disrupted
      if(ecc.gt.1.d0)then
         disrupt = .true.
* Set that it is disrupted in the kick_info array
         kick_info(sn,2) = 1
*
*************************
* Kiel & Hurley method: * Similar to Belczynski et al. (2008) method.
*************************
* Find the semimajor axis and semiminor axis.
*         sepn = hn2/(gmrkm*(m1n+m2)*(ecc*ecc - 1.d0))
         sepn = -sep
*         bb = sqrt(ecc*ecc-1.d0)*sepn
* Direction for hyperbolic velocity in x (csig) and y (ssig).
         csigns = 1.d0/ecc
* Calculate the velocity magnitude at infinity for hyperbolic orbit.
         v1 = SQRT((gmrkm*(m1n+m2))/sepn)
         signs = ACOS(MIN(1.d0,csigns))
         sigc = signs
* Calculating position of NS compared to companion for
* rotation calculation around the z-axis.
         semilatrec = gmrkm*(m1n+m2)
         semilatrec = hn2/semilatrec
         cangleofdeath = (1.d0/ecc)*((semilatrec/r) - 1.d0)
         angleofdeath = ACOS(MIN(1.d0,cangleofdeath))
* Find which hemisphere (in x) the NS/companion originated in...
         psins = angleofdeath
         if((stheta*cphi - calpha).gt.0.d0) psins = -psins
         psic = psins
* Accounting for rotation in x-y plane due to SN event.
         cpsins = COS(signs-psins)
         spsins = SIN(signs-psins)
         cpsic = COS(sigc-psic)
         spsic = SIN(sigc-psic)
* Inverse rotation matrix accounting for our assumed alignment of
* the post-SN orbital angular mometum with the z-axis.
*         RotInvX = vr*salpha + vk*(sphi - ctheta*cphi)
*         mbi = RotInvX
*         RotInvZ = vr*salpha - vk*(ctheta*cphi+sphi)
*         RotInvX = RotInvX/SQRT(RotInvX*RotInvX + RotInvZ*RotInvZ)
*         RotInvZ = RotInvZ/SQRT(mbi*mbi + RotInvZ*RotInvZ)
         RotInvX = cmu
*
         mbi = m1+m2
         mbf = m1n+m2
         mdif = m1 - m1n
* Energy calculation, for interest - should be positive for unbound system.
         energy = vn2/2.d0 - gmrkm*(m1n+m2)/r
*
* Set values in the kick_info array for this disrupted system
* First specify that the system was disrupted from this SN
         kick_info(sn,2) = 1
* Now save the velocity of each star. Note that kick_info[4-6] is for snstar=1.
         if(snstar.eq.1)then
            kick_info(sn,7) = ((m1n/mbf)*vk*ctheta*cphi +
     &           (mdif*m2)/(mbi*mbf)*vr*salpha) -
     &           v1*(spsins)*RotInvX*(m2/mbf)
*
            kick_info(sn,8) = (m1n/mbf)*vk*stheta*cphi +
     &           (mdif*m2)/(mbi*mbf)*vr*calpha -
     &           v1*(cpsins)*(m2/mbf)
*
            kick_info(sn,9) = (m1n/mbf)*vk*sphi
*
            kick_info(sn,11) = ((mdif*m2)/(mbi*mbf)*vr*salpha +
     &           (m1n/mbf)*vk*ctheta*cphi) +
     &           v1*(spsic)*(m1n/mbf)*RotInvX
*
            kick_info(sn,12) = (mdif*m2)/(mbi*mbf)*vr*calpha +
     &           (m1n/mbf)*vk*stheta*cphi +
     &           v1*(cpsic)*(m1n/mbf)
*
            kick_info(sn,13) = (m1n/mbf)*vk*sphi

            bkick(1) = float(snstar)
            bkick(2) = kick_info(sn,7)
            bkick(3) = kick_info(sn,8)
            bkick(4) = kick_info(sn,9)
            bkick(5) = float(snstar)
            bkick(6) = kick_info(sn,11)
            bkick(7) = kick_info(sn,12)
            bkick(8) = kick_info(sn,13)

            if(psins.lt.0.d0)then
               if(r2.gt.sepn*(ecc - 1.d0))then
                  kick_info(sn,7) = vs(1)
                  kick_info(sn,8) = vs(2)
                  kick_info(sn,9) = vs(3)
                  kick_info(sn,11) = 0.d0
                  kick_info(sn,12) = 0.d0
                  kick_info(sn,13) = 0.d0
                  bkick(2) = vs(1)
                  bkick(3) = vs(2)
                  bkick(4) = vs(3)
                  bkick(6) = 0.d0
                  bkick(7) = 0.d0
                  bkick(8) = 0.d0
                  m2 = -1.d0*m2
               endif
            endif
*
         elseif(snstar.eq.2)then
            kick_info(sn,11) = ((m1n/mbf)*vk*ctheta*cphi +
     &           (mdif*m2)/(mbi*mbf)*vr*salpha) -
     &           v1*(spsins)*RotInvX*(m2/mbf)
*
            kick_info(sn,12) = (m1n/mbf)*vk*stheta*cphi +
     &           (mdif*m2)/(mbi*mbf)*vr*calpha -
     &           v1*(cpsins)*(m2/mbf)
*
            kick_info(sn,13) = (m1n/mbf)*vk*sphi
*
            kick_info(sn,7) = ((mdif*m2)/(mbi*mbf)*vr*salpha +
     &           (m1n/mbf)*vk*ctheta*cphi) +
     &           v1*(spsic)*(m1n/mbf)*RotInvX
*
            kick_info(sn,8) = (mdif*m2)/(mbi*mbf)*vr*calpha +
     &           (m1n/mbf)*vk*stheta*cphi +
     &           v1*(cpsic)*(m1n/mbf)
*
            kick_info(sn,9) = (m1n/mbf)*vk*sphi

            bkick(5) = float(snstar)
            bkick(6) = kick_info(sn,11)
            bkick(7) = kick_info(sn,12)
            bkick(8) = kick_info(sn,13)
            bkick(9) = float(snstar)
            bkick(10) = kick_info(sn,7)
            bkick(11) = kick_info(sn,8)
            bkick(12) = kick_info(sn,9)

            if(psins.lt.0.d0)then
               if(r2.gt.sepn*(ecc - 1.d0))then
                  kick_info(sn,7) = vs(1)
                  kick_info(sn,8) = vs(2)
                  kick_info(sn,9) = vs(3)
                  kick_info(sn,11) = 0.d0
                  kick_info(sn,12) = 0.d0
                  kick_info(sn,13) = 0.d0
                  bkick(6) = vs(1)
                  bkick(7) = vs(2)
                  bkick(8) = vs(3)
                  bkick(10) = 0.d0
                  bkick(11) = 0.d0
                  bkick(12) = 0.d0
                  m2 = -1.d0*m2
               endif
            endif
*
         endif
         ecc = MIN(ecc,99.99d0)
      endif
*
* If system survives the SN, save the components of the change in
* centre-of-mass velocity
      if(ecc.lt.1.d0)then
         kick_info(sn,7) = vs(1)
         kick_info(sn,8) = vs(2)
         kick_info(sn,9) = vs(3)
         kick_info(sn,11) = 0
         kick_info(sn,12) = 0
         kick_info(sn,13) = 0
      endif

      if(ecc.lt.1.d0)then
*         if(ecc.eq.1.d0.or.ecc.lt.0.d0) m2 = -1.d0 * m2
* 1st time with kick.
         if(bkick(1).le.0.d0)then
            bkick(1) = float(snstar)
            bkick(2) = vs(1)
            bkick(3) = vs(2)
            bkick(4) = vs(3)
* 2nd time with kick.
         elseif(bkick(5).le.0.d0)then
            bkick(5) = float(snstar)
            bkick(6) = vs(1)
            bkick(7) = vs(2)
            bkick(8) = vs(3)
* 2nd time with kick if already disrupted.
* MJZ - would this if statement ever be hit?
         elseif(bkick(5).gt.0.d0)then
            bkick(9) = float(snstar)
            bkick(10) = vs(1)
            bkick(11) = vs(2)
            bkick(12) = vs(3)
         endif
      endif

* In the impossible chance that the system is exactly parabolic...
      if(ecc.eq.1.d0.and.snstar.eq.1)then
         kick_info(sn,7) = vs(1)
         kick_info(sn,8) = vs(2)
         kick_info(sn,9) = vs(3)
         kick_info(sn,11) = -vs(1)
         kick_info(sn,12) = -vs(2)
         kick_info(sn,13) = -vs(3)
         bkick(1) = float(snstar)
         bkick(2) = vs(1)
         bkick(3) = vs(2)
         bkick(4) = vs(3)
         bkick(5) = float(snstar)
         bkick(6) = -vs(1)
         bkick(7) = -vs(2)
         bkick(8) = -vs(3)
      elseif(ecc.eq.1.d0.and.snstar.eq.2)then
         kick_info(sn,7) = -vs(1)
         kick_info(sn,8) = -vs(2)
         kick_info(sn,9) = -vs(3)
         kick_info(sn,11) = vs(1)
         kick_info(sn,12) = vs(2)
         kick_info(sn,13) = vs(3)
         bkick(5) = float(snstar)
         bkick(6) = vs(1)
         bkick(7) = vs(2)
         bkick(8) = vs(3)
         bkick(9) = float(snstar)
         bkick(10) = -vs(1)
         bkick(11) = -vs(2)
         bkick(12) = -vs(3)
      endif

* Uncomment to randomly rotate system velocities
      CALL randomness3(idum1,
     &            kick_info(sn,7),kick_info(sn,8),kick_info(sn,9),
     &            kick_info(sn,11),kick_info(sn,12),kick_info(sn,13))
*
* Put a cap on the eccentricity
      if(ecc.gt.99.9d0) ecc = 99.9d0

* For systems that were distrupted in the first SN, skip to here
 73   continue
*
* Set systemic velocity magnitudes in the kick_info array
* For first SN, this should be identical to the magnitude
* of the three component vectors. For the second SN, this
* will be the systemic velocity relative to the initial frame.
      if(sn.eq.1)then
         kick_info(sn,10) = SQRT(kick_info(sn,7)*kick_info(sn,7) +
     &              kick_info(sn,8)*kick_info(sn,8) +
     &              kick_info(sn,9)*kick_info(sn,9))
         kick_info(sn,14) = SQRT(kick_info(sn,11)*kick_info(sn,11) +
     &              kick_info(sn,12)*kick_info(sn,12) +
     &              kick_info(sn,13)*kick_info(sn,13))
      elseif(sn.eq.2)then
         kick_info(sn,10) = SQRT(
     &      (kick_info(1,7)+kick_info(2,7))*
     &      (kick_info(1,7)+kick_info(2,7)) +
     &      (kick_info(1,8)+kick_info(2,8))*
     &      (kick_info(1,8)+kick_info(2,8)) +
     &      (kick_info(1,9)+kick_info(2,9))*
     &      (kick_info(1,9)+kick_info(2,9)))
         kick_info(sn,14) = SQRT(
     &      (kick_info(1,11)+kick_info(2,11))*
     &      (kick_info(1,11)+kick_info(2,11)) +
     &      (kick_info(1,12)+kick_info(2,12))*
     &      (kick_info(1,12)+kick_info(2,12)) +
     &      (kick_info(1,13)+kick_info(2,13))*
     &      (kick_info(1,13)+kick_info(2,13)))
      endif

* Write some output information
*
      RETURN
      END
***
      SUBROUTINE randomness3(idum,vx1,vy1,vz1,vx2,vy2,vz2)
*
      implicit none
*
      INTEGER idum
      real ran3
      external ran3
      REAL*8 vx1,vy1,vz1,alpha,gamma,beta,pi,twopi,vx2,vy2,vz2
      REAL*8 cg,sg,ca,sa,cb,sb,vx1s,vy1s,vz1s,vx2s,vy2s,vz2s
*
* Introduce random orientation of binary system to the Galaxy/GC... u bastard.
*
      pi = ACOS(-1.d0)
      twopi = 2.d0*pi
      alpha = twopi*ran3(idum) - pi
      gamma = twopi*ran3(idum) - pi
      beta = pi*ran3(idum) - (pi/2.d0)
*      write(80,*)alpha,gamma,beta
      cg = COS(gamma)
      sg = SIN(gamma)
      ca = COS(alpha)
      sa = SIN(alpha)
      cb = COS(beta)
      sb = SIN(beta)
*
* Randomized orientation
*
      vx1s = vx1
      vy1s = vy1
      vz1s = vz1
      vx2s = vx2
      vy2s = vy2
      vz2s = vz2
* theta = b, phi = a, g = psi; pitch-roll-yaw; z-y-x axis rotations
      vx1 = vx1s*(cb*ca)
      vx1 = vx1 + vy1s*(cb*sa)
      vx1 = vx1 - vz1s*sb
*
      vy1 = vx1s*(sg*sb*ca - cg*sa)
      vy1 = vy1 + vy1s*(sg*sb*sa + cg*ca)
      vy1 = vy1 + vz1s*(cb*sg)
*
      vz1 = vx1s*(cg*sb*ca + sg*sa)
      vz1 = vz1 + vy1s*(cg*sb*sa - sg*ca)
      vz1 = vz1 + vz1s*(cb*cg)
**
**
      vx2 = vx2s*(cb*ca)
      vx2 = vx2 + vy2s*(cb*sa)
      vx2 = vx2 - vz2s*sb
*
      vy2 = vx2s*(sg*sb*ca - cg*sa)
      vy2 = vy2 + vy2s*(sg*sb*sa + cg*ca)
      vy2 = vy2 + vz2s*(cb*sg)
*
      vz2 = vx2s*(cg*sb*ca + sg*sa)
      vz2 = vz2 + vy2s*(cg*sb*sa - sg*ca)
      vz2 = vz2 + vz2s*(cb*cg)
**
*
      RETURN
      END
*



* ======================================================================
* ================== Vector helper functions follow ====================
* ======================================================================

      SUBROUTINE ChangeBasis(Vector, ThetaE, PhiE, PsiE, Result)
* Redefine a vector from one coordinate basis to another using Euler Angles
* Vector is the input vector in the new basis (X', Y', Z')
* Result is the transformed vector in the original basis (X, Y, Z)
* ThetaE, PhiE, PsiE are the Euler angles
  
      real*8 Vector(3), Result(3)
      real*8 ThetaE, PhiE, PsiE
      real*8 cTheta, cPhi, cPsi, sTheta, sPhi, sPsi
      real*8 rotationMatrix(3,3)
      integer i, j
    
* define trigonometric values
      cTheta = COS(ThetaE)
      sTheta = SIN(ThetaE)
      cPhi   = COS(PhiE)
      sPhi   = SIN(PhiE)
      cPsi   = COS(PsiE)
      sPsi   = SIN(PsiE)
    
* define the Rotation Matrix
      rotationMatrix(1,1) = cPhi * cPsi - sPhi * cTheta * sPsi
      rotationMatrix(1,2) = -cPhi * sPsi - sPhi * cTheta * cPsi
      rotationMatrix(1,3) = sTheta * sPhi
      rotationMatrix(2,1) = sPhi * cPsi + cPhi * cTheta * sPsi
      rotationMatrix(2,2) = -sPhi * sPsi + cPhi * cTheta * cPsi
      rotationMatrix(2,3) = -sTheta * cPhi
      rotationMatrix(3,1) = sTheta * sPsi
      rotationMatrix(3,2) = sTheta * cPsi
      rotationMatrix(3,3) = cTheta
    
* initialize the result to zero
      DO i = 1, 3
         Result(i) = 0.0D0
      END DO
    
* apply rotation to the vector
      DO i = 1, 3
         DO j = 1, 3
            Result(i) = Result(i) + Vector(j) * rotationMatrix(i, j)
         END DO
      END DO
    
      RETURN
      END


      SUBROUTINE CrossProduct(A, B, C)
* This function computes the cross product of two vectors A and B
* A, B are input vectors of dimension 3
* C is the resulting vector, also of dimension 3

      real*8 A(3), B(3), C(3)

* Calculate each component of the cross product
      C(1) = A(2) * B(3) - A(3) * B(2)
      C(2) = A(3) * B(1) - A(1) * B(3)
      C(3) = A(1) * B(2) - A(2) * B(1)

      RETURN
      END



      SUBROUTINE VectorMagnitude(A, magnitude)
* This function computes the magnitude of a vector A
* A is the input vector of dimension 3

      real*8 A(3)
      real*8 magnitude

* Calculate the magnitude of the vector
      magnitude = SQRT(A(1) * A(1) + A(2) * A(2) + A(3) * A(3))

      RETURN
      END

      SUBROUTINE VectorHat(A, A_mag, A_hat)
* This function computes the unit vector of a vector A
* A is the input vector of dimension 3
* A_mag is the magnitude of the vector A
* A_hat is the resulting unit vector, also of dimension 3

      real*8 A(3), A_hat(3), A_mag

* Calculate the unit vector
      A_hat(1) = A(1) / A_mag
      A_hat(2) = A(2) / A_mag
      A_hat(3) = A(3) / A_mag
    
      RETURN
      END

      SUBROUTINE DotProduct(A, B, dot)
* This function computes the dot product of two vectors A and B
* A, B are input vectors of dimension 3
* dot is the resulting scalar

      real*8 A(3), B(3), dot

* Calculate the dot product
      dot = A(1) * B(1) + A(2) * B(2) + A(3) * B(3)

      RETURN
      END

      SUBROUTINE AngleBetweenVectors(A, B, angle)
* This function computes the angle between two vectors A and B
* A, B are input vectors of dimension 3
* angle is the resulting angle in radians

      real*8 A(3), B(3), angle
      real*8 dot, magA, magB

* Calculate the dot product of the two vectors
      call DotProduct(A, B, dot)

* Calculate the magnitudes of the two vectors
      call VectorMagnitude(A, magA)
      call VectorMagnitude(B, magB)

* Calculate the angle between the two vectors
      angle = ACOS(dot / (magA * magB))

      RETURN
      END


      SUBROUTINE CollisionCheck(sep_vec, v1, v2, r2, collide)
* This function checks if two stars collide
* It assumes that the compact object is a point mass, that the
* velocities are constant and the secondary star is a sphere, radius r2
*
* Method
* ------
* This result comes from constructing two vectors:
*    r1 = v1 * t, the position of the primary star
*    r2 = sep_vec + v2 * t, the position of the secondary star
* The difference between these vectors is
*    d = sep_vec + (v2 - v1) * t
* If the magnitude of d is less than r2, the stars collide.
* So to find the time of collision, we solve for t when minimising d^2
* (squared because then we can use the quadratic formula) and just plug
* it in.
*
* Variables
* ---------
* sep_vec is the separation vector between the two stars (in km)
* v1 is the velocity of the primary star (in km/s)
* v2 is the velocity of the secondary star (in km/s)
* r2 is the radius of the secondary star (in rsun)
* collide is whether the stars collide (logical)

      real*8 sep_vec(3), v1(3), v2(3), v_dif(3), r2, r2km
      real*8 r_dot_v_dif, v_dif_dot, t_min, d_min, d_min_vec(3)
      logical collide
      integer i

      do i = 1, 3
         v_dif(i) = v2(i) - v1(i)
      end do

      call DotProduct(sep_vec, v_dif, r_dot_v_dif)
      call DotProduct(v_dif, v_dif, v_dif_dot)
      t_min = -r_dot_v_dif / v_dif_dot

      if (t_min.lt.0) then
         collide = .false.
      else
         do i = 1, 3
            d_min_vec(i) = sep_vec(i) + v_dif(i) * t_min
         end do
         call VectorMagnitude(d_min_vec, d_min)
         r2km = r2 * rsunkm
         if (d_min.lt.r2km) then
            collide = .true.
         else
            collide = .false.
         end if
      end if 

      RETURN
      END

      SUBROUTINE RandomLogNormal(mean, sigma, result, idum1, twopi)
* This function generates a random number from a log-normal distribution
* following the Box-Muller transform method.
* http://en.wikipedia.org/wiki/Box-Muller_transform

      real*8 mean, sigma, result, twopi
      real*8 u1, u2, z0

      u1 = ran3(idum1)
      u2 = ran3(idum1)

      if (u1.le.0.d0) u1 = 1.0E-10      ! Avoid log(0)

      Z0 = SQRT(-2.0d0 * LOG(u1)) * COS(twopi * u2)
      result = EXP(mean + sigma * Z0)

      RETURN
      END

***
      SUBROUTINE checkstate(dtp,dtp_original,tsave,tphys,tphysf,
     &                      iplot,isave,binstate,evolve_type,
     &                      mass1,mass2,kstar1,kstar2,sep,
     &                      tb,ecc,rrl1,rrl2,
     &                      aj1,aj2,tms1,tms2,
     &                      massc1,massc2,rad1,rad2,
     &                      mass0_1,mass0_2,lumin1,lumin2,
     &                      radc1,radc2,menv1,menv2,renv1,renv2,
     &                      ospin1,ospin2,b_0_1,b_0_2,bacc1,bacc2,
     &                      tacc1,tacc2,epoch1,epoch2,bhspin1,bhspin2,
     &                      teff1,teff2)
*
* Check timestep conditions for bcm array
*
*     Author : Scott Coughlin
*     Date :   7th April 2020
*
*     Edited : Tom Wagg
*     Date : 15th November 2023
*
* How to add new timestep_conditions variables:
*
* 1. Adjust array size of checkstate_array in checkstate.h (15, x) -> (15, x + 3 * n_new_vars)
* 2. Adjust current_state_array size below
* 3. Add new variable to subroutine definition and current_state_array
* 4. Change DO loop conditions to (2, x, 3) -> (2, x + 3 * n_new_vars, 3)
* 5. In evolv2.f add new vars to every call of checkstate
* 6. In checkstate.py add new vars to CHECKSTATE_COLUMNS
*
      IMPLICIT NONE
      INCLUDE 'checkstate.h'
      INCLUDE 'const_bse.h'
      INTEGER jj,ii,param_index,binstate
      INTEGER kstar1,kstar2
      LOGICAL pass_condition,pass_condition_any
      LOGICAL isave,iplot
*  current_state_array length set by number of columns that can be used as timestep conditions
      REAL*8 current_state_array(43)
      REAL*8 dtp,dtp_original,tsave,tphys,tphysf,mass1,mass2
      REAL*8 evolve_type,sep,tb,ecc,rrl1,rrl2
      REAL*8 aj1,aj2,tms1,tms2,massc1,massc2,rad1,rad2
      REAL*8 mass0_1,mass0_2,lumin1,lumin2,radc1,radc2
      REAL*8 menv1,menv2,renv1,renv2,ospin1,ospin2
      REAL*8 b_0_1,b_0_2,bacc1,bacc2,tacc1,tacc2,epoch1,epoch2
      REAL*8 bhspin1,bhspin2,teff1,teff2
      current_state_array(1) = binstate
      current_state_array(2) = evolve_type
      current_state_array(3) = mass1
      current_state_array(4) = mass2
      current_state_array(5) = kstar1
      current_state_array(6) = kstar2
      current_state_array(7) = sep
      current_state_array(8) = tb
      current_state_array(9) = ecc
      current_state_array(10) = rrl1
      current_state_array(11) = rrl2
      current_state_array(12) = aj1
      current_state_array(13) = aj2
      current_state_array(14) = tms1
      current_state_array(15) = tms2
      current_state_array(16) = massc1
      current_state_array(17) = massc2
      current_state_array(18) = rad1
      current_state_array(19) = rad2
      current_state_array(20) = mass0_1
      current_state_array(21) = mass0_2
      current_state_array(22) = lumin1
      current_state_array(23) = lumin2
      current_state_array(24) = radc1
      current_state_array(25) = radc2
      current_state_array(26) = menv1
      current_state_array(27) = menv2
      current_state_array(28) = renv1
      current_state_array(29) = renv2
      current_state_array(30) = ospin1
      current_state_array(31) = ospin2
      current_state_array(32) = b_0_1
      current_state_array(33) = b_0_2
      current_state_array(34) = bacc1
      current_state_array(35) = bacc2
      current_state_array(36) = tacc1
      current_state_array(37) = tacc2
      current_state_array(38) = epoch1
      current_state_array(39) = epoch2
      current_state_array(40) = bhspin1
      current_state_array(41) = bhspin2
      current_state_array(42) = teff1
      current_state_array(43) = teff2

* tsave should never be bigger than tphysf
      IF(tsave.ge.tphysf)THEN
          tsave = tphysf
      ENDIF

* We track to see if any conditional pass, otherwise dtp will be set to
* dtp_original
      pass_condition_any = .false.

      DO jj = 1,15
* start by assuming we do not pass the current conditional setting of dtp
          pass_condition = .false.
* First check if there is even a dtp requested, if not
* this implies that a conditional has not been set so we should continue
          IF(dtp_state(jj).eq.-1.d0)THEN
              goto 74
          ENDIF
* if we do have the conditional then we need to know the sign of the conditional
* i.e. EQUAL (0), GT (1), GE (2), LT (3), LE (4) and then piece wise together the whole statement
* Moreover we need to keep track of which parameter in the current_state_array we are checking
          param_index = 0
* Loop stop value here is (number of condition columns - 1) * 3
          DO ii = 2, 126, 3
              param_index = param_index + 1
* This part of the checkstate array had no conditional set (we know because the default has not changed)
              IF(checkstate_array(jj,ii-1).eq.-10E30.and.
     &               checkstate_array(jj,ii+1).eq.10E30)THEN
                  goto 69
              ENDIF

* Now we check for what the conditional was and apply it. As soon as the
* conditional is false we do not check anymore
              IF(checkstate_array(jj,ii).eq.0)THEN

                  IF(checkstate_array(jj,ii-1).eq.
     &              current_state_array(param_index)
     &              .and.
     &              checkstate_array(jj,ii+1).eq.
     &              current_state_array(param_index))THEN
                      pass_condition = .true.
                  ELSE
                      pass_condition = .false.
                      goto 79
                  ENDIF

              ELSEIF(checkstate_array(jj,ii).eq.1)THEN

                  IF(current_state_array(param_index).gt.
     &               checkstate_array(jj,ii-1))THEN
                      pass_condition = .true.
                  ELSE
                      pass_condition = .false.
                      goto 79
                  ENDIF
              
              ELSEIF(checkstate_array(jj,ii).eq.2)THEN
                  IF(current_state_array(param_index).ge.
     &               checkstate_array(jj,ii-1))THEN
                      pass_condition = .true.
                  ELSE
                      pass_condition = .false.
                      goto 79
                  ENDIF

              ELSEIF(checkstate_array(jj,ii).eq.3)THEN

                  IF(current_state_array(param_index).lt.
     &               checkstate_array(jj,ii+1))THEN
                      pass_condition = .true.
                  ELSE
                      pass_condition = .false.
                      goto 79
                  ENDIF

              ELSEIF(checkstate_array(jj,ii).eq.4)THEN
                  IF(current_state_array(param_index).le.
     &               checkstate_array(jj,ii+1))THEN
                      pass_condition = .true.
                  ELSE
                      pass_condition = .false.
                      goto 79
                  ENDIF
              ENDIF
 69       CONTINUE
          ENDDO
 79       CONTINUE
* finally we see if we satisfied the conditional and set dtp
          IF(pass_condition)THEN
              IF(dtp_state(jj).ne.tphysf.and.tsave.ge.tphysf)THEN
                  tsave = tphys
              ENDIF
              dtp = dtp_state(jj)
              pass_condition_any = .true.
          ENDIF
 74   CONTINUE
      ENDDO
      IF(pass_condition_any.neqv..true.)THEN
* if no conditions are met then return to orginal dtp
          dtp = dtp_original
      ENDIF
      isave = .true.
      iplot = .false.
      IF(dtp.eq.0.d0)THEN
         iplot = .true.
         isave = .false.
         tsave = tphysf
      ENDIF
      END

***
      SUBROUTINE gntage(mc,mt,kw,zpars,m0,aj)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
* A routine to determine the age of a giant from its core mass and type.
*
*       Author : C. A. Tout
*       Date   : 24th September 1996
*       Revised: 21st February 1997 to include core-helium-burning stars
*
*       Rewritten: 2nd January 1998 by J. R. Hurley to be compatible with
*                  the new evolution routines and to include new stellar
*                  types.
*
*
      integer kw
      integer j,jmax
      parameter(jmax=30)
*
      real*8 mc,mt,m0,aj,tm,tn
      real*8 tscls(20),lums(10),GB(10),zpars(20)
      real*8 mmin,mmax,mmid,dm,f,fmid,dell,derl,lum
      real*8 macc,lacc,tiny
      parameter(macc=0.00001d0,lacc=0.0001d0,tiny=1.0d-14)
      real*8 mcx,mcy
*
      real*8 mcheif,mcagbf,mheif,mbagbf,mcgbf,lmcgbf,lbgbf,lbgbdf
      external mcheif,mcagbf,mheif,mbagbf,mcgbf,lmcgbf,lbgbf,lbgbdf
*
* This should only be entered with KW = 3, 4, 5, 6 or 9
*
* First we check that we don't have a CheB star
* with too small a core mass.
      if(kw.eq.4)then
* Set the minimum CHeB core mass using M = Mflash
         mcy = mcheif(zpars(2),zpars(2),zpars(10))
         if(mc.le.mcy) kw = 3
*        if(mc.le.mcy) WRITE(66,*)' GNTAGE4: changed to 3'
      endif
*
* Next we check that we don't have a GB star for M => Mfgb
      if(kw.eq.3)then
* Set the maximum GB core mass using M = Mfgb
         mcy = mcheif(zpars(3),zpars(2),zpars(9))
         if(mc.ge.mcy)then
            kw = 4
            aj = 0.d0
*           WRITE(66,*)' GNTAGE3: changed to 4'
         endif
      endif
*
      if(kw.eq.6)then
*
* We try to start the star from the start of the SAGB by
* setting Mc = Mc,TP.
*
         mcy = 0.44d0*2.25d0 + 0.448d0
         if(mc.gt.mcy)then
* A type 6 with this sized core mass cannot exist as it should
* already have become a NS or BH as a type 5.
* We set it up so that it will.
            mcx = (mc + 0.35d0)/0.773d0
         elseif(mc.ge.0.8d0)then
            mcx = (mc - 0.448d0)/0.44d0
         else
            mcx = mc
         endif
         m0 = mbagbf(mcx)
         if(m0.lt.tiny)then
* Carbon core mass is less then the minimum for the start of SAGB.
* This must be the case of a low-mass C/O or O/Ne WD with only a
* very small envelope added or possibly the merger of a helium star
* with a main sequence star. We will set m0 = mt and then reset the
* core mass to allow for some helium to be added to the C/O core.
            kw = 14
*           WRITE(66,*)' GNTAGE6: changed to 4'
         else
            CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
            aj = tscls(13) + 2.d0*tiny
         endif
      endif
*
      if(kw.eq.5)then
*
* We fit a Helium core mass at the base of the AGB.
*
         m0 = mbagbf(mc)
         if(m0.lt.tiny)then
* Helium core mass is less then the BAGB minimum.
            kw = 14
*           WRITE(66,*)' GNTAGE5: changed to 4'
         else
            CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
            aj = tscls(2) + tscls(3) + 2.d0*tiny
         endif
      endif
*
*
      if(kw.eq.4)then
*
* The supplied age is actually the fractional age, fage, of CHeB lifetime
* that has been completed, ie. 0 <= aj <= 1.
*
         if(aj.lt.0.d0.or.aj.gt.1.d0)then
*           WRITE(99,*)' FATAL ERROR! GNTAGE4: fage out of bounds '
*           WRITE(99,*)' FAGE ',aj
*           WRITE(*,*)' STOP: FATAL ERROR '
*           CALL exit(0)
*           STOP
            aj = 0.d0
         endif
* Get the minimum, fage=1, and maximum, fage=0, allowable masses
         mcy = mcagbf(zpars(2))
         if(mc.ge.mcy)then
            mmin = mbagbf(mc)
         else
            mmin = zpars(2)
         endif
         mmax = mheif(mc,zpars(2),zpars(10))
         if(aj.lt.tiny)then
            m0 = mmax
            goto 20
         elseif(aj.ge.1.d0)then
            m0 = mmin
            goto 20
         endif
* Use the bisection method to find m0
         fmid = (1.d0-aj)*mcheif(mmax,zpars(2),zpars(10)) +
     &          aj*mcagbf(mmax) - mc
         f = (1.d0-aj)*mcheif(mmin,zpars(2),zpars(10)) +
     &       aj*mcagbf(mmin) - mc
         if(f*fmid.ge.0.d0)then
* This will probably occur if mc is just greater than the minimum
* allowed mass for a CHeB star and fage > 0.
            kw = 3
*           WRITE(66,*)' GNTAGE4: changed to 3'
            goto 90
         endif
         m0 = mmin
         dm = mmax - mmin
         do 10 , j = 1,jmax
            dm = 0.5d0*dm
            mmid = m0 + dm
            fmid = (1.d0-aj)*mcheif(mmid,zpars(2),zpars(10)) +
     &             aj*mcagbf(mmid) - mc
            if(fmid.lt.0.d0) m0 = mmid
            if(ABS(dm).lt.macc.or.ABS(fmid).lt.tiny) goto 20
            if(j.eq.jmax)then
*              WRITE(99,*)' FATAL ERROR! GNTAGE4: root not found '
*              WRITE(*,*)' STOP: FATAL ERROR '
*              CALL exit(0)
*              STOP
               m0 = mt
               aj = 0.d0
            endif
 10      continue
 20      continue
*
         CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
         aj = tscls(2) + aj*tscls(3)
*
      endif
*
 90   continue
*
      if(kw.eq.3)then
*
* First we double check that we don't have a GB star for M => Mfgb
         mcy = mcheif(zpars(3),zpars(2),zpars(9))
         if(mc.ge.mcy)then
*           WRITE(99,*)' GNTAGE3: star too big for GB '
*           WRITE(*,*)' STOP: FATAL ERROR '
*           CALL exit(0)
*           STOP
            mc = 0.99d0*mcy
         endif
* Next we find an m0 so as to place the star at the BGB
         mcx = mcheif(zpars(2),zpars(2),zpars(9))
         if(mc.gt.mcx)then
            m0 = mheif(mc,zpars(2),zpars(9))
         else
* Use Newton-Raphson to find m0 from Lbgb
            m0 = zpars(2)
            CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
            lum = lmcgbf(mc,GB)
            j = 0
 30         continue
            dell = lbgbf(m0) - lum
            if(ABS(dell/lum).le.lacc) goto 40
            derl = lbgbdf(m0)
            m0 = m0 - dell/derl
            j = j + 1
            if(j.eq.jmax)then
*              WRITE(99,*)' FATAL ERROR! GNTAGE3: root not found '
*              WRITE(*,*)' STOP: FATAL ERROR '
*              CALL exit(0)
*              STOP
               m0 = zpars(2)
               m0 = MAX(m0,mt)
               goto 40
            endif
            goto 30
 40         continue
         endif
         CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
         aj = tscls(1) + 1.0d-06*(tscls(2) - tscls(1))
*
      endif
*
      if(kw.eq.8.or.kw.eq.9)then
*
* We make a post-MS naked helium star.
* To make things easier we put the star at the TMS point
* so it actually begins as type 8.
*
         kw = 8
         mmin = mc
         CALL star(kw,mmin,mc,tm,tn,tscls,lums,GB,zpars)
         mcx = mcgbf(lums(2),GB,lums(6))
         if(mcx.ge.mc)then
*           WRITE(99,*)' FATAL ERROR! GNTAGE9: mmin too big '
*           WRITE(*,*)' STOP: FATAL ERROR '
*           CALL exit(0)
*           STOP
            m0 = mt
            goto 80
         endif
         f = mcx - mc
         mmax = mt
         do 50 , j = 1,jmax
            CALL star(kw,mmax,mc,tm,tn,tscls,lums,GB,zpars)
            mcy = mcgbf(lums(2),GB,lums(6))
            if(mcy.gt.mc) goto 60
            mmax = 2.d0*mmax
            if(j.eq.jmax)then
*              WRITE(99,*)' FATAL ERROR! GNTAGE9: mmax not found '
*              WRITE(*,*)' STOP: FATAL ERROR '
*              CALL exit(0)
*              STOP
               m0 = mt
               goto 80
            endif
 50      continue
 60      continue
         fmid = mcy - mc
* Use the bisection method to find m0
         if(f*fmid.ge.0.d0)then
*           WRITE(99,*)' FATAL ERROR! GNTAGE9: root not bracketed '
*           WRITE(*,*)' STOP: FATAL ERROR '
*           CALL exit(0)
*           STOP
            m0 = mt
            goto 80
         endif
         m0 = mmin
         dm = mmax - mmin
         do 70 , j = 1,jmax
            dm = 0.5d0*dm
            mmid = m0 + dm
            CALL star(kw,mmid,mc,tm,tn,tscls,lums,GB,zpars)
            mcy = mcgbf(lums(2),GB,lums(6))
            fmid = mcy - mc
            if(fmid.lt.0.d0) m0 = mmid
            if(ABS(dm).lt.macc.or.ABS(fmid).lt.tiny) goto 80
            if(j.eq.jmax)then
*              WRITE(99,*)' FATAL ERROR! GNTAGE9: root not found '
*              WRITE(*,*)' STOP: FATAL ERROR '
*              CALL exit(0)
*              STOP
               m0 = mt
               goto 80
            endif
 70      continue
 80      continue
*
         CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
         aj = tm + 1.0d-10*tm
*
      endif
*
      if(kw.eq.14)then
*
         kw = 4
         m0 = mt
         mcy = mcagbf(m0)
         aj = mc/mcy
         CALL star(kw,m0,mt,tm,tn,tscls,lums,GB,zpars)
         if(m0.le.zpars(2))then
            mcx = mcgbf(lums(4),GB,lums(6))
         else
            mcx = mcheif(m0,zpars(2),zpars(10))
         end if
         mc = mcx + (mcy - mcx)*aj
         aj = tscls(2) + aj*tscls(3)
      endif
*
      RETURN
      END
***

      BLOCK DATA Taus113_init
        include "tausworth.h"
        DATA c /z'fffffffe', z'fffffff8', z'fffffff0', z'ffffff80'/
        DATA cseed /69069/
      END

      subroutine taus113_seeding(z, seed)
        include "tausworth.h"
        integer(kind=int64) z(4), seed

        print*, umax, bit_size(umax)

        z(1) = iand(umax, seed * cseed)
        if ( z(1) < 2 ) z(1) = z(1) + 2
        z(2) = iand(umax, z(1) * cseed)
        if ( z(2) < 8 ) z(2) = z(2) + 8
        z(3) = iand(umax, z(2) * cseed)
        if ( z(3) < 16 ) z(3) = z(3) + 16
        z(4) = iand(umax, z(3) * cseed)
        if ( z(4) < 128 ) z(4) = z(4) + 128
      end subroutine

      function ishft32(a, shift)
        include "tausworth.h"
        integer(kind=int64) ishft32, a
        integer shift

        ishft32= iand(ishft(a, shift), umax)
      end function

      subroutine taus113_next_state(z)
        include "tausworth.h"
        integer(kind=int64) z(4), znew(4), ishft32
        EXTERNAL ishft32
        integer i

        znew(1)  = ishft32(iand(z(1),c(1)), 18)
        znew(2)  = ishft32(iand(z(2),c(2)), 2)
        znew(3)  = ishft32(iand(z(3),c(3)), 7)
        znew(4)  = ishft32(iand(z(4),c(4)),13)

        znew(1) = ieor(znew(1), ishft(ieor(ishft32(z(1),6), z(1)),-13))
        znew(2) = ieor(znew(2), ishft(ieor(ishft32(z(2),2), z(2)),-27))
        znew(3) = ieor(znew(3), ishft(ieor(ishft32(z(3),13), z(3)),-21))
        znew(4) = ieor(znew(4), ishft(ieor(ishft32(z(4),3), z(4)),-12))

        do i=1,4
          z(i)=znew(i)
        end do
      end subroutine

      function taus113_gen_int(z)
        include "tausworth.h"
        integer(kind=int64) taus113_gen_int, z(4), rnum

        rnum= z(1)
        do i=2,4
          rnum= ieor(rnum, z(i))
        end do

        taus113_gen_int= rnum
      end function

      subroutine test_taus()
        include "int64.h"
        integer(kind=int64) taus113_gen_int
        EXTERNAL taus113_gen_int
        integer(kind=int64) i, z(4), znew(4), seed, maxiter

        seed= 123456
        call taus113_seeding(z, seed)

        maxiter= int(1d9)
        do i=1,maxiter
          call taus113_next_state(z)
        end do

        print*, bit_size(seed), seed, umax
        do i=1,4
          print*, "z(",i,")=", z(i)
        enddo
        print*, taus113_gen_int(z)
      end subroutine

***
      SUBROUTINE deltat(kw,age,tm,tn,tscls,dt,dtr)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
      INTEGER kw
      REAL*8 age,tm,tn,tscls(20)
      REAL*8 dt,dtr
*
*     Base new time scale for changes in radius & mass on stellar type.
*
      if(kw.le.1)then
         dt = pts1*tm
         dtr = tm - age
      elseif(kw.eq.2)then
         dt = pts1*(tscls(1) - tm)
         dtr = tscls(1) - age
      elseif(kw.eq.3)then
         if(age.lt.tscls(6))then
            dt = pts2*(tscls(4) - age)
         else
            dt = pts2*(tscls(5) - age)
         endif
         dtr = MIN(tscls(2),tn) - age
      elseif(kw.eq.4)then
         dt = pts2*tscls(3)
         dtr = MIN(tn,tscls(2) + tscls(3)) - age
      elseif(kw.eq.5)then
         if(age.lt.tscls(9))then
            dt = pts3*(tscls(7) - age)
         else
            dt = pts3*(tscls(8) - age)
         endif
         dtr = MIN(tn,tscls(13)) - age
      elseif(kw.eq.6)then
         if(age.lt.tscls(12))then
            dt = pts3*(tscls(10) - age)
         else
            dt = pts3*(tscls(11) - age)
         endif
         dt = MIN(dt,0.005d0)
         dtr = tn - age
      elseif(kw.eq.7)then
         dt = pts1*tm
         dtr = tm - age
      elseif(kw.eq.8.or.kw.eq.9)then
         if(age.lt.tscls(6))then
            dt = pts2*(tscls(4) - age)
         else
            dt = pts2*(tscls(5) - age)
         endif
         dtr = tn - age
      else
*        dt = MAX(0.1d0,age*10.d0)
         dt = MAX(0.1d0,dt*10.d0)
         dt = MIN(dt,5.0d+02)
         dtr = dt
      endif
*
      RETURN
      END
***

***
      REAL FUNCTION ran3(idum)
      IMPLICIT NONE
      INCLUDE 'const_bse.h'
*
* Random number generator from Numerical Recipes, Press et al. pg 272.
*
      INTEGER idum
      INTEGER j,k,im1,im2,imm1,ia1,ia2,iq1,iq2,ir1,ir2,ntab,ndiv
      PARAMETER(im1=2147483563,im2=2147483399,ia1=40014,ia2=40692)
      PARAMETER(iq1=53668,iq2=52774,ir1=12211,ir2=3791,ntab=32)
      DATA idum2/123456789/, iy/0/, ir/ntab*0/
      REAL am
*
      am = 1.0/float(im1)
      imm1 = im1 - 1
      ndiv = 1 + imm1/ntab
*
      if(idum.le.0)then
         idum = MAX(-idum,1)
         idum2 = idum
         do 11 , j = ntab+8,1,-1
            k = idum/iq1
            idum = ia1*(idum-k*iq1)-k*ir1
            if(idum.lt.0) idum = idum + im1
            if(j.le.ntab) ir(j) = idum
 11      continue
         iy = ir(1)
      endif
      k = idum/iq1
      idum = ia1*(idum-k*iq1)-k*ir1
      if(idum.lt.0) idum = idum + im1
      k = idum2/iq2
      idum2 = ia2*(idum2-k*iq2)-k*ir2
      if(idum2.lt.0) idum2 = idum2 + im2
      j = 1 + iy/ndiv
      iy = ir(j) - idum2
      ir(j) = idum
      if(iy.lt.1) iy = iy + imm1
      ran3 = am*iy
*
      RETURN
      END
***



      SUBROUTINE RandomNormal(mean, sigma, idum, result)
* Generate a normally distributed random number with given mean and sigma
* using the Box-Muller transform

      real*8 mean, sigma, result
      integer idum
      real*8 u1, u2, Z0
      
      u1 = ran3(idum)
      u2 = ran3(idum)
      Z0 = SQRT(-2.d0*LOG(u1))*COS(2.d0*3.141592653589793d0*u2)
      result = Z0 * sigma + mean

      RETURN
      END


      SUBROUTINE RandomTruncatedNormal(mu, sigma, idum, lower, upper, x)
* Generate a random number from a truncated normal distribution
* with mean mu, standard deviation sigma, truncated to [lower, upper]
      IMPLICIT NONE
      REAL*8 mu, sigma, lower, upper, x
      INTEGER idum, max_attempts, attempt

      attempt = 0
      max_attempts = 1000

      do
          attempt = attempt + 1
          call RandomNormal(mu, sigma, idum, x)  ! for debugging
          if (x .GE. lower .AND. x .LE. upper)then
             exit
          elseif (attempt.ge.max_attempts) then
            ! use the midpoint if we exceed max attempts
            x = 0.5d0 * (lower + upper)
            exit
          endif
      end do

      RETURN
      END

#!/bin/bash

# enable strict test flags
if [ "$STRICT" = true ]; then
    _strict="-x --strict"
else
    _strict=""
fi

coverage run --append `which cosmic-pop` --help
coverage run -m py.test -v -r s ${_strict} cosmic/

gfortran -coverage -fprofile-arcs -ftest-coverage -O0 src/cosmic/src/assign_remnant.f src/cosmic/src/benchmarkevolv2.f src/cosmic/src/comenv.f src/cosmic/src/corerd.f src/cosmic/src/deltat.f src/cosmic/src/dgcore.f src/cosmic/src/evolv2.f src/cosmic/src/gntage.f src/cosmic/src/hrdiag.f src/cosmic/src/hrdiag_remnant.f src/cosmic/src/instar.f src/cosmic/src/kick.f src/cosmic/src/mix.f src/cosmic/src/mlwind.f src/cosmic/src/mrenv.f src/cosmic/src/ran3.f src/cosmic/src/rl.f src/cosmic/src/star.f src/cosmic/src/zcnsts.f src/cosmic/src/zfuncs.f src/cosmic/src/concatkstars.f src/cosmic/src/bpp_array.f src/cosmic/src/checkstate.f  -o benchmarkevolv2.exe -I src/cosmic/src -Wl,-rpath,${CONDA_PREFIX}/lib
./benchmarkevolv2.exe

---
name: Question
about: I want to ask a question about COSMIC
title: ''
labels: question
assignees: ''

---

Use this issue to ask any questions about how functions work, how best to use the package for your project or anything else you need help with! Wherever possible please include code examples to make it easier to help you!

---
name: New physics prescription
about: I want to request/suggest a new physics prescription
title: ''
labels: new-prescription
assignees: ''

---

**Describe the new physics prescription you want to add**
TODO

**Link to the publication this is based on**
TODO

**Is this a new option for an existing flag? Or would require a new setting?**
TODO

---
name: general issue
about: Way to systematically track weird evoltuionary behavior and things tried to
  resolve that behavior for better history tracking.
title: "[general issue]"
labels: general
---

# Describe your issue in as much detail as possible -- if your issue arises from a cosmic-pop command line call, please include the exact syntax of the command line call in your description.

---
name: Feature request
about: I want to request a new feature
title: ''
labels: feature-request
assignees: ''

---

**Describe the new feature you'd like**
A clear and concise description of what you want to happen. E.g. "I love how this package can evolve populations, but I think a great improvement would be for it to also do my taxes."

**Any suggestions for how to implement this**
Is there a particular way you would implement this? How could this integrate into the existing code?

**Is your feature request related to a problem? Please describe.**
A clear and concise description of what the problem is. Ex. I'm always frustrated when [...]

---
name: Unexpected Stellar Evolutionary Behavior
about: I want to report some weird evolutionary behavior and things tried to resolve that behavior for better history tracking.
title: ""
labels: Unexpected Evolutionary Behavior
assignees: ''

---

# Checklist
- [ ] Attached CSV file with initial conditions and BSE flags for reproducing this behavior
- [ ] Included code that produces the BPP/BCM arrays
- [ ] Written description of weird behavior
- [ ] Explained expected outcome
- [ ] Listed flags you have tried to turn on and off that you think relate to the evolutionary behavior
- [ ] Attached a plot if applicable

# CSV file 

Attach file with initC file here. You can save this like
```python
# create CSV file
initC.to_csv('weird_behavior.csv', index=False)

# now attach it to this issue!
```

# Code that produces the BPP and BCM arrays

```python
# your code here
```

# Description

Add a description of the weird behavior you've seen

# Expect outcome

How do you think this system _should_ evolve?

# Flags

Which flag have you tried to turn on and off that you think relate to the evolutionary behavior?

# Plot (if applicable)

Plot goes here
